/* Copyright Statement:
 *
 * (C) 2005-2016  MediaTek Inc. All rights reserved.
 *
 * This software/firmware and related documentation ("MediaTek Software") are
 * protected under relevant copyright laws. The information contained herein
 * is confidential and proprietary to MediaTek Inc. ("MediaTek") and/or its licensors.
 * Without the prior written permission of MediaTek and/or its licensors,
 * any reproduction, modification, use or disclosure of MediaTek Software,
 * and information contained herein, in whole or in part, shall be strictly prohibited.
 * You may only use, reproduce, modify, or distribute (as applicable) MediaTek Software
 * if you have agreed to and been bound by the applicable license agreement with
 * MediaTek ("License Agreement") and been granted explicit permission to do so within
 * the License Agreement ("Permitted User").  If you are not a Permitted User,
 * please cease any access or use of MediaTek Software immediately.
 * BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES
 * THAT MEDIATEK SOFTWARE RECEIVED FROM MEDIATEK AND/OR ITS REPRESENTATIVES
 * ARE PROVIDED TO RECEIVER ON AN "AS-IS" BASIS ONLY. MEDIATEK EXPRESSLY DISCLAIMS ANY AND ALL
 * WARRANTIES, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR NONINFRINGEMENT.
 * NEITHER DOES MEDIATEK PROVIDE ANY WARRANTY WHATSOEVER WITH RESPECT TO THE
 * SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY, INCORPORATED IN, OR
 * SUPPLIED WITH MEDIATEK SOFTWARE, AND RECEIVER AGREES TO LOOK ONLY TO SUCH
 * THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO. RECEIVER EXPRESSLY ACKNOWLEDGES
 * THAT IT IS RECEIVER'S SOLE RESPONSIBILITY TO OBTAIN FROM ANY THIRD PARTY ALL PROPER LICENSES
 * CONTAINED IN MEDIATEK SOFTWARE. MEDIATEK SHALL ALSO NOT BE RESPONSIBLE FOR ANY MEDIATEK
 * SOFTWARE RELEASES MADE TO RECEIVER'S SPECIFICATION OR TO CONFORM TO A PARTICULAR
 * STANDARD OR OPEN FORUM. RECEIVER'S SOLE AND EXCLUSIVE REMEDY AND MEDIATEK'S ENTIRE AND
 * CUMULATIVE LIABILITY WITH RESPECT TO MEDIATEK SOFTWARE RELEASED HEREUNDER WILL BE,
 * AT MEDIATEK'S OPTION, TO REVISE OR REPLACE MEDIATEK SOFTWARE AT ISSUE,
 * OR REFUND ANY SOFTWARE LICENSE FEES OR SERVICE CHARGE PAID BY RECEIVER TO
 * MEDIATEK FOR SUCH MEDIATEK SOFTWARE AT ISSUE.
 */

#ifndef __WIFI_DEFAULT_CONFIG_H__
#define __WIFI_DEFAULT_CONFIG_H__


#include "connsys_profile.h"

#ifdef __cplusplus
extern "C" {
#endif

#define WIFI_DEFAULT_COUNTRY_REGION (5)
#define WIFI_DEFAULT_COUNTRY_REGION_A_BAND (3)
#define WIFI_DEFAULT_COUNTRY_CODE ("TW")
#define WIFI_DEFAULT_N9_DEBUG_LEVEL (3)
#define WIFI_DEFAULT_RTS_THRESHOLD (2347)
#define WIFI_DEFAULT_FRAGMENT_THRESHOLD (2346)
#define WIFI_DEFAULT_BG_CHANNEL_TABLE ("1,14,0|")
#define WIFI_DEFAULT_A_CHANNEL_TABLE ("36,8,0|100,11,0|149,4,0|")
#define WIFI_DEFAULT_MANUFACTURER    ("MTK")
#define WIFI_DEFAULT_MODEL_NAME      ("MTK Wireless Device")
#define WIFI_DEFAULT_MODEL_NUMBER    ("MT7687")
#define WIFI_DEFAULT_SERIAL_NUMBER   ("12345678")
#define WIFI_DEFAULT_DEVICE_NAME     ("MTK IoT")
#define WIFI_DEFAULT_CONFIG_FREE_ENABLE   (0)

#define WIFI_DEFAULT_STA_FAST_LINK   (0)
#define WIFI_DEFAULT_STA_BSS_TYPE   (1)
#define WIFI_DEFAULT_STA_CHANNEL   (1)
#define WIFI_DEFAULT_STA_BANDWIDTH (0)
#define WIFI_DEFAULT_STA_WIRELESS_MODE (9)
#define WIFI_DEFAULT_STA_BA_DECLINE (0)
#define WIFI_DEFAULT_STA_AUTO_BA (1)
#define WIFI_DEFAULT_STA_HT_MCS (33)
#define WIFI_DEFAULT_STA_HT_BA_WINDOW_SIZE (64)
#define WIFI_DEFAULT_STA_HT_GI   (1)
#define WIFI_DEFAULT_STA_HT_PROTECT   (1)
#define WIFI_DEFAULT_STA_HT_EXT_CHANNEL   (1)
#define WIFI_DEFAULT_STA_WMM_CAPABLE   (1)
#define WIFI_DEFAULT_STA_LISTEN_INTERVAL  (1)
#define WIFI_DEFAULT_STA_POWER_SAVE_MODE  (0)
#define WIFI_DEFAULT_STA_KEEP_ALIVE_PERIOD  (10)

#define WIFI_DEFAULT_AP_CHANNEL   (1)
#define WIFI_DEFAULT_AP_BANDWIDTH (0)
#define WIFI_DEFAULT_AP_WIRELESS_MODE (9)
#define WIFI_DEFAULT_AP_AUTO_BA (1)
#define WIFI_DEFAULT_AP_HT_MCS (33)
#define WIFI_DEFAULT_AP_HT_BA_WINDOW_SIZE (64)
#define WIFI_DEFAULT_AP_HT_GI   (1)
#define WIFI_DEFAULT_AP_HT_PROTECT   (1)
#define WIFI_DEFAULT_AP_HT_EXT_CHANNEL   (1)
#define WIFI_DEFAULT_AP_WMM_CAPABLE   (1)
#define WIFI_DEFAULT_AP_DTIM_PERIOD   (1)
#define WIFI_DEFAULT_AP_HIDDEN_SSID   (0)
#define WIFI_DEFAULT_AP_AUTO_CHANNEL_SELECT   (0)
#define WIFI_DEFAULT_AP_REKEY_INTERVAL   (3600)
#ifdef MTK_HOMEKIT_ENABLE
#define WIFI_DEFAULT_AP_BEACON_DISABLE   (1)
#else
#define WIFI_DEFAULT_AP_BEACON_DISABLE   (0)
#endif

#define WIFI_DEFAULT_MBSS_ENABLE  (0)
#define WIFI_DEFAULT_MBSS_SSID1  ("MTK_MBSS1")
#define WIFI_DEFAULT_MBSS_SSID2  ("MTK_MBSS2")
#define WIFI_DEFAULT_BEACON_LOST_TIME (2)
#define WIFI_DEFAULT_APCLI_BW_AUTO_UP_BELOW (1)
#ifdef MTK_WIFI_PRIVILEGE_ENABLE
#define WIFI_DEFAULT_WIFI_PRIVILEGE_ENABLE  (1)
#else
#define WIFI_DEFAULT_WIFI_PRIVILEGE_ENABLE  (0)
#endif
int32_t wifi_get_default_config(sys_cfg_t *syscfg);


#ifdef __cplusplus
    }
#endif

#endif //__WIFI_DEFAULT_CONFIG_H__

