/* Copyright Statement:
 *
 * (C) 2005-2016  MediaTek Inc. All rights reserved.
 *
 * This software/firmware and related documentation ("MediaTek Software") are
 * protected under relevant copyright laws. The information contained herein
 * is confidential and proprietary to MediaTek Inc. ("MediaTek") and/or its licensors.
 * Without the prior written permission of MediaTek and/or its licensors,
 * any reproduction, modification, use or disclosure of MediaTek Software,
 * and information contained herein, in whole or in part, shall be strictly prohibited.
 * You may only use, reproduce, modify, or distribute (as applicable) MediaTek Software
 * if you have agreed to and been bound by the applicable license agreement with
 * MediaTek ("License Agreement") and been granted explicit permission to do so within
 * the License Agreement ("Permitted User").  If you are not a Permitted User,
 * please cease any access or use of MediaTek Software immediately.
 * BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES
 * THAT MEDIATEK SOFTWARE RECEIVED FROM MEDIATEK AND/OR ITS REPRESENTATIVES
 * ARE PROVIDED TO RECEIVER ON AN "AS-IS" BASIS ONLY. MEDIATEK EXPRESSLY DISCLAIMS ANY AND ALL
 * WARRANTIES, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR NONINFRINGEMENT.
 * NEITHER DOES MEDIATEK PROVIDE ANY WARRANTY WHATSOEVER WITH RESPECT TO THE
 * SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY, INCORPORATED IN, OR
 * SUPPLIED WITH MEDIATEK SOFTWARE, AND RECEIVER AGREES TO LOOK ONLY TO SUCH
 * THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO. RECEIVER EXPRESSLY ACKNOWLEDGES
 * THAT IT IS RECEIVER'S SOLE RESPONSIBILITY TO OBTAIN FROM ANY THIRD PARTY ALL PROPER LICENSES
 * CONTAINED IN MEDIATEK SOFTWARE. MEDIATEK SHALL ALSO NOT BE RESPONSIBLE FOR ANY MEDIATEK
 * SOFTWARE RELEASES MADE TO RECEIVER'S SPECIFICATION OR TO CONFORM TO A PARTICULAR
 * STANDARD OR OPEN FORUM. RECEIVER'S SOLE AND EXCLUSIVE REMEDY AND MEDIATEK'S ENTIRE AND
 * CUMULATIVE LIABILITY WITH RESPECT TO MEDIATEK SOFTWARE RELEASED HEREUNDER WILL BE,
 * AT MEDIATEK'S OPTION, TO REVISE OR REPLACE MEDIATEK SOFTWARE AT ISSUE,
 * OR REFUND ANY SOFTWARE LICENSE FEES OR SERVICE CHARGE PAID BY RECEIVER TO
 * MEDIATEK FOR SUCH MEDIATEK SOFTWARE AT ISSUE.
 */

#ifndef __MSDC_CUSTOM_CONFIG_H__
#define __MSDC_CUSTOM_CONFIG_H__


/*****************************************************************************************/
/************************************* Common part ***************************************/
/*****************************************************************************************/

/*Define MSDC0 IO driving capability. 
    0:MSDC_IO_4MA
    1:MSDC_IO_8MA
    2:MSDC_IO_12MA
    3:MSDC_IO_16MA
*/
#define MSDC_0_CONTROL_LINE_DRIVING_CAPABILITY (1)
#define MSDC_0_DATA_LINE_DRIVING_CAPABILITY    (1)

/*Define MSDC0 IO slew rate.
    0:MSDC_IO_SLEW_FAST
    1:MSDC_IO_SLEW_SLOW
*/
#define MSDC_0_CONTROL_LINE_SLEW_RATE (0)
#define MSDC_0_DATA_LINE_SLEW_RATE    (0)

/*Define MSDC1 IO driving capability. 
    0:MSDC_IO_4MA
    1:MSDC_IO_8MA
    2:MSDC_IO_12MA
    3:MSDC_IO_16MA
*/
#define MSDC_1_CONTROL_LINE_DRIVING_CAPABILITY (1)
#define MSDC_1_DATA_LINE_DRIVING_CAPABILITY    (1)

/*Define MSDC0 IO slew rate.
    0:MSDC_IO_SLEW_FAST
    1:MSDC_IO_SLEW_SLOW
*/
#define MSDC_1_CONTROL_LINE_SLEW_RATE (0)
#define MSDC_1_DATA_LINE_SLEW_RATE    (0)




/*************************************************************************************/
/************************************* WIFI part ***************************************/
/*************************************************************************************/

/*Define the MSDC port is used by WIFI.
    0: HAL_SDIO_PORT_0
    1: HAL_SDIO_PORT_1
*/
#define WIFI_USE_MSDC_PORT_NUMBER (1)

/*Define the bus width.
    1: HAL_SDIO_BUS_WIDTH_1
    2: HAL_SDIO_BUS_WIDTH_4
*/
#define WIFI_MSDC_BUS_WIDTH  (2)

/*Define the bus clock, for bus clock,it should be less than 50000, the unit is kHz.*/
#define WIFI_MSDC_BUS_CLOCK  (22000)   /*Define bus clock to 22MHz.*/





/*************************************************************************************/
/************************************* FS part ***************************************/
/*************************************************************************************/

/*Define the MSDC port is used by FS.
    0: HAL_SD_PORT_0
    1: HAL_SD_PORT_1
*/
#define FS_USE_MSDC_PORT_NUMBER (0)

/*Define the bus width.
    1: HAL_SD_BUS_WIDTH_1
    2: HAL_SD_BUS_WIDTH_4
*/
#define FS_MSDC_BUS_WIDTH  (2)

/*Define the bus clock, for bus clock,it should be less than 50000, the unit is kHz.*/
#define FS_MSDC_BUS_CLOCK  (45000)   /*Define bus clock to 45MHz.*/




/********************************************************************************************/
/************************************* Mass Storage part ***************************************/
/********************************************************************************************/

/*Define the MSDC port is used by Mass Storage. It is always equal to FS_USE_MSDC_PORT_NUMBER.
    0: HAL_SD_PORT_0
    1: HAL_SD_PORT_1
*/
#define MASS_STORAGE_USE_MSDC_PORT_NUMBER (0)

/*Define the bus width.
    1: HAL_SD_BUS_WIDTH_1
    2: HAL_SD_BUS_WIDTH_4
*/
#define MASS_STORAGE_MSDC_BUS_WIDTH  (2)

/*Define the bus clock, for bus clock,it should be less than 50000, the unit is kHz.*/
#define MASS_STORAGE_MSDC_BUS_CLOCK  (45000)   /*Define bus clock to 45MHz.*/


#endif

