/* Copyright Statement:
 *
 * (C) 2005-2016  MediaTek Inc. All rights reserved.
 *
 * This software/firmware and related documentation ("MediaTek Software") are
 * protected under relevant copyright laws. The information contained herein
 * is confidential and proprietary to MediaTek Inc. ("MediaTek") and/or its licensors.
 * Without the prior written permission of MediaTek and/or its licensors,
 * any reproduction, modification, use or disclosure of MediaTek Software,
 * and information contained herein, in whole or in part, shall be strictly prohibited.
 * You may only use, reproduce, modify, or distribute (as applicable) MediaTek Software
 * if you have agreed to and been bound by the applicable license agreement with
 * MediaTek ("License Agreement") and been granted explicit permission to do so within
 * the License Agreement ("Permitted User").  If you are not a Permitted User,
 * please cease any access or use of MediaTek Software immediately.
 * BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES
 * THAT MEDIATEK SOFTWARE RECEIVED FROM MEDIATEK AND/OR ITS REPRESENTATIVES
 * ARE PROVIDED TO RECEIVER ON AN "AS-IS" BASIS ONLY. MEDIATEK EXPRESSLY DISCLAIMS ANY AND ALL
 * WARRANTIES, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR NONINFRINGEMENT.
 * NEITHER DOES MEDIATEK PROVIDE ANY WARRANTY WHATSOEVER WITH RESPECT TO THE
 * SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY, INCORPORATED IN, OR
 * SUPPLIED WITH MEDIATEK SOFTWARE, AND RECEIVER AGREES TO LOOK ONLY TO SUCH
 * THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO. RECEIVER EXPRESSLY ACKNOWLEDGES
 * THAT IT IS RECEIVER'S SOLE RESPONSIBILITY TO OBTAIN FROM ANY THIRD PARTY ALL PROPER LICENSES
 * CONTAINED IN MEDIATEK SOFTWARE. MEDIATEK SHALL ALSO NOT BE RESPONSIBLE FOR ANY MEDIATEK
 * SOFTWARE RELEASES MADE TO RECEIVER'S SPECIFICATION OR TO CONFORM TO A PARTICULAR
 * STANDARD OR OPEN FORUM. RECEIVER'S SOLE AND EXCLUSIVE REMEDY AND MEDIATEK'S ENTIRE AND
 * CUMULATIVE LIABILITY WITH RESPECT TO MEDIATEK SOFTWARE RELEASED HEREUNDER WILL BE,
 * AT MEDIATEK'S OPTION, TO REVISE OR REPLACE MEDIATEK SOFTWARE AT ISSUE,
 * OR REFUND ANY SOFTWARE LICENSE FEES OR SERVICE CHARGE PAID BY RECEIVER TO
 * MEDIATEK FOR SUCH MEDIATEK SOFTWARE AT ISSUE.
 */

#ifndef __CUST_BATTERY_METER_TABLE_H__
#define __CUST_BATTERY_METER_TABLE_H__

#include "battery_meter.h"

#ifdef __cplusplus
extern "C" {
#endif

#define  BATTERY_CAPACITY_LEVEL_5   80
#define  BATTERY_CAPACITY_LEVEL_4   60
#define  BATTERY_CAPACITY_LEVEL_3   45
#define  BATTERY_CAPACITY_LEVEL_2   30
#define  BATTERY_CAPACITY_LEVEL_1   10


/* T0 -10C */
const BATTERY_PROFILE_STRUC battery_profile_t0[51] = {
    {0    , 4204},
    {2    , 4177},
    {4    , 4156},
    {6    , 4142},
    {8    , 4124},
    {10   , 4106},
    {12   , 4094},
    {14   , 4071},
    {16   , 4058},
    {18   , 4048},
    {20   , 4027},
    {22   , 4016},
    {24   , 4000},
    {26   , 3985},
    {28   , 3975},
    {30   , 3960},
    {32   , 3946},
    {34   , 3932},
    {36   , 3919},
    {38   , 3910},
    {40   , 3896},
    {42   , 3884},
    {44   , 3878},
    {46   , 3863},
    {48   , 3856},
    {50   , 3849},
    {52   , 3836},
    {54   , 3829},
    {56   , 3821},
    {58   , 3813},
    {60   , 3808},
    {62   , 3801},
    {64   , 3792},
    {66   , 3786},
    {68   , 3779},
    {70   , 3775},
    {72   , 3769},
    {74   , 3763},
    {76   , 3758},
    {78   , 3753},
    {80   , 3747},
    {82   , 3742},
    {84   , 3734},
    {86   , 3730},
    {88   , 3722},
    {90   , 3717},
    {92   , 3712},
    {94   , 3707},
    {96   , 3699},
    {98   , 3694},
    {100  , 3687}
};

/* T1 0C */
const BATTERY_PROFILE_STRUC battery_profile_t1[51] = {
    {0    , 4178},
    {2    , 4167},
    {4    , 4149},
    {6    , 4137},
    {8    , 4126},
    {10   , 4111},
    {12   , 4100},
    {14   , 4089},
    {16   , 4076},
    {18   , 4023},
    {20   , 3988},
    {22   , 3967},
    {24   , 3948},
    {26   , 3935},
    {28   , 3924},
    {30   , 3912},
    {32   , 3898},
    {34   , 3888},
    {36   , 3879},
    {38   , 3868},
    {40   , 3862},
    {42   , 3857},
    {44   , 3851},
    {46   , 3844},
    {48   , 3837},
    {50   , 3832},
    {52   , 3827},
    {54   , 3819},
    {56   , 3815},
    {58   , 3811},
    {60   , 3806},
    {62   , 3798},
    {64   , 3793},
    {66   , 3788},
    {68   , 3778},
    {70   , 3772},
    {72   , 3763},
    {74   , 3753},
    {76   , 3743},
    {78   , 3734},
    {80   , 3719},
    {82   , 3711},
    {84   , 3704},
    {86   , 3701},
    {88   , 3695},
    {90   , 3691},
    {92   , 3682},
    {94   , 3654},
    {96   , 3613},
    {98   , 3547},
    {100  , 3449}
};

/* T2 25C */
const BATTERY_PROFILE_STRUC battery_profile_t2[51] = {
    {0    , 4179},
    {2    , 4155},
    {4    , 4135},
    {6    , 4111},
    {8    , 4100},
    {10   , 4077},
    {12   , 4066},
    {14   , 4045},
    {16   , 4036},
    {18   , 4017},
    {20   , 4003},
    {22   , 3989},
    {24   , 3977},
    {26   , 3965},
    {28   , 3953},
    {30   , 3941},
    {32   , 3930},
    {34   , 3919},
    {36   , 3903},
    {38   , 3895},
    {40   , 3874},
    {42   , 3862},
    {44   , 3847},
    {46   , 3839},
    {48   , 3830},
    {50   , 3821},
    {52   , 3815},
    {54   , 3807},
    {56   , 3804},
    {58   , 3798},
    {60   , 3794},
    {62   , 3788},
    {64   , 3787},
    {66   , 3781},
    {68   , 3779},
    {70   , 3771},
    {72   , 3767},
    {74   , 3759},
    {76   , 3752},
    {78   , 3746},
    {80   , 3737},
    {82   , 3726},
    {84   , 3714},
    {86   , 3699},
    {88   , 3685},
    {90   , 3682},
    {92   , 3678},
    {94   , 3672},
    {96   , 3626},
    {98   , 3538},
    {100  , 3403}
};

/* T3 50C  */
BATTERY_PROFILE_STRUC battery_profile_t3[] = {
    {0   , 4191},
    {2   , 4164},
    {4   , 4151},
    {6   , 4127},
    {8   , 4115},
    {10  , 4091},
    {12  , 4075},
    {14  , 4060},
    {16  , 4044},
    {18  , 4029},
    {20  , 4009},
    {22  , 4001},
    {24  , 3981},
    {26  , 3974},
    {28  , 3957},
    {30  , 3946},
    {32  , 3935},
    {34  , 3919},
    {36  , 3913},
    {38  , 3900},
    {40  , 3890},
    {42  , 3868},
    {44  , 3854},
    {46  , 3843},
    {48  , 3833},
    {50  , 3825},
    {52  , 3817},
    {54  , 3810},
    {56  , 3803},
    {58  , 3799},
    {60  , 3795},
    {62  , 3789},
    {64  , 3785},
    {66  , 3778},
    {68  , 3776},
    {70  , 3764},
    {72  , 3756},
    {74  , 3746},
    {76  , 3739},
    {78  , 3730},
    {80  , 3720},
    {82  , 3715},
    {84  , 3699},
    {86  , 3684},
    {88  , 3672},
    {90  , 3669},
    {92  , 3665},
    {94  , 3653},
    {96  , 3632},
    {98  , 3533},
    {100 , 3453}
};

/* battery profile for actual temperature. The size should be the same as T1, T2 and T3 */
BATTERY_PROFILE_STRUC battery_profile_temperature[51] = {
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 }
};

/*============================================================
* <Rbat, Battery_Voltage> Table
*============================================================ */
/* T0 -10C */
const R_PROFILE_STRUC r_profile_t0[51] = {
    {3556 , 4204},
    {3556 , 4177},
    {3568 , 4156},
    {3560 , 4142},
    {3566 , 4124},
    {3560 , 4106},
    {3560 , 4094},
    {3556 , 4071},
    {3548 , 4058},
    {3552 , 4048},
    {3548 , 4027},
    {3552 , 4016},
    {3542 , 4000},
    {3544 , 3985},
    {3540 , 3975},
    {3538 , 3960},
    {3532 , 3946},
    {3538 , 3932},
    {3540 , 3919},
    {3540 , 3910},
    {3538 , 3896},
    {3544 , 3884},
    {3552 , 3878},
    {3556 , 3863},
    {3556 , 3856},
    {3560 , 3849},
    {3568 , 3836},
    {3572 , 3829},
    {3578 , 3821},
    {3580 , 3813},
    {3592 , 3808},
    {3596 , 3801},
    {3600 , 3792},
    {3610 , 3786},
    {3612 , 3779},
    {3616 , 3775},
    {3628 , 3769},
    {3632 , 3763},
    {3632 , 3758},
    {3642 , 3753},
    {3656 , 3747},
    {3660 , 3742},
    {3676 , 3734},
    {3696 , 3730},
    {3692 , 3722},
    {3672 , 3717},
    {3652 , 3712},
    {3636 , 3707},
    {3608 , 3699},
    {3580 , 3694},
    {3564 , 3687}
};

/* T1 0C */
const R_PROFILE_STRUC r_profile_t1[51] = {
    {1924 , 4178},
    {1924 , 4167},
    {1924 , 4149},
    {1924 , 4137},
    {1924 , 4126},
    {1924 , 4111},
    {1924 , 4100},
    {1924 , 4089},
    {1924 , 4076},
    {1924 , 4023},
    {1924 , 3988},
    {1924 , 3967},
    {1924 , 3948},
    {1924 , 3935},
    {1924 , 3924},
    {1924 , 3912},
    {1924 , 3898},
    {1924 , 3888},
    {1924 , 3879},
    {1924 , 3868},
    {1924 , 3862},
    {1924 , 3857},
    {1924 , 3851},
    {1900 , 3844},
    {1922 , 3837},
    {1916 , 3832},
    {1930 , 3827},
    {1916 , 3819},
    {1960 , 3815},
    {1936 , 3811},
    {1960 , 3806},
    {1958 , 3798},
    {1968 , 3793},
    {1974 , 3788},
    {1964 , 3778},
    {1956 , 3772},
    {1984 , 3763},
    {1970 , 3753},
    {1970 , 3743},
    {1976 , 3734},
    {1964 , 3719},
    {2000 , 3711},
    {1980 , 3704},
    {2028 , 3701},
    {2030 , 3695},
    {2060 , 3691},
    {2080 , 3682},
    {2088 , 3654},
    {2128 , 3613},
    {2136 , 3547},
    {2240 , 3449}
};

/* T2 25C */
const R_PROFILE_STRUC r_profile_t2[51] = {
    {548 , 4179},
    {556 , 4155},
    {568 , 4135},
    {580 , 4111},
    {604 , 4100},
    {612 , 4077},
    {608 , 4066},
    {620 , 4045},
    {628 , 4036},
    {628 , 4017},
    {632 , 4003},
    {632 , 3989},
    {632 , 3977},
    {652 , 3965},
    {646 , 3953},
    {652 , 3941},
    {652 , 3930},
    {664 , 3919},
    {660 , 3903},
    {660 , 3895},
    {640 , 3874},
    {624 , 3862},
    {620 , 3847},
    {608 , 3839},
    {624 , 3830},
    {612 , 3821},
    {616 , 3815},
    {624 , 3807},
    {636 , 3804},
    {644 , 3798},
    {640 , 3794},
    {644 , 3788},
    {656 , 3787},
    {644 , 3781},
    {648 , 3779},
    {628 , 3771},
    {634 , 3767},
    {628 , 3759},
    {620 , 3752},
    {628 , 3746},
    {620 , 3737},
    {616 , 3726},
    {620 , 3714},
    {624 , 3699},
    {620 , 3685},
    {620 , 3682},
    {648 , 3678},
    {664 , 3672},
    {680 , 3626},
    {744 , 3538},
    {872 , 3403}
};

/* T3 50C */
const R_PROFILE_STRUC r_profile_t3[51] = {
    {244 , 4191},
    {252 , 4164},
    {252 , 4151},
    {252 , 4127},
    {256 , 4115},
    {252 , 4091},
    {254 , 4075},
    {264 , 4060},
    {262 , 4044},
    {260 , 4029},
    {268 , 4009},
    {272 , 4001},
    {264 , 3981},
    {272 , 3974},
    {272 , 3957},
    {280 , 3946},
    {288 , 3935},
    {284 , 3919},
    {292 , 3913},
    {296 , 3900},
    {284 , 3890},
    {264 , 3868},
    {254 , 3854},
    {248 , 3843},
    {248 , 3833},
    {244 , 3825},
    {252 , 3817},
    {250 , 3810},
    {248 , 3803},
    {256 , 3799},
    {260 , 3795},
    {258 , 3789},
    {264 , 3785},
    {264 , 3778},
    {264 , 3776},
    {248 , 3764},
    {248 , 3756},
    {248 , 3746},
    {252 , 3739},
    {248 , 3730},
    {248 , 3720},
    {252 , 3715},
    {248 , 3699},
    {244 , 3684},
    {240 , 3672},
    {246 , 3669},
    {260 , 3665},
    {280 , 3653},
    {288 , 3632},
    {308 , 3533},
    {324 , 3453}
};

/* r-table profile for actual temperature. The size should be the same as T1, T2 and T3 */
R_PROFILE_STRUC r_profile_temperature[51] = {
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 },
    {0  , 0 }
};

#ifdef __cplusplus
}
#endif

#endif /*__CUST_BATTERY_METER_TABLE_H__*/

