/* Copyright Statement:
 *
 * (C) 2005-2016  MediaTek Inc. All rights reserved.
 *
 * This software/firmware and related documentation ("MediaTek Software") are
 * protected under relevant copyright laws. The information contained herein
 * is confidential and proprietary to MediaTek Inc. ("MediaTek") and/or its licensors.
 * Without the prior written permission of MediaTek and/or its licensors,
 * any reproduction, modification, use or disclosure of MediaTek Software,
 * and information contained herein, in whole or in part, shall be strictly prohibited.
 * You may only use, reproduce, modify, or distribute (as applicable) MediaTek Software
 * if you have agreed to and been bound by the applicable license agreement with
 * MediaTek ("License Agreement") and been granted explicit permission to do so within
 * the License Agreement ("Permitted User").  If you are not a Permitted User,
 * please cease any access or use of MediaTek Software immediately.
 * BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES
 * THAT MEDIATEK SOFTWARE RECEIVED FROM MEDIATEK AND/OR ITS REPRESENTATIVES
 * ARE PROVIDED TO RECEIVER ON AN "AS-IS" BASIS ONLY. MEDIATEK EXPRESSLY DISCLAIMS ANY AND ALL
 * WARRANTIES, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR NONINFRINGEMENT.
 * NEITHER DOES MEDIATEK PROVIDE ANY WARRANTY WHATSOEVER WITH RESPECT TO THE
 * SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY, INCORPORATED IN, OR
 * SUPPLIED WITH MEDIATEK SOFTWARE, AND RECEIVER AGREES TO LOOK ONLY TO SUCH
 * THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO. RECEIVER EXPRESSLY ACKNOWLEDGES
 * THAT IT IS RECEIVER'S SOLE RESPONSIBILITY TO OBTAIN FROM ANY THIRD PARTY ALL PROPER LICENSES
 * CONTAINED IN MEDIATEK SOFTWARE. MEDIATEK SHALL ALSO NOT BE RESPONSIBLE FOR ANY MEDIATEK
 * SOFTWARE RELEASES MADE TO RECEIVER'S SPECIFICATION OR TO CONFORM TO A PARTICULAR
 * STANDARD OR OPEN FORUM. RECEIVER'S SOLE AND EXCLUSIVE REMEDY AND MEDIATEK'S ENTIRE AND
 * CUMULATIVE LIABILITY WITH RESPECT TO MEDIATEK SOFTWARE RELEASED HEREUNDER WILL BE,
 * AT MEDIATEK'S OPTION, TO REVISE OR REPLACE MEDIATEK SOFTWARE AT ISSUE,
 * OR REFUND ANY SOFTWARE LICENSE FEES OR SERVICE CHARGE PAID BY RECEIVER TO
 * MEDIATEK FOR SUCH MEDIATEK SOFTWARE AT ISSUE.
 */

#ifndef __HAL_MT2523_PMU_PLATFORM_H__
#define __HAL_MT2523_PMU_PLATFORM_H__
//PMU E2 Address define

#define PMU_REG_BASE (0x0000)

#define PMU_HWCID0               ((PMU_REG_BASE+0x0000))
#define PMU_HWCID1               ((PMU_REG_BASE+0x0001))
#define PMU_SWCID0               ((PMU_REG_BASE+0x0002))
#define PMU_SWCID1               ((PMU_REG_BASE+0x0003))
#define PMU_TOPSTS               ((PMU_REG_BASE+0x0004))
#define PMU_IOCFG0               ((PMU_REG_BASE+0x0005))
#define PMU_IOCFG1               ((PMU_REG_BASE+0x0006))
#define PMU_IOCFG2               ((PMU_REG_BASE+0x0007))
#define PMU_IOCFG3               ((PMU_REG_BASE+0x0008))
#define PMU_IOCFG4               ((PMU_REG_BASE+0x0009))
#define PMU_IOCFG5               ((PMU_REG_BASE+0x000A))
#define PMU_IOCFG7               ((PMU_REG_BASE+0x000B))
#define PMU_IOCFG8               ((PMU_REG_BASE+0x000C))
#define PMU_IOCFG9               ((PMU_REG_BASE+0x000D))
#define PMU_IOCFG10              ((PMU_REG_BASE+0x000E))
#define PMU_IOCFG11              ((PMU_REG_BASE+0x000F))
#define PMU_IOCFG12              ((PMU_REG_BASE+0x0010))
#define PMU_CKCFG0               ((PMU_REG_BASE+0x0011))
#define PMU_CKCFG1               ((PMU_REG_BASE+0x0012))
#define PMU_CKCFG2               ((PMU_REG_BASE+0x0013))
#define PMU_CKCFG3               ((PMU_REG_BASE+0x0014))
#define PMU_CKCFG4               ((PMU_REG_BASE+0x0015))
#define PMU_CKCFG5               ((PMU_REG_BASE+0x0016))
#define PMU_CKCFG6               ((PMU_REG_BASE+0x0017))
#define PMU_CKCFG7               ((PMU_REG_BASE+0x0018))
#define PMU_I2C_OUT_TYPE         ((PMU_REG_BASE+0x0019))
#define PMU_RSTCFG0              ((PMU_REG_BASE+0x001A))
#define PMU_RSTCFG1              ((PMU_REG_BASE+0x001B))
#define PMU_RSTCFG2              ((PMU_REG_BASE+0x001C))
#define PMU_RSTCFG3              ((PMU_REG_BASE+0x001D))
#define PMU_INTSTS0              ((PMU_REG_BASE+0x001E))
#define PMU_INTSTS1              ((PMU_REG_BASE+0x001F))
#define PMU_INTSTS2              ((PMU_REG_BASE+0x0020))
#define PMU_INTSTS3              ((PMU_REG_BASE+0x0021))
#define PMU_INTSTS4              ((PMU_REG_BASE+0x0022))
#define PMU_INTSTS5              ((PMU_REG_BASE+0x0023))
#define PMU_INTSTS6              ((PMU_REG_BASE+0x0024))
#define PMU_INTEN0               ((PMU_REG_BASE+0x0025))
#define PMU_INTEN1               ((PMU_REG_BASE+0x0026))
#define PMU_INTEN2               ((PMU_REG_BASE+0x0027))
#define PMU_INTEN3               ((PMU_REG_BASE+0x0028))
#define PMU_INTEN4               ((PMU_REG_BASE+0x0029))
#define PMU_INTEN5               ((PMU_REG_BASE+0x002A))
#define PMU_INTEN6               ((PMU_REG_BASE+0x002B))
#define PMU_INTMISC              ((PMU_REG_BASE+0x002C))
#define PMU_PONSTS               ((PMU_REG_BASE+0x002D))
#define PMU_POFFSTS              ((PMU_REG_BASE+0x002E))
#define PMU_PDNSTS0              ((PMU_REG_BASE+0x002F))
#define PMU_PDNSTS1              ((PMU_REG_BASE+0x0030))
#define PMU_PDNSTS2              ((PMU_REG_BASE+0x0031))
#define PMU_PSSTS0               ((PMU_REG_BASE+0x0032))
#define PMU_PSSTS1               ((PMU_REG_BASE+0x0033))
#define PMU_PSSTS2               ((PMU_REG_BASE+0x0034))
#define PMU_PSOCSTS0             ((PMU_REG_BASE+0x0035))
#define PMU_PSOCSTS1             ((PMU_REG_BASE+0x0036))
#define PMU_PSPGSTS0             ((PMU_REG_BASE+0x0037))
#define PMU_PSPGSTS1             ((PMU_REG_BASE+0x0038))
#define PMU_PSOMSTS0             ((PMU_REG_BASE+0x0039))
#define PMU_PSOMSTS1             ((PMU_REG_BASE+0x003A))
#define PMU_PSOMSTS2             ((PMU_REG_BASE+0x003B))
#define PMU_THMSTS               ((PMU_REG_BASE+0x003C))
#define PMU_WKFG_STS             ((PMU_REG_BASE+0x003D))
#define PMU_PSICKEY0             ((PMU_REG_BASE+0x003E))
#define PMU_PSICKEY1             ((PMU_REG_BASE+0x003F))
#define PMU_PSICTL               ((PMU_REG_BASE+0x0040))
#define PMU_PSISTS               ((PMU_REG_BASE+0x0041))
#define PMU_BIASPSI              ((PMU_REG_BASE+0x0042))
#define PMU_VDIG18PSI            ((PMU_REG_BASE+0x0043))
#define PMU_PPCPSI               ((PMU_REG_BASE+0x0044))
#define PMU_STRUPCTL0            ((PMU_REG_BASE+0x0045))
#define PMU_STRUPCTL1            ((PMU_REG_BASE+0x0046))
#define PMU_STRUPCTL2            ((PMU_REG_BASE+0x0047))
#define PMU_PPCCFG0              ((PMU_REG_BASE+0x0048))
#define PMU_PPCCFG1              ((PMU_REG_BASE+0x0049))
#define PMU_PPCCFG2              ((PMU_REG_BASE+0x004A))
#define PMU_PPCCTL0              ((PMU_REG_BASE+0x004B))
#define PMU_SHDNCFG0             ((PMU_REG_BASE+0x004C))
#define PMU_SHDNCFG1             ((PMU_REG_BASE+0x004D))
#define PMU_SHDNCFG2             ((PMU_REG_BASE+0x004E))
#define PMU_SHDNCFG3             ((PMU_REG_BASE+0x004F))
#define PMU_DEBCTL0              ((PMU_REG_BASE+0x0050))
#define PMU_DEBCTL1              ((PMU_REG_BASE+0x0051))
#define PMU_DEBCTL2              ((PMU_REG_BASE+0x0052))
#define PMU_DEBCTL3              ((PMU_REG_BASE+0x0053))
#define PMU_DEBCTL4              ((PMU_REG_BASE+0x0054))
#define PMU_DEBCTL5              ((PMU_REG_BASE+0x0055))
#define PMU_DEBCTL6              ((PMU_REG_BASE+0x0056))
#define PMU_DEBCTL7              ((PMU_REG_BASE+0x0057))
#define PMU_CPSWKEY0             ((PMU_REG_BASE+0x0058))
#define PMU_CPSWKEY1             ((PMU_REG_BASE+0x0059))
#define PMU_CPSCFG0              ((PMU_REG_BASE+0x005A))
#define PMU_LBATPSA0             ((PMU_REG_BASE+0x005B))
#define PMU_LBATPSA1             ((PMU_REG_BASE+0x005C))
#define PMU_LBATPSA2             ((PMU_REG_BASE+0x005D))
#define PMU_LBATPSA3             ((PMU_REG_BASE+0x005E))
#define PMU_LBATPSA4             ((PMU_REG_BASE+0x005F))
#define PMU_LBATPSA5             ((PMU_REG_BASE+0x0060))
#define PMU_CPSCFG1              ((PMU_REG_BASE+0x0061))
#define PMU_CBATPSA0             ((PMU_REG_BASE+0x0062))
#define PMU_CBATPSA1             ((PMU_REG_BASE+0x0063))
#define PMU_CBATPSA2             ((PMU_REG_BASE+0x0064))
#define PMU_CBATPSA3             ((PMU_REG_BASE+0x0065))
#define PMU_CBATPSA4             ((PMU_REG_BASE+0x0066))
#define PMU_CBATPSA5             ((PMU_REG_BASE+0x0067))
#define PMU_CPSCFG2              ((PMU_REG_BASE+0x0068))
#define PMU_LBATDSA0             ((PMU_REG_BASE+0x0069))
#define PMU_LBATDSA1             ((PMU_REG_BASE+0x006A))
#define PMU_LBATDSA2             ((PMU_REG_BASE+0x006B))
#define PMU_LBATDSA3             ((PMU_REG_BASE+0x006C))
#define PMU_LBATDSA4             ((PMU_REG_BASE+0x006D))
#define PMU_LBATDSA5             ((PMU_REG_BASE+0x006E))
#define PMU_CBATDSA0             ((PMU_REG_BASE+0x006F))
#define PMU_CBATDSA1             ((PMU_REG_BASE+0x0070))
#define PMU_CBATDSA2             ((PMU_REG_BASE+0x0071))
#define PMU_CBATDSA3             ((PMU_REG_BASE+0x0072))
#define PMU_CBATDSA4             ((PMU_REG_BASE+0x0073))
#define PMU_CBATDSA5             ((PMU_REG_BASE+0x0074))
#define PMU_CPSCFG3              ((PMU_REG_BASE+0x0075))
#define PMU_CPSWS0A0             ((PMU_REG_BASE+0x0076))
#define PMU_CPSWS0A1             ((PMU_REG_BASE+0x0077))
#define PMU_CPSWS0A2             ((PMU_REG_BASE+0x0078))
#define PMU_CPSWS0A3             ((PMU_REG_BASE+0x0079))
#define PMU_CPSWS0A4             ((PMU_REG_BASE+0x007A))
#define PMU_CPSWS1A0             ((PMU_REG_BASE+0x007B))
#define PMU_CPSWS1A1             ((PMU_REG_BASE+0x007C))
#define PMU_CPSWS1A2             ((PMU_REG_BASE+0x007D))
#define PMU_CPSWS1A3             ((PMU_REG_BASE+0x007E))
#define PMU_CPSWS1A4             ((PMU_REG_BASE+0x007F))
#define PMU_PPCTST0              ((PMU_REG_BASE+0x0080))
#define PMU_PPCMTCTL0            ((PMU_REG_BASE+0x0081))
#define PMU_PPCMTCTL1            ((PMU_REG_BASE+0x0082))
#define PMU_PPCMTCTL2            ((PMU_REG_BASE+0x0083))
#define PMU_PPCMTCST             ((PMU_REG_BASE+0x0084))
#define PMU_PSEQ_RSV0            ((PMU_REG_BASE+0x0085))
#define PMU_PSEQ_RSV1            ((PMU_REG_BASE+0x0086))
#define PMU_CHR_CON0             ((PMU_REG_BASE+0x0087))
#define PMU_CHR_CON1             ((PMU_REG_BASE+0x0088))
#define PMU_CHR_CON2             ((PMU_REG_BASE+0x0089))
#define PMU_CHR_CON3             ((PMU_REG_BASE+0x008A))
#define PMU_CHR_CON4             ((PMU_REG_BASE+0x008B))
#define PMU_CHR_CON5             ((PMU_REG_BASE+0x008C))
#define PMU_CHR_CON6             ((PMU_REG_BASE+0x008D))
#define PMU_CHR_CON7             ((PMU_REG_BASE+0x008E))
#define PMU_CHR_CON8             ((PMU_REG_BASE+0x0090))
#define PMU_CHR_CON8_H           ((PMU_REG_BASE+0x0091))
#define PMU_CHR_CON9             ((PMU_REG_BASE+0x0092))
#define PMU_CHR_CON10            ((PMU_REG_BASE+0x0093))
#define PMU_CHR_CON11            ((PMU_REG_BASE+0x0094))
#define PMU_CHR_CON12            ((PMU_REG_BASE+0x0095))
#define PMU_CHR_CON13            ((PMU_REG_BASE+0x0096))
#define PMU_CHR_CON13_H          ((PMU_REG_BASE+0x0097))
#define PMU_CHR_CON14            ((PMU_REG_BASE+0x0098))
#define PMU_CHR_CON15            ((PMU_REG_BASE+0x0099))
#define PMU_CHR_CON16            ((PMU_REG_BASE+0x009A))
#define PMU_CHR_CON16_H          ((PMU_REG_BASE+0x009B))
#define PMU_CHR_CON17            ((PMU_REG_BASE+0x009C))
#define PMU_CHR_CON18            ((PMU_REG_BASE+0x009D))
#define PMU_CHR_CON19            ((PMU_REG_BASE+0x009E))
#define PMU_CHR_CON20            ((PMU_REG_BASE+0x009F))
#define PMU_CHR_CON21            ((PMU_REG_BASE+0x00A0))
#define PMU_CHR_CON21_H          ((PMU_REG_BASE+0x00A1))
#define PMU_CHR_CON22            ((PMU_REG_BASE+0x00A2))
#define PMU_CHR_CON23            ((PMU_REG_BASE+0x00A3))
#define PMU_CHR_CON24            ((PMU_REG_BASE+0x00A4))
#define PMU_CHR_CON25            ((PMU_REG_BASE+0x00A5))
#define PMU_CHR_CON26            ((PMU_REG_BASE+0x00A6))
#define PMU_CHR_CON27            ((PMU_REG_BASE+0x00A7))
#define PMU_CHR_CON28            ((PMU_REG_BASE+0x00A8))
#define PMU_CHR_CON29            ((PMU_REG_BASE+0x00A9))
#define PMU_CHR_CON30            ((PMU_REG_BASE+0x00AA))
#define PMU_CHR_CON30_H          ((PMU_REG_BASE+0x00AB))
#define PMU_CHR_CON41            ((PMU_REG_BASE+0x00AC))
#define PMU_CHR_CON42            ((PMU_REG_BASE+0x00AD))
#define PMU_BATON_CON0           ((PMU_REG_BASE+0x00AE))
#define PMU_BATON_CON0_H         ((PMU_REG_BASE+0x00AF))
#define PMU_CHR_CON44            ((PMU_REG_BASE+0x00B0))
#define PMU_CHR_CON45            ((PMU_REG_BASE+0x00B1))
#define PMU_CHR_CON45_H          ((PMU_REG_BASE+0x00B2))
#define PMU_CHR_CON46            ((PMU_REG_BASE+0x00B3))
#define PMU_CHR_CON46_H          ((PMU_REG_BASE+0x00B4))
#define PMU_CHR_CON47            ((PMU_REG_BASE+0x00B5))
#define PMU_CHR_CON48            ((PMU_REG_BASE+0x00B7))
#define PMU_CHR_CON49            ((PMU_REG_BASE+0x00B8))
#define PMU_CHR_CON51            ((PMU_REG_BASE+0x00B9))
#define PMU_CHR_CON52            ((PMU_REG_BASE+0x00BA))
#define PMU_CHR_CON53            ((PMU_REG_BASE+0x00BB))
#define PMU_CHR_CON54            ((PMU_REG_BASE+0x00BC))
#define PMU_CHR_CON55            ((PMU_REG_BASE+0x00BD))
#define PMU_CHR_CON56            ((PMU_REG_BASE+0x00BE))
#define PMU_OTP_CON0             ((PMU_REG_BASE+0x00BF))
#define PMU_OTP_CON1             ((PMU_REG_BASE+0x00C0))
#define PMU_OTP_CON2             ((PMU_REG_BASE+0x00C1))
#define PMU_OTP_CON3             ((PMU_REG_BASE+0x00C2))
#define PMU_OTP_CON4             ((PMU_REG_BASE+0x00C3))
#define PMU_OTP_CON5             ((PMU_REG_BASE+0x00C4))
#define PMU_OTP_CON6             ((PMU_REG_BASE+0x00C5))
#define PMU_OTP_CON7             ((PMU_REG_BASE+0x00C6))
#define PMU_OTP_CON8             ((PMU_REG_BASE+0x00C7))
#define PMU_OTP_CON9             ((PMU_REG_BASE+0x00C8))
#define PMU_OTP_CON10            ((PMU_REG_BASE+0x00C9))
#define PMU_OTP_CON11            ((PMU_REG_BASE+0x00CA))
#define PMU_OTP_CON12            ((PMU_REG_BASE+0x00CB))
#define PMU_OTP_CON13            ((PMU_REG_BASE+0x00CC))
#define PMU_OTP_CON14            ((PMU_REG_BASE+0x00CD))
#define PMU_OTP_CON15            ((PMU_REG_BASE+0x00CE))
#define PMU_OTP_CON16            ((PMU_REG_BASE+0x00CF))
#define PMU_OTP_CON17            ((PMU_REG_BASE+0x00D0))
#define PMU_RTC_SPAR_CON0        ((PMU_REG_BASE+0x00D1))
#define PMU_RTC_MISC_CON0        ((PMU_REG_BASE+0x00D2))
#define PMU_RTC_MISC_DBG0        ((PMU_REG_BASE+0x00D3))
#define PMU_RTC_MISC_SPARE0      ((PMU_REG_BASE+0x00D4))
#define PMU_RTC_MISC_SPARE1      ((PMU_REG_BASE+0x00D5))
#define PMU_RTC_MISC_SPARE2      ((PMU_REG_BASE+0x00D6))
#define PMU_RTC_MISC_SPARE3      ((PMU_REG_BASE+0x00D7))
#define PMU_TOP_CLK_TRIM_L       ((PMU_REG_BASE+0x00D8))
#define PMU_TOP_CLK_TRIM_H       ((PMU_REG_BASE+0x00D9))
#define PMU_VA18CTL0             ((PMU_REG_BASE+0x00DA))
#define PMU_VA18CTL1             ((PMU_REG_BASE+0x00DB))
#define PMU_VA18LDO0             ((PMU_REG_BASE+0x00DC))
#define PMU_VA18LDO1             ((PMU_REG_BASE+0x00DD))
#define PMU_VA18LDO2             ((PMU_REG_BASE+0x00DE))
#define PMU_VA18LDO3             ((PMU_REG_BASE+0x00DF))
#define PMU_VA18LDOBF0           ((PMU_REG_BASE+0x00E0))
#define PMU_VA18LDOBF1           ((PMU_REG_BASE+0x00E1))
#define PMU_VA18PSI0             ((PMU_REG_BASE+0x00E2))
#define PMU_VA18PSI1             ((PMU_REG_BASE+0x00E3))
#define PMU_VBTCTL0              ((PMU_REG_BASE+0x00E4))
#define PMU_VACTL0               ((PMU_REG_BASE+0x00E5))
#define PMU_VCLDOCTL0            ((PMU_REG_BASE+0x00E6))
#define PMU_VCLDOCTL1            ((PMU_REG_BASE+0x00E7))
#define PMU_PSWCTL1              ((PMU_REG_BASE+0x00E8))
#define PMU_VIO18CTL0            ((PMU_REG_BASE+0x00E9))
#define PMU_VSFCTL0              ((PMU_REG_BASE+0x00EA))
#define PMU_VIO28CTL0            ((PMU_REG_BASE+0x00EB))
#define PMU_VMCCTL0              ((PMU_REG_BASE+0x00EC))
#define PMU_VUSBCTL0             ((PMU_REG_BASE+0x00ED))
#define PMU_VUSBCTL1             ((PMU_REG_BASE+0x00EE))
#define PMU_VUSBLDO0             ((PMU_REG_BASE+0x00EF))
#define PMU_VUSBLDO1             ((PMU_REG_BASE+0x00F0))
#define PMU_VUSBLDO2             ((PMU_REG_BASE+0x00F1))
#define PMU_VUSBLDO3             ((PMU_REG_BASE+0x00F2))
#define PMU_VUSBLDOBF0           ((PMU_REG_BASE+0x00F3))
#define PMU_VUSBLDOBF1           ((PMU_REG_BASE+0x00F4))
#define PMU_VUSBPSI0             ((PMU_REG_BASE+0x00F5))
#define PMU_VUSBPSI1             ((PMU_REG_BASE+0x00F6))
#define PMU_VDIG18LDO0           ((PMU_REG_BASE+0x00F7))
#define PMU_VDIG18LDO1           ((PMU_REG_BASE+0x00F8))
#define PMU_VDIG18LDO2           ((PMU_REG_BASE+0x00F9))
#define PMU_VDIG18LDO3           ((PMU_REG_BASE+0x00FA))
#define PMU_VDIG18LDOBF0         ((PMU_REG_BASE+0x00FB))
#define PMU_VDIG18LDOBF1         ((PMU_REG_BASE+0x00FC))
#define PMU_VCLDO0               ((PMU_REG_BASE+0x00FD))
#define PMU_VCLDO1               ((PMU_REG_BASE+0x00FE))
#define PMU_VCLDO2               ((PMU_REG_BASE+0x00FF))
#define PMU_VCLDO3               ((PMU_REG_BASE+0x0100))
#define PMU_VCLDOBF0             ((PMU_REG_BASE+0x0101))
#define PMU_VCLDOBF1             ((PMU_REG_BASE+0x0102))
#define PMU_VCLDOPSI0            ((PMU_REG_BASE+0x0103))
#define PMU_VCLDOPSI1            ((PMU_REG_BASE+0x0104))
#define PMU_VCLDOPSI2            ((PMU_REG_BASE+0x0105))
#define PMU_VCLDOPSI3            ((PMU_REG_BASE+0x0106))
#define PMU_VCLDOPSI4            ((PMU_REG_BASE+0x0107))
#define PMU_VCLDOPSI5            ((PMU_REG_BASE+0x0108))
#define PMU_VIO18CTL1            ((PMU_REG_BASE+0x0109))
#define PMU_VIO18LDO0            ((PMU_REG_BASE+0x010A))
#define PMU_VIO18LDO1            ((PMU_REG_BASE+0x010B))
#define PMU_VIO18LDO2            ((PMU_REG_BASE+0x010C))
#define PMU_VIO18LDO3            ((PMU_REG_BASE+0x010D))
#define PMU_VIO18LDOBF0          ((PMU_REG_BASE+0x010E))
#define PMU_VIO18LDOBF1          ((PMU_REG_BASE+0x010F))
#define PMU_VIO18PSI0            ((PMU_REG_BASE+0x0110))
#define PMU_VIO18PSI1            ((PMU_REG_BASE+0x0111))
#define PMU_VSFCTL1              ((PMU_REG_BASE+0x0112))
#define PMU_VSFLDO0              ((PMU_REG_BASE+0x0113))
#define PMU_VSFLDO1              ((PMU_REG_BASE+0x0114))
#define PMU_VSFLDO2              ((PMU_REG_BASE+0x0115))
#define PMU_VSFLDO3              ((PMU_REG_BASE+0x0116))
#define PMU_VSFLDOBF0            ((PMU_REG_BASE+0x0117))
#define PMU_VSFLDOBF1            ((PMU_REG_BASE+0x0118))
#define PMU_VSFPSI0              ((PMU_REG_BASE+0x0119))
#define PMU_VSFPSI1              ((PMU_REG_BASE+0x011A))
#define PMU_BATPSW0              ((PMU_REG_BASE+0x011B))
#define PMU_SMPSCTL0             ((PMU_REG_BASE+0x011C))
#define PMU_SMPSCTL1             ((PMU_REG_BASE+0x011D))
#define PMU_SMPSANA0             ((PMU_REG_BASE+0x011E))
#define PMU_SMPSANA1             ((PMU_REG_BASE+0x011F))
#define PMU_SMPSANA2             ((PMU_REG_BASE+0x0120))
#define PMU_SMPSANA3             ((PMU_REG_BASE+0x0121))
#define PMU_VCBUCK0              ((PMU_REG_BASE+0x0122))
#define PMU_VCBUCK1              ((PMU_REG_BASE+0x0123))
#define PMU_VCBUCK2              ((PMU_REG_BASE+0x0124))
#define PMU_VCBUCK3              ((PMU_REG_BASE+0x0125))
#define PMU_VCBUCK4              ((PMU_REG_BASE+0x0126))
#define PMU_VCBUCK5              ((PMU_REG_BASE+0x0127))
#define PMU_VCBUCK6              ((PMU_REG_BASE+0x0128))
#define PMU_VCBUCK7              ((PMU_REG_BASE+0x0129))
#define PMU_VCBUCK8              ((PMU_REG_BASE+0x012A))
#define PMU_VCBUCK9              ((PMU_REG_BASE+0x012B))
#define PMU_VCBUCK10             ((PMU_REG_BASE+0x012C))
#define PMU_VCBUCK11             ((PMU_REG_BASE+0x012D))
#define PMU_VCBUCK12             ((PMU_REG_BASE+0x012E))
#define PMU_VCBUCK13             ((PMU_REG_BASE+0x012F))
#define PMU_VCBUCK14             ((PMU_REG_BASE+0x0130))
#define PMU_VCBUCK15             ((PMU_REG_BASE+0x0131))
#define PMU_VCBUCK16             ((PMU_REG_BASE+0x0132))
#define PMU_VCBUCK17             ((PMU_REG_BASE+0x0133))
#define PMU_VCBUCK18             ((PMU_REG_BASE+0x0134))
#define PMU_VCBUCK19             ((PMU_REG_BASE+0x0135))
#define PMU_VCBUCK_KCON0         ((PMU_REG_BASE+0x0136))
#define PMU_VCBUCK_KCON1         ((PMU_REG_BASE+0x0137))
#define PMU_VCBUCK_KCON2         ((PMU_REG_BASE+0x0138))
#define PMU_VCBUCK_KCON3         ((PMU_REG_BASE+0x0139))
#define PMU_VCBUCK_KCON4         ((PMU_REG_BASE+0x013A))
#define PMU_VCBUCK_KCON5         ((PMU_REG_BASE+0x013B))
#define PMU_VCBUCKCTL0           ((PMU_REG_BASE+0x013C))
#define PMU_VCBUCKCTL1           ((PMU_REG_BASE+0x013D))
#define PMU_VCBUCKPSI0           ((PMU_REG_BASE+0x013E))
#define PMU_VCBUCKPSI1           ((PMU_REG_BASE+0x013F))
#define PMU_VCBUCKPSI2           ((PMU_REG_BASE+0x0140))
#define PMU_AUXADC_ADC0          ((PMU_REG_BASE+0x0200))
#define PMU_AUXADC_ADC0_H        ((PMU_REG_BASE+0x0201))
#define PMU_AUXADC_ADC1          ((PMU_REG_BASE+0x0202))
#define PMU_AUXADC_ADC1_H        ((PMU_REG_BASE+0x0203))
#define PMU_AUXADC_ADC2          ((PMU_REG_BASE+0x0204))
#define PMU_AUXADC_ADC2_H        ((PMU_REG_BASE+0x0205))
#define PMU_AUXADC_ADC3          ((PMU_REG_BASE+0x0206))
#define PMU_AUXADC_ADC3_H        ((PMU_REG_BASE+0x0207))
#define PMU_AUXADC_ADC4          ((PMU_REG_BASE+0x0208))
#define PMU_AUXADC_ADC4_H        ((PMU_REG_BASE+0x0209))
#define PMU_AUXADC_ADC5          ((PMU_REG_BASE+0x020A))
#define PMU_AUXADC_ADC5_H        ((PMU_REG_BASE+0x020B))
#define PMU_AUXADC_ADC6          ((PMU_REG_BASE+0x020C))
#define PMU_AUXADC_ADC6_H        ((PMU_REG_BASE+0x020D))
#define PMU_AUXADC_ADC7          ((PMU_REG_BASE+0x020E))
#define PMU_AUXADC_ADC7_H        ((PMU_REG_BASE+0x020F))
#define PMU_AUXADC_ADC8          ((PMU_REG_BASE+0x0210))
#define PMU_AUXADC_ADC8_H        ((PMU_REG_BASE+0x0211))
#define PMU_AUXADC_ADC9          ((PMU_REG_BASE+0x0212))
#define PMU_AUXADC_ADC9_H        ((PMU_REG_BASE+0x0213))
#define PMU_AUXADC_ADC10         ((PMU_REG_BASE+0x0214))
#define PMU_AUXADC_ADC10_H       ((PMU_REG_BASE+0x0215))
#define PMU_AUXADC_ADC11         ((PMU_REG_BASE+0x0216))
#define PMU_AUXADC_ADC11_H       ((PMU_REG_BASE+0x0217))
#define PMU_AUXADC_ADC12         ((PMU_REG_BASE+0x0218))
#define PMU_AUXADC_ADC12_H       ((PMU_REG_BASE+0x0219))
#define PMU_AUXADC_ADC13         ((PMU_REG_BASE+0x021A))
#define PMU_AUXADC_ADC13_H       ((PMU_REG_BASE+0x021B))
#define PMU_AUXADC_ADC14         ((PMU_REG_BASE+0x021C))
#define PMU_AUXADC_ADC14_H       ((PMU_REG_BASE+0x021D))
#define PMU_AUXADC_ADC15         ((PMU_REG_BASE+0x021E))
#define PMU_AUXADC_ADC15_H       ((PMU_REG_BASE+0x021F))
#define PMU_AUXADC_ADC16         ((PMU_REG_BASE+0x0220))
#define PMU_AUXADC_ADC16_H       ((PMU_REG_BASE+0x0221))
#define PMU_AUXADC_ADC17         ((PMU_REG_BASE+0x0222))
#define PMU_AUXADC_ADC17_H       ((PMU_REG_BASE+0x0223))
#define PMU_AUXADC_ADC18         ((PMU_REG_BASE+0x0224))
#define PMU_AUXADC_ADC18_H       ((PMU_REG_BASE+0x0225))
#define PMU_AUXADC_ADC19         ((PMU_REG_BASE+0x0226))
#define PMU_AUXADC_ADC19_H       ((PMU_REG_BASE+0x0227))
#define PMU_AUXADC_ADC20         ((PMU_REG_BASE+0x0228))
#define PMU_AUXADC_ADC20_H       ((PMU_REG_BASE+0x0229))
#define PMU_AUXADC_ADC21         ((PMU_REG_BASE+0x022A))
#define PMU_AUXADC_ADC21_H       ((PMU_REG_BASE+0x022B))
#define PMU_AUXADC_ADC22         ((PMU_REG_BASE+0x022C))
#define PMU_AUXADC_ADC22_H       ((PMU_REG_BASE+0x022D))
#define PMU_AUXADC_ADC23         ((PMU_REG_BASE+0x022E))
#define PMU_AUXADC_ADC23_H       ((PMU_REG_BASE+0x022F))
#define PMU_AUXADC_ADC24         ((PMU_REG_BASE+0x0230))
#define PMU_AUXADC_ADC24_H       ((PMU_REG_BASE+0x0231))
#define PMU_AUXADC_ADC25         ((PMU_REG_BASE+0x0232))
#define PMU_AUXADC_ADC25_H       ((PMU_REG_BASE+0x0233))
#define PMU_AUXADC_ADC26         ((PMU_REG_BASE+0x0234))
#define PMU_AUXADC_ADC26_H       ((PMU_REG_BASE+0x0235))
#define PMU_AUXADC_ADC27         ((PMU_REG_BASE+0x0236))
#define PMU_AUXADC_ADC27_H       ((PMU_REG_BASE+0x0237))
#define PMU_AUXADC_ADC28         ((PMU_REG_BASE+0x0238))
#define PMU_AUXADC_ADC28_H       ((PMU_REG_BASE+0x0239))
#define PMU_AUXADC_ADC29         ((PMU_REG_BASE+0x023A))
#define PMU_AUXADC_ADC29_H       ((PMU_REG_BASE+0x023B))
#define PMU_AUXADC_ADC30         ((PMU_REG_BASE+0x023C))
#define PMU_AUXADC_ADC30_H       ((PMU_REG_BASE+0x023D))
#define PMU_AUXADC_ADC31         ((PMU_REG_BASE+0x023E))
#define PMU_AUXADC_ADC31_H       ((PMU_REG_BASE+0x023F))
#define PMU_AUXADC_ADC32         ((PMU_REG_BASE+0x0240))
#define PMU_AUXADC_ADC32_H       ((PMU_REG_BASE+0x0241))
#define PMU_AUXADC_ADC33         ((PMU_REG_BASE+0x0242))
#define PMU_AUXADC_ADC33_H       ((PMU_REG_BASE+0x0243))
#define PMU_AUXADC_ADC34         ((PMU_REG_BASE+0x0244))
#define PMU_AUXADC_ADC34_H       ((PMU_REG_BASE+0x0245))
#define PMU_AUXADC_ADC35         ((PMU_REG_BASE+0x0246))
#define PMU_AUXADC_ADC35_H       ((PMU_REG_BASE+0x0247))
#define PMU_AUXADC_ADC36         ((PMU_REG_BASE+0x0248))
#define PMU_AUXADC_ADC36_H       ((PMU_REG_BASE+0x0249))
#define PMU_AUXADC_ADC37         ((PMU_REG_BASE+0x024A))
#define PMU_AUXADC_ADC37_H       ((PMU_REG_BASE+0x024B))
#define PMU_AUXADC_ADC38         ((PMU_REG_BASE+0x024C))
#define PMU_AUXADC_ADC38_H       ((PMU_REG_BASE+0x024D))
#define PMU_AUXADC_STA0          ((PMU_REG_BASE+0x024E))
#define PMU_AUXADC_STA0_H        ((PMU_REG_BASE+0x024F))
#define PMU_AUXADC_STA1          ((PMU_REG_BASE+0x0250))
#define PMU_AUXADC_STA1_H        ((PMU_REG_BASE+0x0251))
#define PMU_AUXADC_RQST0         ((PMU_REG_BASE+0x0252))
#define PMU_AUXADC_RQST0_H       ((PMU_REG_BASE+0x0253))
#define PMU_AUXADC_RQST1         ((PMU_REG_BASE+0x0254))
#define PMU_AUXADC_RQST1_H       ((PMU_REG_BASE+0x0255))
#define PMU_AUXADC_CON0          ((PMU_REG_BASE+0x0256))
#define PMU_AUXADC_CON0_H        ((PMU_REG_BASE+0x0257))
#define PMU_AUXADC_CON1          ((PMU_REG_BASE+0x0258))
#define PMU_AUXADC_CON1_H        ((PMU_REG_BASE+0x0259))
#define PMU_AUXADC_CON2          ((PMU_REG_BASE+0x025A))
#define PMU_AUXADC_CON2_H        ((PMU_REG_BASE+0x025B))
#define PMU_AUXADC_CON3          ((PMU_REG_BASE+0x025C))
#define PMU_AUXADC_CON3_H        ((PMU_REG_BASE+0x025D))
#define PMU_AUXADC_CON4          ((PMU_REG_BASE+0x025E))
#define PMU_AUXADC_CON4_H        ((PMU_REG_BASE+0x025F))
#define PMU_AUXADC_CON5          ((PMU_REG_BASE+0x0260))
#define PMU_AUXADC_CON5_H        ((PMU_REG_BASE+0x0261))
#define PMU_AUXADC_CON6          ((PMU_REG_BASE+0x0262))
#define PMU_AUXADC_CON6_H        ((PMU_REG_BASE+0x0263))
#define PMU_AUXADC_CON7          ((PMU_REG_BASE+0x0264))
#define PMU_AUXADC_CON7_H        ((PMU_REG_BASE+0x0265))
#define PMU_AUXADC_CON8          ((PMU_REG_BASE+0x0266))
#define PMU_AUXADC_CON8_H        ((PMU_REG_BASE+0x0267))
#define PMU_AUXADC_CON9          ((PMU_REG_BASE+0x0268))
#define PMU_AUXADC_CON9_H        ((PMU_REG_BASE+0x0269))
#define PMU_AUXADC_CON10         ((PMU_REG_BASE+0x026A))
#define PMU_AUXADC_CON10_H       ((PMU_REG_BASE+0x026B))
#define PMU_AUXADC_CON11         ((PMU_REG_BASE+0x026C))
#define PMU_AUXADC_CON11_H       ((PMU_REG_BASE+0x026D))
#define PMU_AUXADC_CON12         ((PMU_REG_BASE+0x026E))
#define PMU_AUXADC_CON12_H       ((PMU_REG_BASE+0x026F))
#define PMU_AUXADC_CON13         ((PMU_REG_BASE+0x0270))
#define PMU_AUXADC_CON13_H       ((PMU_REG_BASE+0x0271))
#define PMU_AUXADC_CON14         ((PMU_REG_BASE+0x0272))
#define PMU_AUXADC_CON14_H       ((PMU_REG_BASE+0x0273))
#define PMU_AUXADC_CON15_H       ((PMU_REG_BASE+0x0275))
#define PMU_AUXADC_CON16         ((PMU_REG_BASE+0x0276))
#define PMU_AUXADC_CON16_H       ((PMU_REG_BASE+0x0277))
#define PMU_AUXADC_AUTORPT0      ((PMU_REG_BASE+0x0278))
#define PMU_AUXADC_AUTORPT0_H    ((PMU_REG_BASE+0x0279))
#define PMU_AUXADC_LBAT0         ((PMU_REG_BASE+0x027A))
#define PMU_AUXADC_LBAT0_H       ((PMU_REG_BASE+0x027B))
#define PMU_AUXADC_LBAT1         ((PMU_REG_BASE+0x027C))
#define PMU_AUXADC_LBAT1_H       ((PMU_REG_BASE+0x027D))
#define PMU_AUXADC_LBAT2         ((PMU_REG_BASE+0x027E))
#define PMU_AUXADC_LBAT3         ((PMU_REG_BASE+0x0280))
#define PMU_AUXADC_LBAT3_H       ((PMU_REG_BASE+0x0281))
#define PMU_AUXADC_LBAT4         ((PMU_REG_BASE+0x0282))
#define PMU_AUXADC_LBAT4_H       ((PMU_REG_BASE+0x0283))
#define PMU_AUXADC_LBAT5         ((PMU_REG_BASE+0x0284))
#define PMU_AUXADC_LBAT5_H       ((PMU_REG_BASE+0x0285))
#define PMU_AUXADC_LBAT6         ((PMU_REG_BASE+0x0286))
#define PMU_AUXADC_LBAT6_H       ((PMU_REG_BASE+0x0287))
#define PMU_AUXADC_ACCDET        ((PMU_REG_BASE+0x0288))
#define PMU_AUXADC_ACCDET_H      ((PMU_REG_BASE+0x0289))
#define PMU_AUXADC_THR0          ((PMU_REG_BASE+0x028A))
#define PMU_AUXADC_THR0_H        ((PMU_REG_BASE+0x028B))
#define PMU_AUXADC_THR1          ((PMU_REG_BASE+0x028C))
#define PMU_AUXADC_THR1_H        ((PMU_REG_BASE+0x028D))
#define PMU_AUXADC_THR2          ((PMU_REG_BASE+0x028E))
#define PMU_AUXADC_THR3          ((PMU_REG_BASE+0x0290))
#define PMU_AUXADC_THR3_H        ((PMU_REG_BASE+0x0291))
#define PMU_AUXADC_THR4          ((PMU_REG_BASE+0x0292))
#define PMU_AUXADC_THR4_H        ((PMU_REG_BASE+0x0293))
#define PMU_AUXADC_THR5          ((PMU_REG_BASE+0x0294))
#define PMU_AUXADC_THR5_H        ((PMU_REG_BASE+0x0295))
#define PMU_AUXADC_THR6          ((PMU_REG_BASE+0x0296))
#define PMU_AUXADC_THR6_H        ((PMU_REG_BASE+0x0297))
#define PMU_AUXADC_EFUSE0        ((PMU_REG_BASE+0x0298))
#define PMU_AUXADC_EFUSE0_H      ((PMU_REG_BASE+0x0299))
#define PMU_AUXADC_EFUSE1        ((PMU_REG_BASE+0x029A))
#define PMU_AUXADC_EFUSE1_H      ((PMU_REG_BASE+0x029B))
#define PMU_AUXADC_EFUSE2        ((PMU_REG_BASE+0x029C))
#define PMU_AUXADC_EFUSE2_H      ((PMU_REG_BASE+0x029D))
#define PMU_AUXADC_EFUSE3        ((PMU_REG_BASE+0x029E))
#define PMU_AUXADC_EFUSE3_H      ((PMU_REG_BASE+0x029F))
#define PMU_AUXADC_EFUSE4        ((PMU_REG_BASE+0x02A0))
#define PMU_AUXADC_EFUSE4_H      ((PMU_REG_BASE+0x02A1))
#define PMU_AUXADC_EFUSE5        ((PMU_REG_BASE+0x02A2))
#define PMU_AUXADC_EFUSE5_H      ((PMU_REG_BASE+0x02A3))
#define PMU_AUXADC_DBG0          ((PMU_REG_BASE+0x02A4))
#define PMU_AUXADC_DBG0_H        ((PMU_REG_BASE+0x02A5))
#define PMU_AUXADC_IMP0          ((PMU_REG_BASE+0x02A6))
#define PMU_AUXADC_IMP0_H        ((PMU_REG_BASE+0x02A7))
#define PMU_AUXADC_IMP1          ((PMU_REG_BASE+0x02A8))
#define PMU_AUXADC_IMP1_H        ((PMU_REG_BASE+0x02A9))
#define PMU_AUXADC_VISMPS0_1     ((PMU_REG_BASE+0x02AA))
#define PMU_AUXADC_VISMPS0_1_H   ((PMU_REG_BASE+0x02AB))
#define PMU_AUXADC_VISMPS0_2     ((PMU_REG_BASE+0x02AC))
#define PMU_AUXADC_VISMPS0_2_H   ((PMU_REG_BASE+0x02AD))
#define PMU_AUXADC_VISMPS0_3     ((PMU_REG_BASE+0x02AE))
#define PMU_AUXADC_VISMPS0_4     ((PMU_REG_BASE+0x02B0))
#define PMU_AUXADC_VISMPS0_4_H   ((PMU_REG_BASE+0x02B1))
#define PMU_AUXADC_VISMPS0_5     ((PMU_REG_BASE+0x02B2))
#define PMU_AUXADC_VISMPS0_5_H   ((PMU_REG_BASE+0x02B3))
#define PMU_AUXADC_VISMPS0_6     ((PMU_REG_BASE+0x02B4))
#define PMU_AUXADC_VISMPS0_6_H   ((PMU_REG_BASE+0x02B5))
#define PMU_AUXADC_VISMPS0_7     ((PMU_REG_BASE+0x02B6))
#define PMU_AUXADC_VISMPS0_7_H   ((PMU_REG_BASE+0x02B7))
#define PMU_AUXADC_LBAT2_1       ((PMU_REG_BASE+0x02B8))
#define PMU_AUXADC_LBAT2_1_H     ((PMU_REG_BASE+0x02B9))
#define PMU_AUXADC_LBAT2_2       ((PMU_REG_BASE+0x02BA))
#define PMU_AUXADC_LBAT2_2_H     ((PMU_REG_BASE+0x02BB))
#define PMU_AUXADC_LBAT2_3       ((PMU_REG_BASE+0x02BC))
#define PMU_AUXADC_LBAT2_4       ((PMU_REG_BASE+0x02BE))
#define PMU_AUXADC_LBAT2_4_H     ((PMU_REG_BASE+0x02BF))
#define PMU_AUXADC_LBAT2_5       ((PMU_REG_BASE+0x02C0))
#define PMU_AUXADC_LBAT2_5_H     ((PMU_REG_BASE+0x02C1))
#define PMU_AUXADC_LBAT2_6       ((PMU_REG_BASE+0x02C2))
#define PMU_AUXADC_LBAT2_6_H     ((PMU_REG_BASE+0x02C3))
#define PMU_AUXADC_LBAT2_7       ((PMU_REG_BASE+0x02C4))
#define PMU_AUXADC_LBAT2_7_H     ((PMU_REG_BASE+0x02C5))
#define PMU_AUXADC_MDRT_0        ((PMU_REG_BASE+0x02C6))
#define PMU_AUXADC_MDRT_0_H      ((PMU_REG_BASE+0x02C7))
#define PMU_AUXADC_MDRT_1        ((PMU_REG_BASE+0x02C8))
#define PMU_AUXADC_MDRT_1_H      ((PMU_REG_BASE+0x02C9))
#define PMU_AUXADC_MDRT_2        ((PMU_REG_BASE+0x02CA))
#define PMU_AUXADC_JEITA_0       ((PMU_REG_BASE+0x02CB))
#define PMU_AUXADC_JEITA_0_H     ((PMU_REG_BASE+0x02CC))
#define PMU_AUXADC_JEITA_1       ((PMU_REG_BASE+0x02CD))
#define PMU_AUXADC_JEITA_1_H     ((PMU_REG_BASE+0x02CE))
#define PMU_AUXADC_JEITA_2       ((PMU_REG_BASE+0x02CF))
#define PMU_AUXADC_JEITA_2_H     ((PMU_REG_BASE+0x02D0))
#define PMU_AUXADC_JEITA_3       ((PMU_REG_BASE+0x02D1))
#define PMU_AUXADC_JEITA_3_H     ((PMU_REG_BASE+0x02D2))
#define PMU_AUXADC_JEITA_4       ((PMU_REG_BASE+0x02D3))
#define PMU_AUXADC_JEITA_4_H     ((PMU_REG_BASE+0x02D4))
#define PMU_AUXADC_JEITA_5       ((PMU_REG_BASE+0x02D5))
#define PMU_AUXADC_JEITA_5_H     ((PMU_REG_BASE+0x02D6))
#define PMU_AUXADC_DCXO_MDRT_0   ((PMU_REG_BASE+0x02D7))
#define PMU_AUXADC_DCXO_MDRT_0_H ((PMU_REG_BASE+0x02D8))
#define PMU_AUXADC_DCXO_MDRT_1   ((PMU_REG_BASE+0x02D9))
#define PMU_AUXADC_DCXO_MDRT_1_H ((PMU_REG_BASE+0x02DA))
#define PMU_AUXADC_DCXO_MDRT_2   ((PMU_REG_BASE+0x02DB))
#define PMU_AUXADC_NAG_0         ((PMU_REG_BASE+0x02DC))
#define PMU_AUXADC_NAG_0_H       ((PMU_REG_BASE+0x02DD))
#define PMU_AUXADC_NAG_1         ((PMU_REG_BASE+0x02DE))
#define PMU_AUXADC_NAG_1_H       ((PMU_REG_BASE+0x02DF))
#define PMU_AUXADC_NAG_2         ((PMU_REG_BASE+0x02E0))
#define PMU_AUXADC_NAG_2_H       ((PMU_REG_BASE+0x02E1))
#define PMU_AUXADC_NAG_3         ((PMU_REG_BASE+0x02E2))
#define PMU_AUXADC_NAG_3_H       ((PMU_REG_BASE+0x02E3))
#define PMU_AUXADC_NAG_4         ((PMU_REG_BASE+0x02E4))
#define PMU_AUXADC_NAG_4_H       ((PMU_REG_BASE+0x02E5))
#define PMU_AUXADC_NAG_5         ((PMU_REG_BASE+0x02E6))
#define PMU_AUXADC_NAG_5_H       ((PMU_REG_BASE+0x02E7))
#define PMU_AUXADC_NAG_6         ((PMU_REG_BASE+0x02E8))
#define PMU_AUXADC_NAG_6_H       ((PMU_REG_BASE+0x02E9))
#define PMU_AUXADC_NAG_7         ((PMU_REG_BASE+0x02EA))
#define PMU_AUXADC_NAG_7_H       ((PMU_REG_BASE+0x02EB))
#define PMU_AUXADC_NAG_8         ((PMU_REG_BASE+0x02EC))
#define PMU_AUXADC_NAG_8_H       ((PMU_REG_BASE+0x02ED))
#define PMU_VBTCTL1              ((PMU_REG_BASE+0x02EE))
#define PMU_VBTLDO0              ((PMU_REG_BASE+0x02EF))
#define PMU_VBTLDO1              ((PMU_REG_BASE+0x02F0))
#define PMU_VBTLDO2              ((PMU_REG_BASE+0x02F1))
#define PMU_VBTLDO3              ((PMU_REG_BASE+0x02F2))
#define PMU_VBTLDOBF0            ((PMU_REG_BASE+0x02F3))
#define PMU_VBTLDOBF1            ((PMU_REG_BASE+0x02F4))
#define PMU_VBTPSI0              ((PMU_REG_BASE+0x02F5))
#define PMU_VBTPSI1              ((PMU_REG_BASE+0x02F6))
#define PMU_VACTL1               ((PMU_REG_BASE+0x02F7))
#define PMU_VALDO0               ((PMU_REG_BASE+0x02F8))
#define PMU_VALDO1               ((PMU_REG_BASE+0x02F9))
#define PMU_VALDO2               ((PMU_REG_BASE+0x02FA))
#define PMU_VALDO3               ((PMU_REG_BASE+0x02FB))
#define PMU_VALDOBF0             ((PMU_REG_BASE+0x02FC))
#define PMU_VALDOBF1             ((PMU_REG_BASE+0x02FD))
#define PMU_VAPSI0               ((PMU_REG_BASE+0x02FE))
#define PMU_VAPSI1               ((PMU_REG_BASE+0x02FF))
#define PMU_VCAMACTL0            ((PMU_REG_BASE+0x0300))
#define PMU_VCAMACTL1            ((PMU_REG_BASE+0x0301))
#define PMU_VCAMALDO0            ((PMU_REG_BASE+0x0302))
#define PMU_VCAMALDO1            ((PMU_REG_BASE+0x0303))
#define PMU_VCAMALDO2            ((PMU_REG_BASE+0x0304))
#define PMU_VCAMALDO3            ((PMU_REG_BASE+0x0305))
#define PMU_VCAMALDOBF0          ((PMU_REG_BASE+0x0306))
#define PMU_VCAMALDOBF1          ((PMU_REG_BASE+0x0307))
#define PMU_EFUSERSVED0          ((PMU_REG_BASE+0x0308))
#define PMU_EFUSERSVED1          ((PMU_REG_BASE+0x0309))
#define PMU_PSWCTL0              ((PMU_REG_BASE+0x030A))
#define PMU_VIO18PSW0            ((PMU_REG_BASE+0x030B))
#define PMU_VIO18PSW1            ((PMU_REG_BASE+0x030C))
#define PMU_VIO18PSW2            ((PMU_REG_BASE+0x030D))
#define PMU_VIO18PSW3            ((PMU_REG_BASE+0x030E))
#define PMU_SWIO18PSI            ((PMU_REG_BASE+0x030F))
#define PMU_VIO28PSW0            ((PMU_REG_BASE+0x0310))
#define PMU_VIO28CTL1            ((PMU_REG_BASE+0x0312))
#define PMU_VIO28LDO0            ((PMU_REG_BASE+0x0313))
#define PMU_VIO28LDO1            ((PMU_REG_BASE+0x0314))
#define PMU_VIO28LDO2            ((PMU_REG_BASE+0x0315))
#define PMU_VIO28LDO3            ((PMU_REG_BASE+0x0316))
#define PMU_VIO28LDOBF0          ((PMU_REG_BASE+0x0317))
#define PMU_VIO28LDOBF1          ((PMU_REG_BASE+0x0318))
#define PMU_VIO28PSI0            ((PMU_REG_BASE+0x0319))
#define PMU_VIO28PSI1            ((PMU_REG_BASE+0x031A))
#define PMU_VMCCTL1              ((PMU_REG_BASE+0x031B))
#define PMU_VMCLDO0              ((PMU_REG_BASE+0x031C))
#define PMU_VMCLDO1              ((PMU_REG_BASE+0x031D))
#define PMU_VMCLDO2              ((PMU_REG_BASE+0x031E))
#define PMU_VMCLDO3              ((PMU_REG_BASE+0x031F))
#define PMU_VMCLDOBF0            ((PMU_REG_BASE+0x0320))
#define PMU_VMCLDOBF1            ((PMU_REG_BASE+0x0321))
#define PMU_VMCPSI0              ((PMU_REG_BASE+0x0322))
#define PMU_VMCPSI1              ((PMU_REG_BASE+0x0323))
#define PMU_VIBRCTL0             ((PMU_REG_BASE+0x0324))
#define PMU_VIBRCTL1             ((PMU_REG_BASE+0x0325))
#define PMU_VIBRLDO0             ((PMU_REG_BASE+0x0326))
#define PMU_VIBRLDO1             ((PMU_REG_BASE+0x0327))
#define PMU_VIBRLDO2             ((PMU_REG_BASE+0x0328))
#define PMU_VIBRLDO3             ((PMU_REG_BASE+0x0329))
#define PMU_VIBRLDOBF0           ((PMU_REG_BASE+0x032A))
#define PMU_VIBRLDOBF1           ((PMU_REG_BASE+0x032B))
#define PMU_ISINK0_CON0          ((PMU_REG_BASE+0x032C))
#define PMU_ISINK0_CON1          ((PMU_REG_BASE+0x032D))
#define PMU_ISINK0_CON2          ((PMU_REG_BASE+0x032E))
#define PMU_ISINK0_CON3          ((PMU_REG_BASE+0x032F))
#define PMU_ISINK0_CON4          ((PMU_REG_BASE+0x0330))
#define PMU_ISINK0_CON5          ((PMU_REG_BASE+0x0331))
#define PMU_ISINK0_CON6          ((PMU_REG_BASE+0x0332))
#define PMU_ISINK1_CON0          ((PMU_REG_BASE+0x0333))
#define PMU_ISINK1_CON1          ((PMU_REG_BASE+0x0334))
#define PMU_ISINK1_CON2          ((PMU_REG_BASE+0x0335))
#define PMU_ISINK1_CON3          ((PMU_REG_BASE+0x0336))
#define PMU_ISINK1_CON4          ((PMU_REG_BASE+0x0337))
#define PMU_ISINK1_CON5          ((PMU_REG_BASE+0x0338))
#define PMU_ISINK1_CON6          ((PMU_REG_BASE+0x0339))
#define PMU_ISINK2_CON1          ((PMU_REG_BASE+0x033A))
#define PMU_ISINK2_CON2          ((PMU_REG_BASE+0x033B))
#define PMU_ISINK3_CON1          ((PMU_REG_BASE+0x033C))
#define PMU_ISINK3_CON2          ((PMU_REG_BASE+0x033D))
#define PMU_ISINK_ANA0_l         ((PMU_REG_BASE+0x033E))
#define PMU_ISINK_ANA0_H         ((PMU_REG_BASE+0x033F))
#define PMU_ISINK_ANA1           ((PMU_REG_BASE+0x0340))
#define PMU_ISINK_PHASE_DLY_L    ((PMU_REG_BASE+0x0341))
#define PMU_ISINK_PHASE_DLY_H    ((PMU_REG_BASE+0x0342))
#define PMU_ISINK_SFSTR          ((PMU_REG_BASE+0x0343))
#define PMU_ISINK_EN_CTRL_Low    ((PMU_REG_BASE+0x0344))
#define PMU_ISINK_EN_CTRL_High   ((PMU_REG_BASE+0x0345))
#define PMU_ISINK_MODE_CTRL      ((PMU_REG_BASE+0x0346))
#define PMU_TSTWKEY0             ((PMU_REG_BASE+0x0347))
#define PMU_TSTWKEY1             ((PMU_REG_BASE+0x0348))
#define PMU_TOPTST0              ((PMU_REG_BASE+0x0349))
#define PMU_TOPTST1              ((PMU_REG_BASE+0x034A))
#define PMU_PPCTST1              ((PMU_REG_BASE+0x034B))
#define PMU_PPCTST2              ((PMU_REG_BASE+0x034C))
#define PMU_MONTST0              ((PMU_REG_BASE+0x034D))
#define PMU_MONTST1              ((PMU_REG_BASE+0x034E))
#define PMU_MONTST2              ((PMU_REG_BASE+0x034F))
#define PMU_INTRTST0             ((PMU_REG_BASE+0x0350))
#define PMU_INTRTST1             ((PMU_REG_BASE+0x0351))
//mask is HEX;  shift is Integer
#define PMU_HWCID_L_ADDR                              PMU_HWCID0
#define PMU_HWCID_L_MASK                              0xFF
#define PMU_HWCID_L_SHIFT                             0
#define PMU_HWCID_H_ADDR                              PMU_HWCID1
#define PMU_HWCID_H_MASK                              0xFF
#define PMU_HWCID_H_SHIFT                             0
#define PMU_SWCID_L_ADDR                              PMU_SWCID0
#define PMU_SWCID_L_MASK                              0xFF
#define PMU_SWCID_L_SHIFT                             0
#define PMU_SWCID_H_ADDR                              PMU_SWCID1
#define PMU_SWCID_H_MASK                              0xFF
#define PMU_SWCID_H_SHIFT                             0
#define PMU_RG_VBAT_COIN_SEL_VAL_ADDR                 PMU_TOPSTS
#define PMU_RG_VBAT_COIN_SEL_VAL_MASK                 0x1
#define PMU_RG_VBAT_COIN_SEL_VAL_SHIFT                0
#define PMU_RG_VDIG18_RDSEL_ADDR                      PMU_IOCFG0
#define PMU_RG_VDIG18_RDSEL_MASK                      0x1
#define PMU_RG_VDIG18_RDSEL_SHIFT                     0
#define PMU_RG_VDIG18_TDSEL_ADDR                      PMU_IOCFG0
#define PMU_RG_VDIG18_TDSEL_MASK                      0x1
#define PMU_RG_VDIG18_TDSEL_SHIFT                     1
#define PMU_RG_VIO18_RDSEL_ADDR                       PMU_IOCFG0
#define PMU_RG_VIO18_RDSEL_MASK                       0x1
#define PMU_RG_VIO18_RDSEL_SHIFT                      2
#define PMU_RG_VIO18_TDSEL_ADDR                       PMU_IOCFG0
#define PMU_RG_VIO18_TDSEL_MASK                       0x1
#define PMU_RG_VIO18_TDSEL_SHIFT                      3
#define PMU_RG_I2C_DAT_OC_ADDR                        PMU_IOCFG1
#define PMU_RG_I2C_DAT_OC_MASK                        0x7
#define PMU_RG_I2C_DAT_OC_SHIFT                       0
#define PMU_RG_PMIC_INT_OC_ADDR                       PMU_IOCFG1
#define PMU_RG_PMIC_INT_OC_MASK                       0x7
#define PMU_RG_PMIC_INT_OC_SHIFT                      4
#define PMU_RG_TST0_OC_ADDR                           PMU_IOCFG2
#define PMU_RG_TST0_OC_MASK                           0x7
#define PMU_RG_TST0_OC_SHIFT                          0
#define PMU_RG_TST1_OC_ADDR                           PMU_IOCFG2
#define PMU_RG_TST1_OC_MASK                           0x7
#define PMU_RG_TST1_OC_SHIFT                          4
#define PMU_RG_DDLO_VRTC_OC_ADDR                      PMU_IOCFG3
#define PMU_RG_DDLO_VRTC_OC_MASK                      0x7
#define PMU_RG_DDLO_VRTC_OC_SHIFT                     0
#define PMU_RG_TESTMODE_OC_ADDR                       PMU_IOCFG3
#define PMU_RG_TESTMODE_OC_MASK                       0x7
#define PMU_RG_TESTMODE_OC_SHIFT                      4
#define PMU_RG_PORSTB_OC_ADDR                         PMU_IOCFG4
#define PMU_RG_PORSTB_OC_MASK                         0x7
#define PMU_RG_PORSTB_OC_SHIFT                        0
#define PMU_RG_F32K_CK_OC_ADDR                        PMU_IOCFG4
#define PMU_RG_F32K_CK_OC_MASK                        0x7
#define PMU_RG_F32K_CK_OC_SHIFT                       4
#define PMU_RG_VCORE_PREON_OC_ADDR                    PMU_IOCFG5
#define PMU_RG_VCORE_PREON_OC_MASK                    0x7
#define PMU_RG_VCORE_PREON_OC_SHIFT                   0
#define PMU_RG_TRPI0_OC_ADDR                          PMU_IOCFG7
#define PMU_RG_TRPI0_OC_MASK                          0x7
#define PMU_RG_TRPI0_OC_SHIFT                         0
#define PMU_RG_TRPI1_OC_ADDR                          PMU_IOCFG7
#define PMU_RG_TRPI1_OC_MASK                          0x7
#define PMU_RG_TRPI1_OC_SHIFT                         4
#define PMU_RG_I2C_DAT_IC_ADDR                        PMU_IOCFG8
#define PMU_RG_I2C_DAT_IC_MASK                        0x7
#define PMU_RG_I2C_DAT_IC_SHIFT                       0
#define PMU_RG_I2C_CLK_IC_ADDR                        PMU_IOCFG8
#define PMU_RG_I2C_CLK_IC_MASK                        0x7
#define PMU_RG_I2C_CLK_IC_SHIFT                       4
#define PMU_RG_PSI0B_IC_ADDR                          PMU_IOCFG9
#define PMU_RG_PSI0B_IC_MASK                          0x7
#define PMU_RG_PSI0B_IC_SHIFT                         0
#define PMU_RG_PSI1B_IC_ADDR                          PMU_IOCFG9
#define PMU_RG_PSI1B_IC_MASK                          0x7
#define PMU_RG_PSI1B_IC_SHIFT                         4
#define PMU_RG_RTC_VRF_EN_IC_ADDR                     PMU_IOCFG10
#define PMU_RG_RTC_VRF_EN_IC_MASK                     0x7
#define PMU_RG_RTC_VRF_EN_IC_SHIFT                    0
#define PMU_RG_RTC_ALARM_IC_ADDR                      PMU_IOCFG10
#define PMU_RG_RTC_ALARM_IC_MASK                      0x7
#define PMU_RG_RTC_ALARM_IC_SHIFT                     4
#define PMU_RG_F32K_CK_VRTC_IC_ADDR                   PMU_IOCFG11
#define PMU_RG_F32K_CK_VRTC_IC_MASK                   0x7
#define PMU_RG_F32K_CK_VRTC_IC_SHIFT                  0
#define PMU_RG_WDTRSTB_IN_IC_ADDR                     PMU_IOCFG11
#define PMU_RG_WDTRSTB_IN_IC_MASK                     0x7
#define PMU_RG_WDTRSTB_IN_IC_SHIFT                    4
#define PMU_RG_EXTRSTB_IC_ADDR                        PMU_IOCFG12
#define PMU_RG_EXTRSTB_IC_MASK                        0x7
#define PMU_RG_EXTRSTB_IC_SHIFT                       0
#define PMU_RG_CG_SYNC_SAVE_MODE_ADDR                 PMU_CKCFG0
#define PMU_RG_CG_SYNC_SAVE_MODE_MASK                 0x1
#define PMU_RG_CG_SYNC_SAVE_MODE_SHIFT                0
#define PMU_RG_CLK_TRIM_F32K_FORCE_ADDR               PMU_CKCFG1
#define PMU_RG_CLK_TRIM_F32K_FORCE_MASK               0x3
#define PMU_RG_CLK_TRIM_F32K_FORCE_SHIFT              0
#define PMU_RG_VRC_PSI_F32K_FORCE_ADDR                PMU_CKCFG1
#define PMU_RG_VRC_PSI_F32K_FORCE_MASK                0x3
#define PMU_RG_VRC_PSI_F32K_FORCE_SHIFT               2
#define PMU_RG_PSEQ_F32K_DIV1024_FORCE_ADDR           PMU_CKCFG1
#define PMU_RG_PSEQ_F32K_DIV1024_FORCE_MASK           0x3
#define PMU_RG_PSEQ_F32K_DIV1024_FORCE_SHIFT          4
#define PMU_RG_PSEQ_F32K_FORCE_ADDR                   PMU_CKCFG1
#define PMU_RG_PSEQ_F32K_FORCE_MASK                   0x3
#define PMU_RG_PSEQ_F32K_FORCE_SHIFT                  6
#define PMU_RG_RTC_MISC_CK_SEL_E1_ADDR                PMU_CKCFG2
#define PMU_RG_RTC_MISC_CK_SEL_E1_MASK                0x1
#define PMU_RG_RTC_MISC_CK_SEL_E1_SHIFT               0
#define PMU_RG_AUXADC_F1HZ_SEL_ADDR                   PMU_CKCFG2
#define PMU_RG_AUXADC_F1HZ_SEL_MASK                   0x1
#define PMU_RG_AUXADC_F1HZ_SEL_SHIFT                  1
#define PMU_RG_AUXADC_F18M_SEL_ADDR                   PMU_CKCFG2
#define PMU_RG_AUXADC_F18M_SEL_MASK                   0x1
#define PMU_RG_AUXADC_F18M_SEL_SHIFT                  2
#define PMU_RG_BMX_F32K_SEL_ADDR                      PMU_CKCFG2
#define PMU_RG_BMX_F32K_SEL_MASK                      0x1
#define PMU_RG_BMX_F32K_SEL_SHIFT                     3
#define PMU_RG_BUCK_F3M_FORCE_ADDR                    PMU_CKCFG2
#define PMU_RG_BUCK_F3M_FORCE_MASK                    0x3
#define PMU_RG_BUCK_F3M_FORCE_SHIFT                   4
#define PMU_RG_BUCK_SMPS_FORCE_ADDR                   PMU_CKCFG2
#define PMU_RG_BUCK_SMPS_FORCE_MASK                   0x3
#define PMU_RG_BUCK_SMPS_FORCE_SHIFT                  6
#define PMU_RG_EFUSE_F32K_FORCE_ADDR                  PMU_CKCFG3
#define PMU_RG_EFUSE_F32K_FORCE_MASK                  0x3
#define PMU_RG_EFUSE_F32K_FORCE_SHIFT                 0
#define PMU_RG_INTCTL_F32K_FORCE_ADDR                 PMU_CKCFG3
#define PMU_RG_INTCTL_F32K_FORCE_MASK                 0x3
#define PMU_RG_INTCTL_F32K_FORCE_SHIFT                2
#define PMU_RG_LDO_STB_FORCE_ADDR                     PMU_CKCFG3
#define PMU_RG_LDO_STB_FORCE_MASK                     0x3
#define PMU_RG_LDO_STB_FORCE_SHIFT                    4
#define PMU_RG_LDO_F1M_FORCE_ADDR                     PMU_CKCFG3
#define PMU_RG_LDO_F1M_FORCE_MASK                     0x3
#define PMU_RG_LDO_F1M_FORCE_SHIFT                    6
#define PMU_RG_AUXADC_F18M_ON_ADDR                    PMU_CKCFG4
#define PMU_RG_AUXADC_F18M_ON_MASK                    0x1
#define PMU_RG_AUXADC_F18M_ON_SHIFT                   0
#define PMU_RG_AUXADC_F2M_FORCE_ADDR                  PMU_CKCFG4
#define PMU_RG_AUXADC_F2M_FORCE_MASK                  0x3
#define PMU_RG_AUXADC_F2M_FORCE_SHIFT                 2
#define PMU_RG_AUXADC_F1M_FORCE_ADDR                  PMU_CKCFG4
#define PMU_RG_AUXADC_F1M_FORCE_MASK                  0x3
#define PMU_RG_AUXADC_F1M_FORCE_SHIFT                 4
#define PMU_RG_AUXADC_F2M_SEL_ADDR                    PMU_CKCFG4
#define PMU_RG_AUXADC_F2M_SEL_MASK                    0x3
#define PMU_RG_AUXADC_F2M_SEL_SHIFT                   6
#define PMU_RG_DRV_ISINK0_FORCE_ADDR                  PMU_CKCFG5
#define PMU_RG_DRV_ISINK0_FORCE_MASK                  0x3
#define PMU_RG_DRV_ISINK0_FORCE_SHIFT                 0
#define PMU_RG_DRV_ISINK1_FORCE_ADDR                  PMU_CKCFG5
#define PMU_RG_DRV_ISINK1_FORCE_MASK                  0x3
#define PMU_RG_DRV_ISINK1_FORCE_SHIFT                 2
#define PMU_RG_DRV_F32K_FORCE_ADDR                    PMU_CKCFG5
#define PMU_RG_DRV_F32K_FORCE_MASK                    0x3
#define PMU_RG_DRV_F32K_FORCE_SHIFT                   4
#define PMU_RG_DRV_ISINK0_CK_CKSEL_ADDR               PMU_CKCFG5
#define PMU_RG_DRV_ISINK0_CK_CKSEL_MASK               0x1
#define PMU_RG_DRV_ISINK0_CK_CKSEL_SHIFT              6
#define PMU_RG_DRV_ISINK1_CK_CKSEL_ADDR               PMU_CKCFG5
#define PMU_RG_DRV_ISINK1_CK_CKSEL_MASK               0x1
#define PMU_RG_DRV_ISINK1_CK_CKSEL_SHIFT              7
#define PMU_RG_RTC_MISC_32K_CK_PDN_E1_ADDR            PMU_CKCFG6
#define PMU_RG_RTC_MISC_32K_CK_PDN_E1_MASK            0x1
#define PMU_RG_RTC_MISC_32K_CK_PDN_E1_SHIFT           0
#define PMU_RG_D2D_F32K_CK_PDN_E1_ADDR                PMU_CKCFG6
#define PMU_RG_D2D_F32K_CK_PDN_E1_MASK                0x1
#define PMU_RG_D2D_F32K_CK_PDN_E1_SHIFT               1
#define PMU_RG_PCHR_32K_CK_PDN_ADDR                   PMU_CKCFG6
#define PMU_RG_PCHR_32K_CK_PDN_MASK                   0x1
#define PMU_RG_PCHR_32K_CK_PDN_SHIFT                  2
#define PMU_RG_AUXADC_32K_CK_PDN_ADDR                 PMU_CKCFG6
#define PMU_RG_AUXADC_32K_CK_PDN_MASK                 0x1
#define PMU_RG_AUXADC_32K_CK_PDN_SHIFT                3
#define PMU_RG_LDO_STB_PDN_ADDR                       PMU_CKCFG6
#define PMU_RG_LDO_STB_PDN_MASK                       0x1
#define PMU_RG_LDO_STB_PDN_SHIFT                      4
#define PMU_RG_AUXADC_CK_HW_MODE_ADDR                 PMU_CKCFG6
#define PMU_RG_AUXADC_CK_HW_MODE_MASK                 0x1
#define PMU_RG_AUXADC_CK_HW_MODE_SHIFT                5
#define PMU_RG_PSEQ_F32K_DIV8_FORCE_ADDR              PMU_CKCFG6
#define PMU_RG_PSEQ_F32K_DIV8_FORCE_MASK              0x3
#define PMU_RG_PSEQ_F32K_DIV8_FORCE_SHIFT             6
#define PMU_RG_ULP_CLK_EN_ADDR                        PMU_CKCFG7
#define PMU_RG_ULP_CLK_EN_MASK                        0x1
#define PMU_RG_ULP_CLK_EN_SHIFT                       0
#define PMU_RG_ULP_CLK_SHAPE_E1_ADDR                  PMU_CKCFG7
#define PMU_RG_ULP_CLK_SHAPE_E1_MASK                  0x3
#define PMU_RG_ULP_CLK_SHAPE_E1_SHIFT                 2
#define PMU_I2C_CONFIG_ADDR                           PMU_I2C_OUT_TYPE
#define PMU_I2C_CONFIG_MASK                           0x1
#define PMU_I2C_CONFIG_SHIFT                          0
#define PMU_RG_HWRST_OPT_ADDR                         PMU_RSTCFG0
#define PMU_RG_HWRST_OPT_MASK                         0x3
#define PMU_RG_HWRST_OPT_SHIFT                        0
#define PMU_RG_FRGRST_OPT_ADDR                        PMU_RSTCFG0
#define PMU_RG_FRGRST_OPT_MASK                        0x1
#define PMU_RG_FRGRST_OPT_SHIFT                       4
#define PMU_RG_PMURST_OPT_ADDR                        PMU_RSTCFG0
#define PMU_RG_PMURST_OPT_MASK                        0x1
#define PMU_RG_PMURST_OPT_SHIFT                       5
#define PMU_RG_EFUSE_MAN_RST_ADDR                     PMU_RSTCFG1
#define PMU_RG_EFUSE_MAN_RST_MASK                     0x1
#define PMU_RG_EFUSE_MAN_RST_SHIFT                    0
#define PMU_RG_AUXADC_RST_ADDR                        PMU_RSTCFG1
#define PMU_RG_AUXADC_RST_MASK                        0x1
#define PMU_RG_AUXADC_RST_SHIFT                       1
#define PMU_RG_AUXADC_REG_RST_ADDR                    PMU_RSTCFG1
#define PMU_RG_AUXADC_REG_RST_MASK                    0x1
#define PMU_RG_AUXADC_REG_RST_SHIFT                   2
#define PMU_RG_DRIVER_RST_ADDR                        PMU_RSTCFG1
#define PMU_RG_DRIVER_RST_MASK                        0x1
#define PMU_RG_DRIVER_RST_SHIFT                       3
#define PMU_RG_CHRWDT_RST_ADDR                        PMU_RSTCFG1
#define PMU_RG_CHRWDT_RST_MASK                        0x1
#define PMU_RG_CHRWDT_RST_SHIFT                       4
#define PMU_RG_CLK_TRIM_RST_ADDR                      PMU_RSTCFG1
#define PMU_RG_CLK_TRIM_RST_MASK                      0x1
#define PMU_RG_CLK_TRIM_RST_SHIFT                     6
#define PMU_RG_TST_RST_ADDR                           PMU_RSTCFG1
#define PMU_RG_TST_RST_MASK                           0x1
#define PMU_RG_TST_RST_SHIFT                          7
#define PMU_RG_CHR_LDO_DET_MODE_ADDR                  PMU_RSTCFG2
#define PMU_RG_CHR_LDO_DET_MODE_MASK                  0x1
#define PMU_RG_CHR_LDO_DET_MODE_SHIFT                 0
#define PMU_RG_CHR_LDO_DET_SW_ADDR                    PMU_RSTCFG2
#define PMU_RG_CHR_LDO_DET_SW_MASK                    0x1
#define PMU_RG_CHR_LDO_DET_SW_SHIFT                   1
#define PMU_RG_CHRWDT_FLAG_MODE_ADDR                  PMU_RSTCFG2
#define PMU_RG_CHRWDT_FLAG_MODE_MASK                  0x1
#define PMU_RG_CHRWDT_FLAG_MODE_SHIFT                 2
#define PMU_RG_CHRWDT_FLAG_SW_ADDR                    PMU_RSTCFG2
#define PMU_RG_CHRWDT_FLAG_SW_MASK                    0x1
#define PMU_RG_CHRWDT_FLAG_SW_SHIFT                   3
#define PMU_RG_WDTRSTB_EN_ADDR                        PMU_RSTCFG3
#define PMU_RG_WDTRSTB_EN_MASK                        0x1
#define PMU_RG_WDTRSTB_EN_SHIFT                       0
#define PMU_RG_WDTRSTB_MODE_ADDR                      PMU_RSTCFG3
#define PMU_RG_WDTRSTB_MODE_MASK                      0x1
#define PMU_RG_WDTRSTB_MODE_SHIFT                     1
#define PMU_WDTRSTB_STATUS_ADDR                       PMU_RSTCFG3
#define PMU_WDTRSTB_STATUS_MASK                       0x1
#define PMU_WDTRSTB_STATUS_SHIFT                      2
#define PMU_WDTRSTB_STATUS_CLR_ADDR                   PMU_RSTCFG3
#define PMU_WDTRSTB_STATUS_CLR_MASK                   0x1
#define PMU_WDTRSTB_STATUS_CLR_SHIFT                  3
#define PMU_RG_WDTRSTB_FB_EN_ADDR                     PMU_RSTCFG3
#define PMU_RG_WDTRSTB_FB_EN_MASK                     0x1
#define PMU_RG_WDTRSTB_FB_EN_SHIFT                    4
#define PMU_INTS_ALDO_OC_R_ADDR                       PMU_INTSTS0
#define PMU_INTS_ALDO_OC_R_MASK                       0x1
#define PMU_INTS_ALDO_OC_R_SHIFT                      0
#define PMU_INTS_ALDO_OC_F_ADDR                       PMU_INTSTS0
#define PMU_INTS_ALDO_OC_F_MASK                       0x1
#define PMU_INTS_ALDO_OC_F_SHIFT                      1
#define PMU_INTS_ALDO_PG_R_ADDR                       PMU_INTSTS0
#define PMU_INTS_ALDO_PG_R_MASK                       0x1
#define PMU_INTS_ALDO_PG_R_SHIFT                      2
#define PMU_INTS_ALDO_PG_F_ADDR                       PMU_INTSTS0
#define PMU_INTS_ALDO_PG_F_MASK                       0x1
#define PMU_INTS_ALDO_PG_F_SHIFT                      3
#define PMU_INTS_DLDO_OC_R_ADDR                       PMU_INTSTS0
#define PMU_INTS_DLDO_OC_R_MASK                       0x1
#define PMU_INTS_DLDO_OC_R_SHIFT                      4
#define PMU_INTS_DLDO_OC_F_ADDR                       PMU_INTSTS0
#define PMU_INTS_DLDO_OC_F_MASK                       0x1
#define PMU_INTS_DLDO_OC_F_SHIFT                      5
#define PMU_INTS_DLDO_PG_R_ADDR                       PMU_INTSTS0
#define PMU_INTS_DLDO_PG_R_MASK                       0x1
#define PMU_INTS_DLDO_PG_R_SHIFT                      6
#define PMU_INTS_DLDO_PG_F_ADDR                       PMU_INTSTS0
#define PMU_INTS_DLDO_PG_F_MASK                       0x1
#define PMU_INTS_DLDO_PG_F_SHIFT                      7
#define PMU_INTS_VC_BUCK_OC_R_ADDR                    PMU_INTSTS1
#define PMU_INTS_VC_BUCK_OC_R_MASK                    0x1
#define PMU_INTS_VC_BUCK_OC_R_SHIFT                   0
#define PMU_INTS_VC_BUCK_OC_F_ADDR                    PMU_INTSTS1
#define PMU_INTS_VC_BUCK_OC_F_MASK                    0x1
#define PMU_INTS_VC_BUCK_OC_F_SHIFT                   1
#define PMU_INTS_VCORE_PG_R_ADDR                      PMU_INTSTS1
#define PMU_INTS_VCORE_PG_R_MASK                      0x1
#define PMU_INTS_VCORE_PG_R_SHIFT                     2
#define PMU_INTS_VCORE_PG_F_ADDR                      PMU_INTSTS1
#define PMU_INTS_VCORE_PG_F_MASK                      0x1
#define PMU_INTS_VCORE_PG_F_SHIFT                     3
#define PMU_INTS_VC_LDO_OC_R_ADDR                     PMU_INTSTS1
#define PMU_INTS_VC_LDO_OC_R_MASK                     0x1
#define PMU_INTS_VC_LDO_OC_R_SHIFT                    4
#define PMU_INTS_VC_LDO_OC_F_ADDR                     PMU_INTSTS1
#define PMU_INTS_VC_LDO_OC_F_MASK                     0x1
#define PMU_INTS_VC_LDO_OC_F_SHIFT                    5
#define PMU_INTS_PKEYLP_R_ADDR                        PMU_INTSTS1
#define PMU_INTS_PKEYLP_R_MASK                        0x1
#define PMU_INTS_PKEYLP_R_SHIFT                       6
#define PMU_INTS_PKEYLP_F_ADDR                        PMU_INTSTS1
#define PMU_INTS_PKEYLP_F_MASK                        0x1
#define PMU_INTS_PKEYLP_F_SHIFT                       7
#define PMU_INTS_THM1_R_ADDR                          PMU_INTSTS2
#define PMU_INTS_THM1_R_MASK                          0x1
#define PMU_INTS_THM1_R_SHIFT                         0
#define PMU_INTS_THM1_F_ADDR                          PMU_INTSTS2
#define PMU_INTS_THM1_F_MASK                          0x1
#define PMU_INTS_THM1_F_SHIFT                         1
#define PMU_INTS_THM2_R_ADDR                          PMU_INTSTS2
#define PMU_INTS_THM2_R_MASK                          0x1
#define PMU_INTS_THM2_R_SHIFT                         2
#define PMU_INTS_THM2_F_ADDR                          PMU_INTSTS2
#define PMU_INTS_THM2_F_MASK                          0x1
#define PMU_INTS_THM2_F_SHIFT                         3
#define PMU_INTS_AXPKEY_R_ADDR                        PMU_INTSTS2
#define PMU_INTS_AXPKEY_R_MASK                        0x1
#define PMU_INTS_AXPKEY_R_SHIFT                       4
#define PMU_INTS_AXPKEY_F_ADDR                        PMU_INTSTS2
#define PMU_INTS_AXPKEY_F_MASK                        0x1
#define PMU_INTS_AXPKEY_F_SHIFT                       5
#define PMU_INTS_PWRKEY_R_ADDR                        PMU_INTSTS2
#define PMU_INTS_PWRKEY_R_MASK                        0x1
#define PMU_INTS_PWRKEY_R_SHIFT                       6
#define PMU_INTS_PWRKEY_F_ADDR                        PMU_INTSTS2
#define PMU_INTS_PWRKEY_F_MASK                        0x1
#define PMU_INTS_PWRKEY_F_SHIFT                       7
#define PMU_INTS_CHGOV_R_ADDR                         PMU_INTSTS3
#define PMU_INTS_CHGOV_R_MASK                         0x1
#define PMU_INTS_CHGOV_R_SHIFT                        0
#define PMU_INTS_CHGOV_F_ADDR                         PMU_INTSTS3
#define PMU_INTS_CHGOV_F_MASK                         0x1
#define PMU_INTS_CHGOV_F_SHIFT                        1
#define PMU_INTS_CHRDET_R_ADDR                        PMU_INTSTS3
#define PMU_INTS_CHRDET_R_MASK                        0x1
#define PMU_INTS_CHRDET_R_SHIFT                       2
#define PMU_INTS_CHRDET_F_ADDR                        PMU_INTSTS3
#define PMU_INTS_CHRDET_F_MASK                        0x1
#define PMU_INTS_CHRDET_F_SHIFT                       3
#define PMU_INTS_THR_H_R_ADDR                         PMU_INTSTS3
#define PMU_INTS_THR_H_R_MASK                         0x1
#define PMU_INTS_THR_H_R_SHIFT                        4
#define PMU_INTS_THR_H_F_ADDR                         PMU_INTSTS3
#define PMU_INTS_THR_H_F_MASK                         0x1
#define PMU_INTS_THR_H_F_SHIFT                        5
#define PMU_INTS_THR_L_R_ADDR                         PMU_INTSTS3
#define PMU_INTS_THR_L_R_MASK                         0x1
#define PMU_INTS_THR_L_R_SHIFT                        6
#define PMU_INTS_THR_L_F_ADDR                         PMU_INTSTS3
#define PMU_INTS_THR_L_F_MASK                         0x1
#define PMU_INTS_THR_L_F_SHIFT                        7
#define PMU_INTS_OVER110_R_ADDR                       PMU_INTSTS4
#define PMU_INTS_OVER110_R_MASK                       0x1
#define PMU_INTS_OVER110_R_SHIFT                      0
#define PMU_INTS_OVER110_F_ADDR                       PMU_INTSTS4
#define PMU_INTS_OVER110_F_MASK                       0x1
#define PMU_INTS_OVER110_F_SHIFT                      1
#define PMU_INTS_OVER40_R_ADDR                        PMU_INTSTS4
#define PMU_INTS_OVER40_R_MASK                        0x1
#define PMU_INTS_OVER40_R_SHIFT                       2
#define PMU_INTS_OVER40_F_ADDR                        PMU_INTSTS4
#define PMU_INTS_OVER40_F_MASK                        0x1
#define PMU_INTS_OVER40_F_SHIFT                       3
#define PMU_INTS_PSW_PG_R_ADDR                        PMU_INTSTS4
#define PMU_INTS_PSW_PG_R_MASK                        0x1
#define PMU_INTS_PSW_PG_R_SHIFT                       4
#define PMU_INTS_PSW_PG_F_ADDR                        PMU_INTSTS4
#define PMU_INTS_PSW_PG_F_MASK                        0x1
#define PMU_INTS_PSW_PG_F_SHIFT                       5
#define PMU_INTS_BAT_H_LV_ADDR                        PMU_INTSTS5
#define PMU_INTS_BAT_H_LV_MASK                        0x1
#define PMU_INTS_BAT_H_LV_SHIFT                       0
#define PMU_INTS_BAT_L_LV_ADDR                        PMU_INTSTS5
#define PMU_INTS_BAT_L_LV_MASK                        0x1
#define PMU_INTS_BAT_L_LV_SHIFT                       1
#define PMU_INTS_VBATON_HV_LV_ADDR                    PMU_INTSTS5
#define PMU_INTS_VBATON_HV_LV_MASK                    0x1
#define PMU_INTS_VBATON_HV_LV_SHIFT                   2
#define PMU_INTS_VBAT_UNDET_LV_ADDR                   PMU_INTSTS5
#define PMU_INTS_VBAT_UNDET_LV_MASK                   0x1
#define PMU_INTS_VBAT_UNDET_LV_SHIFT                  3
#define PMU_INTS_BVALID_DET_LV_ADDR                   PMU_INTSTS5
#define PMU_INTS_BVALID_DET_LV_MASK                   0x1
#define PMU_INTS_BVALID_DET_LV_SHIFT                  4
#define PMU_INTS_CHRWDT_LV_ADDR                       PMU_INTSTS5
#define PMU_INTS_CHRWDT_LV_MASK                       0x1
#define PMU_INTS_CHRWDT_LV_SHIFT                      5
#define PMU_INTS_HOT_LV_ADDR                          PMU_INTSTS5
#define PMU_INTS_HOT_LV_MASK                          0x1
#define PMU_INTS_HOT_LV_SHIFT                         6
#define PMU_INTS_WARM_LV_ADDR                         PMU_INTSTS5
#define PMU_INTS_WARM_LV_MASK                         0x1
#define PMU_INTS_WARM_LV_SHIFT                        7
#define PMU_INTS_COOL_LV_ADDR                         PMU_INTSTS6
#define PMU_INTS_COOL_LV_MASK                         0x1
#define PMU_INTS_COOL_LV_SHIFT                        0
#define PMU_INTS_COLD_LV_ADDR                         PMU_INTSTS6
#define PMU_INTS_COLD_LV_MASK                         0x1
#define PMU_INTS_COLD_LV_SHIFT                        1
#define PMU_INTS_IMP_LV_ADDR                          PMU_INTSTS6
#define PMU_INTS_IMP_LV_MASK                          0x1
#define PMU_INTS_IMP_LV_SHIFT                         2
#define PMU_INTS_NAG_C_LV_ADDR                        PMU_INTSTS6
#define PMU_INTS_NAG_C_LV_MASK                        0x1
#define PMU_INTS_NAG_C_LV_SHIFT                       3
#define PMU_INTS_AD_LBAT_LV_ADDR                      PMU_INTSTS6
#define PMU_INTS_AD_LBAT_LV_MASK                      0x1
#define PMU_INTS_AD_LBAT_LV_SHIFT                     4
#define PMU_INTE_ALDO_OC_R_ADDR                       PMU_INTEN0
#define PMU_INTE_ALDO_OC_R_MASK                       0x1
#define PMU_INTE_ALDO_OC_R_SHIFT                      0
#define PMU_INTE_ALDO_OC_F_ADDR                       PMU_INTEN0
#define PMU_INTE_ALDO_OC_F_MASK                       0x1
#define PMU_INTE_ALDO_OC_F_SHIFT                      1
#define PMU_INTE_ALDO_PG_R_ADDR                       PMU_INTEN0
#define PMU_INTE_ALDO_PG_R_MASK                       0x1
#define PMU_INTE_ALDO_PG_R_SHIFT                      2
#define PMU_INTE_ALDO_PG_F_ADDR                       PMU_INTEN0
#define PMU_INTE_ALDO_PG_F_MASK                       0x1
#define PMU_INTE_ALDO_PG_F_SHIFT                      3
#define PMU_INTE_DLDO_OC_R_ADDR                       PMU_INTEN0
#define PMU_INTE_DLDO_OC_R_MASK                       0x1
#define PMU_INTE_DLDO_OC_R_SHIFT                      4
#define PMU_INTE_DLDO_OC_F_ADDR                       PMU_INTEN0
#define PMU_INTE_DLDO_OC_F_MASK                       0x1
#define PMU_INTE_DLDO_OC_F_SHIFT                      5
#define PMU_INTE_DLDO_PG_R_ADDR                       PMU_INTEN0
#define PMU_INTE_DLDO_PG_R_MASK                       0x1
#define PMU_INTE_DLDO_PG_R_SHIFT                      6
#define PMU_INTE_DLDO_PG_F_ADDR                       PMU_INTEN0
#define PMU_INTE_DLDO_PG_F_MASK                       0x1
#define PMU_INTE_DLDO_PG_F_SHIFT                      7
#define PMU_INTE_VC_BUCK_OC_R_ADDR                    PMU_INTEN1
#define PMU_INTE_VC_BUCK_OC_R_MASK                    0x1
#define PMU_INTE_VC_BUCK_OC_R_SHIFT                   0
#define PMU_INTE_VC_BUCK_OC_F_ADDR                    PMU_INTEN1
#define PMU_INTE_VC_BUCK_OC_F_MASK                    0x1
#define PMU_INTE_VC_BUCK_OC_F_SHIFT                   1
#define PMU_INTE_VCORE_PG_R_ADDR                      PMU_INTEN1
#define PMU_INTE_VCORE_PG_R_MASK                      0x1
#define PMU_INTE_VCORE_PG_R_SHIFT                     2
#define PMU_INTE_VCORE_PG_F_ADDR                      PMU_INTEN1
#define PMU_INTE_VCORE_PG_F_MASK                      0x1
#define PMU_INTE_VCORE_PG_F_SHIFT                     3
#define PMU_INTE_VC_LDO_OC_R_ADDR                     PMU_INTEN1
#define PMU_INTE_VC_LDO_OC_R_MASK                     0x1
#define PMU_INTE_VC_LDO_OC_R_SHIFT                    4
#define PMU_INTE_VC_LDO_OC_F_ADDR                     PMU_INTEN1
#define PMU_INTE_VC_LDO_OC_F_MASK                     0x1
#define PMU_INTE_VC_LDO_OC_F_SHIFT                    5
#define PMU_INTE_PKEYLP_R_ADDR                        PMU_INTEN1
#define PMU_INTE_PKEYLP_R_MASK                        0x1
#define PMU_INTE_PKEYLP_R_SHIFT                       6
#define PMU_INTE_PKEYLP_F_ADDR                        PMU_INTEN1
#define PMU_INTE_PKEYLP_F_MASK                        0x1
#define PMU_INTE_PKEYLP_F_SHIFT                       7
#define PMU_INTE_THM1_R_ADDR                          PMU_INTEN2
#define PMU_INTE_THM1_R_MASK                          0x1
#define PMU_INTE_THM1_R_SHIFT                         0
#define PMU_INTE_THM1_F_ADDR                          PMU_INTEN2
#define PMU_INTE_THM1_F_MASK                          0x1
#define PMU_INTE_THM1_F_SHIFT                         1
#define PMU_INTE_THM2_R_ADDR                          PMU_INTEN2
#define PMU_INTE_THM2_R_MASK                          0x1
#define PMU_INTE_THM2_R_SHIFT                         2
#define PMU_INTE_THM2_F_ADDR                          PMU_INTEN2
#define PMU_INTE_THM2_F_MASK                          0x1
#define PMU_INTE_THM2_F_SHIFT                         3
#define PMU_INTE_AXPKEY_R_ADDR                        PMU_INTEN2
#define PMU_INTE_AXPKEY_R_MASK                        0x1
#define PMU_INTE_AXPKEY_R_SHIFT                       4
#define PMU_INTE_AXPKEY_F_ADDR                        PMU_INTEN2
#define PMU_INTE_AXPKEY_F_MASK                        0x1
#define PMU_INTE_AXPKEY_F_SHIFT                       5
#define PMU_INTE_PWRKEY_R_ADDR                        PMU_INTEN2
#define PMU_INTE_PWRKEY_R_MASK                        0x1
#define PMU_INTE_PWRKEY_R_SHIFT                       6
#define PMU_INTE_PWRKEY_F_ADDR                        PMU_INTEN2
#define PMU_INTE_PWRKEY_F_MASK                        0x1
#define PMU_INTE_PWRKEY_F_SHIFT                       7
#define PMU_INTE_CHGOV_R_ADDR                         PMU_INTEN3
#define PMU_INTE_CHGOV_R_MASK                         0x1
#define PMU_INTE_CHGOV_R_SHIFT                        0
#define PMU_INTE_CHGOV_F_ADDR                         PMU_INTEN3
#define PMU_INTE_CHGOV_F_MASK                         0x1
#define PMU_INTE_CHGOV_F_SHIFT                        1
#define PMU_INTE_CHRDET_R_ADDR                        PMU_INTEN3
#define PMU_INTE_CHRDET_R_MASK                        0x1
#define PMU_INTE_CHRDET_R_SHIFT                       2
#define PMU_INTE_CHRDET_F_ADDR                        PMU_INTEN3
#define PMU_INTE_CHRDET_F_MASK                        0x1
#define PMU_INTE_CHRDET_F_SHIFT                       3
#define PMU_INTE_THR_H_R_ADDR                         PMU_INTEN3
#define PMU_INTE_THR_H_R_MASK                         0x1
#define PMU_INTE_THR_H_R_SHIFT                        4
#define PMU_INTE_THR_H_F_ADDR                         PMU_INTEN3
#define PMU_INTE_THR_H_F_MASK                         0x1
#define PMU_INTE_THR_H_F_SHIFT                        5
#define PMU_INTE_THR_L_R_ADDR                         PMU_INTEN3
#define PMU_INTE_THR_L_R_MASK                         0x1
#define PMU_INTE_THR_L_R_SHIFT                        6
#define PMU_INTE_THR_L_F_ADDR                         PMU_INTEN3
#define PMU_INTE_THR_L_F_MASK                         0x1
#define PMU_INTE_THR_L_F_SHIFT                        7
#define PMU_INTE_OVER110_R_ADDR                       PMU_INTEN4
#define PMU_INTE_OVER110_R_MASK                       0x1
#define PMU_INTE_OVER110_R_SHIFT                      0
#define PMU_INTE_OVER110_F_ADDR                       PMU_INTEN4
#define PMU_INTE_OVER110_F_MASK                       0x1
#define PMU_INTE_OVER110_F_SHIFT                      1
#define PMU_INTE_OVER40_R_ADDR                        PMU_INTEN4
#define PMU_INTE_OVER40_R_MASK                        0x1
#define PMU_INTE_OVER40_R_SHIFT                       2
#define PMU_INTE_OVER40_F_ADDR                        PMU_INTEN4
#define PMU_INTE_OVER40_F_MASK                        0x1
#define PMU_INTE_OVER40_F_SHIFT                       3
#define PMU_INTE_PSW_PG_R_ADDR                        PMU_INTEN4
#define PMU_INTE_PSW_PG_R_MASK                        0x1
#define PMU_INTE_PSW_PG_R_SHIFT                       4
#define PMU_INTE_PSW_PG_F_ADDR                        PMU_INTEN4
#define PMU_INTE_PSW_PG_F_MASK                        0x1
#define PMU_INTE_PSW_PG_F_SHIFT                       5
#define PMU_INTE_BAT_H_LV_ADDR                        PMU_INTEN5
#define PMU_INTE_BAT_H_LV_MASK                        0x1
#define PMU_INTE_BAT_H_LV_SHIFT                       0
#define PMU_INTE_BAT_L_LV_ADDR                        PMU_INTEN5
#define PMU_INTE_BAT_L_LV_MASK                        0x1
#define PMU_INTE_BAT_L_LV_SHIFT                       1
#define PMU_INTE_VBATON_HV_LV_ADDR                    PMU_INTEN5
#define PMU_INTE_VBATON_HV_LV_MASK                    0x1
#define PMU_INTE_VBATON_HV_LV_SHIFT                   2
#define PMU_INTE_VBAT_UNDET_LV_ADDR                   PMU_INTEN5
#define PMU_INTE_VBAT_UNDET_LV_MASK                   0x1
#define PMU_INTE_VBAT_UNDET_LV_SHIFT                  3
#define PMU_INTE_BVALID_DET_LV_ADDR                   PMU_INTEN5
#define PMU_INTE_BVALID_DET_LV_MASK                   0x1
#define PMU_INTE_BVALID_DET_LV_SHIFT                  4
#define PMU_INTE_CHRWDT_LV_ADDR                       PMU_INTEN5
#define PMU_INTE_CHRWDT_LV_MASK                       0x1
#define PMU_INTE_CHRWDT_LV_SHIFT                      5
#define PMU_INTE_HOT_LV_ADDR                          PMU_INTEN5
#define PMU_INTE_HOT_LV_MASK                          0x1
#define PMU_INTE_HOT_LV_SHIFT                         6
#define PMU_INTE_WARM_LV_ADDR                         PMU_INTEN5
#define PMU_INTE_WARM_LV_MASK                         0x1
#define PMU_INTE_WARM_LV_SHIFT                        7
#define PMU_INTE_COOL_LV_ADDR                         PMU_INTEN6
#define PMU_INTE_COOL_LV_MASK                         0x1
#define PMU_INTE_COOL_LV_SHIFT                        0
#define PMU_INTE_COLD_LV_ADDR                         PMU_INTEN6
#define PMU_INTE_COLD_LV_MASK                         0x1
#define PMU_INTE_COLD_LV_SHIFT                        1
#define PMU_INTE_IMP_LV_ADDR                          PMU_INTEN6
#define PMU_INTE_IMP_LV_MASK                          0x1
#define PMU_INTE_IMP_LV_SHIFT                         2
#define PMU_INTE_NAG_C_LV_ADDR                        PMU_INTEN6
#define PMU_INTE_NAG_C_LV_MASK                        0x1
#define PMU_INTE_NAG_C_LV_SHIFT                       3
#define PMU_INTE_AD_LBAT_LV_ADDR                      PMU_INTEN6
#define PMU_INTE_AD_LBAT_LV_MASK                      0x1
#define PMU_INTE_AD_LBAT_LV_SHIFT                     4
#define PMU_POLARITY_ADDR                             PMU_INTMISC
#define PMU_POLARITY_MASK                             0x1
#define PMU_POLARITY_SHIFT                            0
#define PMU_RG_INTR_MODE_SEL_ADDR                     PMU_INTMISC
#define PMU_RG_INTR_MODE_SEL_MASK                     0x1
#define PMU_RG_INTR_MODE_SEL_SHIFT                    1
#define PMU_STS_PWRKEY_ADDR                           PMU_PONSTS
#define PMU_STS_PWRKEY_MASK                           0x1
#define PMU_STS_PWRKEY_SHIFT                          0
#define PMU_STS_RTCA_ADDR                             PMU_PONSTS
#define PMU_STS_RTCA_MASK                             0x1
#define PMU_STS_RTCA_SHIFT                            1
#define PMU_STS_CHRIN_ADDR                            PMU_PONSTS
#define PMU_STS_CHRIN_MASK                            0x1
#define PMU_STS_CHRIN_SHIFT                           2
#define PMU_STS_SPAR_ADDR                             PMU_PONSTS
#define PMU_STS_SPAR_MASK                             0x1
#define PMU_STS_SPAR_SHIFT                            3
#define PMU_STS_RBOOT_ADDR                            PMU_PONSTS
#define PMU_STS_RBOOT_MASK                            0x1
#define PMU_STS_RBOOT_SHIFT                           4
#define PMU_STS_UVLO_ADDR                             PMU_POFFSTS
#define PMU_STS_UVLO_MASK                             0x1
#define PMU_STS_UVLO_SHIFT                            0
#define PMU_STS_PGFAIL_ADDR                           PMU_POFFSTS
#define PMU_STS_PGFAIL_MASK                           0x1
#define PMU_STS_PGFAIL_SHIFT                          1
#define PMU_STS_PSOC_ADDR                             PMU_POFFSTS
#define PMU_STS_PSOC_MASK                             0x1
#define PMU_STS_PSOC_SHIFT                            2
#define PMU_STS_THRDN_ADDR                            PMU_POFFSTS
#define PMU_STS_THRDN_MASK                            0x1
#define PMU_STS_THRDN_SHIFT                           3
#define PMU_STS_WRST_ADDR                             PMU_POFFSTS
#define PMU_STS_WRST_MASK                             0x1
#define PMU_STS_WRST_SHIFT                            4
#define PMU_STS_CRST_ADDR                             PMU_POFFSTS
#define PMU_STS_CRST_MASK                             0x1
#define PMU_STS_CRST_SHIFT                            5
#define PMU_STS_PKEYLP_ADDR                           PMU_POFFSTS
#define PMU_STS_PKEYLP_MASK                           0x1
#define PMU_STS_PKEYLP_SHIFT                          6
#define PMU_STS_NORMOFF_ADDR                          PMU_POFFSTS
#define PMU_STS_NORMOFF_MASK                          0x1
#define PMU_STS_NORMOFF_SHIFT                         7
#define PMU_STS_PDN_VBT_PG_ADDR                       PMU_PDNSTS0
#define PMU_STS_PDN_VBT_PG_MASK                       0x1
#define PMU_STS_PDN_VBT_PG_SHIFT                      0
#define PMU_STS_PDN_VA_PG_ADDR                        PMU_PDNSTS0
#define PMU_STS_PDN_VA_PG_MASK                        0x1
#define PMU_STS_PDN_VA_PG_SHIFT                       1
#define PMU_STS_PDN_VCAMA_PG_ADDR                     PMU_PDNSTS0
#define PMU_STS_PDN_VCAMA_PG_MASK                     0x1
#define PMU_STS_PDN_VCAMA_PG_SHIFT                    2
#define PMU_STS_PDN_VA18_PG_ADDR                      PMU_PDNSTS0
#define PMU_STS_PDN_VA18_PG_MASK                      0x1
#define PMU_STS_PDN_VA18_PG_SHIFT                     3
#define PMU_STS_PDN_VCORE_PG_ADDR                     PMU_PDNSTS0
#define PMU_STS_PDN_VCORE_PG_MASK                     0x1
#define PMU_STS_PDN_VCORE_PG_SHIFT                    4
#define PMU_STS_PDN_VIO18_PG_ADDR                     PMU_PDNSTS0
#define PMU_STS_PDN_VIO18_PG_MASK                     0x1
#define PMU_STS_PDN_VIO18_PG_SHIFT                    5
#define PMU_STS_PDN_VSF_PG_ADDR                       PMU_PDNSTS0
#define PMU_STS_PDN_VSF_PG_MASK                       0x1
#define PMU_STS_PDN_VSF_PG_SHIFT                      6
#define PMU_STS_PDN_SWXM_PG_ADDR                      PMU_PDNSTS1
#define PMU_STS_PDN_SWXM_PG_MASK                      0x1
#define PMU_STS_PDN_SWXM_PG_SHIFT                     0
#define PMU_STS_PDN_SWDP_PG_ADDR                      PMU_PDNSTS1
#define PMU_STS_PDN_SWDP_PG_MASK                      0x1
#define PMU_STS_PDN_SWDP_PG_SHIFT                     1
#define PMU_STS_PDN_VIO28_PG_ADDR                     PMU_PDNSTS1
#define PMU_STS_PDN_VIO28_PG_MASK                     0x1
#define PMU_STS_PDN_VIO28_PG_SHIFT                    2
#define PMU_STS_PDN_SWMP_PG_ADDR                      PMU_PDNSTS1
#define PMU_STS_PDN_SWMP_PG_MASK                      0x1
#define PMU_STS_PDN_SWMP_PG_SHIFT                     3
#define PMU_STS_PDN_VMC_PG_ADDR                       PMU_PDNSTS1
#define PMU_STS_PDN_VMC_PG_MASK                       0x1
#define PMU_STS_PDN_VMC_PG_SHIFT                      4
#define PMU_STS_PDN_VUSB_PG_ADDR                      PMU_PDNSTS1
#define PMU_STS_PDN_VUSB_PG_MASK                      0x1
#define PMU_STS_PDN_VUSB_PG_SHIFT                     5
#define PMU_STS_PDN_VIBR_PG_ADDR                      PMU_PDNSTS1
#define PMU_STS_PDN_VIBR_PG_MASK                      0x1
#define PMU_STS_PDN_VIBR_PG_SHIFT                     6
#define PMU_STS_PDN_SWBAT_PG_ADDR                     PMU_PDNSTS1
#define PMU_STS_PDN_SWBAT_PG_MASK                     0x1
#define PMU_STS_PDN_SWBAT_PG_SHIFT                    7
#define PMU_STS_PDN_VMC_OC_ADDR                       PMU_PDNSTS2
#define PMU_STS_PDN_VMC_OC_MASK                       0x1
#define PMU_STS_PDN_VMC_OC_SHIFT                      0
#define PMU_STS_PDN_VA_OC_ADDR                        PMU_PDNSTS2
#define PMU_STS_PDN_VA_OC_MASK                        0x1
#define PMU_STS_PDN_VA_OC_SHIFT                       1
#define PMU_STS_PDN_VIO28_OC_ADDR                     PMU_PDNSTS2
#define PMU_STS_PDN_VIO28_OC_MASK                     0x1
#define PMU_STS_PDN_VIO28_OC_SHIFT                    2
#define PMU_STS_PDN_VCORE_BUCK_OC_ADDR                PMU_PDNSTS2
#define PMU_STS_PDN_VCORE_BUCK_OC_MASK                0x1
#define PMU_STS_PDN_VCORE_BUCK_OC_SHIFT               3
#define PMU_STS_PDN_VCORE_LDO_OC_ADDR                 PMU_PDNSTS2
#define PMU_STS_PDN_VCORE_LDO_OC_MASK                 0x1
#define PMU_STS_PDN_VCORE_LDO_OC_SHIFT                4
#define PMU_STS_PDN_VIO18_OC_ADDR                     PMU_PDNSTS2
#define PMU_STS_PDN_VIO18_OC_MASK                     0x1
#define PMU_STS_PDN_VIO18_OC_SHIFT                    5
#define PMU_STS_IVGEN_EN_ADDR                         PMU_PSSTS0
#define PMU_STS_IVGEN_EN_MASK                         0x1
#define PMU_STS_IVGEN_EN_SHIFT                        0
#define PMU_STS_OSC_EN_ADDR                           PMU_PSSTS0
#define PMU_STS_OSC_EN_MASK                           0x1
#define PMU_STS_OSC_EN_SHIFT                          1
#define PMU_STS_VUSB_ENA_ADDR                         PMU_PSSTS0
#define PMU_STS_VUSB_ENA_MASK                         0x1
#define PMU_STS_VUSB_ENA_SHIFT                        2
#define PMU_STS_VCAMA_ENA_ADDR                        PMU_PSSTS0
#define PMU_STS_VCAMA_ENA_MASK                        0x1
#define PMU_STS_VCAMA_ENA_SHIFT                       3
#define PMU_STS_VBT_ENA_ADDR                          PMU_PSSTS0
#define PMU_STS_VBT_ENA_MASK                          0x1
#define PMU_STS_VBT_ENA_SHIFT                         4
#define PMU_STS_VA_ENA_ADDR                           PMU_PSSTS0
#define PMU_STS_VA_ENA_MASK                           0x1
#define PMU_STS_VA_ENA_SHIFT                          5
#define PMU_STS_VA18_ENA_ADDR                         PMU_PSSTS0
#define PMU_STS_VA18_ENA_MASK                         0x1
#define PMU_STS_VA18_ENA_SHIFT                        6
#define PMU_STS_VC_BUCK_ENA_ADDR                      PMU_PSSTS1
#define PMU_STS_VC_BUCK_ENA_MASK                      0x1
#define PMU_STS_VC_BUCK_ENA_SHIFT                     0
#define PMU_STS_VC_LDO_ENA_ADDR                       PMU_PSSTS1
#define PMU_STS_VC_LDO_ENA_MASK                       0x1
#define PMU_STS_VC_LDO_ENA_SHIFT                      1
#define PMU_STS_VIO18_ENA_ADDR                        PMU_PSSTS1
#define PMU_STS_VIO18_ENA_MASK                        0x1
#define PMU_STS_VIO18_ENA_SHIFT                       2
#define PMU_STS_VSF_ENA_ADDR                          PMU_PSSTS1
#define PMU_STS_VSF_ENA_MASK                          0x1
#define PMU_STS_VSF_ENA_SHIFT                         3
#define PMU_STS_VIO28_ENA_ADDR                        PMU_PSSTS1
#define PMU_STS_VIO28_ENA_MASK                        0x1
#define PMU_STS_VIO28_ENA_SHIFT                       4
#define PMU_STS_VMC_ENA_ADDR                          PMU_PSSTS1
#define PMU_STS_VMC_ENA_MASK                          0x1
#define PMU_STS_VMC_ENA_SHIFT                         5
#define PMU_STS_VIBR_ENA_ADDR                         PMU_PSSTS1
#define PMU_STS_VIBR_ENA_MASK                         0x1
#define PMU_STS_VIBR_ENA_SHIFT                        6
#define PMU_STS_SWBAT_ENA_ADDR                        PMU_PSSTS2
#define PMU_STS_SWBAT_ENA_MASK                        0x1
#define PMU_STS_SWBAT_ENA_SHIFT                       0
#define PMU_STS_SWXM_ENA_ADDR                         PMU_PSSTS2
#define PMU_STS_SWXM_ENA_MASK                         0x1
#define PMU_STS_SWXM_ENA_SHIFT                        1
#define PMU_STS_SWDP_ENA_ADDR                         PMU_PSSTS2
#define PMU_STS_SWDP_ENA_MASK                         0x1
#define PMU_STS_SWDP_ENA_SHIFT                        2
#define PMU_STS_SWMP_ENA_ADDR                         PMU_PSSTS2
#define PMU_STS_SWMP_ENA_MASK                         0x1
#define PMU_STS_SWMP_ENA_SHIFT                        3
#define PMU_PWRKEY_VAL_ADDR                           PMU_PSSTS2
#define PMU_PWRKEY_VAL_MASK                           0x1
#define PMU_PWRKEY_VAL_SHIFT                          4
#define PMU_AXPKEY_VAL_ADDR                           PMU_PSSTS2
#define PMU_AXPKEY_VAL_MASK                           0x1
#define PMU_AXPKEY_VAL_SHIFT                          5
#define PMU_PKEYLP_VAL_ADDR                           PMU_PSSTS2
#define PMU_PKEYLP_VAL_MASK                           0x1
#define PMU_PKEYLP_VAL_SHIFT                          6
#define PMU_STS_VBT_OC_ADDR                           PMU_PSOCSTS0
#define PMU_STS_VBT_OC_MASK                           0x1
#define PMU_STS_VBT_OC_SHIFT                          0
#define PMU_STS_VA_OC_ADDR                            PMU_PSOCSTS0
#define PMU_STS_VA_OC_MASK                            0x1
#define PMU_STS_VA_OC_SHIFT                           1
#define PMU_STS_VA18_OC_ADDR                          PMU_PSOCSTS0
#define PMU_STS_VA18_OC_MASK                          0x1
#define PMU_STS_VA18_OC_SHIFT                         2
#define PMU_STS_VC_BUCK_OC_ADDR                       PMU_PSOCSTS0
#define PMU_STS_VC_BUCK_OC_MASK                       0x1
#define PMU_STS_VC_BUCK_OC_SHIFT                      3
#define PMU_STS_VC_LDO_OC_ADDR                        PMU_PSOCSTS0
#define PMU_STS_VC_LDO_OC_MASK                        0x1
#define PMU_STS_VC_LDO_OC_SHIFT                       4
#define PMU_STS_VIO18_OC_ADDR                         PMU_PSOCSTS0
#define PMU_STS_VIO18_OC_MASK                         0x1
#define PMU_STS_VIO18_OC_SHIFT                        5
#define PMU_STS_VSF_OC_ADDR                           PMU_PSOCSTS0
#define PMU_STS_VSF_OC_MASK                           0x1
#define PMU_STS_VSF_OC_SHIFT                          6
#define PMU_STS_VIO28_OC_ADDR                         PMU_PSOCSTS1
#define PMU_STS_VIO28_OC_MASK                         0x1
#define PMU_STS_VIO28_OC_SHIFT                        0
#define PMU_STS_VMC_OC_ADDR                           PMU_PSOCSTS1
#define PMU_STS_VMC_OC_MASK                           0x1
#define PMU_STS_VMC_OC_SHIFT                          1
#define PMU_STS_VUSB_OC_ADDR                          PMU_PSOCSTS1
#define PMU_STS_VUSB_OC_MASK                          0x1
#define PMU_STS_VUSB_OC_SHIFT                         2
#define PMU_STS_VCAMA_OC_ADDR                         PMU_PSOCSTS1
#define PMU_STS_VCAMA_OC_MASK                         0x1
#define PMU_STS_VCAMA_OC_SHIFT                        3
#define PMU_STS_VIBR_OC_ADDR                          PMU_PSOCSTS1
#define PMU_STS_VIBR_OC_MASK                          0x1
#define PMU_STS_VIBR_OC_SHIFT                         4
#define PMU_STS_VBT_PG_ADDR                           PMU_PSPGSTS0
#define PMU_STS_VBT_PG_MASK                           0x1
#define PMU_STS_VBT_PG_SHIFT                          0
#define PMU_STS_VA_PG_ADDR                            PMU_PSPGSTS0
#define PMU_STS_VA_PG_MASK                            0x1
#define PMU_STS_VA_PG_SHIFT                           1
#define PMU_STS_VCAMA_PG_ADDR                         PMU_PSPGSTS0
#define PMU_STS_VCAMA_PG_MASK                         0x1
#define PMU_STS_VCAMA_PG_SHIFT                        2
#define PMU_STS_VA18_PG_ADDR                          PMU_PSPGSTS0
#define PMU_STS_VA18_PG_MASK                          0x1
#define PMU_STS_VA18_PG_SHIFT                         3
#define PMU_STS_VCORE_PG_ADDR                         PMU_PSPGSTS0
#define PMU_STS_VCORE_PG_MASK                         0x1
#define PMU_STS_VCORE_PG_SHIFT                        4
#define PMU_STS_VIO18_PG_ADDR                         PMU_PSPGSTS0
#define PMU_STS_VIO18_PG_MASK                         0x1
#define PMU_STS_VIO18_PG_SHIFT                        5
#define PMU_STS_VSF_PG_ADDR                           PMU_PSPGSTS0
#define PMU_STS_VSF_PG_MASK                           0x1
#define PMU_STS_VSF_PG_SHIFT                          6
#define PMU_STS_SWXM_PG_ADDR                          PMU_PSPGSTS1
#define PMU_STS_SWXM_PG_MASK                          0x1
#define PMU_STS_SWXM_PG_SHIFT                         0
#define PMU_STS_SWDP_PG_ADDR                          PMU_PSPGSTS1
#define PMU_STS_SWDP_PG_MASK                          0x1
#define PMU_STS_SWDP_PG_SHIFT                         1
#define PMU_STS_VIO28_PG_ADDR                         PMU_PSPGSTS1
#define PMU_STS_VIO28_PG_MASK                         0x1
#define PMU_STS_VIO28_PG_SHIFT                        2
#define PMU_STS_SWMP_PG_ADDR                          PMU_PSPGSTS1
#define PMU_STS_SWMP_PG_MASK                          0x1
#define PMU_STS_SWMP_PG_SHIFT                         3
#define PMU_STS_VMC_PG_ADDR                           PMU_PSPGSTS1
#define PMU_STS_VMC_PG_MASK                           0x1
#define PMU_STS_VMC_PG_SHIFT                          4
#define PMU_STS_VUSB_PG_ADDR                          PMU_PSPGSTS1
#define PMU_STS_VUSB_PG_MASK                          0x1
#define PMU_STS_VUSB_PG_SHIFT                         5
#define PMU_STS_VIBR_PG_ADDR                          PMU_PSPGSTS1
#define PMU_STS_VIBR_PG_MASK                          0x1
#define PMU_STS_VIBR_PG_SHIFT                         6
#define PMU_STS_SWBAT_PG_ADDR                         PMU_PSPGSTS1
#define PMU_STS_SWBAT_PG_MASK                         0x1
#define PMU_STS_SWBAT_PG_SHIFT                        7
#define PMU_STS_VBT_OPMOD_ADDR                        PMU_PSOMSTS0
#define PMU_STS_VBT_OPMOD_MASK                        0x3
#define PMU_STS_VBT_OPMOD_SHIFT                       0
#define PMU_STS_VA_OPMOD_ADDR                         PMU_PSOMSTS0
#define PMU_STS_VA_OPMOD_MASK                         0x3
#define PMU_STS_VA_OPMOD_SHIFT                        2
#define PMU_STS_VCAMA_OPMOD_ADDR                      PMU_PSOMSTS0
#define PMU_STS_VCAMA_OPMOD_MASK                      0x3
#define PMU_STS_VCAMA_OPMOD_SHIFT                     4
#define PMU_STS_VA18_OPMOD_ADDR                       PMU_PSOMSTS0
#define PMU_STS_VA18_OPMOD_MASK                       0x1
#define PMU_STS_VA18_OPMOD_SHIFT                      6
#define PMU_STS_VDIG18_OPMOD_ADDR                     PMU_PSOMSTS1
#define PMU_STS_VDIG18_OPMOD_MASK                     0x3
#define PMU_STS_VDIG18_OPMOD_SHIFT                    0
#define PMU_STS_VC_LDO_OPMOD_ADDR                     PMU_PSOMSTS1
#define PMU_STS_VC_LDO_OPMOD_MASK                     0x3
#define PMU_STS_VC_LDO_OPMOD_SHIFT                    2
#define PMU_STS_VIO18_OPMOD_ADDR                      PMU_PSOMSTS1
#define PMU_STS_VIO18_OPMOD_MASK                      0x3
#define PMU_STS_VIO18_OPMOD_SHIFT                     4
#define PMU_STS_VSF_OPMOD_ADDR                        PMU_PSOMSTS1
#define PMU_STS_VSF_OPMOD_MASK                        0x3
#define PMU_STS_VSF_OPMOD_SHIFT                       6
#define PMU_STS_VIO28_OPMOD_ADDR                      PMU_PSOMSTS2
#define PMU_STS_VIO28_OPMOD_MASK                      0x3
#define PMU_STS_VIO28_OPMOD_SHIFT                     0
#define PMU_STS_VMC_OPMOD_ADDR                        PMU_PSOMSTS2
#define PMU_STS_VMC_OPMOD_MASK                        0x3
#define PMU_STS_VMC_OPMOD_SHIFT                       2
#define PMU_STS_VUSB_OPMOD_ADDR                       PMU_PSOMSTS2
#define PMU_STS_VUSB_OPMOD_MASK                       0x3
#define PMU_STS_VUSB_OPMOD_SHIFT                      4
#define PMU_STS_VIBR_OPMOD_ADDR                       PMU_PSOMSTS2
#define PMU_STS_VIBR_OPMOD_MASK                       0x3
#define PMU_STS_VIBR_OPMOD_SHIFT                      6
#define PMU_STS_THM_OVER40_ADDR                       PMU_THMSTS
#define PMU_STS_THM_OVER40_MASK                       0x1
#define PMU_STS_THM_OVER40_SHIFT                      0
#define PMU_STS_THM_OVER55_ADDR                       PMU_THMSTS
#define PMU_STS_THM_OVER55_MASK                       0x1
#define PMU_STS_THM_OVER55_SHIFT                      1
#define PMU_STS_THM_OVER110_ADDR                      PMU_THMSTS
#define PMU_STS_THM_OVER110_MASK                      0x1
#define PMU_STS_THM_OVER110_SHIFT                     2
#define PMU_STS_THM_OVER125_ADDR                      PMU_THMSTS
#define PMU_STS_THM_OVER125_MASK                      0x1
#define PMU_STS_THM_OVER125_SHIFT                     3
#define PMU_STS_THM_RAW_STS_ADDR                      PMU_THMSTS
#define PMU_STS_THM_RAW_STS_MASK                      0x1
#define PMU_STS_THM_RAW_STS_SHIFT                     4
#define PMU_STS_THM_DEB_STS_ADDR                      PMU_THMSTS
#define PMU_STS_THM_DEB_STS_MASK                      0x1
#define PMU_STS_THM_DEB_STS_SHIFT                     5
#define PMU_STS_WKUP_FG_DONE_ADDR                     PMU_WKFG_STS
#define PMU_STS_WKUP_FG_DONE_MASK                     0x1
#define PMU_STS_WKUP_FG_DONE_SHIFT                    0
#define PMU_RG_VRC_CFG_KEY0_ADDR                      PMU_PSICKEY0
#define PMU_RG_VRC_CFG_KEY0_MASK                      0xFF
#define PMU_RG_VRC_CFG_KEY0_SHIFT                     0
#define PMU_RG_VRC_CFG_KEY1_ADDR                      PMU_PSICKEY1
#define PMU_RG_VRC_CFG_KEY1_MASK                      0xFF
#define PMU_RG_VRC_CFG_KEY1_SHIFT                     0
#define PMU_RG_PSIOVR_ADDR                            PMU_PSICTL
#define PMU_RG_PSIOVR_MASK                            0x1
#define PMU_RG_PSIOVR_SHIFT                           0
#define PMU_RG_HNDOVR_LEN_ADDR                        PMU_PSICTL
#define PMU_RG_HNDOVR_LEN_MASK                        0x3
#define PMU_RG_HNDOVR_LEN_SHIFT                       2
#define PMU_RGS_S0_BGP_LP_ADDR                        PMU_PSISTS
#define PMU_RGS_S0_BGP_LP_MASK                        0x1
#define PMU_RGS_S0_BGP_LP_SHIFT                       0
#define PMU_RGS_S1_BGP_LP_ADDR                        PMU_PSISTS
#define PMU_RGS_S1_BGP_LP_MASK                        0x1
#define PMU_RGS_S1_BGP_LP_SHIFT                       1
#define PMU_RGS_S0_IVGEN_ON_ADDR                      PMU_PSISTS
#define PMU_RGS_S0_IVGEN_ON_MASK                      0x1
#define PMU_RGS_S0_IVGEN_ON_SHIFT                     2
#define PMU_RGS_S1_IVGEN_ON_ADDR                      PMU_PSISTS
#define PMU_RGS_S1_IVGEN_ON_MASK                      0x1
#define PMU_RGS_S1_IVGEN_ON_SHIFT                     3
#define PMU_RGS_S0_VBATSW_ON_ADDR                     PMU_PSISTS
#define PMU_RGS_S0_VBATSW_ON_MASK                     0x1
#define PMU_RGS_S0_VBATSW_ON_SHIFT                    4
#define PMU_RGS_S1_VBATSW_ON_ADDR                     PMU_PSISTS
#define PMU_RGS_S1_VBATSW_ON_MASK                     0x1
#define PMU_RGS_S1_VBATSW_ON_SHIFT                    5
#define PMU_RGS_PSI_STS_ADDR                          PMU_PSISTS
#define PMU_RGS_PSI_STS_MASK                          0x3
#define PMU_RGS_PSI_STS_SHIFT                         6
#define PMU_RG_S0_BGP_LP_EN_ADDR                      PMU_BIASPSI
#define PMU_RG_S0_BGP_LP_EN_MASK                      0x1
#define PMU_RG_S0_BGP_LP_EN_SHIFT                     0
#define PMU_RG_S1_BGP_LP_EN_ADDR                      PMU_BIASPSI
#define PMU_RG_S1_BGP_LP_EN_MASK                      0x1
#define PMU_RG_S1_BGP_LP_EN_SHIFT                     1
#define PMU_RG_S0_IVGEN_OFF_EN_ADDR                   PMU_BIASPSI
#define PMU_RG_S0_IVGEN_OFF_EN_MASK                   0x1
#define PMU_RG_S0_IVGEN_OFF_EN_SHIFT                  2
#define PMU_RG_S1_IVGEN_OFF_EN_ADDR                   PMU_BIASPSI
#define PMU_RG_S1_IVGEN_OFF_EN_MASK                   0x1
#define PMU_RG_S1_IVGEN_OFF_EN_SHIFT                  3
#define PMU_RG_S0_VBATSW_OFF_EN_ADDR                  PMU_BIASPSI
#define PMU_RG_S0_VBATSW_OFF_EN_MASK                  0x1
#define PMU_RG_S0_VBATSW_OFF_EN_SHIFT                 4
#define PMU_RG_S1_VBATSW_OFF_EN_ADDR                  PMU_BIASPSI
#define PMU_RG_S1_VBATSW_OFF_EN_MASK                  0x1
#define PMU_RG_S1_VBATSW_OFF_EN_SHIFT                 5
#define PMU_RG_OFF_VDIG18_PMOD_ADDR                   PMU_VDIG18PSI
#define PMU_RG_OFF_VDIG18_PMOD_MASK                   0x3
#define PMU_RG_OFF_VDIG18_PMOD_SHIFT                  0
#define PMU_RG_ACT_VDIG18_PMOD_ADDR                   PMU_VDIG18PSI
#define PMU_RG_ACT_VDIG18_PMOD_MASK                   0x3
#define PMU_RG_ACT_VDIG18_PMOD_SHIFT                  2
#define PMU_RG_SLP_VDIG18_PMOD_ADDR                   PMU_VDIG18PSI
#define PMU_RG_SLP_VDIG18_PMOD_MASK                   0x3
#define PMU_RG_SLP_VDIG18_PMOD_SHIFT                  4
#define PMU_RG_S0_LP_WKHALT_ADDR                      PMU_PPCPSI
#define PMU_RG_S0_LP_WKHALT_MASK                      0x1
#define PMU_RG_S0_LP_WKHALT_SHIFT                     0
#define PMU_RG_S0_HP_WKHALT_ADDR                      PMU_PPCPSI
#define PMU_RG_S0_HP_WKHALT_MASK                      0x1
#define PMU_RG_S0_HP_WKHALT_SHIFT                     1
#define PMU_RG_S1_LP_WKHALT_ADDR                      PMU_PPCPSI
#define PMU_RG_S1_LP_WKHALT_MASK                      0x1
#define PMU_RG_S1_LP_WKHALT_SHIFT                     2
#define PMU_RG_S1_HP_WKHALT_ADDR                      PMU_PPCPSI
#define PMU_RG_S1_HP_WKHALT_MASK                      0x1
#define PMU_RG_S1_HP_WKHALT_SHIFT                     3
#define PMU_RG_S0_LP_CO_WKHALT_ADDR                   PMU_PPCPSI
#define PMU_RG_S0_LP_CO_WKHALT_MASK                   0x1
#define PMU_RG_S0_LP_CO_WKHALT_SHIFT                  4
#define PMU_RG_S0_HP_CO_WKHALT_ADDR                   PMU_PPCPSI
#define PMU_RG_S0_HP_CO_WKHALT_MASK                   0x1
#define PMU_RG_S0_HP_CO_WKHALT_SHIFT                  5
#define PMU_RG_S1_LP_CO_WKHALT_ADDR                   PMU_PPCPSI
#define PMU_RG_S1_LP_CO_WKHALT_MASK                   0x1
#define PMU_RG_S1_LP_CO_WKHALT_SHIFT                  6
#define PMU_RG_S1_HP_CO_WKHALT_ADDR                   PMU_PPCPSI
#define PMU_RG_S1_HP_CO_WKHALT_MASK                   0x1
#define PMU_RG_S1_HP_CO_WKHALT_SHIFT                  7
#define PMU_RG_THRDET_SEL_ADDR                        PMU_STRUPCTL0
#define PMU_RG_THRDET_SEL_MASK                        0x1
#define PMU_RG_THRDET_SEL_SHIFT                       0
#define PMU_RG_STRUP_THR_SEL_ADDR                     PMU_STRUPCTL0
#define PMU_RG_STRUP_THR_SEL_MASK                     0x3
#define PMU_RG_STRUP_THR_SEL_SHIFT                    1
#define PMU_RG_THR_TMODE_ADDR                         PMU_STRUPCTL0
#define PMU_RG_THR_TMODE_MASK                         0x1
#define PMU_RG_THR_TMODE_SHIFT                        3
#define PMU_RG_VREF_BG_ADDR                           PMU_STRUPCTL0
#define PMU_RG_VREF_BG_MASK                           0x7
#define PMU_RG_VREF_BG_SHIFT                          4
#define PMU_RG_STRUP_IREF_TRIM_LSB_ADDR               PMU_STRUPCTL0
#define PMU_RG_STRUP_IREF_TRIM_LSB_MASK               0x1
#define PMU_RG_STRUP_IREF_TRIM_LSB_SHIFT              7
#define PMU_RG_STRUP_IREF_TRIM_MSB_ADDR               PMU_STRUPCTL1
#define PMU_RG_STRUP_IREF_TRIM_MSB_MASK               0xF
#define PMU_RG_STRUP_IREF_TRIM_MSB_SHIFT              0
#define PMU_RG_RST_DRVSEL_ADDR                        PMU_STRUPCTL1
#define PMU_RG_RST_DRVSEL_MASK                        0x1
#define PMU_RG_RST_DRVSEL_SHIFT                       4
#define PMU_RG_FCHR_KEYDET_EN_ADDR                    PMU_STRUPCTL1
#define PMU_RG_FCHR_KEYDET_EN_MASK                    0x1
#define PMU_RG_FCHR_KEYDET_EN_SHIFT                   6
#define PMU_RG_PMU_RSV_ADDR                           PMU_STRUPCTL2
#define PMU_RG_PMU_RSV_MASK                           0xF
#define PMU_RG_PMU_RSV_SHIFT                          0
#define PMU_RG_FCHR_PU_EN_ADDR                        PMU_STRUPCTL2
#define PMU_RG_FCHR_PU_EN_MASK                        0x1
#define PMU_RG_FCHR_PU_EN_SHIFT                       4
#define PMU_RGS_ANA_CHIP_ID_ADDR                      PMU_STRUPCTL2
#define PMU_RGS_ANA_CHIP_ID_MASK                      0x7
#define PMU_RGS_ANA_CHIP_ID_SHIFT                     5
#define PMU_RG_THM_SHDN_EN_ADDR                       PMU_PPCCFG0
#define PMU_RG_THM_SHDN_EN_MASK                       0x1
#define PMU_RG_THM_SHDN_EN_SHIFT                      0
#define PMU_RG_WDTRST_EN_ADDR                         PMU_PPCCFG0
#define PMU_RG_WDTRST_EN_MASK                         0x1
#define PMU_RG_WDTRST_EN_SHIFT                        1
#define PMU_RG_WDTRST_ACT_ADDR                        PMU_PPCCFG0
#define PMU_RG_WDTRST_ACT_MASK                        0x3
#define PMU_RG_WDTRST_ACT_SHIFT                       2
#define PMU_RG_PSPG_SHDN_EN_ADDR                      PMU_PPCCFG0
#define PMU_RG_PSPG_SHDN_EN_MASK                      0x3
#define PMU_RG_PSPG_SHDN_EN_SHIFT                     4
#define PMU_RG_PHSK_TIME_ADDR                         PMU_PPCCFG0
#define PMU_RG_PHSK_TIME_MASK                         0x3
#define PMU_RG_PHSK_TIME_SHIFT                        6
#define PMU_RG_PWRKEY_TRIG_ADDR                       PMU_PPCCFG1
#define PMU_RG_PWRKEY_TRIG_MASK                       0x1
#define PMU_RG_PWRKEY_TRIG_SHIFT                      0
#define PMU_RG_CHGDET_TRIG_ADDR                       PMU_PPCCFG1
#define PMU_RG_CHGDET_TRIG_MASK                       0x1
#define PMU_RG_CHGDET_TRIG_SHIFT                      1
#define PMU_RG_RSTB_ONINTV_ADDR                       PMU_PPCCFG1
#define PMU_RG_RSTB_ONINTV_MASK                       0x3
#define PMU_RG_RSTB_ONINTV_SHIFT                      2
#define PMU_RG_CRST_INTV_ADDR                         PMU_PPCCFG1
#define PMU_RG_CRST_INTV_MASK                         0x3
#define PMU_RG_CRST_INTV_SHIFT                        4
#define PMU_RG_WRST_INTV_ADDR                         PMU_PPCCFG1
#define PMU_RG_WRST_INTV_MASK                         0x3
#define PMU_RG_WRST_INTV_SHIFT                        6
#define PMU_RG_RTCA_PUP_EN_ADDR                       PMU_PPCCFG2
#define PMU_RG_RTCA_PUP_EN_MASK                       0x1
#define PMU_RG_RTCA_PUP_EN_SHIFT                      0
#define PMU_RG_IMS_RBOOT_EN_ADDR                      PMU_PPCCFG2
#define PMU_RG_IMS_RBOOT_EN_MASK                      0x1
#define PMU_RG_IMS_RBOOT_EN_SHIFT                     1
#define PMU_RG_XRST_ACT_ADDR                          PMU_PPCCFG2
#define PMU_RG_XRST_ACT_MASK                          0x1
#define PMU_RG_XRST_ACT_SHIFT                         2
#define PMU_RG_XRST_EN_ADDR                           PMU_PPCCFG2
#define PMU_RG_XRST_EN_MASK                           0x1
#define PMU_RG_XRST_EN_SHIFT                          3
#define PMU_RG_WDR_PWRCYC_LEN_ADDR                    PMU_PPCCFG2
#define PMU_RG_WDR_PWRCYC_LEN_MASK                    0x1
#define PMU_RG_WDR_PWRCYC_LEN_SHIFT                   4
#define PMU_RG_WDR_VSF_PWRCYC_EN_ADDR                 PMU_PPCCFG2
#define PMU_RG_WDR_VSF_PWRCYC_EN_MASK                 0x1
#define PMU_RG_WDR_VSF_PWRCYC_EN_SHIFT                5
#define PMU_RG_WDR_SWXM_PWRCYC_EN_ADDR                PMU_PPCCFG2
#define PMU_RG_WDR_SWXM_PWRCYC_EN_MASK                0x1
#define PMU_RG_WDR_SWXM_PWRCYC_EN_SHIFT               6
#define PMU_RG_PWRHOLD_ADDR                           PMU_PPCCTL0
#define PMU_RG_PWRHOLD_MASK                           0x1
#define PMU_RG_PWRHOLD_SHIFT                          0
#define PMU_RG_USBDL_MODE_ADDR                        PMU_PPCCTL0
#define PMU_RG_USBDL_MODE_MASK                        0x1
#define PMU_RG_USBDL_MODE_SHIFT                       1
#define PMU_RG_WK_ZCV_EN_ADDR                         PMU_PPCCTL0
#define PMU_RG_WK_ZCV_EN_MASK                         0x1
#define PMU_RG_WK_ZCV_EN_SHIFT                        2
#define PMU_RGS_RESUME_ACT_ADDR                       PMU_PPCCTL0
#define PMU_RGS_RESUME_ACT_MASK                       0x1
#define PMU_RGS_RESUME_ACT_SHIFT                      3
#define PMU_RG_WRST_ADDR                              PMU_PPCCTL0
#define PMU_RG_WRST_MASK                              0x1
#define PMU_RG_WRST_SHIFT                             4
#define PMU_RG_CRST_ADDR                              PMU_PPCCTL0
#define PMU_RG_CRST_MASK                              0x1
#define PMU_RG_CRST_SHIFT                             5
#define PMU_RG_VC_BUCK_OC_EN_ADDR                     PMU_SHDNCFG0
#define PMU_RG_VC_BUCK_OC_EN_MASK                     0x1
#define PMU_RG_VC_BUCK_OC_EN_SHIFT                    0
#define PMU_RG_VC_LDO_OC_EN_ADDR                      PMU_SHDNCFG0
#define PMU_RG_VC_LDO_OC_EN_MASK                      0x1
#define PMU_RG_VC_LDO_OC_EN_SHIFT                     1
#define PMU_RG_VIO18_OC_EN_ADDR                       PMU_SHDNCFG0
#define PMU_RG_VIO18_OC_EN_MASK                       0x1
#define PMU_RG_VIO18_OC_EN_SHIFT                      2
#define PMU_RG_VA_OC_EN_ADDR                          PMU_SHDNCFG0
#define PMU_RG_VA_OC_EN_MASK                          0x1
#define PMU_RG_VA_OC_EN_SHIFT                         3
#define PMU_RG_VIO28_OC_EN_ADDR                       PMU_SHDNCFG0
#define PMU_RG_VIO28_OC_EN_MASK                       0x1
#define PMU_RG_VIO28_OC_EN_SHIFT                      4
#define PMU_RG_VMC_OC_EN_ADDR                         PMU_SHDNCFG0
#define PMU_RG_VMC_OC_EN_MASK                         0x1
#define PMU_RG_VMC_OC_EN_SHIFT                        5
#define PMU_RG_PKEY_CFG_ADDR                          PMU_SHDNCFG1
#define PMU_RG_PKEY_CFG_MASK                          0x3
#define PMU_RG_PKEY_CFG_SHIFT                         0
#define PMU_RG_PKEY_LTIME_ADDR                        PMU_SHDNCFG1
#define PMU_RG_PKEY_LTIME_MASK                        0x3
#define PMU_RG_PKEY_LTIME_SHIFT                       2
#define PMU_RG_PKEY_LACT_CFG_ADDR                     PMU_SHDNCFG1
#define PMU_RG_PKEY_LACT_CFG_MASK                     0x1
#define PMU_RG_PKEY_LACT_CFG_SHIFT                    4
#define PMU_RG_PKEY_LPEN_ADDR                         PMU_SHDNCFG1
#define PMU_RG_PKEY_LPEN_MASK                         0x1
#define PMU_RG_PKEY_LPEN_SHIFT                        5
#define PMU_RG_VBT_PG_EN_ADDR                         PMU_SHDNCFG2
#define PMU_RG_VBT_PG_EN_MASK                         0x1
#define PMU_RG_VBT_PG_EN_SHIFT                        0
#define PMU_RG_VA_PG_EN_ADDR                          PMU_SHDNCFG2
#define PMU_RG_VA_PG_EN_MASK                          0x1
#define PMU_RG_VA_PG_EN_SHIFT                         1
#define PMU_RG_VA18_PG_EN_ADDR                        PMU_SHDNCFG2
#define PMU_RG_VA18_PG_EN_MASK                        0x1
#define PMU_RG_VA18_PG_EN_SHIFT                       2
#define PMU_RG_VCAMA_PG_EN_ADDR                       PMU_SHDNCFG2
#define PMU_RG_VCAMA_PG_EN_MASK                       0x1
#define PMU_RG_VCAMA_PG_EN_SHIFT                      3
#define PMU_RG_VCORE_PG_EN_ADDR                       PMU_SHDNCFG2
#define PMU_RG_VCORE_PG_EN_MASK                       0x1
#define PMU_RG_VCORE_PG_EN_SHIFT                      4
#define PMU_RG_VIO18_PG_EN_ADDR                       PMU_SHDNCFG2
#define PMU_RG_VIO18_PG_EN_MASK                       0x1
#define PMU_RG_VIO18_PG_EN_SHIFT                      5
#define PMU_RG_VSF_PG_EN_ADDR                         PMU_SHDNCFG2
#define PMU_RG_VSF_PG_EN_MASK                         0x1
#define PMU_RG_VSF_PG_EN_SHIFT                        6
#define PMU_RG_VIO28_PG_EN_ADDR                       PMU_SHDNCFG3
#define PMU_RG_VIO28_PG_EN_MASK                       0x1
#define PMU_RG_VIO28_PG_EN_SHIFT                      0
#define PMU_RG_VMC_PG_EN_ADDR                         PMU_SHDNCFG3
#define PMU_RG_VMC_PG_EN_MASK                         0x1
#define PMU_RG_VMC_PG_EN_SHIFT                        1
#define PMU_RG_VUSB_PG_EN_ADDR                        PMU_SHDNCFG3
#define PMU_RG_VUSB_PG_EN_MASK                        0x1
#define PMU_RG_VUSB_PG_EN_SHIFT                       2
#define PMU_RG_VIBR_PG_EN_ADDR                        PMU_SHDNCFG3
#define PMU_RG_VIBR_PG_EN_MASK                        0x1
#define PMU_RG_VIBR_PG_EN_SHIFT                       3
#define PMU_RG_SWXM_PG_EN_ADDR                        PMU_SHDNCFG3
#define PMU_RG_SWXM_PG_EN_MASK                        0x1
#define PMU_RG_SWXM_PG_EN_SHIFT                       4
#define PMU_RG_SWDP_PG_EN_ADDR                        PMU_SHDNCFG3
#define PMU_RG_SWDP_PG_EN_MASK                        0x1
#define PMU_RG_SWDP_PG_EN_SHIFT                       5
#define PMU_RG_SWMP_PG_EN_ADDR                        PMU_SHDNCFG3
#define PMU_RG_SWMP_PG_EN_MASK                        0x1
#define PMU_RG_SWMP_PG_EN_SHIFT                       6
#define PMU_RG_SWBAT_PG_EN_ADDR                       PMU_SHDNCFG3
#define PMU_RG_SWBAT_PG_EN_MASK                       0x1
#define PMU_RG_SWBAT_PG_EN_SHIFT                      7
#define PMU_RG_DDUVLO_DEB_BYP_ADDR                    PMU_DEBCTL0
#define PMU_RG_DDUVLO_DEB_BYP_MASK                    0x1
#define PMU_RG_DDUVLO_DEB_BYP_SHIFT                   0
#define PMU_RG_THM_DEB_BYP_ADDR                       PMU_DEBCTL0
#define PMU_RG_THM_DEB_BYP_MASK                       0x1
#define PMU_RG_THM_DEB_BYP_SHIFT                      1
#define PMU_RG_XRST_DEB_BYP_ADDR                      PMU_DEBCTL0
#define PMU_RG_XRST_DEB_BYP_MASK                      0x1
#define PMU_RG_XRST_DEB_BYP_SHIFT                     2
#define PMU_RG_WDTRST_DEB_BYP_ADDR                    PMU_DEBCTL0
#define PMU_RG_WDTRST_DEB_BYP_MASK                    0x1
#define PMU_RG_WDTRST_DEB_BYP_SHIFT                   3
#define PMU_RG_PWRKEY_DEB_BYP_ADDR                    PMU_DEBCTL0
#define PMU_RG_PWRKEY_DEB_BYP_MASK                    0x1
#define PMU_RG_PWRKEY_DEB_BYP_SHIFT                   4
#define PMU_RG_CHGDET_DEB_BYP_ADDR                    PMU_DEBCTL0
#define PMU_RG_CHGDET_DEB_BYP_MASK                    0x1
#define PMU_RG_CHGDET_DEB_BYP_SHIFT                   5
#define PMU_RG_AXPKEY_DEB_BYP_ADDR                    PMU_DEBCTL0
#define PMU_RG_AXPKEY_DEB_BYP_MASK                    0x1
#define PMU_RG_AXPKEY_DEB_BYP_SHIFT                   6
#define PMU_RG_PKEY_LPDEB_BYP_ADDR                    PMU_DEBCTL0
#define PMU_RG_PKEY_LPDEB_BYP_MASK                    0x1
#define PMU_RG_PKEY_LPDEB_BYP_SHIFT                   7
#define PMU_RG_VBT_OC_H2L_EN_ADDR                     PMU_DEBCTL1
#define PMU_RG_VBT_OC_H2L_EN_MASK                     0x1
#define PMU_RG_VBT_OC_H2L_EN_SHIFT                    0
#define PMU_RG_VA_OC_H2L_EN_ADDR                      PMU_DEBCTL1
#define PMU_RG_VA_OC_H2L_EN_MASK                      0x1
#define PMU_RG_VA_OC_H2L_EN_SHIFT                     1
#define PMU_RG_VA18_OC_H2L_EN_ADDR                    PMU_DEBCTL1
#define PMU_RG_VA18_OC_H2L_EN_MASK                    0x1
#define PMU_RG_VA18_OC_H2L_EN_SHIFT                   2
#define PMU_RG_VC_BUCK_OC_H2L_EN_ADDR                 PMU_DEBCTL1
#define PMU_RG_VC_BUCK_OC_H2L_EN_MASK                 0x1
#define PMU_RG_VC_BUCK_OC_H2L_EN_SHIFT                3
#define PMU_RG_VC_LDO_OC_H2L_EN_ADDR                  PMU_DEBCTL1
#define PMU_RG_VC_LDO_OC_H2L_EN_MASK                  0x1
#define PMU_RG_VC_LDO_OC_H2L_EN_SHIFT                 4
#define PMU_RG_VIO18_OC_H2L_EN_ADDR                   PMU_DEBCTL1
#define PMU_RG_VIO18_OC_H2L_EN_MASK                   0x1
#define PMU_RG_VIO18_OC_H2L_EN_SHIFT                  5
#define PMU_RG_VSF_OC_H2L_EN_ADDR                     PMU_DEBCTL1
#define PMU_RG_VSF_OC_H2L_EN_MASK                     0x1
#define PMU_RG_VSF_OC_H2L_EN_SHIFT                    6
#define PMU_RG_VIO28_OC_H2L_EN_ADDR                   PMU_DEBCTL2
#define PMU_RG_VIO28_OC_H2L_EN_MASK                   0x1
#define PMU_RG_VIO28_OC_H2L_EN_SHIFT                  0
#define PMU_RG_VMC_OC_H2L_EN_ADDR                     PMU_DEBCTL2
#define PMU_RG_VMC_OC_H2L_EN_MASK                     0x1
#define PMU_RG_VMC_OC_H2L_EN_SHIFT                    1
#define PMU_RG_VUSB_OC_H2L_EN_ADDR                    PMU_DEBCTL2
#define PMU_RG_VUSB_OC_H2L_EN_MASK                    0x1
#define PMU_RG_VUSB_OC_H2L_EN_SHIFT                   2
#define PMU_RG_VCAMA_OC_H2L_EN_ADDR                   PMU_DEBCTL2
#define PMU_RG_VCAMA_OC_H2L_EN_MASK                   0x1
#define PMU_RG_VCAMA_OC_H2L_EN_SHIFT                  3
#define PMU_RG_VIBR_OC_H2L_EN_ADDR                    PMU_DEBCTL2
#define PMU_RG_VIBR_OC_H2L_EN_MASK                    0x1
#define PMU_RG_VIBR_OC_H2L_EN_SHIFT                   4
#define PMU_RG_VBT_OC_BYP_ADDR                        PMU_DEBCTL3
#define PMU_RG_VBT_OC_BYP_MASK                        0x1
#define PMU_RG_VBT_OC_BYP_SHIFT                       0
#define PMU_RG_VA_OC_BYP_ADDR                         PMU_DEBCTL3
#define PMU_RG_VA_OC_BYP_MASK                         0x1
#define PMU_RG_VA_OC_BYP_SHIFT                        1
#define PMU_RG_VA18_OC_BYP_ADDR                       PMU_DEBCTL3
#define PMU_RG_VA18_OC_BYP_MASK                       0x1
#define PMU_RG_VA18_OC_BYP_SHIFT                      2
#define PMU_RG_VC_BUCK_OC_BYP_ADDR                    PMU_DEBCTL3
#define PMU_RG_VC_BUCK_OC_BYP_MASK                    0x1
#define PMU_RG_VC_BUCK_OC_BYP_SHIFT                   3
#define PMU_RG_VC_LDO_OC_BYP_ADDR                     PMU_DEBCTL3
#define PMU_RG_VC_LDO_OC_BYP_MASK                     0x1
#define PMU_RG_VC_LDO_OC_BYP_SHIFT                    4
#define PMU_RG_VIO18_OC_BYP_ADDR                      PMU_DEBCTL3
#define PMU_RG_VIO18_OC_BYP_MASK                      0x1
#define PMU_RG_VIO18_OC_BYP_SHIFT                     5
#define PMU_RG_VSF_OC_BYP_ADDR                        PMU_DEBCTL3
#define PMU_RG_VSF_OC_BYP_MASK                        0x1
#define PMU_RG_VSF_OC_BYP_SHIFT                       6
#define PMU_RG_VIO28_OC_BYP_ADDR                      PMU_DEBCTL4
#define PMU_RG_VIO28_OC_BYP_MASK                      0x1
#define PMU_RG_VIO28_OC_BYP_SHIFT                     0
#define PMU_RG_VMC_OC_BYP_ADDR                        PMU_DEBCTL4
#define PMU_RG_VMC_OC_BYP_MASK                        0x1
#define PMU_RG_VMC_OC_BYP_SHIFT                       1
#define PMU_RG_VUSB_OC_BYP_ADDR                       PMU_DEBCTL4
#define PMU_RG_VUSB_OC_BYP_MASK                       0x1
#define PMU_RG_VUSB_OC_BYP_SHIFT                      2
#define PMU_RG_VCAMA_OC_BYP_ADDR                      PMU_DEBCTL4
#define PMU_RG_VCAMA_OC_BYP_MASK                      0x1
#define PMU_RG_VCAMA_OC_BYP_SHIFT                     3
#define PMU_RG_VIBR_OC_BYP_ADDR                       PMU_DEBCTL4
#define PMU_RG_VIBR_OC_BYP_MASK                       0x1
#define PMU_RG_VIBR_OC_BYP_SHIFT                      4
#define PMU_RG_VBT_PG_BYP_ADDR                        PMU_DEBCTL5
#define PMU_RG_VBT_PG_BYP_MASK                        0x1
#define PMU_RG_VBT_PG_BYP_SHIFT                       0
#define PMU_RG_VA_PG_BYP_ADDR                         PMU_DEBCTL5
#define PMU_RG_VA_PG_BYP_MASK                         0x1
#define PMU_RG_VA_PG_BYP_SHIFT                        1
#define PMU_RG_VA18_PG_BYP_ADDR                       PMU_DEBCTL5
#define PMU_RG_VA18_PG_BYP_MASK                       0x1
#define PMU_RG_VA18_PG_BYP_SHIFT                      2
#define PMU_RG_VCAMA_PG_BYP_ADDR                      PMU_DEBCTL5
#define PMU_RG_VCAMA_PG_BYP_MASK                      0x1
#define PMU_RG_VCAMA_PG_BYP_SHIFT                     3
#define PMU_RG_VCORE_PG_BYP_ADDR                      PMU_DEBCTL5
#define PMU_RG_VCORE_PG_BYP_MASK                      0x1
#define PMU_RG_VCORE_PG_BYP_SHIFT                     4
#define PMU_RG_VIO18_PG_BYP_ADDR                      PMU_DEBCTL5
#define PMU_RG_VIO18_PG_BYP_MASK                      0x1
#define PMU_RG_VIO18_PG_BYP_SHIFT                     5
#define PMU_RG_VSF_PG_BYP_ADDR                        PMU_DEBCTL5
#define PMU_RG_VSF_PG_BYP_MASK                        0x1
#define PMU_RG_VSF_PG_BYP_SHIFT                       6
#define PMU_RG_VIO28_PG_BYP_ADDR                      PMU_DEBCTL6
#define PMU_RG_VIO28_PG_BYP_MASK                      0x1
#define PMU_RG_VIO28_PG_BYP_SHIFT                     0
#define PMU_RG_VMC_PG_BYP_ADDR                        PMU_DEBCTL6
#define PMU_RG_VMC_PG_BYP_MASK                        0x1
#define PMU_RG_VMC_PG_BYP_SHIFT                       1
#define PMU_RG_VUSB_PG_BYP_ADDR                       PMU_DEBCTL6
#define PMU_RG_VUSB_PG_BYP_MASK                       0x1
#define PMU_RG_VUSB_PG_BYP_SHIFT                      2
#define PMU_RG_VIBR_PG_BYP_ADDR                       PMU_DEBCTL6
#define PMU_RG_VIBR_PG_BYP_MASK                       0x1
#define PMU_RG_VIBR_PG_BYP_SHIFT                      3
#define PMU_RG_SWXM_PG_BYP_ADDR                       PMU_DEBCTL6
#define PMU_RG_SWXM_PG_BYP_MASK                       0x1
#define PMU_RG_SWXM_PG_BYP_SHIFT                      4
#define PMU_RG_SWDP_PG_BYP_ADDR                       PMU_DEBCTL6
#define PMU_RG_SWDP_PG_BYP_MASK                       0x1
#define PMU_RG_SWDP_PG_BYP_SHIFT                      5
#define PMU_RG_SWMP_PG_BYP_ADDR                       PMU_DEBCTL6
#define PMU_RG_SWMP_PG_BYP_MASK                       0x1
#define PMU_RG_SWMP_PG_BYP_SHIFT                      6
#define PMU_RG_SWBAT_PG_BYP_ADDR                      PMU_DEBCTL6
#define PMU_RG_SWBAT_PG_BYP_MASK                      0x1
#define PMU_RG_SWBAT_PG_BYP_SHIFT                     7
#define PMU_RG_PG_DEB_LEN_ADDR                        PMU_DEBCTL7
#define PMU_RG_PG_DEB_LEN_MASK                        0x1
#define PMU_RG_PG_DEB_LEN_SHIFT                       0
#define PMU_RG_PG_DEB_H2L_EN_ADDR                     PMU_DEBCTL7
#define PMU_RG_PG_DEB_H2L_EN_MASK                     0x1
#define PMU_RG_PG_DEB_H2L_EN_SHIFT                    1
#define PMU_RG_UVLO_DEB_LEN_ADDR                      PMU_DEBCTL7
#define PMU_RG_UVLO_DEB_LEN_MASK                      0x3
#define PMU_RG_UVLO_DEB_LEN_SHIFT                     2
#define PMU_RG_UVLRST_SYNC_ADDR                       PMU_DEBCTL7
#define PMU_RG_UVLRST_SYNC_MASK                       0x1
#define PMU_RG_UVLRST_SYNC_SHIFT                      4
#define PMU_RG_CPS_W_KEY0_ADDR                        PMU_CPSWKEY0
#define PMU_RG_CPS_W_KEY0_MASK                        0xFF
#define PMU_RG_CPS_W_KEY0_SHIFT                       0
#define PMU_RG_CPS_W_KEY1_ADDR                        PMU_CPSWKEY1
#define PMU_RG_CPS_W_KEY1_MASK                        0xFF
#define PMU_RG_CPS_W_KEY1_SHIFT                       0
#define PMU_RG_SLOT_INTV_UP_L_ADDR                    PMU_CPSCFG0
#define PMU_RG_SLOT_INTV_UP_L_MASK                    0x3
#define PMU_RG_SLOT_INTV_UP_L_SHIFT                   0
#define PMU_RG_SLOT_INTV_DOWN_L_ADDR                  PMU_CPSCFG0
#define PMU_RG_SLOT_INTV_DOWN_L_MASK                  0x3
#define PMU_RG_SLOT_INTV_DOWN_L_SHIFT                 2
#define PMU_RG_SEQ_LEN_L_ADDR                         PMU_CPSCFG0
#define PMU_RG_SEQ_LEN_L_MASK                         0xF
#define PMU_RG_SEQ_LEN_L_SHIFT                        4
#define PMU_RG_VBT_USA_L_ADDR                         PMU_LBATPSA0
#define PMU_RG_VBT_USA_L_MASK                         0xF
#define PMU_RG_VBT_USA_L_SHIFT                        0
#define PMU_RG_VA_USA_L_ADDR                          PMU_LBATPSA0
#define PMU_RG_VA_USA_L_MASK                          0xF
#define PMU_RG_VA_USA_L_SHIFT                         4
#define PMU_RG_VC_BUCK_USA_L_ADDR                     PMU_LBATPSA1
#define PMU_RG_VC_BUCK_USA_L_MASK                     0xF
#define PMU_RG_VC_BUCK_USA_L_SHIFT                    0
#define PMU_RG_VC_LDO_USA_L_ADDR                      PMU_LBATPSA1
#define PMU_RG_VC_LDO_USA_L_MASK                      0xF
#define PMU_RG_VC_LDO_USA_L_SHIFT                     4
#define PMU_RG_VIO18_USA_L_ADDR                       PMU_LBATPSA2
#define PMU_RG_VIO18_USA_L_MASK                       0xF
#define PMU_RG_VIO18_USA_L_SHIFT                      0
#define PMU_RG_SWXM_USA_L_ADDR                        PMU_LBATPSA2
#define PMU_RG_SWXM_USA_L_MASK                        0xF
#define PMU_RG_SWXM_USA_L_SHIFT                       4
#define PMU_RG_SWDP_USA_L_ADDR                        PMU_LBATPSA3
#define PMU_RG_SWDP_USA_L_MASK                        0xF
#define PMU_RG_SWDP_USA_L_SHIFT                       0
#define PMU_RG_VSF_USA_L_ADDR                         PMU_LBATPSA3
#define PMU_RG_VSF_USA_L_MASK                         0xF
#define PMU_RG_VSF_USA_L_SHIFT                        4
#define PMU_RG_VIO28_USA_L_ADDR                       PMU_LBATPSA4
#define PMU_RG_VIO28_USA_L_MASK                       0xF
#define PMU_RG_VIO28_USA_L_SHIFT                      0
#define PMU_RG_VMC_USA_L_ADDR                         PMU_LBATPSA4
#define PMU_RG_VMC_USA_L_MASK                         0xF
#define PMU_RG_VMC_USA_L_SHIFT                        4
#define PMU_RG_VUSB_USA_L_ADDR                        PMU_LBATPSA5
#define PMU_RG_VUSB_USA_L_MASK                        0xF
#define PMU_RG_VUSB_USA_L_SHIFT                       0
#define PMU_RG_VIO28_VOSEL_ADDR                       PMU_CPSCFG1
#define PMU_RG_VIO28_VOSEL_MASK                       0x1
#define PMU_RG_VIO28_VOSEL_SHIFT                      0
#define PMU_RG_SLOT_INTV_UP_C_E1_ADDR                 PMU_CPSCFG1
#define PMU_RG_SLOT_INTV_UP_C_E1_MASK                 0x1
#define PMU_RG_SLOT_INTV_UP_C_E1_SHIFT                1
#define PMU_RG_SLOT_INTV_DOWN_C_ADDR                  PMU_CPSCFG1
#define PMU_RG_SLOT_INTV_DOWN_C_MASK                  0x3
#define PMU_RG_SLOT_INTV_DOWN_C_SHIFT                 2
#define PMU_RG_VIO28_CAL_ADDR                         PMU_CPSCFG1
#define PMU_RG_VIO28_CAL_MASK                         0xF
#define PMU_RG_VIO28_CAL_SHIFT                        4
#define PMU_RG_VBT_USA_C_ADDR                         PMU_CBATPSA0
#define PMU_RG_VBT_USA_C_MASK                         0xF
#define PMU_RG_VBT_USA_C_SHIFT                        0
#define PMU_RG_VIO28_BUF_CAL_ADDR                     PMU_CBATPSA0
#define PMU_RG_VIO28_BUF_CAL_MASK                     0xF
#define PMU_RG_VIO28_BUF_CAL_SHIFT                    4
#define PMU_RG_HP_VIO28_PMOD_ADDR                     PMU_CBATPSA1
#define PMU_RG_HP_VIO28_PMOD_MASK                     0x3
#define PMU_RG_HP_VIO28_PMOD_SHIFT                    0
#define PMU_RG_VC_BUCK_USA_C_E1_ADDR                  PMU_CBATPSA1
#define PMU_RG_VC_BUCK_USA_C_E1_MASK                  0x3
#define PMU_RG_VC_BUCK_USA_C_E1_SHIFT                 2
#define PMU_RG_LP_VIO28_PMOD_ADDR                     PMU_CBATPSA1
#define PMU_RG_LP_VIO28_PMOD_MASK                     0x3
#define PMU_RG_LP_VIO28_PMOD_SHIFT                    4
#define PMU_RG_VC_LDO_USA_C_E1_ADDR                   PMU_CBATPSA1
#define PMU_RG_VC_LDO_USA_C_E1_MASK                   0x3
#define PMU_RG_VC_LDO_USA_C_E1_SHIFT                  6
#define PMU_RG_S1_VIO28_PMOD_ADDR                     PMU_CBATPSA2
#define PMU_RG_S1_VIO28_PMOD_MASK                     0x3
#define PMU_RG_S1_VIO28_PMOD_SHIFT                    0
#define PMU_RG_VIO18_USA_C_E1_ADDR                    PMU_CBATPSA2
#define PMU_RG_VIO18_USA_C_E1_MASK                    0x3
#define PMU_RG_VIO18_USA_C_E1_SHIFT                   2
#define PMU_RGS_S0_VIO28_ON_ADDR                      PMU_CBATPSA2
#define PMU_RGS_S0_VIO28_ON_MASK                      0x1
#define PMU_RGS_S0_VIO28_ON_SHIFT                     4
#define PMU_RGS_S1_VIO28_ON_ADDR                      PMU_CBATPSA2
#define PMU_RGS_S1_VIO28_ON_MASK                      0x1
#define PMU_RGS_S1_VIO28_ON_SHIFT                     5
#define PMU_RG_SWXM_USA_C_E1_ADDR                     PMU_CBATPSA2
#define PMU_RG_SWXM_USA_C_E1_MASK                     0x3
#define PMU_RG_SWXM_USA_C_E1_SHIFT                    6
#define PMU_RG_SWDP_USA_C_E1_ADDR                     PMU_CBATPSA3
#define PMU_RG_SWDP_USA_C_E1_MASK                     0xF
#define PMU_RG_SWDP_USA_C_E1_SHIFT                    0
#define PMU_RG_S0_VIO28_PMOD_ADDR                     PMU_CBATPSA3
#define PMU_RG_S0_VIO28_PMOD_MASK                     0x3
#define PMU_RG_S0_VIO28_PMOD_SHIFT                    4
#define PMU_RG_VSF_USA_C_E1_ADDR                      PMU_CBATPSA3
#define PMU_RG_VSF_USA_C_E1_MASK                      0x3
#define PMU_RG_VSF_USA_C_E1_SHIFT                     6
#define PMU_RG_VIO28_USA_C_ADDR                       PMU_CBATPSA4
#define PMU_RG_VIO28_USA_C_MASK                       0xF
#define PMU_RG_VIO28_USA_C_SHIFT                      0
#define PMU_RG_VMC_USA_C_ADDR                         PMU_CBATPSA4
#define PMU_RG_VMC_USA_C_MASK                         0xF
#define PMU_RG_VMC_USA_C_SHIFT                        4
#define PMU_RG_VUSB_USA_C_ADDR                        PMU_CBATPSA5
#define PMU_RG_VUSB_USA_C_MASK                        0xF
#define PMU_RG_VUSB_USA_C_SHIFT                       0
#define PMU_RG_DSEQ_LEN_L_ADDR                        PMU_CPSCFG2
#define PMU_RG_DSEQ_LEN_L_MASK                        0xF
#define PMU_RG_DSEQ_LEN_L_SHIFT                       0
#define PMU_RG_DSEQ_LEN_C_ADDR                        PMU_CPSCFG2
#define PMU_RG_DSEQ_LEN_C_MASK                        0xF
#define PMU_RG_DSEQ_LEN_C_SHIFT                       4
#define PMU_RG_VBT_DSA_L_ADDR                         PMU_LBATDSA0
#define PMU_RG_VBT_DSA_L_MASK                         0xF
#define PMU_RG_VBT_DSA_L_SHIFT                        0
#define PMU_RG_VA_DSA_L_ADDR                          PMU_LBATDSA0
#define PMU_RG_VA_DSA_L_MASK                          0xF
#define PMU_RG_VA_DSA_L_SHIFT                         4
#define PMU_RG_VC_BUCK_DSA_L_ADDR                     PMU_LBATDSA1
#define PMU_RG_VC_BUCK_DSA_L_MASK                     0xF
#define PMU_RG_VC_BUCK_DSA_L_SHIFT                    0
#define PMU_RG_VC_LDO_DSA_L_ADDR                      PMU_LBATDSA1
#define PMU_RG_VC_LDO_DSA_L_MASK                      0xF
#define PMU_RG_VC_LDO_DSA_L_SHIFT                     4
#define PMU_RG_VIO18_DSA_L_ADDR                       PMU_LBATDSA2
#define PMU_RG_VIO18_DSA_L_MASK                       0xF
#define PMU_RG_VIO18_DSA_L_SHIFT                      0
#define PMU_RG_SWXM_DSA_L_ADDR                        PMU_LBATDSA2
#define PMU_RG_SWXM_DSA_L_MASK                        0xF
#define PMU_RG_SWXM_DSA_L_SHIFT                       4
#define PMU_RG_SWDP_DSA_L_ADDR                        PMU_LBATDSA3
#define PMU_RG_SWDP_DSA_L_MASK                        0xF
#define PMU_RG_SWDP_DSA_L_SHIFT                       0
#define PMU_RG_VSF_DSA_L_ADDR                         PMU_LBATDSA3
#define PMU_RG_VSF_DSA_L_MASK                         0xF
#define PMU_RG_VSF_DSA_L_SHIFT                        4
#define PMU_RG_VIO28_DSA_L_ADDR                       PMU_LBATDSA4
#define PMU_RG_VIO28_DSA_L_MASK                       0xF
#define PMU_RG_VIO28_DSA_L_SHIFT                      0
#define PMU_RG_VMC_DSA_L_ADDR                         PMU_LBATDSA4
#define PMU_RG_VMC_DSA_L_MASK                         0xF
#define PMU_RG_VMC_DSA_L_SHIFT                        4
#define PMU_RG_VUSB_DSA_L_ADDR                        PMU_LBATDSA5
#define PMU_RG_VUSB_DSA_L_MASK                        0xF
#define PMU_RG_VUSB_DSA_L_SHIFT                       0
#define PMU_RG_VBT_DSA_C_ADDR                         PMU_CBATDSA0
#define PMU_RG_VBT_DSA_C_MASK                         0xF
#define PMU_RG_VBT_DSA_C_SHIFT                        0
#define PMU_RG_VA_DSA_C_ADDR                          PMU_CBATDSA0
#define PMU_RG_VA_DSA_C_MASK                          0xF
#define PMU_RG_VA_DSA_C_SHIFT                         4
#define PMU_RG_VC_BUCK_DSA_C_ADDR                     PMU_CBATDSA1
#define PMU_RG_VC_BUCK_DSA_C_MASK                     0xF
#define PMU_RG_VC_BUCK_DSA_C_SHIFT                    0
#define PMU_RG_VC_LDO_DSA_C_E1_ADDR                   PMU_CBATDSA1
#define PMU_RG_VC_LDO_DSA_C_E1_MASK                   0x1
#define PMU_RG_VC_LDO_DSA_C_E1_SHIFT                  4
#define PMU_RG_SLP_XCPT_MSK_ADDR                      PMU_CBATDSA1
#define PMU_RG_SLP_XCPT_MSK_MASK                      0x7
#define PMU_RG_SLP_XCPT_MSK_SHIFT                     5
#define PMU_RG_VIO18_DSA_C_ADDR                       PMU_CBATDSA2
#define PMU_RG_VIO18_DSA_C_MASK                       0xF
#define PMU_RG_VIO18_DSA_C_SHIFT                      0
#define PMU_RG_SWXM_DSA_C_ADDR                        PMU_CBATDSA2
#define PMU_RG_SWXM_DSA_C_MASK                        0xF
#define PMU_RG_SWXM_DSA_C_SHIFT                       4
#define PMU_RG_THM_SHDN_SEL_ADDR                      PMU_CBATDSA3
#define PMU_RG_THM_SHDN_SEL_MASK                      0x3
#define PMU_RG_THM_SHDN_SEL_SHIFT                     0
#define PMU_RG_SWDP_DSA_C_E1_ADDR                     PMU_CBATDSA3
#define PMU_RG_SWDP_DSA_C_E1_MASK                     0x3
#define PMU_RG_SWDP_DSA_C_E1_SHIFT                    2
#define PMU_RG_VSF_DSA_C_ADDR                         PMU_CBATDSA3
#define PMU_RG_VSF_DSA_C_MASK                         0xF
#define PMU_RG_VSF_DSA_C_SHIFT                        4
#define PMU_RG_VIO28_DSA_C_ADDR                       PMU_CBATDSA4
#define PMU_RG_VIO28_DSA_C_MASK                       0xF
#define PMU_RG_VIO28_DSA_C_SHIFT                      0
#define PMU_RG_VMC_DSA_C_ADDR                         PMU_CBATDSA4
#define PMU_RG_VMC_DSA_C_MASK                         0xF
#define PMU_RG_VMC_DSA_C_SHIFT                        4
#define PMU_RG_VUSB_DSA_C_ADDR                        PMU_CBATDSA5
#define PMU_RG_VUSB_DSA_C_MASK                        0x3
#define PMU_RG_VUSB_DSA_C_SHIFT                       0
#define PMU_RG_D2D_F32K_CK_PDN_ADDR                   PMU_CBATDSA5
#define PMU_RG_D2D_F32K_CK_PDN_MASK                   0x1
#define PMU_RG_D2D_F32K_CK_PDN_SHIFT                  2
#define PMU_RG_VUSB_DSA_C_E1_ADDR                     PMU_CBATDSA5
#define PMU_RG_VUSB_DSA_C_E1_MASK                     0x1
#define PMU_RG_VUSB_DSA_C_E1_SHIFT                    3
#define PMU_RG_W0SEQ_LEN_ADDR                         PMU_CPSCFG3
#define PMU_RG_W0SEQ_LEN_MASK                         0xF
#define PMU_RG_W0SEQ_LEN_SHIFT                        0
#define PMU_RG_W1SEQ_LEN_ADDR                         PMU_CPSCFG3
#define PMU_RG_W1SEQ_LEN_MASK                         0xF
#define PMU_RG_W1SEQ_LEN_SHIFT                        4
#define PMU_RG_VBT_WS0A_ADDR                          PMU_CPSWS0A0
#define PMU_RG_VBT_WS0A_MASK                          0xF
#define PMU_RG_VBT_WS0A_SHIFT                         0
#define PMU_RG_VA_WS0A_ADDR                           PMU_CPSWS0A0
#define PMU_RG_VA_WS0A_MASK                           0xF
#define PMU_RG_VA_WS0A_SHIFT                          4
#define PMU_RG_SWXM_WS0A_ADDR                         PMU_CPSWS0A1
#define PMU_RG_SWXM_WS0A_MASK                         0xF
#define PMU_RG_SWXM_WS0A_SHIFT                        4
#define PMU_RG_SWDP_WS0A_ADDR                         PMU_CPSWS0A2
#define PMU_RG_SWDP_WS0A_MASK                         0xF
#define PMU_RG_SWDP_WS0A_SHIFT                        0
#define PMU_RG_VSF_WS0A_ADDR                          PMU_CPSWS0A2
#define PMU_RG_VSF_WS0A_MASK                          0xF
#define PMU_RG_VSF_WS0A_SHIFT                         4
#define PMU_RG_VIO28_WS0A_ADDR                        PMU_CPSWS0A3
#define PMU_RG_VIO28_WS0A_MASK                        0xF
#define PMU_RG_VIO28_WS0A_SHIFT                       0
#define PMU_RG_VMC_WS0A_ADDR                          PMU_CPSWS0A3
#define PMU_RG_VMC_WS0A_MASK                          0xF
#define PMU_RG_VMC_WS0A_SHIFT                         4
#define PMU_RG_VUSB_WS0A_ADDR                         PMU_CPSWS0A4
#define PMU_RG_VUSB_WS0A_MASK                         0xF
#define PMU_RG_VUSB_WS0A_SHIFT                        0
#define PMU_RG_VBT_WS1A_ADDR                          PMU_CPSWS1A0
#define PMU_RG_VBT_WS1A_MASK                          0xF
#define PMU_RG_VBT_WS1A_SHIFT                         0
#define PMU_RG_VA_WS1A_ADDR                           PMU_CPSWS1A0
#define PMU_RG_VA_WS1A_MASK                           0xF
#define PMU_RG_VA_WS1A_SHIFT                          4
#define PMU_RG_SWXM_WS1A_ADDR                         PMU_CPSWS1A1
#define PMU_RG_SWXM_WS1A_MASK                         0xF
#define PMU_RG_SWXM_WS1A_SHIFT                        4
#define PMU_RG_SWDP_WS1A_ADDR                         PMU_CPSWS1A2
#define PMU_RG_SWDP_WS1A_MASK                         0xF
#define PMU_RG_SWDP_WS1A_SHIFT                        0
#define PMU_RG_VSF_WS1A_ADDR                          PMU_CPSWS1A2
#define PMU_RG_VSF_WS1A_MASK                          0xF
#define PMU_RG_VSF_WS1A_SHIFT                         4
#define PMU_RG_VIO28_WS1A_ADDR                        PMU_CPSWS1A3
#define PMU_RG_VIO28_WS1A_MASK                        0xF
#define PMU_RG_VIO28_WS1A_SHIFT                       0
#define PMU_RG_VMC_WS1A_ADDR                          PMU_CPSWS1A3
#define PMU_RG_VMC_WS1A_MASK                          0xF
#define PMU_RG_VMC_WS1A_SHIFT                         4
#define PMU_RG_VUSB_WS1A_ADDR                         PMU_CPSWS1A4
#define PMU_RG_VUSB_WS1A_MASK                         0xF
#define PMU_RG_VUSB_WS1A_SHIFT                        0
#define PMU_RG_PSEQ_FORCE_ALL_DOFF_ADDR               PMU_PPCTST0
#define PMU_RG_PSEQ_FORCE_ALL_DOFF_MASK               0x1
#define PMU_RG_PSEQ_FORCE_ALL_DOFF_SHIFT              0
#define PMU_RG_PSEQ_FORCE_ON_ADDR                     PMU_PPCTST0
#define PMU_RG_PSEQ_FORCE_ON_MASK                     0x1
#define PMU_RG_PSEQ_FORCE_ON_SHIFT                    1
#define PMU_RG_DEB_BYPASS_ADDR                        PMU_PPCTST0
#define PMU_RG_DEB_BYPASS_MASK                        0x1
#define PMU_RG_DEB_BYPASS_SHIFT                       2
#define PMU_RG_MTCTL_FORCE_ON_ADDR                    PMU_PPCMTCTL0
#define PMU_RG_MTCTL_FORCE_ON_MASK                    0x1
#define PMU_RG_MTCTL_FORCE_ON_SHIFT                   0
#define PMU_RG_MTCTL_FORCE_OFF_ADDR                   PMU_PPCMTCTL0
#define PMU_RG_MTCTL_FORCE_OFF_MASK                   0x1
#define PMU_RG_MTCTL_FORCE_OFF_SHIFT                  1
#define PMU_RG_MTCTL_MODE_ADDR                        PMU_PPCMTCTL0
#define PMU_RG_MTCTL_MODE_MASK                        0x1
#define PMU_RG_MTCTL_MODE_SHIFT                       2
#define PMU_RG_MTCTL_RSV0_ADDR                        PMU_PPCMTCTL0
#define PMU_RG_MTCTL_RSV0_MASK                        0x1
#define PMU_RG_MTCTL_RSV0_SHIFT                       3
#define PMU_RG_MTCTL_ISOTD_ADDR                       PMU_PPCMTCTL0
#define PMU_RG_MTCTL_ISOTD_MASK                       0x3
#define PMU_RG_MTCTL_ISOTD_SHIFT                      4
#define PMU_RG_MTCTL_PONTD_ADDR                       PMU_PPCMTCTL0
#define PMU_RG_MTCTL_PONTD_MASK                       0x3
#define PMU_RG_MTCTL_PONTD_SHIFT                      6
#define PMU_RG_MTCTL_S0_ON_ADDR                       PMU_PPCMTCTL1
#define PMU_RG_MTCTL_S0_ON_MASK                       0x1
#define PMU_RG_MTCTL_S0_ON_SHIFT                      0
#define PMU_RG_MTCTL_S1_ON_ADDR                       PMU_PPCMTCTL1
#define PMU_RG_MTCTL_S1_ON_MASK                       0x1
#define PMU_RG_MTCTL_S1_ON_SHIFT                      1
#define PMU_RG_MTCTL_SW_EN_ADDR                       PMU_PPCMTCTL2
#define PMU_RG_MTCTL_SW_EN_MASK                       0x1
#define PMU_RG_MTCTL_SW_EN_SHIFT                      0
#define PMU_RG_MTCTL_SW_PWR_ON_ADDR                   PMU_PPCMTCTL2
#define PMU_RG_MTCTL_SW_PWR_ON_MASK                   0x1
#define PMU_RG_MTCTL_SW_PWR_ON_SHIFT                  1
#define PMU_RG_MTCTL_SW_ISO_OFF_ADDR                  PMU_PPCMTCTL2
#define PMU_RG_MTCTL_SW_ISO_OFF_MASK                  0x1
#define PMU_RG_MTCTL_SW_ISO_OFF_SHIFT                 2
#define PMU_RG_MTCTL_SW_RSTB_ADDR                     PMU_PPCMTCTL2
#define PMU_RG_MTCTL_SW_RSTB_MASK                     0x1
#define PMU_RG_MTCTL_SW_RSTB_SHIFT                    3
#define PMU_RGS_MTC_PWRON_ADDR                        PMU_PPCMTCST
#define PMU_RGS_MTC_PWRON_MASK                        0x1
#define PMU_RGS_MTC_PWRON_SHIFT                       0
#define PMU_RGS_MTC_ISO_OFF_ADDR                      PMU_PPCMTCST
#define PMU_RGS_MTC_ISO_OFF_MASK                      0x1
#define PMU_RGS_MTC_ISO_OFF_SHIFT                     1
#define PMU_RGS_MTC_RSTB_ADDR                         PMU_PPCMTCST
#define PMU_RGS_MTC_RSTB_MASK                         0x1
#define PMU_RGS_MTC_RSTB_SHIFT                        2
#define PMU_RGS_MTC_PWRACK_ADDR                       PMU_PPCMTCST
#define PMU_RGS_MTC_PWRACK_MASK                       0x1
#define PMU_RGS_MTC_PWRACK_SHIFT                      3
#define PMU_RGS_MTC_READY_ADDR                        PMU_PPCMTCST
#define PMU_RGS_MTC_READY_MASK                        0x1
#define PMU_RGS_MTC_READY_SHIFT                       4
#define PMU_RG_PSEQ_RSV0_ADDR                         PMU_PSEQ_RSV0
#define PMU_RG_PSEQ_RSV0_MASK                         0x1F
#define PMU_RG_PSEQ_RSV0_SHIFT                        0
#define PMU_RG_ULP_CLK_SHAPE_ADDR                     PMU_PSEQ_RSV0
#define PMU_RG_ULP_CLK_SHAPE_MASK                     0x3
#define PMU_RG_ULP_CLK_SHAPE_SHIFT                    5
#define PMU_RG_PSEQ_RSV0_E1_ADDR                      PMU_PSEQ_RSV0
#define PMU_RG_PSEQ_RSV0_E1_MASK                      0x1
#define PMU_RG_PSEQ_RSV0_E1_SHIFT                     7
#define PMU_RG_POR_FLAG_ADDR                          PMU_PSEQ_RSV1
#define PMU_RG_POR_FLAG_MASK                          0x1
#define PMU_RG_POR_FLAG_SHIFT                         0
#define PMU_RG_POR_RSV_ADDR                           PMU_PSEQ_RSV1
#define PMU_RG_POR_RSV_MASK                           0x7
#define PMU_RG_POR_RSV_SHIFT                          1
#define PMU_RG_PSEQ_RSV1_LSB_ADDR                     PMU_PSEQ_RSV1
#define PMU_RG_PSEQ_RSV1_LSB_MASK                     0x3
#define PMU_RG_PSEQ_RSV1_LSB_SHIFT                    4
#define PMU_RG_PSEQ_RSV1_MSB_ADDR                     PMU_PSEQ_RSV1
#define PMU_RG_PSEQ_RSV1_MSB_MASK                     0x3
#define PMU_RG_PSEQ_RSV1_MSB_SHIFT                    6
#define PMU_RG_VCDT_HV_EN_ADDR                        PMU_CHR_CON0
#define PMU_RG_VCDT_HV_EN_MASK                        0x1
#define PMU_RG_VCDT_HV_EN_SHIFT                       0
#define PMU_RGS_CHR_LDO_DET_ADDR                      PMU_CHR_CON0
#define PMU_RGS_CHR_LDO_DET_MASK                      0x1
#define PMU_RGS_CHR_LDO_DET_SHIFT                     1
#define PMU_RG_PCHR_AUTOMODE_ADDR                     PMU_CHR_CON0
#define PMU_RG_PCHR_AUTOMODE_MASK                     0x1
#define PMU_RG_PCHR_AUTOMODE_SHIFT                    2
#define PMU_RG_CSDAC_EN_ADDR                          PMU_CHR_CON0
#define PMU_RG_CSDAC_EN_MASK                          0x1
#define PMU_RG_CSDAC_EN_SHIFT                         3
#define PMU_RG_NORM_CHR_EN_ADDR                       PMU_CHR_CON0
#define PMU_RG_NORM_CHR_EN_MASK                       0x1
#define PMU_RG_NORM_CHR_EN_SHIFT                      4
#define PMU_RGS_CHRDET_ADDR                           PMU_CHR_CON0
#define PMU_RGS_CHRDET_MASK                           0x1
#define PMU_RGS_CHRDET_SHIFT                          5
#define PMU_RGS_VCDT_LV_DET_ADDR                      PMU_CHR_CON0
#define PMU_RGS_VCDT_LV_DET_MASK                      0x1
#define PMU_RGS_VCDT_LV_DET_SHIFT                     6
#define PMU_RGS_VCDT_HV_DET_ADDR                      PMU_CHR_CON0
#define PMU_RGS_VCDT_HV_DET_MASK                      0x1
#define PMU_RGS_VCDT_HV_DET_SHIFT                     7
#define PMU_RG_VCDT_LV_VTH_ADDR                       PMU_CHR_CON1
#define PMU_RG_VCDT_LV_VTH_MASK                       0xF
#define PMU_RG_VCDT_LV_VTH_SHIFT                      0
#define PMU_RG_VCDT_HV_VTH_ADDR                       PMU_CHR_CON1
#define PMU_RG_VCDT_HV_VTH_MASK                       0xF
#define PMU_RG_VCDT_HV_VTH_SHIFT                      4
#define PMU_RG_VBAT_CV_EN_ADDR                        PMU_CHR_CON2
#define PMU_RG_VBAT_CV_EN_MASK                        0x1
#define PMU_RG_VBAT_CV_EN_SHIFT                       1
#define PMU_RG_VBAT_CC_EN_ADDR                        PMU_CHR_CON2
#define PMU_RG_VBAT_CC_EN_MASK                        0x1
#define PMU_RG_VBAT_CC_EN_SHIFT                       2
#define PMU_RG_CS_EN_ADDR                             PMU_CHR_CON2
#define PMU_RG_CS_EN_MASK                             0x1
#define PMU_RG_CS_EN_SHIFT                            3
#define PMU_RGS_CS_DET_ADDR                           PMU_CHR_CON2
#define PMU_RGS_CS_DET_MASK                           0x1
#define PMU_RGS_CS_DET_SHIFT                          5
#define PMU_RGS_VBAT_CV_DET_ADDR                      PMU_CHR_CON2
#define PMU_RGS_VBAT_CV_DET_MASK                      0x1
#define PMU_RGS_VBAT_CV_DET_SHIFT                     6
#define PMU_RGS_VBAT_CC_DET_ADDR                      PMU_CHR_CON2
#define PMU_RGS_VBAT_CC_DET_MASK                      0x1
#define PMU_RGS_VBAT_CC_DET_SHIFT                     7
#define PMU_RG_VBAT_NORM_CV_VTH_ADDR                  PMU_CHR_CON3
#define PMU_RG_VBAT_NORM_CV_VTH_MASK                  0x3F
#define PMU_RG_VBAT_NORM_CV_VTH_SHIFT                 0
#define PMU_RG_VBAT_CC_VTH_ADDR                       PMU_CHR_CON3
#define PMU_RG_VBAT_CC_VTH_MASK                       0x3
#define PMU_RG_VBAT_CC_VTH_SHIFT                      6
#define PMU_RG_NORM_CS_VTH_ADDR                       PMU_CHR_CON4
#define PMU_RG_NORM_CS_VTH_MASK                       0xF
#define PMU_RG_NORM_CS_VTH_SHIFT                      0
#define PMU_RG_PCHR_TOHTC_ADDR                        PMU_CHR_CON5
#define PMU_RG_PCHR_TOHTC_MASK                        0x7
#define PMU_RG_PCHR_TOHTC_SHIFT                       0
#define PMU_RG_PCHR_TOLTC_ADDR                        PMU_CHR_CON5
#define PMU_RG_PCHR_TOLTC_MASK                        0x7
#define PMU_RG_PCHR_TOLTC_SHIFT                       4
#define PMU_RG_VBAT_OV_EN_ADDR                        PMU_CHR_CON6
#define PMU_RG_VBAT_OV_EN_MASK                        0x1
#define PMU_RG_VBAT_OV_EN_SHIFT                       0
#define PMU_RG_VBAT_OV_VTH_ADDR                       PMU_CHR_CON6
#define PMU_RG_VBAT_OV_VTH_MASK                       0xF
#define PMU_RG_VBAT_OV_VTH_SHIFT                      1
#define PMU_RG_VBAT_OV_DEG_ADDR                       PMU_CHR_CON6
#define PMU_RG_VBAT_OV_DEG_MASK                       0x1
#define PMU_RG_VBAT_OV_DEG_SHIFT                      5
#define PMU_RGS_VBAT_OV_DET_ADDR                      PMU_CHR_CON6
#define PMU_RGS_VBAT_OV_DET_MASK                      0x1
#define PMU_RGS_VBAT_OV_DET_SHIFT                     6
#define PMU_RG_BATON_EN_ADDR                          PMU_CHR_CON7
#define PMU_RG_BATON_EN_MASK                          0x1
#define PMU_RG_BATON_EN_SHIFT                         0
#define PMU_RG_BATON_HT_EN_RSV0_ADDR                  PMU_CHR_CON7
#define PMU_RG_BATON_HT_EN_RSV0_MASK                  0x1
#define PMU_RG_BATON_HT_EN_RSV0_SHIFT                 1
#define PMU_BATON_TDET_EN_ADDR                        PMU_CHR_CON7
#define PMU_BATON_TDET_EN_MASK                        0x1
#define PMU_BATON_TDET_EN_SHIFT                       2
#define PMU_RG_BATON_HT_TRIM_ADDR                     PMU_CHR_CON7
#define PMU_RG_BATON_HT_TRIM_MASK                     0x7
#define PMU_RG_BATON_HT_TRIM_SHIFT                    4
#define PMU_RG_CSDAC_DATA_LSB_ADDR                    PMU_CHR_CON8
#define PMU_RG_CSDAC_DATA_LSB_MASK                    0xFF
#define PMU_RG_CSDAC_DATA_LSB_SHIFT                   0
#define PMU_RG_CSDAC_DATA_MSB_ADDR                    PMU_CHR_CON8_H
#define PMU_RG_CSDAC_DATA_MSB_MASK                    0x3
#define PMU_RG_CSDAC_DATA_MSB_SHIFT                   0
#define PMU_RG_FRC_CSVTH_USBDL_ADDR                   PMU_CHR_CON9
#define PMU_RG_FRC_CSVTH_USBDL_MASK                   0x1
#define PMU_RG_FRC_CSVTH_USBDL_SHIFT                  0
#define PMU_RGS_PCHR_FLAG_OUT_ADDR                    PMU_CHR_CON10
#define PMU_RGS_PCHR_FLAG_OUT_MASK                    0xF
#define PMU_RGS_PCHR_FLAG_OUT_SHIFT                   0
#define PMU_RG_PCHR_FLAG_EN_ADDR                      PMU_CHR_CON10
#define PMU_RG_PCHR_FLAG_EN_MASK                      0x1
#define PMU_RG_PCHR_FLAG_EN_SHIFT                     4
#define PMU_RG_OTG_BVALID_EN_ADDR                     PMU_CHR_CON10
#define PMU_RG_OTG_BVALID_EN_MASK                     0x1
#define PMU_RG_OTG_BVALID_EN_SHIFT                    5
#define PMU_RGS_OTG_BVALID_DET_ADDR                   PMU_CHR_CON10
#define PMU_RGS_OTG_BVALID_DET_MASK                   0x1
#define PMU_RGS_OTG_BVALID_DET_SHIFT                  6
#define PMU_RG_PCHR_FLAG_SEL_ADDR                     PMU_CHR_CON11
#define PMU_RG_PCHR_FLAG_SEL_MASK                     0x3F
#define PMU_RG_PCHR_FLAG_SEL_SHIFT                    0
#define PMU_RG_PCHR_TESTMODE_ADDR                     PMU_CHR_CON12
#define PMU_RG_PCHR_TESTMODE_MASK                     0x1
#define PMU_RG_PCHR_TESTMODE_SHIFT                    0
#define PMU_RG_CSDAC_TESTMODE_ADDR                    PMU_CHR_CON12
#define PMU_RG_CSDAC_TESTMODE_MASK                    0x1
#define PMU_RG_CSDAC_TESTMODE_SHIFT                   1
#define PMU_RG_PCHR_RST_ADDR                          PMU_CHR_CON12
#define PMU_RG_PCHR_RST_MASK                          0x1
#define PMU_RG_PCHR_RST_SHIFT                         2
#define PMU_RG_PCHR_FT_CTRL_ADDR                      PMU_CHR_CON12
#define PMU_RG_PCHR_FT_CTRL_MASK                      0x7
#define PMU_RG_PCHR_FT_CTRL_SHIFT                     4
#define PMU_RG_CHRWDT_TD_ADDR                         PMU_CHR_CON13
#define PMU_RG_CHRWDT_TD_MASK                         0xF
#define PMU_RG_CHRWDT_TD_SHIFT                        0
#define PMU_RG_CHRWDT_EN_ADDR                         PMU_CHR_CON13
#define PMU_RG_CHRWDT_EN_MASK                         0x1
#define PMU_RG_CHRWDT_EN_SHIFT                        4
#define PMU_RG_CHRWDT_WR_ADDR                         PMU_CHR_CON13_H
#define PMU_RG_CHRWDT_WR_MASK                         0x1
#define PMU_RG_CHRWDT_WR_SHIFT                        0
#define PMU_RG_PCHR_RV_ADDR                           PMU_CHR_CON14
#define PMU_RG_PCHR_RV_MASK                           0xFF
#define PMU_RG_PCHR_RV_SHIFT                          0
#define PMU_RG_CHRWDT_FLAG_WR_ADDR                    PMU_CHR_CON15
#define PMU_RG_CHRWDT_FLAG_WR_MASK                    0x1
#define PMU_RG_CHRWDT_FLAG_WR_SHIFT                   1
#define PMU_RGS_CHRWDT_OUT_ADDR                       PMU_CHR_CON15
#define PMU_RGS_CHRWDT_OUT_MASK                       0x1
#define PMU_RGS_CHRWDT_OUT_SHIFT                      2
#define PMU_RG_USBDL_RST_ADDR                         PMU_CHR_CON16
#define PMU_RG_USBDL_RST_MASK                         0x1
#define PMU_RG_USBDL_RST_SHIFT                        2
#define PMU_RG_USBDL_SET_ADDR                         PMU_CHR_CON16
#define PMU_RG_USBDL_SET_MASK                         0x1
#define PMU_RG_USBDL_SET_SHIFT                        3
#define PMU_RG_ADCIN_VSEN_MUX_EN_ADDR                 PMU_CHR_CON16_H
#define PMU_RG_ADCIN_VSEN_MUX_EN_MASK                 0x1
#define PMU_RG_ADCIN_VSEN_MUX_EN_SHIFT                0
#define PMU_RG_ADCIN_VSEN_EXT_BATON_EN_ADDR           PMU_CHR_CON16_H
#define PMU_RG_ADCIN_VSEN_EXT_BATON_EN_MASK           0x1
#define PMU_RG_ADCIN_VSEN_EXT_BATON_EN_SHIFT          1
#define PMU_RG_ADCIN_VBAT_EN_ADDR                     PMU_CHR_CON16_H
#define PMU_RG_ADCIN_VBAT_EN_MASK                     0x1
#define PMU_RG_ADCIN_VBAT_EN_SHIFT                    2
#define PMU_RG_ADCIN_VSEN_EN_ADDR                     PMU_CHR_CON16_H
#define PMU_RG_ADCIN_VSEN_EN_MASK                     0x1
#define PMU_RG_ADCIN_VSEN_EN_SHIFT                    3
#define PMU_RG_ADCIN_CHR_EN_ADDR                      PMU_CHR_CON16_H
#define PMU_RG_ADCIN_CHR_EN_MASK                      0x1
#define PMU_RG_ADCIN_CHR_EN_SHIFT                     4
#define PMU_RG_UVLO_VTHL_ADDR                         PMU_CHR_CON17
#define PMU_RG_UVLO_VTHL_MASK                         0x1F
#define PMU_RG_UVLO_VTHL_SHIFT                        0
#define PMU_RG_UVLO_VH_LAT_ADDR                       PMU_CHR_CON17
#define PMU_RG_UVLO_VH_LAT_MASK                       0x1
#define PMU_RG_UVLO_VH_LAT_SHIFT                      7
#define PMU_RG_LBAT_INT_VTH_ADDR                      PMU_CHR_CON18
#define PMU_RG_LBAT_INT_VTH_MASK                      0x1F
#define PMU_RG_LBAT_INT_VTH_SHIFT                     0
#define PMU_RG_BGR_RSEL_ADDR                          PMU_CHR_CON19
#define PMU_RG_BGR_RSEL_MASK                          0x7
#define PMU_RG_BGR_RSEL_SHIFT                         0
#define PMU_RG_BC11_BB_CTRL_ADDR                      PMU_CHR_CON20
#define PMU_RG_BC11_BB_CTRL_MASK                      0x1
#define PMU_RG_BC11_BB_CTRL_SHIFT                     0
#define PMU_RG_BC11_RST_ADDR                          PMU_CHR_CON20
#define PMU_RG_BC11_RST_MASK                          0x1
#define PMU_RG_BC11_RST_SHIFT                         1
#define PMU_RG_BC11_VSRC_EN_ADDR                      PMU_CHR_CON20
#define PMU_RG_BC11_VSRC_EN_MASK                      0x3
#define PMU_RG_BC11_VSRC_EN_SHIFT                     2
#define PMU_RGS_BC11_CMP_OUT_ADDR                     PMU_CHR_CON20
#define PMU_RGS_BC11_CMP_OUT_MASK                     0x1
#define PMU_RGS_BC11_CMP_OUT_SHIFT                    7
#define PMU_RG_BC11_VREF_VTH_ADDR                     PMU_CHR_CON21
#define PMU_RG_BC11_VREF_VTH_MASK                     0x3
#define PMU_RG_BC11_VREF_VTH_SHIFT                    0
#define PMU_RG_BC11_CMP_EN_ADDR                       PMU_CHR_CON21
#define PMU_RG_BC11_CMP_EN_MASK                       0x3
#define PMU_RG_BC11_CMP_EN_SHIFT                      2
#define PMU_RG_BC11_IPD_EN_ADDR                       PMU_CHR_CON21
#define PMU_RG_BC11_IPD_EN_MASK                       0x3
#define PMU_RG_BC11_IPD_EN_SHIFT                      4
#define PMU_RG_BC11_IPU_EN_ADDR                       PMU_CHR_CON21
#define PMU_RG_BC11_IPU_EN_MASK                       0x3
#define PMU_RG_BC11_IPU_EN_SHIFT                      6
#define PMU_RG_BC11_BIAS_EN_ADDR                      PMU_CHR_CON21_H
#define PMU_RG_BC11_BIAS_EN_MASK                      0x1
#define PMU_RG_BC11_BIAS_EN_SHIFT                     0
#define PMU_RG_CSDAC_STP_INC_ADDR                     PMU_CHR_CON22
#define PMU_RG_CSDAC_STP_INC_MASK                     0x7
#define PMU_RG_CSDAC_STP_INC_SHIFT                    0
#define PMU_RG_CSDAC_STP_DEC_ADDR                     PMU_CHR_CON22
#define PMU_RG_CSDAC_STP_DEC_MASK                     0x7
#define PMU_RG_CSDAC_STP_DEC_SHIFT                    4
#define PMU_RG_CSDAC_DLY_ADDR                         PMU_CHR_CON23
#define PMU_RG_CSDAC_DLY_MASK                         0x7
#define PMU_RG_CSDAC_DLY_SHIFT                        0
#define PMU_RG_CSDAC_STP_ADDR                         PMU_CHR_CON23
#define PMU_RG_CSDAC_STP_MASK                         0x7
#define PMU_RG_CSDAC_STP_SHIFT                        4
#define PMU_RG_LOW_ICH_DB_ADDR                        PMU_CHR_CON24
#define PMU_RG_LOW_ICH_DB_MASK                        0x3F
#define PMU_RG_LOW_ICH_DB_SHIFT                       0
#define PMU_RG_CHRIND_ON_ADDR                         PMU_CHR_CON24
#define PMU_RG_CHRIND_ON_MASK                         0x1
#define PMU_RG_CHRIND_ON_SHIFT                        6
#define PMU_RG_CHRIND_DIMMING_ADDR                    PMU_CHR_CON24
#define PMU_RG_CHRIND_DIMMING_MASK                    0x1
#define PMU_RG_CHRIND_DIMMING_SHIFT                   7
#define PMU_RG_CV_MODE_ADDR                           PMU_CHR_CON25
#define PMU_RG_CV_MODE_MASK                           0x1
#define PMU_RG_CV_MODE_SHIFT                          0
#define PMU_RG_VCDT_MODE_ADDR                         PMU_CHR_CON25
#define PMU_RG_VCDT_MODE_MASK                         0x1
#define PMU_RG_VCDT_MODE_SHIFT                        1
#define PMU_RG_CSDAC_MODE_ADDR                        PMU_CHR_CON25
#define PMU_RG_CSDAC_MODE_MASK                        0x1
#define PMU_RG_CSDAC_MODE_SHIFT                       2
#define PMU_RG_TRACKING_EN_ADDR                       PMU_CHR_CON25
#define PMU_RG_TRACKING_EN_MASK                       0x1
#define PMU_RG_TRACKING_EN_SHIFT                      4
#define PMU_RG_HWCV_EN_ADDR                           PMU_CHR_CON25
#define PMU_RG_HWCV_EN_MASK                           0x1
#define PMU_RG_HWCV_EN_SHIFT                          6
#define PMU_RG_ULC_DET_EN_ADDR                        PMU_CHR_CON25
#define PMU_RG_ULC_DET_EN_MASK                        0x1
#define PMU_RG_ULC_DET_EN_SHIFT                       7
#define PMU_RG_BGR_TRIM_EN_ADDR                       PMU_CHR_CON26
#define PMU_RG_BGR_TRIM_EN_MASK                       0x1
#define PMU_RG_BGR_TRIM_EN_SHIFT                      0
#define PMU_RG_ICHRG_TRIM_ADDR                        PMU_CHR_CON26
#define PMU_RG_ICHRG_TRIM_MASK                        0x3F
#define PMU_RG_ICHRG_TRIM_SHIFT                       2
#define PMU_RG_BGR_TRIM_ADDR                          PMU_CHR_CON27
#define PMU_RG_BGR_TRIM_MASK                          0x1F
#define PMU_RG_BGR_TRIM_SHIFT                         0
#define PMU_RG_OVP_TRIM_ADDR                          PMU_CHR_CON28
#define PMU_RG_OVP_TRIM_MASK                          0xF
#define PMU_RG_OVP_TRIM_SHIFT                         0
#define PMU_RG_CHR_OSC_TRIM_ADDR                      PMU_CHR_CON29
#define PMU_RG_CHR_OSC_TRIM_MASK                      0x1F
#define PMU_RG_CHR_OSC_TRIM_SHIFT                     0
#define PMU_DA_QI_BGR_EXT_BUF_EN_ADDR                 PMU_CHR_CON29
#define PMU_DA_QI_BGR_EXT_BUF_EN_MASK                 0x1
#define PMU_DA_QI_BGR_EXT_BUF_EN_SHIFT                5
#define PMU_RG_BGR_TEST_EN_ADDR                       PMU_CHR_CON29
#define PMU_RG_BGR_TEST_EN_MASK                       0x1
#define PMU_RG_BGR_TEST_EN_SHIFT                      6
#define PMU_RG_BGR_TEST_RSTB_ADDR                     PMU_CHR_CON29
#define PMU_RG_BGR_TEST_RSTB_MASK                     0x1
#define PMU_RG_BGR_TEST_RSTB_SHIFT                    7
#define PMU_RG_DAC_USBDL_MAX_LSB_ADDR                 PMU_CHR_CON30
#define PMU_RG_DAC_USBDL_MAX_LSB_MASK                 0xFF
#define PMU_RG_DAC_USBDL_MAX_LSB_SHIFT                0
#define PMU_RG_DAC_USBDL_MAX_MSB_ADDR                 PMU_CHR_CON30_H
#define PMU_RG_DAC_USBDL_MAX_MSB_MASK                 0x3
#define PMU_RG_DAC_USBDL_MAX_MSB_SHIFT                0
#define PMU_RG_PCHR_RSV_ADDR                          PMU_CHR_CON41
#define PMU_RG_PCHR_RSV_MASK                          0xFF
#define PMU_RG_PCHR_RSV_SHIFT                         0
#define PMU_RG_ENVTEM_D_ADDR                          PMU_CHR_CON42
#define PMU_RG_ENVTEM_D_MASK                          0x1
#define PMU_RG_ENVTEM_D_SHIFT                         0
#define PMU_RG_ENVTEM_EN_ADDR                         PMU_CHR_CON42
#define PMU_RG_ENVTEM_EN_MASK                         0x1
#define PMU_RG_ENVTEM_EN_SHIFT                        1
#define PMU_RG_BATON_HT_EN_ADDR                       PMU_BATON_CON0
#define PMU_RG_BATON_HT_EN_MASK                       0x1
#define PMU_RG_BATON_HT_EN_SHIFT                      0
#define PMU_QI_BATON_HT_EN_ADDR                       PMU_BATON_CON0
#define PMU_QI_BATON_HT_EN_MASK                       0x1
#define PMU_QI_BATON_HT_EN_SHIFT                      5
#define PMU_RGS_BATON_HV_ADDR                         PMU_BATON_CON0
#define PMU_RGS_BATON_HV_MASK                         0x1
#define PMU_RGS_BATON_HV_SHIFT                        6
#define PMU_RG_HW_VTH_CTRL_ADDR                       PMU_BATON_CON0_H
#define PMU_RG_HW_VTH_CTRL_MASK                       0x1
#define PMU_RG_HW_VTH_CTRL_SHIFT                      3
#define PMU_RG_HW_VTH1_ADDR                           PMU_BATON_CON0_H
#define PMU_RG_HW_VTH1_MASK                           0x3
#define PMU_RG_HW_VTH1_SHIFT                          6
#define PMU_RG_QI_BATON_LT_EN_ADDR                    PMU_CHR_CON44
#define PMU_RG_QI_BATON_LT_EN_MASK                    0x1
#define PMU_RG_QI_BATON_LT_EN_SHIFT                   0
#define PMU_RGS_BATON_UNDET_ADDR                      PMU_CHR_CON44
#define PMU_RGS_BATON_UNDET_MASK                      0x1
#define PMU_RGS_BATON_UNDET_SHIFT                     1
#define PMU_RG_JW_CS_VTH_ADDR                         PMU_CHR_CON45
#define PMU_RG_JW_CS_VTH_MASK                         0xF
#define PMU_RG_JW_CS_VTH_SHIFT                        0
#define PMU_RG_JW_CV_VTH_ADDR                         PMU_CHR_CON45_H
#define PMU_RG_JW_CV_VTH_MASK                         0x3F
#define PMU_RG_JW_CV_VTH_SHIFT                        0
#define PMU_RG_JC_CS_VTH_ADDR                         PMU_CHR_CON46
#define PMU_RG_JC_CS_VTH_MASK                         0xF
#define PMU_RG_JC_CS_VTH_SHIFT                        0
#define PMU_RG_JC_CV_VTH_ADDR                         PMU_CHR_CON46_H
#define PMU_RG_JC_CV_VTH_MASK                         0x3F
#define PMU_RG_JC_CV_VTH_SHIFT                        0
#define PMU_RG_JEITA_EN_ADDR                          PMU_CHR_CON47
#define PMU_RG_JEITA_EN_MASK                          0x1
#define PMU_RG_JEITA_EN_SHIFT                         1
#define PMU_RG_VCDT_TRIM_ADDR                         PMU_CHR_CON48
#define PMU_RG_VCDT_TRIM_MASK                         0xF
#define PMU_RG_VCDT_TRIM_SHIFT                        0
#define PMU_RG_IVGEN_TEST_EN_ADDR                     PMU_CHR_CON49
#define PMU_RG_IVGEN_TEST_EN_MASK                     0x1
#define PMU_RG_IVGEN_TEST_EN_SHIFT                    0
#define PMU_RG_IVGEN_TEST_RSTB_ADDR                   PMU_CHR_CON49
#define PMU_RG_IVGEN_TEST_RSTB_MASK                   0x1
#define PMU_RG_IVGEN_TEST_RSTB_SHIFT                  1
#define PMU_RG_IVGEN_TRIM_EN_ADDR                     PMU_CHR_CON49
#define PMU_RG_IVGEN_TRIM_EN_MASK                     0x1
#define PMU_RG_IVGEN_TRIM_EN_SHIFT                    2
#define PMU_RG_IVGEN_TRIM_ADDR                        PMU_CHR_CON49
#define PMU_RG_IVGEN_TRIM_MASK                        0x1F
#define PMU_RG_IVGEN_TRIM_SHIFT                       3
#define PMU_RG_ICHRG_DC_TRIM_ADDR                     PMU_CHR_CON51
#define PMU_RG_ICHRG_DC_TRIM_MASK                     0x3F
#define PMU_RG_ICHRG_DC_TRIM_SHIFT                    0
#define PMU_RG_PCHR_REV_ADDR                          PMU_CHR_CON52
#define PMU_RG_PCHR_REV_MASK                          0xFF
#define PMU_RG_PCHR_REV_SHIFT                         0
#define PMU_RG_UVLO_VTHH_EFUSE_SEL_ADDR               PMU_CHR_CON53
#define PMU_RG_UVLO_VTHH_EFUSE_SEL_MASK               0x1
#define PMU_RG_UVLO_VTHH_EFUSE_SEL_SHIFT              0
#define PMU_RG_UVLO_VTHH_EFUSE_ADDR                   PMU_CHR_CON53
#define PMU_RG_UVLO_VTHH_EFUSE_MASK                   0x7
#define PMU_RG_UVLO_VTHH_EFUSE_SHIFT                  1
#define PMU_RG_UVLO_VTHH_ADDR                         PMU_CHR_CON53
#define PMU_RG_UVLO_VTHH_MASK                         0x7
#define PMU_RG_UVLO_VTHH_SHIFT                        4
#define PMU_RG_DDLO_VTHL_COIN_ADDR                    PMU_CHR_CON54
#define PMU_RG_DDLO_VTHL_COIN_MASK                    0x1F
#define PMU_RG_DDLO_VTHL_COIN_SHIFT                   0
#define PMU_RG_DDLO_VTHL_COIN_EFUSE_SEL_ADDR          PMU_CHR_CON55
#define PMU_RG_DDLO_VTHL_COIN_EFUSE_SEL_MASK          0x1
#define PMU_RG_DDLO_VTHL_COIN_EFUSE_SEL_SHIFT         0
#define PMU_RG_DDLO_VTHL_COIN_EFUSE_ADDR              PMU_CHR_CON55
#define PMU_RG_DDLO_VTHL_COIN_EFUSE_MASK              0x1F
#define PMU_RG_DDLO_VTHL_COIN_EFUSE_SHIFT             1
#define PMU_RG_DDLO_VTHH_COIN_EFUSE_SEL_ADDR          PMU_CHR_CON56
#define PMU_RG_DDLO_VTHH_COIN_EFUSE_SEL_MASK          0x1
#define PMU_RG_DDLO_VTHH_COIN_EFUSE_SEL_SHIFT         0
#define PMU_RG_DDLO_VTHH_COIN_EFUSE_ADDR              PMU_CHR_CON56
#define PMU_RG_DDLO_VTHH_COIN_EFUSE_MASK              0x7
#define PMU_RG_DDLO_VTHH_COIN_EFUSE_SHIFT             1
#define PMU_RG_DDLO_VTHH_COIN_ADDR                    PMU_CHR_CON56
#define PMU_RG_DDLO_VTHH_COIN_MASK                    0x7
#define PMU_RG_DDLO_VTHH_COIN_SHIFT                   4
#define PMU_RG_OTP_PA_ADDR                            PMU_OTP_CON0
#define PMU_RG_OTP_PA_MASK                            0x7F
#define PMU_RG_OTP_PA_SHIFT                           0
#define PMU_RG_OTP_PDIN_ADDR                          PMU_OTP_CON1
#define PMU_RG_OTP_PDIN_MASK                          0xFF
#define PMU_RG_OTP_PDIN_SHIFT                         0
#define PMU_RG_OTP_PTM_ADDR                           PMU_OTP_CON2
#define PMU_RG_OTP_PTM_MASK                           0x3
#define PMU_RG_OTP_PTM_SHIFT                          0
#define PMU_RG_OTP_PWE_ADDR                           PMU_OTP_CON3
#define PMU_RG_OTP_PWE_MASK                           0x3
#define PMU_RG_OTP_PWE_SHIFT                          0
#define PMU_RG_OTP_PPROG_ADDR                         PMU_OTP_CON4
#define PMU_RG_OTP_PPROG_MASK                         0x1
#define PMU_RG_OTP_PPROG_SHIFT                        0
#define PMU_RG_OTP_PWE_SRC_ADDR                       PMU_OTP_CON5
#define PMU_RG_OTP_PWE_SRC_MASK                       0x1
#define PMU_RG_OTP_PWE_SRC_SHIFT                      0
#define PMU_RG_OTP_PROG_PKEY_L_ADDR                   PMU_OTP_CON6
#define PMU_RG_OTP_PROG_PKEY_L_MASK                   0xFF
#define PMU_RG_OTP_PROG_PKEY_L_SHIFT                  0
#define PMU_RG_OTP_PROG_PKEY_H_ADDR                   PMU_OTP_CON7
#define PMU_RG_OTP_PROG_PKEY_H_MASK                   0xFF
#define PMU_RG_OTP_PROG_PKEY_H_SHIFT                  0
#define PMU_RG_OTP_RD_PKEY_L_ADDR                     PMU_OTP_CON8
#define PMU_RG_OTP_RD_PKEY_L_MASK                     0xFF
#define PMU_RG_OTP_RD_PKEY_L_SHIFT                    0
#define PMU_RG_OTP_RD_PKEY_H_ADDR                     PMU_OTP_CON9
#define PMU_RG_OTP_RD_PKEY_H_MASK                     0xFF
#define PMU_RG_OTP_RD_PKEY_H_SHIFT                    0
#define PMU_RG_OTP_RD_TRIG_ADDR                       PMU_OTP_CON10
#define PMU_RG_OTP_RD_TRIG_MASK                       0x1
#define PMU_RG_OTP_RD_TRIG_SHIFT                      0
#define PMU_RG_RD_RDY_BYPASS_ADDR                     PMU_OTP_CON11
#define PMU_RG_RD_RDY_BYPASS_MASK                     0x1
#define PMU_RG_RD_RDY_BYPASS_SHIFT                    0
#define PMU_RG_SKIP_OTP_OUT_ADDR                      PMU_OTP_CON12
#define PMU_RG_SKIP_OTP_OUT_MASK                      0x1
#define PMU_RG_SKIP_OTP_OUT_SHIFT                     0
#define PMU_RG_OTP_RD_SW_ADDR                         PMU_OTP_CON13
#define PMU_RG_OTP_RD_SW_MASK                         0x1
#define PMU_RG_OTP_RD_SW_SHIFT                        0
#define PMU_RG_OTP_DOUT_SW_L_ADDR                     PMU_OTP_CON14
#define PMU_RG_OTP_DOUT_SW_L_MASK                     0xFF
#define PMU_RG_OTP_DOUT_SW_L_SHIFT                    0
#define PMU_RG_OTP_DOUT_SW_H_ADDR                     PMU_OTP_CON15
#define PMU_RG_OTP_DOUT_SW_H_MASK                     0xFF
#define PMU_RG_OTP_DOUT_SW_H_SHIFT                    0
#define PMU_RG_OTP_RD_BUSY_ADDR                       PMU_OTP_CON16
#define PMU_RG_OTP_RD_BUSY_MASK                       0x1
#define PMU_RG_OTP_RD_BUSY_SHIFT                      0
#define PMU_RG_OTP_RD_ACK_ADDR                        PMU_OTP_CON16
#define PMU_RG_OTP_RD_ACK_MASK                        0x1
#define PMU_RG_OTP_RD_ACK_SHIFT                       2
#define PMU_RG_OTP_PA_SW_ADDR                         PMU_OTP_CON17
#define PMU_RG_OTP_PA_SW_MASK                         0x3F
#define PMU_RG_OTP_PA_SW_SHIFT                        0
#define PMU_RTC_SPAR_2SEC_EN_ADDR                     PMU_RTC_SPAR_CON0
#define PMU_RTC_SPAR_2SEC_EN_MASK                     0x1
#define PMU_RTC_SPAR_2SEC_EN_SHIFT                    0
#define PMU_RTC_SPAR_2SEC_MODE_ADDR                   PMU_RTC_SPAR_CON0
#define PMU_RTC_SPAR_2SEC_MODE_MASK                   0x3
#define PMU_RTC_SPAR_2SEC_MODE_SHIFT                  1
#define PMU_RTC_SPAR_2SEC_STAT_CLEAR_ADDR             PMU_RTC_SPAR_CON0
#define PMU_RTC_SPAR_2SEC_STAT_CLEAR_MASK             0x1
#define PMU_RTC_SPAR_2SEC_STAT_CLEAR_SHIFT            3
#define PMU_RTC_SPAR_2SEC_STAT_STA_ADDR               PMU_RTC_SPAR_CON0
#define PMU_RTC_SPAR_2SEC_STAT_STA_MASK               0x1
#define PMU_RTC_SPAR_2SEC_STAT_STA_SHIFT              4
#define PMU_RTC_XOSC32_ENB_ADDR                       PMU_RTC_MISC_CON0
#define PMU_RTC_XOSC32_ENB_MASK                       0x1
#define PMU_RTC_XOSC32_ENB_SHIFT                      0
#define PMU_RTC_K_EOSC32_EN_ADDR                      PMU_RTC_MISC_CON0
#define PMU_RTC_K_EOSC32_EN_MASK                      0x1
#define PMU_RTC_K_EOSC32_EN_SHIFT                     1
#define PMU_RTC_MISC_DBG_EN_ADDR                      PMU_RTC_MISC_DBG0
#define PMU_RTC_MISC_DBG_EN_MASK                      0x1
#define PMU_RTC_MISC_DBG_EN_SHIFT                     0
#define PMU_D2D_PMU_F32K_CK_ADDR                      PMU_RTC_MISC_DBG0
#define PMU_D2D_PMU_F32K_CK_MASK                      0x1
#define PMU_D2D_PMU_F32K_CK_SHIFT                     1
#define PMU_D2D_DDLO_VRTC_ADDR                        PMU_RTC_MISC_DBG0
#define PMU_D2D_DDLO_VRTC_MASK                        0x1
#define PMU_D2D_DDLO_VRTC_SHIFT                       2
#define PMU_D2D_PMU_PORSTB_ADDR                       PMU_RTC_MISC_DBG0
#define PMU_D2D_PMU_PORSTB_MASK                       0x1
#define PMU_D2D_PMU_PORSTB_SHIFT                      3
#define PMU_D2D_TESTMODE_ADDR                         PMU_RTC_MISC_DBG0
#define PMU_D2D_TESTMODE_MASK                         0x1
#define PMU_D2D_TESTMODE_SHIFT                        4
#define PMU_D2D_RTC_VRF_EN_ADDR                       PMU_RTC_MISC_DBG0
#define PMU_D2D_RTC_VRF_EN_MASK                       0x1
#define PMU_D2D_RTC_VRF_EN_SHIFT                      5
#define PMU_D2D_RTC_ALARM_ADDR                        PMU_RTC_MISC_DBG0
#define PMU_D2D_RTC_ALARM_MASK                        0x1
#define PMU_D2D_RTC_ALARM_SHIFT                       6
#define PMU_D2D_RTC_F32K_CK_ADDR                      PMU_RTC_MISC_DBG0
#define PMU_D2D_RTC_F32K_CK_MASK                      0x1
#define PMU_D2D_RTC_F32K_CK_SHIFT                     7
#define PMU_RG_BGP_ULP_DLY_SWMD_ADDR                  PMU_RTC_MISC_SPARE0
#define PMU_RG_BGP_ULP_DLY_SWMD_MASK                  0x1
#define PMU_RG_BGP_ULP_DLY_SWMD_SHIFT                 0
#define PMU_RG_BGP_ULP_DLY_SWCTL_ADDR                 PMU_RTC_MISC_SPARE0
#define PMU_RG_BGP_ULP_DLY_SWCTL_MASK                 0x1
#define PMU_RG_BGP_ULP_DLY_SWCTL_SHIFT                1
#define PMU_RTC_SPAR0_E1_0_ADDR                       PMU_RTC_MISC_SPARE0
#define PMU_RTC_SPAR0_E1_0_MASK                       0x3
#define PMU_RTC_SPAR0_E1_0_SHIFT                      2
#define PMU_RG_VC_LDO_OC_DEB_32US_ADDR                PMU_RTC_MISC_SPARE0
#define PMU_RG_VC_LDO_OC_DEB_32US_MASK                0x1
#define PMU_RG_VC_LDO_OC_DEB_32US_SHIFT               4
#define PMU_RTC_SPAR0_E1_1_ADDR                       PMU_RTC_MISC_SPARE0
#define PMU_RTC_SPAR0_E1_1_MASK                       0x1
#define PMU_RTC_SPAR0_E1_1_SHIFT                      5
#define PMU_RG_CPWKLP_NOGATE_ADDR                     PMU_RTC_MISC_SPARE0
#define PMU_RG_CPWKLP_NOGATE_MASK                     0x1
#define PMU_RG_CPWKLP_NOGATE_SHIFT                    6
#define PMU_RG_XRSTB_NOGATE_ADDR                      PMU_RTC_MISC_SPARE0
#define PMU_RG_XRSTB_NOGATE_MASK                      0x1
#define PMU_RG_XRSTB_NOGATE_SHIFT                     7
#define PMU_RG_RTC_MISC_32K_CK_PDN_ADDR               PMU_RTC_MISC_SPARE1
#define PMU_RG_RTC_MISC_32K_CK_PDN_MASK               0x1
#define PMU_RG_RTC_MISC_32K_CK_PDN_SHIFT              0
#define PMU_RG_RTC_MISC_CK_SEL_ADDR                   PMU_RTC_MISC_SPARE1
#define PMU_RG_RTC_MISC_CK_SEL_MASK                   0x1
#define PMU_RG_RTC_MISC_CK_SEL_SHIFT                  1
#define PMU_RTC_SPAR1_E1_ADDR                         PMU_RTC_MISC_SPARE1
#define PMU_RTC_SPAR1_E1_MASK                         0x3F
#define PMU_RTC_SPAR1_E1_SHIFT                        2
#define PMU_RTC_SPAR2_ADDR                            PMU_RTC_MISC_SPARE2
#define PMU_RTC_SPAR2_MASK                            0xFF
#define PMU_RTC_SPAR2_SHIFT                           0
#define PMU_RTC_SPAR3_ADDR                            PMU_RTC_MISC_SPARE3
#define PMU_RTC_SPAR3_MASK                            0xFF
#define PMU_RTC_SPAR3_SHIFT                           0
#define PMU_OSC_32K_TRIM_ADDR                         PMU_TOP_CLK_TRIM_L
#define PMU_OSC_32K_TRIM_MASK                         0x1F
#define PMU_OSC_32K_TRIM_SHIFT                        0
#define PMU_RG_OSC_32K_TRIM_EN_ADDR                   PMU_TOP_CLK_TRIM_L
#define PMU_RG_OSC_32K_TRIM_EN_MASK                   0x1
#define PMU_RG_OSC_32K_TRIM_EN_SHIFT                  5
#define PMU_RG_OSC_32K_TRIM_RATE_ADDR                 PMU_TOP_CLK_TRIM_L
#define PMU_RG_OSC_32K_TRIM_RATE_MASK                 0x3
#define PMU_RG_OSC_32K_TRIM_RATE_SHIFT                6
#define PMU_RG_OSC_32K_TRIM_ADDR                      PMU_TOP_CLK_TRIM_H
#define PMU_RG_OSC_32K_TRIM_MASK                      0x1F
#define PMU_RG_OSC_32K_TRIM_SHIFT                     0
#define PMU_RG_VA18_EN_ADDR                           PMU_VA18CTL0
#define PMU_RG_VA18_EN_MASK                           0x1
#define PMU_RG_VA18_EN_SHIFT                          0
#define PMU_RG_VA18_OCFB_EN_ADDR                      PMU_VA18CTL0
#define PMU_RG_VA18_OCFB_EN_MASK                      0x1
#define PMU_RG_VA18_OCFB_EN_SHIFT                     1
#define PMU_RG_OVR_VA18_PMOD_ADDR                     PMU_VA18CTL0
#define PMU_RG_OVR_VA18_PMOD_MASK                     0x1
#define PMU_RG_OVR_VA18_PMOD_SHIFT                    2
#define PMU_RG_VA18_STBTD_ADDR                        PMU_VA18CTL0
#define PMU_RG_VA18_STBTD_MASK                        0x3
#define PMU_RG_VA18_STBTD_SHIFT                       4
#define PMU_RGS_VA18_STBSTS_ADDR                      PMU_VA18CTL0
#define PMU_RGS_VA18_STBSTS_MASK                      0x1
#define PMU_RGS_VA18_STBSTS_SHIFT                     6
#define PMU_RG_VA18_OC_DEB_LEN_ADDR                   PMU_VA18CTL1
#define PMU_RG_VA18_OC_DEB_LEN_MASK                   0x3
#define PMU_RG_VA18_OC_DEB_LEN_SHIFT                  0
#define PMU_RG_OFF_VA18_PMOD_ADDR                     PMU_VA18CTL1
#define PMU_RG_OFF_VA18_PMOD_MASK                     0x1
#define PMU_RG_OFF_VA18_PMOD_SHIFT                    2
#define PMU_RG_VA18_CAL_ADDR                          PMU_VA18LDO0
#define PMU_RG_VA18_CAL_MASK                          0xF
#define PMU_RG_VA18_CAL_SHIFT                         0
#define PMU_RG_VA18_VOSEL_ADDR                        PMU_VA18LDO1
#define PMU_RG_VA18_VOSEL_MASK                        0x7
#define PMU_RG_VA18_VOSEL_SHIFT                       0
#define PMU_RG_VA18_NDIS_EN_ADDR                      PMU_VA18LDO2
#define PMU_RG_VA18_NDIS_EN_MASK                      0x1
#define PMU_RG_VA18_NDIS_EN_SHIFT                     1
#define PMU_RG_VA18_RSV_ADDR                          PMU_VA18LDO2
#define PMU_RG_VA18_RSV_MASK                          0xF
#define PMU_RG_VA18_RSV_SHIFT                         2
#define PMU_RG_VA18_DUMMY0_ADDR                       PMU_VA18LDO3
#define PMU_RG_VA18_DUMMY0_MASK                       0x1
#define PMU_RG_VA18_DUMMY0_SHIFT                      0
#define PMU_RG_VA18_COIN_SS_TRIM_BIAS_ADDR            PMU_VA18LDOBF0
#define PMU_RG_VA18_COIN_SS_TRIM_BIAS_MASK            0x7
#define PMU_RG_VA18_COIN_SS_TRIM_BIAS_SHIFT           4
#define PMU_RG_VA18_BUF_DUMMY0_ADDR                   PMU_VA18LDOBF1
#define PMU_RG_VA18_BUF_DUMMY0_MASK                   0x1
#define PMU_RG_VA18_BUF_DUMMY0_SHIFT                  0
#define PMU_RG_HP_VA18_PMOD_ADDR                      PMU_VA18PSI0
#define PMU_RG_HP_VA18_PMOD_MASK                      0x1
#define PMU_RG_HP_VA18_PMOD_SHIFT                     1
#define PMU_RG_LP_VA18_PMOD_ADDR                      PMU_VA18PSI0
#define PMU_RG_LP_VA18_PMOD_MASK                      0x1
#define PMU_RG_LP_VA18_PMOD_SHIFT                     5
#define PMU_RG_S0_VA18_ON_ADDR                        PMU_VA18PSI1
#define PMU_RG_S0_VA18_ON_MASK                        0x1
#define PMU_RG_S0_VA18_ON_SHIFT                       0
#define PMU_RG_S0_VA18_PMOD_ADDR                      PMU_VA18PSI1
#define PMU_RG_S0_VA18_PMOD_MASK                      0x1
#define PMU_RG_S0_VA18_PMOD_SHIFT                     1
#define PMU_RG_S1_VA18_ON_ADDR                        PMU_VA18PSI1
#define PMU_RG_S1_VA18_ON_MASK                        0x1
#define PMU_RG_S1_VA18_ON_SHIFT                       4
#define PMU_RG_S1_VA18_PMOD_ADDR                      PMU_VA18PSI1
#define PMU_RG_S1_VA18_PMOD_MASK                      0x1
#define PMU_RG_S1_VA18_PMOD_SHIFT                     5
#define PMU_RG_VBT_EN_ADDR                            PMU_VBTCTL0
#define PMU_RG_VBT_EN_MASK                            0x1
#define PMU_RG_VBT_EN_SHIFT                           0
#define PMU_RG_VBT_OCFB_EN_ADDR                       PMU_VBTCTL0
#define PMU_RG_VBT_OCFB_EN_MASK                       0x1
#define PMU_RG_VBT_OCFB_EN_SHIFT                      1
#define PMU_RG_OVR_VBT_PMOD_ADDR                      PMU_VBTCTL0
#define PMU_RG_OVR_VBT_PMOD_MASK                      0x3
#define PMU_RG_OVR_VBT_PMOD_SHIFT                     2
#define PMU_RG_VBT_STBTD_ADDR                         PMU_VBTCTL0
#define PMU_RG_VBT_STBTD_MASK                         0x3
#define PMU_RG_VBT_STBTD_SHIFT                        4
#define PMU_RGS_VBT_STBSTS_ADDR                       PMU_VBTCTL0
#define PMU_RGS_VBT_STBSTS_MASK                       0x1
#define PMU_RGS_VBT_STBSTS_SHIFT                      6
#define PMU_RG_VA_EN_ADDR                             PMU_VACTL0
#define PMU_RG_VA_EN_MASK                             0x1
#define PMU_RG_VA_EN_SHIFT                            0
#define PMU_RG_VA_OCFB_EN_ADDR                        PMU_VACTL0
#define PMU_RG_VA_OCFB_EN_MASK                        0x1
#define PMU_RG_VA_OCFB_EN_SHIFT                       1
#define PMU_RG_OVR_VA_PMOD_ADDR                       PMU_VACTL0
#define PMU_RG_OVR_VA_PMOD_MASK                       0x3
#define PMU_RG_OVR_VA_PMOD_SHIFT                      2
#define PMU_RG_VA_STBTD_ADDR                          PMU_VACTL0
#define PMU_RG_VA_STBTD_MASK                          0x3
#define PMU_RG_VA_STBTD_SHIFT                         4
#define PMU_RGS_VA_STBSTS_ADDR                        PMU_VACTL0
#define PMU_RGS_VA_STBSTS_MASK                        0x1
#define PMU_RGS_VA_STBSTS_SHIFT                       6
#define PMU_RG_VC_LDO_EN_ADDR                         PMU_VCLDOCTL0
#define PMU_RG_VC_LDO_EN_MASK                         0x1
#define PMU_RG_VC_LDO_EN_SHIFT                        0
#define PMU_RG_VC_LDO_OCFB_EN_ADDR                    PMU_VCLDOCTL0
#define PMU_RG_VC_LDO_OCFB_EN_MASK                    0x1
#define PMU_RG_VC_LDO_OCFB_EN_SHIFT                   1
#define PMU_RG_OVR_VC_LDO_PMOD_ADDR                   PMU_VCLDOCTL0
#define PMU_RG_OVR_VC_LDO_PMOD_MASK                   0x3
#define PMU_RG_OVR_VC_LDO_PMOD_SHIFT                  2
#define PMU_RG_VC_LDO_STBTD_ADDR                      PMU_VCLDOCTL0
#define PMU_RG_VC_LDO_STBTD_MASK                      0x3
#define PMU_RG_VC_LDO_STBTD_SHIFT                     4
#define PMU_RGS_VC_LDO_STBSTS_ADDR                    PMU_VCLDOCTL0
#define PMU_RGS_VC_LDO_STBSTS_MASK                    0x1
#define PMU_RGS_VC_LDO_STBSTS_SHIFT                   6
#define PMU_RG_VC_LDO_OC_DEB_LEN_ADDR                 PMU_VCLDOCTL1
#define PMU_RG_VC_LDO_OC_DEB_LEN_MASK                 0x3
#define PMU_RG_VC_LDO_OC_DEB_LEN_SHIFT                0
#define PMU_RG_VC_LDO_DVS_DISCH_LEN_ADDR              PMU_VCLDOCTL1
#define PMU_RG_VC_LDO_DVS_DISCH_LEN_MASK              0x1
#define PMU_RG_VC_LDO_DVS_DISCH_LEN_SHIFT             2
#define PMU_RG_VC_LDO_DVS_STB_LEN_ADDR                PMU_VCLDOCTL1
#define PMU_RG_VC_LDO_DVS_STB_LEN_MASK                0x3
#define PMU_RG_VC_LDO_DVS_STB_LEN_SHIFT               4
#define PMU_RG_SWXM_ENA_ADDR                          PMU_PSWCTL1
#define PMU_RG_SWXM_ENA_MASK                          0x1
#define PMU_RG_SWXM_ENA_SHIFT                         0
#define PMU_RG_SWDP_ENA_ADDR                          PMU_PSWCTL1
#define PMU_RG_SWDP_ENA_MASK                          0x1
#define PMU_RG_SWDP_ENA_SHIFT                         1
#define PMU_RG_SWXM_STBTD_ADDR                        PMU_PSWCTL1
#define PMU_RG_SWXM_STBTD_MASK                        0x1
#define PMU_RG_SWXM_STBTD_SHIFT                       4
#define PMU_RG_SWDP_STBTD_ADDR                        PMU_PSWCTL1
#define PMU_RG_SWDP_STBTD_MASK                        0x1
#define PMU_RG_SWDP_STBTD_SHIFT                       5
#define PMU_RG_SWMP_STBTD_ADDR                        PMU_PSWCTL1
#define PMU_RG_SWMP_STBTD_MASK                        0x1
#define PMU_RG_SWMP_STBTD_SHIFT                       6
#define PMU_RG_VIO18_EN_ADDR                          PMU_VIO18CTL0
#define PMU_RG_VIO18_EN_MASK                          0x1
#define PMU_RG_VIO18_EN_SHIFT                         0
#define PMU_RG_VIO18_OCFB_EN_ADDR                     PMU_VIO18CTL0
#define PMU_RG_VIO18_OCFB_EN_MASK                     0x1
#define PMU_RG_VIO18_OCFB_EN_SHIFT                    1
#define PMU_RG_OVR_VIO18_PMOD_ADDR                    PMU_VIO18CTL0
#define PMU_RG_OVR_VIO18_PMOD_MASK                    0x3
#define PMU_RG_OVR_VIO18_PMOD_SHIFT                   2
#define PMU_RG_VIO18_STBTD_ADDR                       PMU_VIO18CTL0
#define PMU_RG_VIO18_STBTD_MASK                       0x3
#define PMU_RG_VIO18_STBTD_SHIFT                      4
#define PMU_RGS_VIO18_STBSTS_ADDR                     PMU_VIO18CTL0
#define PMU_RGS_VIO18_STBSTS_MASK                     0x1
#define PMU_RGS_VIO18_STBSTS_SHIFT                    6
#define PMU_RG_VSF_EN_ADDR                            PMU_VSFCTL0
#define PMU_RG_VSF_EN_MASK                            0x1
#define PMU_RG_VSF_EN_SHIFT                           0
#define PMU_RG_VSF_OCFB_EN_ADDR                       PMU_VSFCTL0
#define PMU_RG_VSF_OCFB_EN_MASK                       0x1
#define PMU_RG_VSF_OCFB_EN_SHIFT                      1
#define PMU_RG_OVR_VSF_PMOD_ADDR                      PMU_VSFCTL0
#define PMU_RG_OVR_VSF_PMOD_MASK                      0x3
#define PMU_RG_OVR_VSF_PMOD_SHIFT                     2
#define PMU_RG_VSF_STBTD_ADDR                         PMU_VSFCTL0
#define PMU_RG_VSF_STBTD_MASK                         0x3
#define PMU_RG_VSF_STBTD_SHIFT                        4
#define PMU_RGS_VSF_STBSTS_ADDR                       PMU_VSFCTL0
#define PMU_RGS_VSF_STBSTS_MASK                       0x1
#define PMU_RGS_VSF_STBSTS_SHIFT                      6
#define PMU_RG_VIO28_EN_ADDR                          PMU_VIO28CTL0
#define PMU_RG_VIO28_EN_MASK                          0x1
#define PMU_RG_VIO28_EN_SHIFT                         0
#define PMU_RG_VIO28_OCFB_EN_ADDR                     PMU_VIO28CTL0
#define PMU_RG_VIO28_OCFB_EN_MASK                     0x1
#define PMU_RG_VIO28_OCFB_EN_SHIFT                    1
#define PMU_RG_OVR_VIO28_PMOD_ADDR                    PMU_VIO28CTL0
#define PMU_RG_OVR_VIO28_PMOD_MASK                    0x3
#define PMU_RG_OVR_VIO28_PMOD_SHIFT                   2
#define PMU_RG_VIO28_STBTD_ADDR                       PMU_VIO28CTL0
#define PMU_RG_VIO28_STBTD_MASK                       0x3
#define PMU_RG_VIO28_STBTD_SHIFT                      4
#define PMU_RGS_VIO28_STBSTS_ADDR                     PMU_VIO28CTL0
#define PMU_RGS_VIO28_STBSTS_MASK                     0x1
#define PMU_RGS_VIO28_STBSTS_SHIFT                    6
#define PMU_RG_VMC_EN_ADDR                            PMU_VMCCTL0
#define PMU_RG_VMC_EN_MASK                            0x1
#define PMU_RG_VMC_EN_SHIFT                           0
#define PMU_RG_VMC_OCFB_EN_ADDR                       PMU_VMCCTL0
#define PMU_RG_VMC_OCFB_EN_MASK                       0x1
#define PMU_RG_VMC_OCFB_EN_SHIFT                      1
#define PMU_RG_OVR_VMC_PMOD_ADDR                      PMU_VMCCTL0
#define PMU_RG_OVR_VMC_PMOD_MASK                      0x3
#define PMU_RG_OVR_VMC_PMOD_SHIFT                     2
#define PMU_RG_VMC_STBTD_ADDR                         PMU_VMCCTL0
#define PMU_RG_VMC_STBTD_MASK                         0x3
#define PMU_RG_VMC_STBTD_SHIFT                        4
#define PMU_RGS_VMC_STBSTS_ADDR                       PMU_VMCCTL0
#define PMU_RGS_VMC_STBSTS_MASK                       0x1
#define PMU_RGS_VMC_STBSTS_SHIFT                      6
#define PMU_RG_VUSB_EN_ADDR                           PMU_VUSBCTL0
#define PMU_RG_VUSB_EN_MASK                           0x1
#define PMU_RG_VUSB_EN_SHIFT                          0
#define PMU_RG_VUSB_OCFB_EN_ADDR                      PMU_VUSBCTL0
#define PMU_RG_VUSB_OCFB_EN_MASK                      0x1
#define PMU_RG_VUSB_OCFB_EN_SHIFT                     1
#define PMU_RG_OVR_VUSB_PMOD_ADDR                     PMU_VUSBCTL0
#define PMU_RG_OVR_VUSB_PMOD_MASK                     0x3
#define PMU_RG_OVR_VUSB_PMOD_SHIFT                    2
#define PMU_RG_VUSB_STBTD_ADDR                        PMU_VUSBCTL0
#define PMU_RG_VUSB_STBTD_MASK                        0x3
#define PMU_RG_VUSB_STBTD_SHIFT                       4
#define PMU_RGS_VUSB_STBSTS_ADDR                      PMU_VUSBCTL0
#define PMU_RGS_VUSB_STBSTS_MASK                      0x1
#define PMU_RGS_VUSB_STBSTS_SHIFT                     6
#define PMU_RG_VUSB_OC_DEB_LEN_ADDR                   PMU_VUSBCTL1
#define PMU_RG_VUSB_OC_DEB_LEN_MASK                   0x3
#define PMU_RG_VUSB_OC_DEB_LEN_SHIFT                  0
#define PMU_RG_VUSB_CAL_ADDR                          PMU_VUSBLDO0
#define PMU_RG_VUSB_CAL_MASK                          0xF
#define PMU_RG_VUSB_CAL_SHIFT                         0
#define PMU_RG_VUSB_DUMMY0_ADDR                       PMU_VUSBLDO1
#define PMU_RG_VUSB_DUMMY0_MASK                       0x3
#define PMU_RG_VUSB_DUMMY0_SHIFT                      0
#define PMU_RG_VUSB_NDIS_EN_ADDR                      PMU_VUSBLDO2
#define PMU_RG_VUSB_NDIS_EN_MASK                      0x1
#define PMU_RG_VUSB_NDIS_EN_SHIFT                     1
#define PMU_RG_VUSB_FT_EN_ADDR                        PMU_VUSBLDO2
#define PMU_RG_VUSB_FT_EN_MASK                        0x1
#define PMU_RG_VUSB_FT_EN_SHIFT                       2
#define PMU_RG_VUSB_RSV_ADDR                          PMU_VUSBLDO2
#define PMU_RG_VUSB_RSV_MASK                          0xF
#define PMU_RG_VUSB_RSV_SHIFT                         3
#define PMU_RG_VUSB_DUMMY1_ADDR                       PMU_VUSBLDO3
#define PMU_RG_VUSB_DUMMY1_MASK                       0x1
#define PMU_RG_VUSB_DUMMY1_SHIFT                      0
#define PMU_RG_VUSB_BUF_CAL_ADDR                      PMU_VUSBLDOBF0
#define PMU_RG_VUSB_BUF_CAL_MASK                      0xF
#define PMU_RG_VUSB_BUF_CAL_SHIFT                     0
#define PMU_RG_VUSB_COIN_SS_TRIM_BIAS_ADDR            PMU_VUSBLDOBF0
#define PMU_RG_VUSB_COIN_SS_TRIM_BIAS_MASK            0x7
#define PMU_RG_VUSB_COIN_SS_TRIM_BIAS_SHIFT           4
#define PMU_RG_VUSB_BUF_DUMMY0_ADDR                   PMU_VUSBLDOBF1
#define PMU_RG_VUSB_BUF_DUMMY0_MASK                   0x3
#define PMU_RG_VUSB_BUF_DUMMY0_SHIFT                  0
#define PMU_RG_HP_VUSB_PMOD_ADDR                      PMU_VUSBPSI0
#define PMU_RG_HP_VUSB_PMOD_MASK                      0x3
#define PMU_RG_HP_VUSB_PMOD_SHIFT                     1
#define PMU_RG_LP_VUSB_PMOD_ADDR                      PMU_VUSBPSI0
#define PMU_RG_LP_VUSB_PMOD_MASK                      0x3
#define PMU_RG_LP_VUSB_PMOD_SHIFT                     5
#define PMU_RGS_S0_VUSB_ON_ADDR                       PMU_VUSBPSI1
#define PMU_RGS_S0_VUSB_ON_MASK                       0x1
#define PMU_RGS_S0_VUSB_ON_SHIFT                      0
#define PMU_RG_S0_VUSB_PMOD_ADDR                      PMU_VUSBPSI1
#define PMU_RG_S0_VUSB_PMOD_MASK                      0x3
#define PMU_RG_S0_VUSB_PMOD_SHIFT                     1
#define PMU_RGS_S1_VUSB_ON_ADDR                       PMU_VUSBPSI1
#define PMU_RGS_S1_VUSB_ON_MASK                       0x1
#define PMU_RGS_S1_VUSB_ON_SHIFT                      4
#define PMU_RG_S1_VUSB_PMOD_ADDR                      PMU_VUSBPSI1
#define PMU_RG_S1_VUSB_PMOD_MASK                      0x3
#define PMU_RG_S1_VUSB_PMOD_SHIFT                     5
#define PMU_RG_OVR_VDIG18_CAL_ADDR                    PMU_VDIG18LDO0
#define PMU_RG_OVR_VDIG18_CAL_MASK                    0xF
#define PMU_RG_OVR_VDIG18_CAL_SHIFT                   0
#define PMU_RG_VDIG18_DUMMY0_ADDR                     PMU_VDIG18LDO1
#define PMU_RG_VDIG18_DUMMY0_MASK                     0x1
#define PMU_RG_VDIG18_DUMMY0_SHIFT                    0
#define PMU_RG_VDIG18_RSV_ADDR                        PMU_VDIG18LDO2
#define PMU_RG_VDIG18_RSV_MASK                        0xF
#define PMU_RG_VDIG18_RSV_SHIFT                       1
#define PMU_RG_VDIG18_DUMMY1_ADDR                     PMU_VDIG18LDO3
#define PMU_RG_VDIG18_DUMMY1_MASK                     0x3
#define PMU_RG_VDIG18_DUMMY1_SHIFT                    0
#define PMU_RG_OVR_VDIG18_BUF_CAL_ADDR                PMU_VDIG18LDOBF0
#define PMU_RG_OVR_VDIG18_BUF_CAL_MASK                0xF
#define PMU_RG_OVR_VDIG18_BUF_CAL_SHIFT               0
#define PMU_RG_VDIG18_BUF_DUMMY0_ADDR                 PMU_VDIG18LDOBF1
#define PMU_RG_VDIG18_BUF_DUMMY0_MASK                 0x3
#define PMU_RG_VDIG18_BUF_DUMMY0_SHIFT                0
#define PMU_RG_OVR_VC_LDO_CAL_ADDR                    PMU_VCLDO0
#define PMU_RG_OVR_VC_LDO_CAL_MASK                    0x1F
#define PMU_RG_OVR_VC_LDO_CAL_SHIFT                   0
#define PMU_RG_OVR_VC_LDO_VOSEL_ADDR                  PMU_VCLDO1
#define PMU_RG_OVR_VC_LDO_VOSEL_MASK                  0xF
#define PMU_RG_OVR_VC_LDO_VOSEL_SHIFT                 0
#define PMU_RG_VC_LDO_NDIS_EN_ADDR                    PMU_VCLDO2
#define PMU_RG_VC_LDO_NDIS_EN_MASK                    0x1
#define PMU_RG_VC_LDO_NDIS_EN_SHIFT                   1
#define PMU_RG_VC_LDO_FT_EN_ADDR                      PMU_VCLDO2
#define PMU_RG_VC_LDO_FT_EN_MASK                      0x1
#define PMU_RG_VC_LDO_FT_EN_SHIFT                     2
#define PMU_RG_VC_LDO_RSV_ADDR                        PMU_VCLDO2
#define PMU_RG_VC_LDO_RSV_MASK                        0x7
#define PMU_RG_VC_LDO_RSV_SHIFT                       3
#define PMU_RG_VC_LDO_DUMMY0_ADDR                     PMU_VCLDO3
#define PMU_RG_VC_LDO_DUMMY0_MASK                     0x1
#define PMU_RG_VC_LDO_DUMMY0_SHIFT                    0
#define PMU_RG_OVR_VC_LDO_BUF_CAL_ADDR                PMU_VCLDOBF0
#define PMU_RG_OVR_VC_LDO_BUF_CAL_MASK                0x1F
#define PMU_RG_OVR_VC_LDO_BUF_CAL_SHIFT               0
#define PMU_RG_VC_LDO_COIN_SS_TRIM_BIAS_ADDR          PMU_VCLDOBF0
#define PMU_RG_VC_LDO_COIN_SS_TRIM_BIAS_MASK          0x7
#define PMU_RG_VC_LDO_COIN_SS_TRIM_BIAS_SHIFT         5
#define PMU_RG_VC_LDO_BUF_DUMMY0_ADDR                 PMU_VCLDOBF1
#define PMU_RG_VC_LDO_BUF_DUMMY0_MASK                 0x1
#define PMU_RG_VC_LDO_BUF_DUMMY0_SHIFT                0
#define PMU_RG_HP_VC_LDO_ON_ADDR                      PMU_VCLDOPSI0
#define PMU_RG_HP_VC_LDO_ON_MASK                      0x1
#define PMU_RG_HP_VC_LDO_ON_SHIFT                     0
#define PMU_RG_HP_VC_LDO_PMOD_ADDR                    PMU_VCLDOPSI0
#define PMU_RG_HP_VC_LDO_PMOD_MASK                    0x3
#define PMU_RG_HP_VC_LDO_PMOD_SHIFT                   1
#define PMU_RG_HP_VC_LDO_VOSEL_ADDR                   PMU_VCLDOPSI0
#define PMU_RG_HP_VC_LDO_VOSEL_MASK                   0xF
#define PMU_RG_HP_VC_LDO_VOSEL_SHIFT                  4
#define PMU_RG_HP_VC_LDO_CAL_ADDR                     PMU_VCLDOPSI1
#define PMU_RG_HP_VC_LDO_CAL_MASK                     0x1F
#define PMU_RG_HP_VC_LDO_CAL_SHIFT                    0
#define PMU_RG_LP_VC_LDO_ON_ADDR                      PMU_VCLDOPSI2
#define PMU_RG_LP_VC_LDO_ON_MASK                      0x1
#define PMU_RG_LP_VC_LDO_ON_SHIFT                     0
#define PMU_RG_LP_VC_LDO_PMOD_ADDR                    PMU_VCLDOPSI2
#define PMU_RG_LP_VC_LDO_PMOD_MASK                    0x3
#define PMU_RG_LP_VC_LDO_PMOD_SHIFT                   1
#define PMU_RG_LP_VC_LDO_VOSEL_ADDR                   PMU_VCLDOPSI2
#define PMU_RG_LP_VC_LDO_VOSEL_MASK                   0xF
#define PMU_RG_LP_VC_LDO_VOSEL_SHIFT                  4
#define PMU_RG_LP_VC_LDO_CAL_ADDR                     PMU_VCLDOPSI3
#define PMU_RG_LP_VC_LDO_CAL_MASK                     0x1F
#define PMU_RG_LP_VC_LDO_CAL_SHIFT                    0
#define PMU_RG_S0_VC_LDO_PMOD_ADDR                    PMU_VCLDOPSI4
#define PMU_RG_S0_VC_LDO_PMOD_MASK                    0x3
#define PMU_RG_S0_VC_LDO_PMOD_SHIFT                   1
#define PMU_RG_S1_VC_LDO_PMOD_ADDR                    PMU_VCLDOPSI5
#define PMU_RG_S1_VC_LDO_PMOD_MASK                    0x3
#define PMU_RG_S1_VC_LDO_PMOD_SHIFT                   1
#define PMU_RG_S1_VC_LDO_VOSEL_ADDR                   PMU_VCLDOPSI5
#define PMU_RG_S1_VC_LDO_VOSEL_MASK                   0xF
#define PMU_RG_S1_VC_LDO_VOSEL_SHIFT                  4
#define PMU_RG_VIO18_OC_DEB_LEN_ADDR                  PMU_VIO18CTL1
#define PMU_RG_VIO18_OC_DEB_LEN_MASK                  0x3
#define PMU_RG_VIO18_OC_DEB_LEN_SHIFT                 0
#define PMU_RG_VIO18_CAL_ADDR                         PMU_VIO18LDO0
#define PMU_RG_VIO18_CAL_MASK                         0xF
#define PMU_RG_VIO18_CAL_SHIFT                        0
#define PMU_RG_VIO18_DUMMY0_ADDR                      PMU_VIO18LDO1
#define PMU_RG_VIO18_DUMMY0_MASK                      0x1
#define PMU_RG_VIO18_DUMMY0_SHIFT                     0
#define PMU_RG_VIO18_NDIS_EN_ADDR                     PMU_VIO18LDO2
#define PMU_RG_VIO18_NDIS_EN_MASK                     0x1
#define PMU_RG_VIO18_NDIS_EN_SHIFT                    1
#define PMU_RG_VIO18_FT_EN_ADDR                       PMU_VIO18LDO2
#define PMU_RG_VIO18_FT_EN_MASK                       0x1
#define PMU_RG_VIO18_FT_EN_SHIFT                      2
#define PMU_RG_VIO18_RSV_ADDR                         PMU_VIO18LDO2
#define PMU_RG_VIO18_RSV_MASK                         0x7
#define PMU_RG_VIO18_RSV_SHIFT                        3
#define PMU_RG_VIO18_DUMMY1_ADDR                      PMU_VIO18LDO3
#define PMU_RG_VIO18_DUMMY1_MASK                      0x1
#define PMU_RG_VIO18_DUMMY1_SHIFT                     0
#define PMU_RG_VIO18_BUF_CAL_ADDR                     PMU_VIO18LDOBF0
#define PMU_RG_VIO18_BUF_CAL_MASK                     0xF
#define PMU_RG_VIO18_BUF_CAL_SHIFT                    0
#define PMU_RG_VIO18_COIN_SS_TRIM_BIAS_ADDR           PMU_VIO18LDOBF0
#define PMU_RG_VIO18_COIN_SS_TRIM_BIAS_MASK           0x7
#define PMU_RG_VIO18_COIN_SS_TRIM_BIAS_SHIFT          4
#define PMU_RG_VIO18_BUF_DUMMY0_ADDR                  PMU_VIO18LDOBF1
#define PMU_RG_VIO18_BUF_DUMMY0_MASK                  0x1
#define PMU_RG_VIO18_BUF_DUMMY0_SHIFT                 0
#define PMU_RG_HP_VIO18_PMOD_ADDR                     PMU_VIO18PSI0
#define PMU_RG_HP_VIO18_PMOD_MASK                     0x3
#define PMU_RG_HP_VIO18_PMOD_SHIFT                    1
#define PMU_RG_LP_VIO18_PMOD_ADDR                     PMU_VIO18PSI0
#define PMU_RG_LP_VIO18_PMOD_MASK                     0x3
#define PMU_RG_LP_VIO18_PMOD_SHIFT                    5
#define PMU_RG_S0_VIO18_PMOD_ADDR                     PMU_VIO18PSI1
#define PMU_RG_S0_VIO18_PMOD_MASK                     0x3
#define PMU_RG_S0_VIO18_PMOD_SHIFT                    1
#define PMU_RG_S1_VIO18_PMOD_ADDR                     PMU_VIO18PSI1
#define PMU_RG_S1_VIO18_PMOD_MASK                     0x3
#define PMU_RG_S1_VIO18_PMOD_SHIFT                    5
#define PMU_RG_VSF_OC_DEB_LEN_ADDR                    PMU_VSFCTL1
#define PMU_RG_VSF_OC_DEB_LEN_MASK                    0x3
#define PMU_RG_VSF_OC_DEB_LEN_SHIFT                   0
#define PMU_RG_VSF_DMYLOAD_VAL_ADDR                   PMU_VSFCTL1
#define PMU_RG_VSF_DMYLOAD_VAL_MASK                   0x1F
#define PMU_RG_VSF_DMYLOAD_VAL_SHIFT                  2
#define PMU_RG_VSF_CAL_ADDR                           PMU_VSFLDO0
#define PMU_RG_VSF_CAL_MASK                           0xF
#define PMU_RG_VSF_CAL_SHIFT                          0
#define PMU_RG_VSF_VOSEL_0_ADDR                       PMU_VSFLDO1
#define PMU_RG_VSF_VOSEL_0_MASK                       0x1
#define PMU_RG_VSF_VOSEL_0_SHIFT                      0
#define PMU_RG_VSF_VOSEL_1_ADDR                       PMU_VSFLDO1
#define PMU_RG_VSF_VOSEL_1_MASK                       0x1
#define PMU_RG_VSF_VOSEL_1_SHIFT                      1
#define PMU_RG_VSF_NDIS_EN_ADDR                       PMU_VSFLDO2
#define PMU_RG_VSF_NDIS_EN_MASK                       0x1
#define PMU_RG_VSF_NDIS_EN_SHIFT                      1
#define PMU_RG_VSF_DUMMYLOAD_EN_ADDR                  PMU_VSFLDO2
#define PMU_RG_VSF_DUMMYLOAD_EN_MASK                  0x1
#define PMU_RG_VSF_DUMMYLOAD_EN_SHIFT                 2
#define PMU_RG_VSF_FT_EN_ADDR                         PMU_VSFLDO2
#define PMU_RG_VSF_FT_EN_MASK                         0x1
#define PMU_RG_VSF_FT_EN_SHIFT                        3
#define PMU_RG_VSF_RSV_ADDR                           PMU_VSFLDO2
#define PMU_RG_VSF_RSV_MASK                           0x3
#define PMU_RG_VSF_RSV_SHIFT                          4
#define PMU_RG_VSF_DUMMY0_ADDR                        PMU_VSFLDO3
#define PMU_RG_VSF_DUMMY0_MASK                        0x1
#define PMU_RG_VSF_DUMMY0_SHIFT                       0
#define PMU_RG_VSF_BUF_CAL_ADDR                       PMU_VSFLDOBF0
#define PMU_RG_VSF_BUF_CAL_MASK                       0xF
#define PMU_RG_VSF_BUF_CAL_SHIFT                      0
#define PMU_RG_VSF_COIN_SS_TRIM_BIAS_ADDR             PMU_VSFLDOBF0
#define PMU_RG_VSF_COIN_SS_TRIM_BIAS_MASK             0x7
#define PMU_RG_VSF_COIN_SS_TRIM_BIAS_SHIFT            4
#define PMU_RG_VSF_BUF_DUMMY0_ADDR                    PMU_VSFLDOBF1
#define PMU_RG_VSF_BUF_DUMMY0_MASK                    0x1
#define PMU_RG_VSF_BUF_DUMMY0_SHIFT                   0
#define PMU_RG_HP_VSF_PMOD_ADDR                       PMU_VSFPSI0
#define PMU_RG_HP_VSF_PMOD_MASK                       0x3
#define PMU_RG_HP_VSF_PMOD_SHIFT                      1
#define PMU_RG_LP_VSF_PMOD_ADDR                       PMU_VSFPSI0
#define PMU_RG_LP_VSF_PMOD_MASK                       0x3
#define PMU_RG_LP_VSF_PMOD_SHIFT                      5
#define PMU_RGS_S0_VSF_ON_ADDR                        PMU_VSFPSI1
#define PMU_RGS_S0_VSF_ON_MASK                        0x1
#define PMU_RGS_S0_VSF_ON_SHIFT                       0
#define PMU_RG_S0_VSF_PMOD_ADDR                       PMU_VSFPSI1
#define PMU_RG_S0_VSF_PMOD_MASK                       0x3
#define PMU_RG_S0_VSF_PMOD_SHIFT                      1
#define PMU_RGS_S1_VSF_ON_ADDR                        PMU_VSFPSI1
#define PMU_RGS_S1_VSF_ON_MASK                        0x1
#define PMU_RGS_S1_VSF_ON_SHIFT                       4
#define PMU_RG_S1_VSF_PMOD_ADDR                       PMU_VSFPSI1
#define PMU_RG_S1_VSF_PMOD_MASK                       0x3
#define PMU_RG_S1_VSF_PMOD_SHIFT                      5
#define PMU_RG_SWBAT_STBTD_ADDR                       PMU_BATPSW0
#define PMU_RG_SWBAT_STBTD_MASK                       0x1
#define PMU_RG_SWBAT_STBTD_SHIFT                      0
#define PMU_RG_SWBAT_NDIS_EN_ADDR                     PMU_BATPSW0
#define PMU_RG_SWBAT_NDIS_EN_MASK                     0x1
#define PMU_RG_SWBAT_NDIS_EN_SHIFT                    1
#define PMU_RG_VCORE_BUCK_DEB_TIME_ADDR               PMU_SMPSCTL0
#define PMU_RG_VCORE_BUCK_DEB_TIME_MASK               0x3
#define PMU_RG_VCORE_BUCK_DEB_TIME_SHIFT              0
#define PMU_RG_VCORE_BUCK_DVSEN_INTV_ADDR             PMU_SMPSCTL0
#define PMU_RG_VCORE_BUCK_DVSEN_INTV_MASK             0x3
#define PMU_RG_VCORE_BUCK_DVSEN_INTV_SHIFT            2
#define PMU_RG_VCORE_BUCK_SCHG_EN_ADDR                PMU_SMPSCTL0
#define PMU_RG_VCORE_BUCK_SCHG_EN_MASK                0x1
#define PMU_RG_VCORE_BUCK_SCHG_EN_SHIFT               4
#define PMU_RG_VCORE_BUCK_SCHG_TSTEP_ADDR             PMU_SMPSCTL0
#define PMU_RG_VCORE_BUCK_SCHG_TSTEP_MASK             0x3
#define PMU_RG_VCORE_BUCK_SCHG_TSTEP_SHIFT            6
#define PMU_RG_VCORE_BUCK_OSC_SEL_ADDR                PMU_SMPSCTL1
#define PMU_RG_VCORE_BUCK_OSC_SEL_MASK                0x1
#define PMU_RG_VCORE_BUCK_OSC_SEL_SHIFT               0
#define PMU_RG_OSC_SLEEP_AUTOFF_ADDR                  PMU_SMPSCTL1
#define PMU_RG_OSC_SLEEP_AUTOFF_MASK                  0x1
#define PMU_RG_OSC_SLEEP_AUTOFF_SHIFT                 1
#define PMU_RG_SMPS_TESTMODE_B_LSB_ADDR               PMU_SMPSANA0
#define PMU_RG_SMPS_TESTMODE_B_LSB_MASK               0xFF
#define PMU_RG_SMPS_TESTMODE_B_LSB_SHIFT              0
#define PMU_RG_SMPS_TESTMODE_B_MSB_ADDR               PMU_SMPSANA1
#define PMU_RG_SMPS_TESTMODE_B_MSB_MASK               0xF
#define PMU_RG_SMPS_TESTMODE_B_MSB_SHIFT              0
#define PMU_RG_VCORE_TRIMH_LSB_ADDR                   PMU_SMPSANA1
#define PMU_RG_VCORE_TRIMH_LSB_MASK                   0xF
#define PMU_RG_VCORE_TRIMH_LSB_SHIFT                  4
#define PMU_RG_VCORE_TRIMH_MSB_ADDR                   PMU_SMPSANA2
#define PMU_RG_VCORE_TRIMH_MSB_MASK                   0x1
#define PMU_RG_VCORE_TRIMH_MSB_SHIFT                  0
#define PMU_RG_VCORE_TRIML_ADDR                       PMU_SMPSANA2
#define PMU_RG_VCORE_TRIML_MASK                       0x1F
#define PMU_RG_VCORE_TRIML_SHIFT                      1
#define PMU_RG_VCORE_VSLEEP_LSB_ADDR                  PMU_SMPSANA2
#define PMU_RG_VCORE_VSLEEP_LSB_MASK                  0x3
#define PMU_RG_VCORE_VSLEEP_LSB_SHIFT                 6
#define PMU_RG_VCORE_VSLEEP_MSB_ADDR                  PMU_SMPSANA3
#define PMU_RG_VCORE_VSLEEP_MSB_MASK                  0x1
#define PMU_RG_VCORE_VSLEEP_MSB_SHIFT                 0
#define PMU_RG_VCORE_VSLEEP_SEL_ADDR                  PMU_SMPSANA3
#define PMU_RG_VCORE_VSLEEP_SEL_MASK                  0x3
#define PMU_RG_VCORE_VSLEEP_SEL_SHIFT                 1
#define PMU_RG_VOUTDET_EN_ADDR                        PMU_SMPSANA3
#define PMU_RG_VOUTDET_EN_MASK                        0x1
#define PMU_RG_VOUTDET_EN_SHIFT                       3
#define PMU_RG_VCORE_MODESET_ADDR                     PMU_VCBUCK0
#define PMU_RG_VCORE_MODESET_MASK                     0x1
#define PMU_RG_VCORE_MODESET_SHIFT                    1
#define PMU_RG_VCORE_NDIS_EN_ADDR                     PMU_VCBUCK0
#define PMU_RG_VCORE_NDIS_EN_MASK                     0x1
#define PMU_RG_VCORE_NDIS_EN_SHIFT                    2
#define PMU_RG_VCORE_VRF18_SSTART_EN_ADDR             PMU_VCBUCK0
#define PMU_RG_VCORE_VRF18_SSTART_EN_MASK             0x1
#define PMU_RG_VCORE_VRF18_SSTART_EN_SHIFT            3
#define PMU_RG_VCORE_AUTO_MODE_ADDR                   PMU_VCBUCK0
#define PMU_RG_VCORE_AUTO_MODE_MASK                   0x1
#define PMU_RG_VCORE_AUTO_MODE_SHIFT                  4
#define PMU_RG_VCORE_BUCK_RSV0_ADDR                   PMU_VCBUCK1
#define PMU_RG_VCORE_BUCK_RSV0_MASK                   0xFF
#define PMU_RG_VCORE_BUCK_RSV0_SHIFT                  0
#define PMU_RG_VCORE_RZSEL0_ADDR                      PMU_VCBUCK2
#define PMU_RG_VCORE_RZSEL0_MASK                      0x7
#define PMU_RG_VCORE_RZSEL0_SHIFT                     0
#define PMU_RG_VCORE_RZSEL1_ADDR                      PMU_VCBUCK2
#define PMU_RG_VCORE_RZSEL1_MASK                      0xF
#define PMU_RG_VCORE_RZSEL1_SHIFT                     3
#define PMU_RG_VCORE_CCSEL0_LSB_ADDR                  PMU_VCBUCK2
#define PMU_RG_VCORE_CCSEL0_LSB_MASK                  0x1
#define PMU_RG_VCORE_CCSEL0_LSB_SHIFT                 7
#define PMU_RG_VCORE_CCSEL0_MSB_ADDR                  PMU_VCBUCK3
#define PMU_RG_VCORE_CCSEL0_MSB_MASK                  0x1
#define PMU_RG_VCORE_CCSEL0_MSB_SHIFT                 0
#define PMU_RG_VCORE_CCSEL1_ADDR                      PMU_VCBUCK3
#define PMU_RG_VCORE_CCSEL1_MASK                      0x3
#define PMU_RG_VCORE_CCSEL1_SHIFT                     1
#define PMU_RG_VCORE_CSL_ADDR                         PMU_VCBUCK3
#define PMU_RG_VCORE_CSL_MASK                         0xF
#define PMU_RG_VCORE_CSL_SHIFT                        3
#define PMU_RG_VCORE_SLP_ADDR                         PMU_VCBUCK4
#define PMU_RG_VCORE_SLP_MASK                         0x7
#define PMU_RG_VCORE_SLP_SHIFT                        0
#define PMU_RG_VCORE_ADRC_FEN_ADDR                    PMU_VCBUCK4
#define PMU_RG_VCORE_ADRC_FEN_MASK                    0x1
#define PMU_RG_VCORE_ADRC_FEN_SHIFT                   3
#define PMU_RG_VCORE_VCCAP_CLAMP_FEN_ADDR             PMU_VCBUCK4
#define PMU_RG_VCORE_VCCAP_CLAMP_FEN_MASK             0x1
#define PMU_RG_VCORE_VCCAP_CLAMP_FEN_SHIFT            4
#define PMU_RG_VCORE_PREOC_SEL_ADDR                   PMU_VCBUCK4
#define PMU_RG_VCORE_PREOC_SEL_MASK                   0x7
#define PMU_RG_VCORE_PREOC_SEL_SHIFT                  5
#define PMU_RG_VCORE_BUCK_PFMOC_ADDR                  PMU_VCBUCK5
#define PMU_RG_VCORE_BUCK_PFMOC_MASK                  0x7
#define PMU_RG_VCORE_BUCK_PFMOC_SHIFT                 0
#define PMU_RG_VCORE_CSR_ADDR                         PMU_VCBUCK5
#define PMU_RG_VCORE_CSR_MASK                         0x7
#define PMU_RG_VCORE_CSR_SHIFT                        3
#define PMU_RG_VCORE_VC_CLAMP_FEN_ADDR                PMU_VCBUCK5
#define PMU_RG_VCORE_VC_CLAMP_FEN_MASK                0x1
#define PMU_RG_VCORE_VC_CLAMP_FEN_SHIFT               6
#define PMU_RG_VCORE_ZXOS_TRIM_ADDR                   PMU_VCBUCK6
#define PMU_RG_VCORE_ZXOS_TRIM_MASK                   0xFF
#define PMU_RG_VCORE_ZXOS_TRIM_SHIFT                  0
#define PMU_RG_VCORE_CSM_N_ADDR                       PMU_VCBUCK7
#define PMU_RG_VCORE_CSM_N_MASK                       0x3F
#define PMU_RG_VCORE_CSM_N_SHIFT                      0
#define PMU_RG_VCORE_CSM_P_LSB_ADDR                   PMU_VCBUCK7
#define PMU_RG_VCORE_CSM_P_LSB_MASK                   0x1
#define PMU_RG_VCORE_CSM_P_LSB_SHIFT                  7
#define PMU_RG_VCORE_CSM_P_MSB_ADDR                   PMU_VCBUCK8
#define PMU_RG_VCORE_CSM_P_MSB_MASK                   0x1F
#define PMU_RG_VCORE_CSM_P_MSB_SHIFT                  0
#define PMU_RG_VCORE_PFMSR_EH_ADDR                    PMU_VCBUCK8
#define PMU_RG_VCORE_PFMSR_EH_MASK                    0x1
#define PMU_RG_VCORE_PFMSR_EH_SHIFT                   5
#define PMU_RG_VCORE_NLIM_GATING_ADDR                 PMU_VCBUCK8
#define PMU_RG_VCORE_NLIM_GATING_MASK                 0x1
#define PMU_RG_VCORE_NLIM_GATING_SHIFT                6
#define PMU_RG_VCORE_PWRSR_EH_ADDR                    PMU_VCBUCK8
#define PMU_RG_VCORE_PWRSR_EH_MASK                    0x1
#define PMU_RG_VCORE_PWRSR_EH_SHIFT                   7
#define PMU_RG_VCORE_HS_VTHDET_ADDR                   PMU_VCBUCK9
#define PMU_RG_VCORE_HS_VTHDET_MASK                   0x1
#define PMU_RG_VCORE_HS_VTHDET_SHIFT                  0
#define PMU_RG_VCORE_PG_GATING_ADDR                   PMU_VCBUCK9
#define PMU_RG_VCORE_PG_GATING_MASK                   0x1
#define PMU_RG_VCORE_PG_GATING_SHIFT                  1
#define PMU_RG_VCORE_HS_ONSPEED_EH_ADDR               PMU_VCBUCK9
#define PMU_RG_VCORE_HS_ONSPEED_EH_MASK               0x1
#define PMU_RG_VCORE_HS_ONSPEED_EH_SHIFT              2
#define PMU_RG_VCORE_NLIM_TRIMMING_ADDR               PMU_VCBUCK9
#define PMU_RG_VCORE_NLIM_TRIMMING_MASK               0xF
#define PMU_RG_VCORE_NLIM_TRIMMING_SHIFT              3
#define PMU_RG_VCORE_DLC_LSB_ADDR                     PMU_VCBUCK9
#define PMU_RG_VCORE_DLC_LSB_MASK                     0x1
#define PMU_RG_VCORE_DLC_LSB_SHIFT                    7
#define PMU_RG_VCORE_DLC_MSB_ADDR                     PMU_VCBUCK10
#define PMU_RG_VCORE_DLC_MSB_MASK                     0x1
#define PMU_RG_VCORE_DLC_MSB_SHIFT                    0
#define PMU_RG_VCORE_DLC_N_ADDR                       PMU_VCBUCK10
#define PMU_RG_VCORE_DLC_N_MASK                       0x3
#define PMU_RG_VCORE_DLC_N_SHIFT                      1
#define PMU_RG_VCORE_PFM_RIP_ADDR                     PMU_VCBUCK10
#define PMU_RG_VCORE_PFM_RIP_MASK                     0x7
#define PMU_RG_VCORE_PFM_RIP_SHIFT                    3
#define PMU_RG_VCORE_TRAN_BST_LSB_ADDR                PMU_VCBUCK10
#define PMU_RG_VCORE_TRAN_BST_LSB_MASK                0x3
#define PMU_RG_VCORE_TRAN_BST_LSB_SHIFT               6
#define PMU_RG_VCORE_TRAN_BST_MSB_ADDR                PMU_VCBUCK11
#define PMU_RG_VCORE_TRAN_BST_MSB_MASK                0xF
#define PMU_RG_VCORE_TRAN_BST_MSB_SHIFT               0
#define PMU_RG_VCORE_DTS_ENB_ADDR                     PMU_VCBUCK11
#define PMU_RG_VCORE_DTS_ENB_MASK                     0x1
#define PMU_RG_VCORE_DTS_ENB_SHIFT                    4
#define PMU_RG_VCORE_MIN_OFF_ADDR                     PMU_VCBUCK11
#define PMU_RG_VCORE_MIN_OFF_MASK                     0x3
#define PMU_RG_VCORE_MIN_OFF_SHIFT                    5
#define PMU_RG_VCORE_1P35UP_SEL_EN_ADDR               PMU_VCBUCK11
#define PMU_RG_VCORE_1P35UP_SEL_EN_MASK               0x1
#define PMU_RG_VCORE_1P35UP_SEL_EN_SHIFT              7
#define PMU_RG_VCORE_DLC_AUTO_MODE_ADDR               PMU_VCBUCK12
#define PMU_RG_VCORE_DLC_AUTO_MODE_MASK               0x1
#define PMU_RG_VCORE_DLC_AUTO_MODE_SHIFT              0
#define PMU_RG_VCORE_DLC_SEL_ADDR                     PMU_VCBUCK12
#define PMU_RG_VCORE_DLC_SEL_MASK                     0x7
#define PMU_RG_VCORE_DLC_SEL_SHIFT                    1
#define PMU_RG_VCORE_SRC_AUTO_MODE_ADDR               PMU_VCBUCK12
#define PMU_RG_VCORE_SRC_AUTO_MODE_MASK               0x1
#define PMU_RG_VCORE_SRC_AUTO_MODE_SHIFT              4
#define PMU_RG_VCORE_UGP_SR_ADDR                      PMU_VCBUCK12
#define PMU_RG_VCORE_UGP_SR_MASK                      0x3
#define PMU_RG_VCORE_UGP_SR_SHIFT                     5
#define PMU_RG_VCORE_LGN_SR_LSB_ADDR                  PMU_VCBUCK12
#define PMU_RG_VCORE_LGN_SR_LSB_MASK                  0x1
#define PMU_RG_VCORE_LGN_SR_LSB_SHIFT                 7
#define PMU_RG_VCORE_LGN_SR_MSB_ADDR                  PMU_VCBUCK13
#define PMU_RG_VCORE_LGN_SR_MSB_MASK                  0x1
#define PMU_RG_VCORE_LGN_SR_MSB_SHIFT                 0
#define PMU_RG_VCORE_UGP_SR_PFM_ADDR                  PMU_VCBUCK13
#define PMU_RG_VCORE_UGP_SR_PFM_MASK                  0x3
#define PMU_RG_VCORE_UGP_SR_PFM_SHIFT                 1
#define PMU_RG_VCORE_LGN_SR_PFM_ADDR                  PMU_VCBUCK13
#define PMU_RG_VCORE_LGN_SR_PFM_MASK                  0x3
#define PMU_RG_VCORE_LGN_SR_PFM_SHIFT                 3
#define PMU_RG_VCORE_UGD_VTHSEL_ADDR                  PMU_VCBUCK13
#define PMU_RG_VCORE_UGD_VTHSEL_MASK                  0x3
#define PMU_RG_VCORE_UGD_VTHSEL_SHIFT                 5
#define PMU_RG_VCORE_FNLX_SNS_ADDR                    PMU_VCBUCK13
#define PMU_RG_VCORE_FNLX_SNS_MASK                    0x1
#define PMU_RG_VCORE_FNLX_SNS_SHIFT                   7
#define PMU_RG_VCORE_VDIFF_ENLOWIQ_ADDR               PMU_VCBUCK14
#define PMU_RG_VCORE_VDIFF_ENLOWIQ_MASK               0x1
#define PMU_RG_VCORE_VDIFF_ENLOWIQ_SHIFT              0
#define PMU_RG_VCORE_PFMOC_FWUPOFF_ADDR               PMU_VCBUCK14
#define PMU_RG_VCORE_PFMOC_FWUPOFF_MASK               0x1
#define PMU_RG_VCORE_PFMOC_FWUPOFF_SHIFT              1
#define PMU_RG_VCORE_PWFMOC_FWUPOFF_ADDR              PMU_VCBUCK14
#define PMU_RG_VCORE_PWFMOC_FWUPOFF_MASK              0x1
#define PMU_RG_VCORE_PWFMOC_FWUPOFF_SHIFT             2
#define PMU_RG_VCORE_CP_FWUPOFF_ADDR                  PMU_VCBUCK14
#define PMU_RG_VCORE_CP_FWUPOFF_MASK                  0x1
#define PMU_RG_VCORE_CP_FWUPOFF_SHIFT                 3
#define PMU_RG_VCORE_ZX_GATING_ADDR                   PMU_VCBUCK14
#define PMU_RG_VCORE_ZX_GATING_MASK                   0x1
#define PMU_RG_VCORE_ZX_GATING_SHIFT                  4
#define PMU_RG_VCORE_BUCK_RSV1_ADDR                   PMU_VCBUCK15
#define PMU_RG_VCORE_BUCK_RSV1_MASK                   0xFF
#define PMU_RG_VCORE_BUCK_RSV1_SHIFT                  0
#define PMU_RG_VCORE_BUCK_RSV2_ADDR                   PMU_VCBUCK16
#define PMU_RG_VCORE_BUCK_RSV2_MASK                   0xFF
#define PMU_RG_VCORE_BUCK_RSV2_SHIFT                  0
#define PMU_RG_VCORE_BUCK_RSV3_ADDR                   PMU_VCBUCK17
#define PMU_RG_VCORE_BUCK_RSV3_MASK                   0xFF
#define PMU_RG_VCORE_BUCK_RSV3_SHIFT                  0
#define PMU_RG_VCORE_PREOC_TRIMMING_ADDR              PMU_VCBUCK18
#define PMU_RG_VCORE_PREOC_TRIMMING_MASK              0x1F
#define PMU_RG_VCORE_PREOC_TRIMMING_SHIFT             0
#define PMU_RG_VCORE_AZC_EN_ADDR                      PMU_VCBUCK18
#define PMU_RG_VCORE_AZC_EN_MASK                      0x1
#define PMU_RG_VCORE_AZC_EN_SHIFT                     5
#define PMU_RG_VCORE_AZC_DELAY_ADDR                   PMU_VCBUCK18
#define PMU_RG_VCORE_AZC_DELAY_MASK                   0x3
#define PMU_RG_VCORE_AZC_DELAY_SHIFT                  6
#define PMU_RG_VCORE_AZC_HOLD_ENB_ADDR                PMU_VCBUCK19
#define PMU_RG_VCORE_AZC_HOLD_ENB_MASK                0x1
#define PMU_RG_VCORE_AZC_HOLD_ENB_SHIFT               0
#define PMU_RGS_QI_VCORE_OC_STATUS_ADDR               PMU_VCBUCK19
#define PMU_RGS_QI_VCORE_OC_STATUS_MASK               0x1
#define PMU_RGS_QI_VCORE_OC_STATUS_SHIFT              1
#define PMU_RGS_QI_VCORE_DIG_MON_ADDR                 PMU_VCBUCK19
#define PMU_RGS_QI_VCORE_DIG_MON_MASK                 0xF
#define PMU_RGS_QI_VCORE_DIG_MON_SHIFT                2
#define PMU_RGS_QI_VCORE_ENPWM_STATUS_ADDR            PMU_VCBUCK19
#define PMU_RGS_QI_VCORE_ENPWM_STATUS_MASK            0x1
#define PMU_RGS_QI_VCORE_ENPWM_STATUS_SHIFT           6
#define PMU_RGS_QI_VCORE_PREOC_ADDR                   PMU_VCBUCK19
#define PMU_RGS_QI_VCORE_PREOC_MASK                   0x1
#define PMU_RGS_QI_VCORE_PREOC_SHIFT                  7
#define PMU_RG_K_RST_DONE_ADDR                        PMU_VCBUCK_KCON0
#define PMU_RG_K_RST_DONE_MASK                        0x1
#define PMU_RG_K_RST_DONE_SHIFT                       0
#define PMU_RG_K_MAP_SEL_ADDR                         PMU_VCBUCK_KCON0
#define PMU_RG_K_MAP_SEL_MASK                         0x1
#define PMU_RG_K_MAP_SEL_SHIFT                        1
#define PMU_RG_K_ONCE_EN_ADDR                         PMU_VCBUCK_KCON0
#define PMU_RG_K_ONCE_EN_MASK                         0x1
#define PMU_RG_K_ONCE_EN_SHIFT                        2
#define PMU_RG_K_ONCE_ADDR                            PMU_VCBUCK_KCON0
#define PMU_RG_K_ONCE_MASK                            0x1
#define PMU_RG_K_ONCE_SHIFT                           3
#define PMU_RG_K_START_MANUAL_ADDR                    PMU_VCBUCK_KCON0
#define PMU_RG_K_START_MANUAL_MASK                    0x1
#define PMU_RG_K_START_MANUAL_SHIFT                   4
#define PMU_RG_K_AUTO_EN_ADDR                         PMU_VCBUCK_KCON0
#define PMU_RG_K_AUTO_EN_MASK                         0x1
#define PMU_RG_K_AUTO_EN_SHIFT                        6
#define PMU_RG_K_INV_ADDR                             PMU_VCBUCK_KCON0
#define PMU_RG_K_INV_MASK                             0x1
#define PMU_RG_K_INV_SHIFT                            7
#define PMU_RG_K_CONTROL_SMPS_ADDR                    PMU_VCBUCK_KCON1
#define PMU_RG_K_CONTROL_SMPS_MASK                    0x3F
#define PMU_RG_K_CONTROL_SMPS_SHIFT                   0
#define PMU_RGS_K_RESULT_ADDR                         PMU_VCBUCK_KCON2
#define PMU_RGS_K_RESULT_MASK                         0x1
#define PMU_RGS_K_RESULT_SHIFT                        0
#define PMU_RGS_K_DONE_ADDR                           PMU_VCBUCK_KCON2
#define PMU_RGS_K_DONE_MASK                           0x1
#define PMU_RGS_K_DONE_SHIFT                          1
#define PMU_RGS_K_CONTROL_ADDR                        PMU_VCBUCK_KCON2
#define PMU_RGS_K_CONTROL_MASK                        0x3F
#define PMU_RGS_K_CONTROL_SHIFT                       2
#define PMU_RGS_SMPS_OSC_CAL_ADDR                     PMU_VCBUCK_KCON3
#define PMU_RGS_SMPS_OSC_CAL_MASK                     0x3F
#define PMU_RGS_SMPS_OSC_CAL_SHIFT                    0
#define PMU_RG_K_BUCK_CK_CNT_LSB_ADDR                 PMU_VCBUCK_KCON4
#define PMU_RG_K_BUCK_CK_CNT_LSB_MASK                 0xFF
#define PMU_RG_K_BUCK_CK_CNT_LSB_SHIFT                0
#define PMU_RG_K_BUCK_CK_CNT_MSB_ADDR                 PMU_VCBUCK_KCON5
#define PMU_RG_K_BUCK_CK_CNT_MSB_MASK                 0x3
#define PMU_RG_K_BUCK_CK_CNT_MSB_SHIFT                0
#define PMU_RG_VC_BUCK_EN_ADDR                        PMU_VCBUCKCTL0
#define PMU_RG_VC_BUCK_EN_MASK                        0x1
#define PMU_RG_VC_BUCK_EN_SHIFT                       0
#define PMU_RG_VC_BUCK_SLP_ADDR                       PMU_VCBUCKCTL0
#define PMU_RG_VC_BUCK_SLP_MASK                       0x1
#define PMU_RG_VC_BUCK_SLP_SHIFT                      2
#define PMU_RG_OVR_VC_BUCK_VOVAL_ADDR                 PMU_VCBUCKCTL0
#define PMU_RG_OVR_VC_BUCK_VOVAL_MASK                 0xF
#define PMU_RG_OVR_VC_BUCK_VOVAL_SHIFT                4
#define PMU_RG_OVR_VC_BUCK_VOADJ_ADDR                 PMU_VCBUCKCTL1
#define PMU_RG_OVR_VC_BUCK_VOADJ_MASK                 0x7
#define PMU_RG_OVR_VC_BUCK_VOADJ_SHIFT                0
#define PMU_RG_HP_VC_BUCK_ON_ADDR                     PMU_VCBUCKPSI0
#define PMU_RG_HP_VC_BUCK_ON_MASK                     0x1
#define PMU_RG_HP_VC_BUCK_ON_SHIFT                    0
#define PMU_RG_HP_VC_BUCK_VOADJ_ADDR                  PMU_VCBUCKPSI0
#define PMU_RG_HP_VC_BUCK_VOADJ_MASK                  0x7
#define PMU_RG_HP_VC_BUCK_VOADJ_SHIFT                 1
#define PMU_RG_HP_VC_BUCK_VOVAL_ADDR                  PMU_VCBUCKPSI0
#define PMU_RG_HP_VC_BUCK_VOVAL_MASK                  0xF
#define PMU_RG_HP_VC_BUCK_VOVAL_SHIFT                 4
#define PMU_RG_LP_VC_BUCK_ON_ADDR                     PMU_VCBUCKPSI1
#define PMU_RG_LP_VC_BUCK_ON_MASK                     0x1
#define PMU_RG_LP_VC_BUCK_ON_SHIFT                    0
#define PMU_RG_LP_VC_BUCK_VOADJ_ADDR                  PMU_VCBUCKPSI1
#define PMU_RG_LP_VC_BUCK_VOADJ_MASK                  0x7
#define PMU_RG_LP_VC_BUCK_VOADJ_SHIFT                 1
#define PMU_RG_LP_VC_BUCK_VOVAL_ADDR                  PMU_VCBUCKPSI1
#define PMU_RG_LP_VC_BUCK_VOVAL_MASK                  0xF
#define PMU_RG_LP_VC_BUCK_VOVAL_SHIFT                 4
#define PMU_RG_S1_VC_BUCK_VOADJ_ADDR                  PMU_VCBUCKPSI2
#define PMU_RG_S1_VC_BUCK_VOADJ_MASK                  0x7
#define PMU_RG_S1_VC_BUCK_VOADJ_SHIFT                 1
#define PMU_RG_S1_VC_BUCK_VOVAL_ADDR                  PMU_VCBUCKPSI2
#define PMU_RG_S1_VC_BUCK_VOVAL_MASK                  0xF
#define PMU_RG_S1_VC_BUCK_VOVAL_SHIFT                 4
#define PMU_AUXADC_ADC_OUT_CH0_L_ADDR                 PMU_AUXADC_ADC0
#define PMU_AUXADC_ADC_OUT_CH0_L_MASK                 0xFF
#define PMU_AUXADC_ADC_OUT_CH0_L_SHIFT                0
#define PMU_AUXADC_ADC_OUT_CH0_H_ADDR                 PMU_AUXADC_ADC0_H
#define PMU_AUXADC_ADC_OUT_CH0_H_MASK                 0x7F
#define PMU_AUXADC_ADC_OUT_CH0_H_SHIFT                0
#define PMU_AUXADC_ADC_RDY_CH0_ADDR                   PMU_AUXADC_ADC0_H
#define PMU_AUXADC_ADC_RDY_CH0_MASK                   0x1
#define PMU_AUXADC_ADC_RDY_CH0_SHIFT                  7
#define PMU_AUXADC_ADC_OUT_CH1_L_ADDR                 PMU_AUXADC_ADC1
#define PMU_AUXADC_ADC_OUT_CH1_L_MASK                 0xFF
#define PMU_AUXADC_ADC_OUT_CH1_L_SHIFT                0
#define PMU_AUXADC_ADC_OUT_CH1_H_ADDR                 PMU_AUXADC_ADC1_H
#define PMU_AUXADC_ADC_OUT_CH1_H_MASK                 0x7F
#define PMU_AUXADC_ADC_OUT_CH1_H_SHIFT                0
#define PMU_AUXADC_ADC_RDY_CH1_ADDR                   PMU_AUXADC_ADC1_H
#define PMU_AUXADC_ADC_RDY_CH1_MASK                   0x1
#define PMU_AUXADC_ADC_RDY_CH1_SHIFT                  7
#define PMU_AUXADC_ADC_OUT_CH2_L_ADDR                 PMU_AUXADC_ADC2
#define PMU_AUXADC_ADC_OUT_CH2_L_MASK                 0xFF
#define PMU_AUXADC_ADC_OUT_CH2_L_SHIFT                0
#define PMU_AUXADC_ADC_OUT_CH2_H_ADDR                 PMU_AUXADC_ADC2_H
#define PMU_AUXADC_ADC_OUT_CH2_H_MASK                 0xF
#define PMU_AUXADC_ADC_OUT_CH2_H_SHIFT                0
#define PMU_AUXADC_ADC_RDY_CH2_ADDR                   PMU_AUXADC_ADC2_H
#define PMU_AUXADC_ADC_RDY_CH2_MASK                   0x1
#define PMU_AUXADC_ADC_RDY_CH2_SHIFT                  7
#define PMU_AUXADC_ADC_OUT_CH3_L_ADDR                 PMU_AUXADC_ADC3
#define PMU_AUXADC_ADC_OUT_CH3_L_MASK                 0xFF
#define PMU_AUXADC_ADC_OUT_CH3_L_SHIFT                0
#define PMU_AUXADC_ADC_OUT_CH3_H_ADDR                 PMU_AUXADC_ADC3_H
#define PMU_AUXADC_ADC_OUT_CH3_H_MASK                 0xF
#define PMU_AUXADC_ADC_OUT_CH3_H_SHIFT                0
#define PMU_AUXADC_ADC_RDY_CH3_ADDR                   PMU_AUXADC_ADC3_H
#define PMU_AUXADC_ADC_RDY_CH3_MASK                   0x1
#define PMU_AUXADC_ADC_RDY_CH3_SHIFT                  7
#define PMU_AUXADC_ADC_OUT_CH4_L_ADDR                 PMU_AUXADC_ADC4
#define PMU_AUXADC_ADC_OUT_CH4_L_MASK                 0xFF
#define PMU_AUXADC_ADC_OUT_CH4_L_SHIFT                0
#define PMU_AUXADC_ADC_OUT_CH4_H_ADDR                 PMU_AUXADC_ADC4_H
#define PMU_AUXADC_ADC_OUT_CH4_H_MASK                 0xF
#define PMU_AUXADC_ADC_OUT_CH4_H_SHIFT                0
#define PMU_AUXADC_ADC_RDY_CH4_ADDR                   PMU_AUXADC_ADC4_H
#define PMU_AUXADC_ADC_RDY_CH4_MASK                   0x1
#define PMU_AUXADC_ADC_RDY_CH4_SHIFT                  7
#define PMU_AUXADC_ADC_OUT_CH5_L_ADDR                 PMU_AUXADC_ADC5
#define PMU_AUXADC_ADC_OUT_CH5_L_MASK                 0xFF
#define PMU_AUXADC_ADC_OUT_CH5_L_SHIFT                0
#define PMU_AUXADC_ADC_OUT_CH5_H_ADDR                 PMU_AUXADC_ADC5_H
#define PMU_AUXADC_ADC_OUT_CH5_H_MASK                 0xF
#define PMU_AUXADC_ADC_OUT_CH5_H_SHIFT                0
#define PMU_AUXADC_ADC_RDY_CH5_ADDR                   PMU_AUXADC_ADC5_H
#define PMU_AUXADC_ADC_RDY_CH5_MASK                   0x1
#define PMU_AUXADC_ADC_RDY_CH5_SHIFT                  7
#define PMU_AUXADC_ADC_OUT_CH6_L_ADDR                 PMU_AUXADC_ADC6
#define PMU_AUXADC_ADC_OUT_CH6_L_MASK                 0xFF
#define PMU_AUXADC_ADC_OUT_CH6_L_SHIFT                0
#define PMU_AUXADC_ADC_OUT_CH6_H_ADDR                 PMU_AUXADC_ADC6_H
#define PMU_AUXADC_ADC_OUT_CH6_H_MASK                 0xF
#define PMU_AUXADC_ADC_OUT_CH6_H_SHIFT                0
#define PMU_AUXADC_ADC_RDY_CH6_ADDR                   PMU_AUXADC_ADC6_H
#define PMU_AUXADC_ADC_RDY_CH6_MASK                   0x1
#define PMU_AUXADC_ADC_RDY_CH6_SHIFT                  7
#define PMU_AUXADC_ADC_OUT_CH7_L_ADDR                 PMU_AUXADC_ADC7
#define PMU_AUXADC_ADC_OUT_CH7_L_MASK                 0xFF
#define PMU_AUXADC_ADC_OUT_CH7_L_SHIFT                0
#define PMU_AUXADC_ADC_OUT_CH7_H_ADDR                 PMU_AUXADC_ADC7_H
#define PMU_AUXADC_ADC_OUT_CH7_H_MASK                 0x7F
#define PMU_AUXADC_ADC_OUT_CH7_H_SHIFT                0
#define PMU_AUXADC_ADC_RDY_CH7_ADDR                   PMU_AUXADC_ADC7_H
#define PMU_AUXADC_ADC_RDY_CH7_MASK                   0x1
#define PMU_AUXADC_ADC_RDY_CH7_SHIFT                  7
#define PMU_AUXADC_ADC_OUT_CH8_L_ADDR                 PMU_AUXADC_ADC8
#define PMU_AUXADC_ADC_OUT_CH8_L_MASK                 0xFF
#define PMU_AUXADC_ADC_OUT_CH8_L_SHIFT                0
#define PMU_AUXADC_ADC_OUT_CH8_H_ADDR                 PMU_AUXADC_ADC8_H
#define PMU_AUXADC_ADC_OUT_CH8_H_MASK                 0xF
#define PMU_AUXADC_ADC_OUT_CH8_H_SHIFT                0
#define PMU_AUXADC_ADC_RDY_CH8_ADDR                   PMU_AUXADC_ADC8_H
#define PMU_AUXADC_ADC_RDY_CH8_MASK                   0x1
#define PMU_AUXADC_ADC_RDY_CH8_SHIFT                  7
#define PMU_AUXADC_ADC_OUT_CH9_L_ADDR                 PMU_AUXADC_ADC9
#define PMU_AUXADC_ADC_OUT_CH9_L_MASK                 0xFF
#define PMU_AUXADC_ADC_OUT_CH9_L_SHIFT                0
#define PMU_AUXADC_ADC_OUT_CH9_H_ADDR                 PMU_AUXADC_ADC9_H
#define PMU_AUXADC_ADC_OUT_CH9_H_MASK                 0xF
#define PMU_AUXADC_ADC_OUT_CH9_H_SHIFT                0
#define PMU_AUXADC_ADC_RDY_CH9_ADDR                   PMU_AUXADC_ADC9_H
#define PMU_AUXADC_ADC_RDY_CH9_MASK                   0x1
#define PMU_AUXADC_ADC_RDY_CH9_SHIFT                  7
#define PMU_AUXADC_ADC_OUT_CH10_L_ADDR                PMU_AUXADC_ADC10
#define PMU_AUXADC_ADC_OUT_CH10_L_MASK                0xFF
#define PMU_AUXADC_ADC_OUT_CH10_L_SHIFT               0
#define PMU_AUXADC_ADC_OUT_CH10_H_ADDR                PMU_AUXADC_ADC10_H
#define PMU_AUXADC_ADC_OUT_CH10_H_MASK                0xF
#define PMU_AUXADC_ADC_OUT_CH10_H_SHIFT               0
#define PMU_AUXADC_ADC_RDY_CH10_ADDR                  PMU_AUXADC_ADC10_H
#define PMU_AUXADC_ADC_RDY_CH10_MASK                  0x1
#define PMU_AUXADC_ADC_RDY_CH10_SHIFT                 7
#define PMU_AUXADC_ADC_OUT_CH11_L_ADDR                PMU_AUXADC_ADC11
#define PMU_AUXADC_ADC_OUT_CH11_L_MASK                0xFF
#define PMU_AUXADC_ADC_OUT_CH11_L_SHIFT               0
#define PMU_AUXADC_ADC_OUT_CH11_H_ADDR                PMU_AUXADC_ADC11_H
#define PMU_AUXADC_ADC_OUT_CH11_H_MASK                0xF
#define PMU_AUXADC_ADC_OUT_CH11_H_SHIFT               0
#define PMU_AUXADC_ADC_RDY_CH11_ADDR                  PMU_AUXADC_ADC11_H
#define PMU_AUXADC_ADC_RDY_CH11_MASK                  0x1
#define PMU_AUXADC_ADC_RDY_CH11_SHIFT                 7
#define PMU_AUXADC_ADC_OUT_CH12_15_L_ADDR             PMU_AUXADC_ADC12
#define PMU_AUXADC_ADC_OUT_CH12_15_L_MASK             0xFF
#define PMU_AUXADC_ADC_OUT_CH12_15_L_SHIFT            0
#define PMU_AUXADC_ADC_OUT_CH12_15_H_ADDR             PMU_AUXADC_ADC12_H
#define PMU_AUXADC_ADC_OUT_CH12_15_H_MASK             0xF
#define PMU_AUXADC_ADC_OUT_CH12_15_H_SHIFT            0
#define PMU_AUXADC_ADC_RDY_CH12_15_ADDR               PMU_AUXADC_ADC12_H
#define PMU_AUXADC_ADC_RDY_CH12_15_MASK               0x1
#define PMU_AUXADC_ADC_RDY_CH12_15_SHIFT              7
#define PMU_AUXADC_ADC_OUT_THR_HW_L_ADDR              PMU_AUXADC_ADC13
#define PMU_AUXADC_ADC_OUT_THR_HW_L_MASK              0xFF
#define PMU_AUXADC_ADC_OUT_THR_HW_L_SHIFT             0
#define PMU_AUXADC_ADC_OUT_THR_HW_H_ADDR              PMU_AUXADC_ADC13_H
#define PMU_AUXADC_ADC_OUT_THR_HW_H_MASK              0xF
#define PMU_AUXADC_ADC_OUT_THR_HW_H_SHIFT             0
#define PMU_AUXADC_ADC_RDY_THR_HW_ADDR                PMU_AUXADC_ADC13_H
#define PMU_AUXADC_ADC_RDY_THR_HW_MASK                0x1
#define PMU_AUXADC_ADC_RDY_THR_HW_SHIFT               7
#define PMU_AUXADC_ADC_OUT_LBAT_L_ADDR                PMU_AUXADC_ADC14
#define PMU_AUXADC_ADC_OUT_LBAT_L_MASK                0xFF
#define PMU_AUXADC_ADC_OUT_LBAT_L_SHIFT               0
#define PMU_AUXADC_ADC_OUT_LBAT_H_ADDR                PMU_AUXADC_ADC14_H
#define PMU_AUXADC_ADC_OUT_LBAT_H_MASK                0xF
#define PMU_AUXADC_ADC_OUT_LBAT_H_SHIFT               0
#define PMU_AUXADC_ADC_RDY_LBAT_ADDR                  PMU_AUXADC_ADC14_H
#define PMU_AUXADC_ADC_RDY_LBAT_MASK                  0x1
#define PMU_AUXADC_ADC_RDY_LBAT_SHIFT                 7
#define PMU_AUXADC_ADC_OUT_LBAT2_L_ADDR               PMU_AUXADC_ADC15
#define PMU_AUXADC_ADC_OUT_LBAT2_L_MASK               0xFF
#define PMU_AUXADC_ADC_OUT_LBAT2_L_SHIFT              0
#define PMU_AUXADC_ADC_OUT_LBAT2_H_ADDR               PMU_AUXADC_ADC15_H
#define PMU_AUXADC_ADC_OUT_LBAT2_H_MASK               0xF
#define PMU_AUXADC_ADC_OUT_LBAT2_H_SHIFT              0
#define PMU_AUXADC_ADC_RDY_LBAT2_ADDR                 PMU_AUXADC_ADC15_H
#define PMU_AUXADC_ADC_RDY_LBAT2_MASK                 0x1
#define PMU_AUXADC_ADC_RDY_LBAT2_SHIFT                7
#define PMU_AUXADC_ADC_OUT_CH7_BY_GPS_L_ADDR          PMU_AUXADC_ADC16
#define PMU_AUXADC_ADC_OUT_CH7_BY_GPS_L_MASK          0xFF
#define PMU_AUXADC_ADC_OUT_CH7_BY_GPS_L_SHIFT         0
#define PMU_AUXADC_ADC_OUT_CH7_BY_GPS_H_ADDR          PMU_AUXADC_ADC16_H
#define PMU_AUXADC_ADC_OUT_CH7_BY_GPS_H_MASK          0x7F
#define PMU_AUXADC_ADC_OUT_CH7_BY_GPS_H_SHIFT         0
#define PMU_AUXADC_ADC_RDY_CH7_BY_GPS_ADDR            PMU_AUXADC_ADC16_H
#define PMU_AUXADC_ADC_RDY_CH7_BY_GPS_MASK            0x1
#define PMU_AUXADC_ADC_RDY_CH7_BY_GPS_SHIFT           7
#define PMU_AUXADC_ADC_OUT_CH7_BY_MD_L_ADDR           PMU_AUXADC_ADC17
#define PMU_AUXADC_ADC_OUT_CH7_BY_MD_L_MASK           0xFF
#define PMU_AUXADC_ADC_OUT_CH7_BY_MD_L_SHIFT          0
#define PMU_AUXADC_ADC_OUT_CH7_BY_MD_H_ADDR           PMU_AUXADC_ADC17_H
#define PMU_AUXADC_ADC_OUT_CH7_BY_MD_H_MASK           0x7F
#define PMU_AUXADC_ADC_OUT_CH7_BY_MD_H_SHIFT          0
#define PMU_AUXADC_ADC_RDY_CH7_BY_MD_ADDR             PMU_AUXADC_ADC17_H
#define PMU_AUXADC_ADC_RDY_CH7_BY_MD_MASK             0x1
#define PMU_AUXADC_ADC_RDY_CH7_BY_MD_SHIFT            7
#define PMU_AUXADC_ADC_OUT_CH7_BY_AP_L_ADDR           PMU_AUXADC_ADC18
#define PMU_AUXADC_ADC_OUT_CH7_BY_AP_L_MASK           0xFF
#define PMU_AUXADC_ADC_OUT_CH7_BY_AP_L_SHIFT          0
#define PMU_AUXADC_ADC_OUT_CH7_BY_AP_H_ADDR           PMU_AUXADC_ADC18_H
#define PMU_AUXADC_ADC_OUT_CH7_BY_AP_H_MASK           0x7F
#define PMU_AUXADC_ADC_OUT_CH7_BY_AP_H_SHIFT          0
#define PMU_AUXADC_ADC_RDY_CH7_BY_AP_ADDR             PMU_AUXADC_ADC18_H
#define PMU_AUXADC_ADC_RDY_CH7_BY_AP_MASK             0x1
#define PMU_AUXADC_ADC_RDY_CH7_BY_AP_SHIFT            7
#define PMU_AUXADC_ADC_OUT_CH4_BY_MD_L_ADDR           PMU_AUXADC_ADC19
#define PMU_AUXADC_ADC_OUT_CH4_BY_MD_L_MASK           0xFF
#define PMU_AUXADC_ADC_OUT_CH4_BY_MD_L_SHIFT          0
#define PMU_AUXADC_ADC_OUT_CH4_BY_MD_H_ADDR           PMU_AUXADC_ADC19_H
#define PMU_AUXADC_ADC_OUT_CH4_BY_MD_H_MASK           0xF
#define PMU_AUXADC_ADC_OUT_CH4_BY_MD_H_SHIFT          0
#define PMU_AUXADC_ADC_RDY_CH4_BY_MD_ADDR             PMU_AUXADC_ADC19_H
#define PMU_AUXADC_ADC_RDY_CH4_BY_MD_MASK             0x1
#define PMU_AUXADC_ADC_RDY_CH4_BY_MD_SHIFT            7
#define PMU_AUXADC_ADC_OUT_WAKEUP_PCHR_L_ADDR         PMU_AUXADC_ADC20
#define PMU_AUXADC_ADC_OUT_WAKEUP_PCHR_L_MASK         0xFF
#define PMU_AUXADC_ADC_OUT_WAKEUP_PCHR_L_SHIFT        0
#define PMU_AUXADC_ADC_OUT_WAKEUP_PCHR_H_ADDR         PMU_AUXADC_ADC20_H
#define PMU_AUXADC_ADC_OUT_WAKEUP_PCHR_H_MASK         0x7F
#define PMU_AUXADC_ADC_OUT_WAKEUP_PCHR_H_SHIFT        0
#define PMU_AUXADC_ADC_RDY_WAKEUP_PCHR_ADDR           PMU_AUXADC_ADC20_H
#define PMU_AUXADC_ADC_RDY_WAKEUP_PCHR_MASK           0x1
#define PMU_AUXADC_ADC_RDY_WAKEUP_PCHR_SHIFT          7
#define PMU_AUXADC_ADC_OUT_WAKEUP_SWCHR_L_ADDR        PMU_AUXADC_ADC21
#define PMU_AUXADC_ADC_OUT_WAKEUP_SWCHR_L_MASK        0xFF
#define PMU_AUXADC_ADC_OUT_WAKEUP_SWCHR_L_SHIFT       0
#define PMU_AUXADC_ADC_OUT_WAKEUP_SWCHR_H_ADDR        PMU_AUXADC_ADC21_H
#define PMU_AUXADC_ADC_OUT_WAKEUP_SWCHR_H_MASK        0x7F
#define PMU_AUXADC_ADC_OUT_WAKEUP_SWCHR_H_SHIFT       0
#define PMU_AUXADC_ADC_RDY_WAKEUP_SWCHR_ADDR          PMU_AUXADC_ADC21_H
#define PMU_AUXADC_ADC_RDY_WAKEUP_SWCHR_MASK          0x1
#define PMU_AUXADC_ADC_RDY_WAKEUP_SWCHR_SHIFT         7
#define PMU_AUXADC_ADC_OUT_CH0_BY_MD_L_ADDR           PMU_AUXADC_ADC22
#define PMU_AUXADC_ADC_OUT_CH0_BY_MD_L_MASK           0xFF
#define PMU_AUXADC_ADC_OUT_CH0_BY_MD_L_SHIFT          0
#define PMU_AUXADC_ADC_OUT_CH0_BY_MD_H_ADDR           PMU_AUXADC_ADC22_H
#define PMU_AUXADC_ADC_OUT_CH0_BY_MD_H_MASK           0x7F
#define PMU_AUXADC_ADC_OUT_CH0_BY_MD_H_SHIFT          0
#define PMU_AUXADC_ADC_RDY_CH0_BY_MD_ADDR             PMU_AUXADC_ADC22_H
#define PMU_AUXADC_ADC_RDY_CH0_BY_MD_MASK             0x1
#define PMU_AUXADC_ADC_RDY_CH0_BY_MD_SHIFT            7
#define PMU_AUXADC_ADC_OUT_CH0_BY_AP_L_ADDR           PMU_AUXADC_ADC23
#define PMU_AUXADC_ADC_OUT_CH0_BY_AP_L_MASK           0xFF
#define PMU_AUXADC_ADC_OUT_CH0_BY_AP_L_SHIFT          0
#define PMU_AUXADC_ADC_OUT_CH0_BY_AP_H_ADDR           PMU_AUXADC_ADC23_H
#define PMU_AUXADC_ADC_OUT_CH0_BY_AP_H_MASK           0x7F
#define PMU_AUXADC_ADC_OUT_CH0_BY_AP_H_SHIFT          0
#define PMU_AUXADC_ADC_RDY_CH0_BY_AP_ADDR             PMU_AUXADC_ADC23_H
#define PMU_AUXADC_ADC_RDY_CH0_BY_AP_MASK             0x1
#define PMU_AUXADC_ADC_RDY_CH0_BY_AP_SHIFT            7
#define PMU_AUXADC_ADC_OUT_CH1_BY_MD_L_ADDR           PMU_AUXADC_ADC24
#define PMU_AUXADC_ADC_OUT_CH1_BY_MD_L_MASK           0xFF
#define PMU_AUXADC_ADC_OUT_CH1_BY_MD_L_SHIFT          0
#define PMU_AUXADC_ADC_OUT_CH1_BY_MD_H_ADDR           PMU_AUXADC_ADC24_H
#define PMU_AUXADC_ADC_OUT_CH1_BY_MD_H_MASK           0x7F
#define PMU_AUXADC_ADC_OUT_CH1_BY_MD_H_SHIFT          0
#define PMU_AUXADC_ADC_RDY_CH1_BY_MD_ADDR             PMU_AUXADC_ADC24_H
#define PMU_AUXADC_ADC_RDY_CH1_BY_MD_MASK             0x1
#define PMU_AUXADC_ADC_RDY_CH1_BY_MD_SHIFT            7
#define PMU_AUXADC_ADC_OUT_CH1_BY_AP_L_ADDR           PMU_AUXADC_ADC25
#define PMU_AUXADC_ADC_OUT_CH1_BY_AP_L_MASK           0xFF
#define PMU_AUXADC_ADC_OUT_CH1_BY_AP_L_SHIFT          0
#define PMU_AUXADC_ADC_OUT_CH1_BY_AP_H_ADDR           PMU_AUXADC_ADC25_H
#define PMU_AUXADC_ADC_OUT_CH1_BY_AP_H_MASK           0x7F
#define PMU_AUXADC_ADC_OUT_CH1_BY_AP_H_SHIFT          0
#define PMU_AUXADC_ADC_RDY_CH1_BY_AP_ADDR             PMU_AUXADC_ADC25_H
#define PMU_AUXADC_ADC_RDY_CH1_BY_AP_MASK             0x1
#define PMU_AUXADC_ADC_RDY_CH1_BY_AP_SHIFT            7
#define PMU_AUXADC_ADC_OUT_VISMPS0_L_ADDR             PMU_AUXADC_ADC26
#define PMU_AUXADC_ADC_OUT_VISMPS0_L_MASK             0xFF
#define PMU_AUXADC_ADC_OUT_VISMPS0_L_SHIFT            0
#define PMU_AUXADC_ADC_OUT_VISMPS0_H_ADDR             PMU_AUXADC_ADC26_H
#define PMU_AUXADC_ADC_OUT_VISMPS0_H_MASK             0xF
#define PMU_AUXADC_ADC_OUT_VISMPS0_H_SHIFT            0
#define PMU_AUXADC_ADC_RDY_VISMPS0_ADDR               PMU_AUXADC_ADC26_H
#define PMU_AUXADC_ADC_RDY_VISMPS0_MASK               0x1
#define PMU_AUXADC_ADC_RDY_VISMPS0_SHIFT              7
#define PMU_AUXADC_ADC_OUT_FGADC1_L_ADDR              PMU_AUXADC_ADC27
#define PMU_AUXADC_ADC_OUT_FGADC1_L_MASK              0xFF
#define PMU_AUXADC_ADC_OUT_FGADC1_L_SHIFT             0
#define PMU_AUXADC_ADC_OUT_FGADC1_H_ADDR              PMU_AUXADC_ADC27_H
#define PMU_AUXADC_ADC_OUT_FGADC1_H_MASK              0x7F
#define PMU_AUXADC_ADC_OUT_FGADC1_H_SHIFT             0
#define PMU_AUXADC_ADC_RDY_FGADC1_ADDR                PMU_AUXADC_ADC27_H
#define PMU_AUXADC_ADC_RDY_FGADC1_MASK                0x1
#define PMU_AUXADC_ADC_RDY_FGADC1_SHIFT               7
#define PMU_AUXADC_ADC_OUT_FGADC2_L_ADDR              PMU_AUXADC_ADC28
#define PMU_AUXADC_ADC_OUT_FGADC2_L_MASK              0xFF
#define PMU_AUXADC_ADC_OUT_FGADC2_L_SHIFT             0
#define PMU_AUXADC_ADC_OUT_FGADC2_H_ADDR              PMU_AUXADC_ADC28_H
#define PMU_AUXADC_ADC_OUT_FGADC2_H_MASK              0x7F
#define PMU_AUXADC_ADC_OUT_FGADC2_H_SHIFT             0
#define PMU_AUXADC_ADC_RDY_FGADC2_ADDR                PMU_AUXADC_ADC28_H
#define PMU_AUXADC_ADC_RDY_FGADC2_MASK                0x1
#define PMU_AUXADC_ADC_RDY_FGADC2_SHIFT               7
#define PMU_AUXADC_ADC_OUT_IMP_L_ADDR                 PMU_AUXADC_ADC29
#define PMU_AUXADC_ADC_OUT_IMP_L_MASK                 0xFF
#define PMU_AUXADC_ADC_OUT_IMP_L_SHIFT                0
#define PMU_AUXADC_ADC_OUT_IMP_H_ADDR                 PMU_AUXADC_ADC29_H
#define PMU_AUXADC_ADC_OUT_IMP_H_MASK                 0x7F
#define PMU_AUXADC_ADC_OUT_IMP_H_SHIFT                0
#define PMU_AUXADC_ADC_RDY_IMP_ADDR                   PMU_AUXADC_ADC29_H
#define PMU_AUXADC_ADC_RDY_IMP_MASK                   0x1
#define PMU_AUXADC_ADC_RDY_IMP_SHIFT                  7
#define PMU_AUXADC_ADC_OUT_IMP_AVG_L_ADDR             PMU_AUXADC_ADC30
#define PMU_AUXADC_ADC_OUT_IMP_AVG_L_MASK             0xFF
#define PMU_AUXADC_ADC_OUT_IMP_AVG_L_SHIFT            0
#define PMU_AUXADC_ADC_OUT_IMP_AVG_H_ADDR             PMU_AUXADC_ADC30_H
#define PMU_AUXADC_ADC_OUT_IMP_AVG_H_MASK             0x7F
#define PMU_AUXADC_ADC_OUT_IMP_AVG_H_SHIFT            0
#define PMU_AUXADC_ADC_RDY_IMP_AVG_ADDR               PMU_AUXADC_ADC30_H
#define PMU_AUXADC_ADC_RDY_IMP_AVG_MASK               0x1
#define PMU_AUXADC_ADC_RDY_IMP_AVG_SHIFT              7
#define PMU_AUXADC_ADC_OUT_RAW_L_ADDR                 PMU_AUXADC_ADC31
#define PMU_AUXADC_ADC_OUT_RAW_L_MASK                 0xFF
#define PMU_AUXADC_ADC_OUT_RAW_L_SHIFT                0
#define PMU_AUXADC_ADC_OUT_RAW_H_ADDR                 PMU_AUXADC_ADC31_H
#define PMU_AUXADC_ADC_OUT_RAW_H_MASK                 0x7F
#define PMU_AUXADC_ADC_OUT_RAW_H_SHIFT                0
#define PMU_AUXADC_ADC_OUT_MDRT_L_ADDR                PMU_AUXADC_ADC32
#define PMU_AUXADC_ADC_OUT_MDRT_L_MASK                0xFF
#define PMU_AUXADC_ADC_OUT_MDRT_L_SHIFT               0
#define PMU_AUXADC_ADC_OUT_MDRT_H_ADDR                PMU_AUXADC_ADC32_H
#define PMU_AUXADC_ADC_OUT_MDRT_H_MASK                0x7F
#define PMU_AUXADC_ADC_OUT_MDRT_H_SHIFT               0
#define PMU_AUXADC_ADC_RDY_MDRT_ADDR                  PMU_AUXADC_ADC32_H
#define PMU_AUXADC_ADC_RDY_MDRT_MASK                  0x1
#define PMU_AUXADC_ADC_RDY_MDRT_SHIFT                 7
#define PMU_AUXADC_ADC_OUT_JEITA_L_ADDR               PMU_AUXADC_ADC33
#define PMU_AUXADC_ADC_OUT_JEITA_L_MASK               0xFF
#define PMU_AUXADC_ADC_OUT_JEITA_L_SHIFT              0
#define PMU_AUXADC_ADC_OUT_JEITA_H_ADDR               PMU_AUXADC_ADC33_H
#define PMU_AUXADC_ADC_OUT_JEITA_H_MASK               0xF
#define PMU_AUXADC_ADC_OUT_JEITA_H_SHIFT              0
#define PMU_AUXADC_ADC_RDY_JEITA_ADDR                 PMU_AUXADC_ADC33_H
#define PMU_AUXADC_ADC_RDY_JEITA_MASK                 0x1
#define PMU_AUXADC_ADC_RDY_JEITA_SHIFT                7
#define PMU_AUXADC_ADC_OUT_DCXO_BY_GPS_L_ADDR         PMU_AUXADC_ADC34
#define PMU_AUXADC_ADC_OUT_DCXO_BY_GPS_L_MASK         0xFF
#define PMU_AUXADC_ADC_OUT_DCXO_BY_GPS_L_SHIFT        0
#define PMU_AUXADC_ADC_OUT_DCXO_BY_GPS_H_ADDR         PMU_AUXADC_ADC34_H
#define PMU_AUXADC_ADC_OUT_DCXO_BY_GPS_H_MASK         0xF
#define PMU_AUXADC_ADC_OUT_DCXO_BY_GPS_H_SHIFT        0
#define PMU_AUXADC_ADC_RDY_DCXO_BY_GPS_ADDR           PMU_AUXADC_ADC34_H
#define PMU_AUXADC_ADC_RDY_DCXO_BY_GPS_MASK           0x1
#define PMU_AUXADC_ADC_RDY_DCXO_BY_GPS_SHIFT          7
#define PMU_AUXADC_ADC_OUT_DCXO_BY_MD_L_ADDR          PMU_AUXADC_ADC35
#define PMU_AUXADC_ADC_OUT_DCXO_BY_MD_L_MASK          0xFF
#define PMU_AUXADC_ADC_OUT_DCXO_BY_MD_L_SHIFT         0
#define PMU_AUXADC_ADC_OUT_DCXO_BY_MD_H_ADDR          PMU_AUXADC_ADC35_H
#define PMU_AUXADC_ADC_OUT_DCXO_BY_MD_H_MASK          0xF
#define PMU_AUXADC_ADC_OUT_DCXO_BY_MD_H_SHIFT         0
#define PMU_AUXADC_ADC_RDY_DCXO_BY_MD_ADDR            PMU_AUXADC_ADC35_H
#define PMU_AUXADC_ADC_RDY_DCXO_BY_MD_MASK            0x1
#define PMU_AUXADC_ADC_RDY_DCXO_BY_MD_SHIFT           7
#define PMU_AUXADC_ADC_OUT_DCXO_BY_AP_L_ADDR          PMU_AUXADC_ADC36
#define PMU_AUXADC_ADC_OUT_DCXO_BY_AP_L_MASK          0xFF
#define PMU_AUXADC_ADC_OUT_DCXO_BY_AP_L_SHIFT         0
#define PMU_AUXADC_ADC_OUT_DCXO_BY_AP_H_ADDR          PMU_AUXADC_ADC36_H
#define PMU_AUXADC_ADC_OUT_DCXO_BY_AP_H_MASK          0xF
#define PMU_AUXADC_ADC_OUT_DCXO_BY_AP_H_SHIFT         0
#define PMU_AUXADC_ADC_RDY_DCXO_BY_AP_ADDR            PMU_AUXADC_ADC36_H
#define PMU_AUXADC_ADC_RDY_DCXO_BY_AP_MASK            0x1
#define PMU_AUXADC_ADC_RDY_DCXO_BY_AP_SHIFT           7
#define PMU_AUXADC_ADC_OUT_DCXO_MDRT_L_ADDR           PMU_AUXADC_ADC37
#define PMU_AUXADC_ADC_OUT_DCXO_MDRT_L_MASK           0xFF
#define PMU_AUXADC_ADC_OUT_DCXO_MDRT_L_SHIFT          0
#define PMU_AUXADC_ADC_OUT_DCXO_MDRT_H_ADDR           PMU_AUXADC_ADC37_H
#define PMU_AUXADC_ADC_OUT_DCXO_MDRT_H_MASK           0xF
#define PMU_AUXADC_ADC_OUT_DCXO_MDRT_H_SHIFT          0
#define PMU_AUXADC_ADC_RDY_DCXO_MDRT_ADDR             PMU_AUXADC_ADC37_H
#define PMU_AUXADC_ADC_RDY_DCXO_MDRT_MASK             0x1
#define PMU_AUXADC_ADC_RDY_DCXO_MDRT_SHIFT            7
#define PMU_AUXADC_ADC_OUT_NAG_L_ADDR                 PMU_AUXADC_ADC38
#define PMU_AUXADC_ADC_OUT_NAG_L_MASK                 0xFF
#define PMU_AUXADC_ADC_OUT_NAG_L_SHIFT                0
#define PMU_AUXADC_ADC_OUT_NAG_H_ADDR                 PMU_AUXADC_ADC38_H
#define PMU_AUXADC_ADC_OUT_NAG_H_MASK                 0x7F
#define PMU_AUXADC_ADC_OUT_NAG_H_SHIFT                0
#define PMU_AUXADC_ADC_RDY_NAG_ADDR                   PMU_AUXADC_ADC38_H
#define PMU_AUXADC_ADC_RDY_NAG_MASK                   0x1
#define PMU_AUXADC_ADC_RDY_NAG_SHIFT                  7
#define PMU_AUXADC_ADC_BUSY_IN_L_ADDR                 PMU_AUXADC_STA0
#define PMU_AUXADC_ADC_BUSY_IN_L_MASK                 0xFF
#define PMU_AUXADC_ADC_BUSY_IN_L_SHIFT                0
#define PMU_AUXADC_ADC_BUSY_IN_H_ADDR                 PMU_AUXADC_STA0_H
#define PMU_AUXADC_ADC_BUSY_IN_H_MASK                 0xF
#define PMU_AUXADC_ADC_BUSY_IN_H_SHIFT                0
#define PMU_AUXADC_ADC_BUSY_IN_LBAT_ADDR              PMU_AUXADC_STA0_H
#define PMU_AUXADC_ADC_BUSY_IN_LBAT_MASK              0x1
#define PMU_AUXADC_ADC_BUSY_IN_LBAT_SHIFT             4
#define PMU_AUXADC_ADC_BUSY_IN_LBAT2_ADDR             PMU_AUXADC_STA0_H
#define PMU_AUXADC_ADC_BUSY_IN_LBAT2_MASK             0x1
#define PMU_AUXADC_ADC_BUSY_IN_LBAT2_SHIFT            5
#define PMU_AUXADC_ADC_BUSY_IN_VISMPS0_ADDR           PMU_AUXADC_STA0_H
#define PMU_AUXADC_ADC_BUSY_IN_VISMPS0_MASK           0x1
#define PMU_AUXADC_ADC_BUSY_IN_VISMPS0_SHIFT          6
#define PMU_AUXADC_ADC_BUSY_IN_WAKEUP_ADDR            PMU_AUXADC_STA0_H
#define PMU_AUXADC_ADC_BUSY_IN_WAKEUP_MASK            0x1
#define PMU_AUXADC_ADC_BUSY_IN_WAKEUP_SHIFT           7
#define PMU_AUXADC_ADC_BUSY_IN_DCXO_MDRT_ADDR         PMU_AUXADC_STA1
#define PMU_AUXADC_ADC_BUSY_IN_DCXO_MDRT_MASK         0x1
#define PMU_AUXADC_ADC_BUSY_IN_DCXO_MDRT_SHIFT        0
#define PMU_AUXADC_ADC_BUSY_IN_DCXO_GPS_AP_ADDR       PMU_AUXADC_STA1
#define PMU_AUXADC_ADC_BUSY_IN_DCXO_GPS_AP_MASK       0x1
#define PMU_AUXADC_ADC_BUSY_IN_DCXO_GPS_AP_SHIFT      1
#define PMU_AUXADC_ADC_BUSY_IN_DCXO_GPS_MD_ADDR       PMU_AUXADC_STA1
#define PMU_AUXADC_ADC_BUSY_IN_DCXO_GPS_MD_MASK       0x1
#define PMU_AUXADC_ADC_BUSY_IN_DCXO_GPS_MD_SHIFT      2
#define PMU_AUXADC_ADC_BUSY_IN_DCXO_GPS_ADDR          PMU_AUXADC_STA1
#define PMU_AUXADC_ADC_BUSY_IN_DCXO_GPS_MASK          0x1
#define PMU_AUXADC_ADC_BUSY_IN_DCXO_GPS_SHIFT         3
#define PMU_AUXADC_ADC_BUSY_IN_NAG_ADDR               PMU_AUXADC_STA1
#define PMU_AUXADC_ADC_BUSY_IN_NAG_MASK               0x1
#define PMU_AUXADC_ADC_BUSY_IN_NAG_SHIFT              4
#define PMU_AUXADC_ADC_BUSY_IN_JEITA_ADDR             PMU_AUXADC_STA1
#define PMU_AUXADC_ADC_BUSY_IN_JEITA_MASK             0x1
#define PMU_AUXADC_ADC_BUSY_IN_JEITA_SHIFT            5
#define PMU_AUXADC_ADC_BUSY_IN_MDRT_ADDR              PMU_AUXADC_STA1
#define PMU_AUXADC_ADC_BUSY_IN_MDRT_MASK              0x1
#define PMU_AUXADC_ADC_BUSY_IN_MDRT_SHIFT             6
#define PMU_AUXADC_ADC_BUSY_IN_SHARE_ADDR             PMU_AUXADC_STA1
#define PMU_AUXADC_ADC_BUSY_IN_SHARE_MASK             0x1
#define PMU_AUXADC_ADC_BUSY_IN_SHARE_SHIFT            7
#define PMU_AUXADC_ADC_BUSY_IN_IMP_ADDR               PMU_AUXADC_STA1_H
#define PMU_AUXADC_ADC_BUSY_IN_IMP_MASK               0x1
#define PMU_AUXADC_ADC_BUSY_IN_IMP_SHIFT              0
#define PMU_AUXADC_ADC_BUSY_IN_FGADC1_ADDR            PMU_AUXADC_STA1_H
#define PMU_AUXADC_ADC_BUSY_IN_FGADC1_MASK            0x1
#define PMU_AUXADC_ADC_BUSY_IN_FGADC1_SHIFT           1
#define PMU_AUXADC_ADC_BUSY_IN_FGADC2_ADDR            PMU_AUXADC_STA1_H
#define PMU_AUXADC_ADC_BUSY_IN_FGADC2_MASK            0x1
#define PMU_AUXADC_ADC_BUSY_IN_FGADC2_SHIFT           2
#define PMU_AUXADC_ADC_BUSY_IN_GPS_AP_ADDR            PMU_AUXADC_STA1_H
#define PMU_AUXADC_ADC_BUSY_IN_GPS_AP_MASK            0x1
#define PMU_AUXADC_ADC_BUSY_IN_GPS_AP_SHIFT           3
#define PMU_AUXADC_ADC_BUSY_IN_GPS_MD_ADDR            PMU_AUXADC_STA1_H
#define PMU_AUXADC_ADC_BUSY_IN_GPS_MD_MASK            0x1
#define PMU_AUXADC_ADC_BUSY_IN_GPS_MD_SHIFT           4
#define PMU_AUXADC_ADC_BUSY_IN_GPS_ADDR               PMU_AUXADC_STA1_H
#define PMU_AUXADC_ADC_BUSY_IN_GPS_MASK               0x1
#define PMU_AUXADC_ADC_BUSY_IN_GPS_SHIFT              5
#define PMU_AUXADC_ADC_BUSY_IN_THR_HW_ADDR            PMU_AUXADC_STA1_H
#define PMU_AUXADC_ADC_BUSY_IN_THR_HW_MASK            0x1
#define PMU_AUXADC_ADC_BUSY_IN_THR_HW_SHIFT           6
#define PMU_AUXADC_ADC_BUSY_IN_THR_MD_ADDR            PMU_AUXADC_STA1_H
#define PMU_AUXADC_ADC_BUSY_IN_THR_MD_MASK            0x1
#define PMU_AUXADC_ADC_BUSY_IN_THR_MD_SHIFT           7
#define PMU_AUXADC_RQST_CH0_ADDR                      PMU_AUXADC_RQST0
#define PMU_AUXADC_RQST_CH0_MASK                      0x1
#define PMU_AUXADC_RQST_CH0_SHIFT                     0
#define PMU_AUXADC_RQST_CH1_ADDR                      PMU_AUXADC_RQST0
#define PMU_AUXADC_RQST_CH1_MASK                      0x1
#define PMU_AUXADC_RQST_CH1_SHIFT                     1
#define PMU_AUXADC_RQST_CH2_ADDR                      PMU_AUXADC_RQST0
#define PMU_AUXADC_RQST_CH2_MASK                      0x1
#define PMU_AUXADC_RQST_CH2_SHIFT                     2
#define PMU_AUXADC_RQST_CH3_ADDR                      PMU_AUXADC_RQST0
#define PMU_AUXADC_RQST_CH3_MASK                      0x1
#define PMU_AUXADC_RQST_CH3_SHIFT                     3
#define PMU_AUXADC_RQST_CH4_ADDR                      PMU_AUXADC_RQST0
#define PMU_AUXADC_RQST_CH4_MASK                      0x1
#define PMU_AUXADC_RQST_CH4_SHIFT                     4
#define PMU_AUXADC_RQST_CH5_ADDR                      PMU_AUXADC_RQST0
#define PMU_AUXADC_RQST_CH5_MASK                      0x1
#define PMU_AUXADC_RQST_CH5_SHIFT                     5
#define PMU_AUXADC_RQST_CH6_ADDR                      PMU_AUXADC_RQST0
#define PMU_AUXADC_RQST_CH6_MASK                      0x1
#define PMU_AUXADC_RQST_CH6_SHIFT                     6
#define PMU_AUXADC_RQST_CH7_ADDR                      PMU_AUXADC_RQST0
#define PMU_AUXADC_RQST_CH7_MASK                      0x1
#define PMU_AUXADC_RQST_CH7_SHIFT                     7
#define PMU_AUXADC_RQST_CH8_ADDR                      PMU_AUXADC_RQST0_H
#define PMU_AUXADC_RQST_CH8_MASK                      0x1
#define PMU_AUXADC_RQST_CH8_SHIFT                     0
#define PMU_AUXADC_RQST_CH9_ADDR                      PMU_AUXADC_RQST0_H
#define PMU_AUXADC_RQST_CH9_MASK                      0x1
#define PMU_AUXADC_RQST_CH9_SHIFT                     1
#define PMU_AUXADC_RQST_CH10_ADDR                     PMU_AUXADC_RQST0_H
#define PMU_AUXADC_RQST_CH10_MASK                     0x1
#define PMU_AUXADC_RQST_CH10_SHIFT                    2
#define PMU_AUXADC_RQST_CH11_ADDR                     PMU_AUXADC_RQST0_H
#define PMU_AUXADC_RQST_CH11_MASK                     0x1
#define PMU_AUXADC_RQST_CH11_SHIFT                    3
#define PMU_AUXADC_RQST_CH12_ADDR                     PMU_AUXADC_RQST0_H
#define PMU_AUXADC_RQST_CH12_MASK                     0x1
#define PMU_AUXADC_RQST_CH12_SHIFT                    4
#define PMU_AUXADC_RQST_CH13_ADDR                     PMU_AUXADC_RQST0_H
#define PMU_AUXADC_RQST_CH13_MASK                     0x1
#define PMU_AUXADC_RQST_CH13_SHIFT                    5
#define PMU_AUXADC_RQST_CH14_ADDR                     PMU_AUXADC_RQST0_H
#define PMU_AUXADC_RQST_CH14_MASK                     0x1
#define PMU_AUXADC_RQST_CH14_SHIFT                    6
#define PMU_AUXADC_RQST_CH15_ADDR                     PMU_AUXADC_RQST0_H
#define PMU_AUXADC_RQST_CH15_MASK                     0x1
#define PMU_AUXADC_RQST_CH15_SHIFT                    7
#define PMU_AUXADC_RQST_CH0_BY_MD_ADDR                PMU_AUXADC_RQST1
#define PMU_AUXADC_RQST_CH0_BY_MD_MASK                0x1
#define PMU_AUXADC_RQST_CH0_BY_MD_SHIFT               0
#define PMU_AUXADC_RQST_CH1_BY_MD_ADDR                PMU_AUXADC_RQST1
#define PMU_AUXADC_RQST_CH1_BY_MD_MASK                0x1
#define PMU_AUXADC_RQST_CH1_BY_MD_SHIFT               1
#define PMU_AUXADC_RQST_RSV0_ADDR                     PMU_AUXADC_RQST1
#define PMU_AUXADC_RQST_RSV0_MASK                     0x3
#define PMU_AUXADC_RQST_RSV0_SHIFT                    2
#define PMU_AUXADC_RQST_CH4_BY_MD_ADDR                PMU_AUXADC_RQST1
#define PMU_AUXADC_RQST_CH4_BY_MD_MASK                0x1
#define PMU_AUXADC_RQST_CH4_BY_MD_SHIFT               4
#define PMU_AUXADC_RQST_RSV2_ADDR                     PMU_AUXADC_RQST1
#define PMU_AUXADC_RQST_RSV2_MASK                     0x3
#define PMU_AUXADC_RQST_RSV2_SHIFT                    5
#define PMU_AUXADC_RQST_CH7_BY_MD_ADDR                PMU_AUXADC_RQST1
#define PMU_AUXADC_RQST_CH7_BY_MD_MASK                0x1
#define PMU_AUXADC_RQST_CH7_BY_MD_SHIFT               7
#define PMU_AUXADC_RQST_CH7_BY_GPS_ADDR               PMU_AUXADC_RQST1_H
#define PMU_AUXADC_RQST_CH7_BY_GPS_MASK               0x1
#define PMU_AUXADC_RQST_CH7_BY_GPS_SHIFT              0
#define PMU_AUXADC_RQST_DCXO_BY_MD_ADDR               PMU_AUXADC_RQST1_H
#define PMU_AUXADC_RQST_DCXO_BY_MD_MASK               0x1
#define PMU_AUXADC_RQST_DCXO_BY_MD_SHIFT              1
#define PMU_AUXADC_RQST_DCXO_BY_GPS_ADDR              PMU_AUXADC_RQST1_H
#define PMU_AUXADC_RQST_DCXO_BY_GPS_MASK              0x1
#define PMU_AUXADC_RQST_DCXO_BY_GPS_SHIFT             2
#define PMU_AUXADC_RQST_RSV1_ADDR                     PMU_AUXADC_RQST1_H
#define PMU_AUXADC_RQST_RSV1_MASK                     0x1F
#define PMU_AUXADC_RQST_RSV1_SHIFT                    3
#define PMU_AUXADC_CK_ON_EXTD_ADDR                    PMU_AUXADC_CON0
#define PMU_AUXADC_CK_ON_EXTD_MASK                    0x3F
#define PMU_AUXADC_CK_ON_EXTD_SHIFT                   0
#define PMU_AUXADC_SRCLKEN_SRC_SEL_ADDR               PMU_AUXADC_CON0
#define PMU_AUXADC_SRCLKEN_SRC_SEL_MASK               0x3
#define PMU_AUXADC_SRCLKEN_SRC_SEL_SHIFT              6
#define PMU_AUXADC_ADC_PWDB_ADDR                      PMU_AUXADC_CON0_H
#define PMU_AUXADC_ADC_PWDB_MASK                      0x1
#define PMU_AUXADC_ADC_PWDB_SHIFT                     0
#define PMU_AUXADC_ADC_PWDB_SWCTRL_ADDR               PMU_AUXADC_CON0_H
#define PMU_AUXADC_ADC_PWDB_SWCTRL_MASK               0x1
#define PMU_AUXADC_ADC_PWDB_SWCTRL_SHIFT              1
#define PMU_AUXADC_STRUP_CK_ON_ENB_ADDR               PMU_AUXADC_CON0_H
#define PMU_AUXADC_STRUP_CK_ON_ENB_MASK               0x1
#define PMU_AUXADC_STRUP_CK_ON_ENB_SHIFT              2
#define PMU_AUXADC_ADC_RDY_WAKEUP_CLR_ADDR            PMU_AUXADC_CON0_H
#define PMU_AUXADC_ADC_RDY_WAKEUP_CLR_MASK            0x1
#define PMU_AUXADC_ADC_RDY_WAKEUP_CLR_SHIFT           3
#define PMU_AUXADC_SRCLKEN_CK_EN_ADDR                 PMU_AUXADC_CON0_H
#define PMU_AUXADC_SRCLKEN_CK_EN_MASK                 0x1
#define PMU_AUXADC_SRCLKEN_CK_EN_SHIFT                4
#define PMU_AUXADC_CK_AON_GPS_ADDR                    PMU_AUXADC_CON0_H
#define PMU_AUXADC_CK_AON_GPS_MASK                    0x1
#define PMU_AUXADC_CK_AON_GPS_SHIFT                   5
#define PMU_AUXADC_CK_AON_MD_ADDR                     PMU_AUXADC_CON0_H
#define PMU_AUXADC_CK_AON_MD_MASK                     0x1
#define PMU_AUXADC_CK_AON_MD_SHIFT                    6
#define PMU_AUXADC_CK_AON_ADDR                        PMU_AUXADC_CON0_H
#define PMU_AUXADC_CK_AON_MASK                        0x1
#define PMU_AUXADC_CK_AON_SHIFT                       7
#define PMU_AUXADC_AVG_NUM_SMALL_ADDR                 PMU_AUXADC_CON1
#define PMU_AUXADC_AVG_NUM_SMALL_MASK                 0x7
#define PMU_AUXADC_AVG_NUM_SMALL_SHIFT                0
#define PMU_AUXADC_AVG_NUM_LARGE_ADDR                 PMU_AUXADC_CON1
#define PMU_AUXADC_AVG_NUM_LARGE_MASK                 0x7
#define PMU_AUXADC_AVG_NUM_LARGE_SHIFT                3
#define PMU_AUXADC_SPL_NUM_LSB_ADDR                   PMU_AUXADC_CON1
#define PMU_AUXADC_SPL_NUM_LSB_MASK                   0x3
#define PMU_AUXADC_SPL_NUM_LSB_SHIFT                  6
#define PMU_AUXADC_SPL_NUM_MSB_ADDR                   PMU_AUXADC_CON1_H
#define PMU_AUXADC_SPL_NUM_MSB_MASK                   0xFF
#define PMU_AUXADC_SPL_NUM_MSB_SHIFT                  0
#define PMU_AUXADC_AVG_NUM_SEL_LSB_ADDR               PMU_AUXADC_CON2
#define PMU_AUXADC_AVG_NUM_SEL_LSB_MASK               0xFF
#define PMU_AUXADC_AVG_NUM_SEL_LSB_SHIFT              0
#define PMU_AUXADC_AVG_NUM_SEL_MSB_ADDR               PMU_AUXADC_CON2_H
#define PMU_AUXADC_AVG_NUM_SEL_MSB_MASK               0xF
#define PMU_AUXADC_AVG_NUM_SEL_MSB_SHIFT              0
#define PMU_AUXADC_AVG_NUM_SEL_SHARE_ADDR             PMU_AUXADC_CON2_H
#define PMU_AUXADC_AVG_NUM_SEL_SHARE_MASK             0x1
#define PMU_AUXADC_AVG_NUM_SEL_SHARE_SHIFT            4
#define PMU_AUXADC_AVG_NUM_SEL_LBAT_ADDR              PMU_AUXADC_CON2_H
#define PMU_AUXADC_AVG_NUM_SEL_LBAT_MASK              0x1
#define PMU_AUXADC_AVG_NUM_SEL_LBAT_SHIFT             5
#define PMU_AUXADC_AVG_NUM_SEL_VISMPS_ADDR            PMU_AUXADC_CON2_H
#define PMU_AUXADC_AVG_NUM_SEL_VISMPS_MASK            0x1
#define PMU_AUXADC_AVG_NUM_SEL_VISMPS_SHIFT           6
#define PMU_AUXADC_AVG_NUM_SEL_WAKEUP_ADDR            PMU_AUXADC_CON2_H
#define PMU_AUXADC_AVG_NUM_SEL_WAKEUP_MASK            0x1
#define PMU_AUXADC_AVG_NUM_SEL_WAKEUP_SHIFT           7
#define PMU_AUXADC_SPL_NUM_LARGE_LSB_ADDR             PMU_AUXADC_CON3
#define PMU_AUXADC_SPL_NUM_LARGE_LSB_MASK             0xFF
#define PMU_AUXADC_SPL_NUM_LARGE_LSB_SHIFT            0
#define PMU_AUXADC_SPL_NUM_LARGE_MSB_ADDR             PMU_AUXADC_CON3_H
#define PMU_AUXADC_SPL_NUM_LARGE_MSB_MASK             0x3
#define PMU_AUXADC_SPL_NUM_LARGE_MSB_SHIFT            0
#define PMU_AUXADC_SPL_NUM_SLEEP_LSB_ADDR             PMU_AUXADC_CON4
#define PMU_AUXADC_SPL_NUM_SLEEP_LSB_MASK             0xFF
#define PMU_AUXADC_SPL_NUM_SLEEP_LSB_SHIFT            0
#define PMU_AUXADC_SPL_NUM_SLEEP_MSB_ADDR             PMU_AUXADC_CON4_H
#define PMU_AUXADC_SPL_NUM_SLEEP_MSB_MASK             0x3
#define PMU_AUXADC_SPL_NUM_SLEEP_MSB_SHIFT            0
#define PMU_AUXADC_SPL_NUM_SLEEP_SEL_ADDR             PMU_AUXADC_CON4_H
#define PMU_AUXADC_SPL_NUM_SLEEP_SEL_MASK             0x1
#define PMU_AUXADC_SPL_NUM_SLEEP_SEL_SHIFT            7
#define PMU_AUXADC_SPL_NUM_SEL_LSB_ADDR               PMU_AUXADC_CON5
#define PMU_AUXADC_SPL_NUM_SEL_LSB_MASK               0xFF
#define PMU_AUXADC_SPL_NUM_SEL_LSB_SHIFT              0
#define PMU_AUXADC_SPL_NUM_SEL_MSB_ADDR               PMU_AUXADC_CON5_H
#define PMU_AUXADC_SPL_NUM_SEL_MSB_MASK               0xF
#define PMU_AUXADC_SPL_NUM_SEL_MSB_SHIFT              0
#define PMU_AUXADC_SPL_NUM_SEL_SHARE_ADDR             PMU_AUXADC_CON5_H
#define PMU_AUXADC_SPL_NUM_SEL_SHARE_MASK             0x1
#define PMU_AUXADC_SPL_NUM_SEL_SHARE_SHIFT            4
#define PMU_AUXADC_SPL_NUM_SEL_LBAT_ADDR              PMU_AUXADC_CON5_H
#define PMU_AUXADC_SPL_NUM_SEL_LBAT_MASK              0x1
#define PMU_AUXADC_SPL_NUM_SEL_LBAT_SHIFT             5
#define PMU_AUXADC_SPL_NUM_SEL_VISMPS_ADDR            PMU_AUXADC_CON5_H
#define PMU_AUXADC_SPL_NUM_SEL_VISMPS_MASK            0x1
#define PMU_AUXADC_SPL_NUM_SEL_VISMPS_SHIFT           6
#define PMU_AUXADC_SPL_NUM_SEL_WAKEUP_ADDR            PMU_AUXADC_CON5_H
#define PMU_AUXADC_SPL_NUM_SEL_WAKEUP_MASK            0x1
#define PMU_AUXADC_SPL_NUM_SEL_WAKEUP_SHIFT           7
#define PMU_AUXADC_TRIM_CH0_SEL_ADDR                  PMU_AUXADC_CON6
#define PMU_AUXADC_TRIM_CH0_SEL_MASK                  0x3
#define PMU_AUXADC_TRIM_CH0_SEL_SHIFT                 0
#define PMU_AUXADC_TRIM_CH1_SEL_ADDR                  PMU_AUXADC_CON6
#define PMU_AUXADC_TRIM_CH1_SEL_MASK                  0x3
#define PMU_AUXADC_TRIM_CH1_SEL_SHIFT                 2
#define PMU_AUXADC_TRIM_CH2_SEL_ADDR                  PMU_AUXADC_CON6
#define PMU_AUXADC_TRIM_CH2_SEL_MASK                  0x3
#define PMU_AUXADC_TRIM_CH2_SEL_SHIFT                 4
#define PMU_AUXADC_TRIM_CH3_SEL_ADDR                  PMU_AUXADC_CON6
#define PMU_AUXADC_TRIM_CH3_SEL_MASK                  0x3
#define PMU_AUXADC_TRIM_CH3_SEL_SHIFT                 6
#define PMU_AUXADC_TRIM_CH4_SEL_ADDR                  PMU_AUXADC_CON6_H
#define PMU_AUXADC_TRIM_CH4_SEL_MASK                  0x3
#define PMU_AUXADC_TRIM_CH4_SEL_SHIFT                 0
#define PMU_AUXADC_TRIM_CH5_SEL_ADDR                  PMU_AUXADC_CON6_H
#define PMU_AUXADC_TRIM_CH5_SEL_MASK                  0x3
#define PMU_AUXADC_TRIM_CH5_SEL_SHIFT                 2
#define PMU_AUXADC_TRIM_CH6_SEL_ADDR                  PMU_AUXADC_CON6_H
#define PMU_AUXADC_TRIM_CH6_SEL_MASK                  0x3
#define PMU_AUXADC_TRIM_CH6_SEL_SHIFT                 4
#define PMU_AUXADC_TRIM_CH7_SEL_ADDR                  PMU_AUXADC_CON6_H
#define PMU_AUXADC_TRIM_CH7_SEL_MASK                  0x3
#define PMU_AUXADC_TRIM_CH7_SEL_SHIFT                 6
#define PMU_AUXADC_TRIM_CH8_SEL_ADDR                  PMU_AUXADC_CON7
#define PMU_AUXADC_TRIM_CH8_SEL_MASK                  0x3
#define PMU_AUXADC_TRIM_CH8_SEL_SHIFT                 0
#define PMU_AUXADC_TRIM_CH9_SEL_ADDR                  PMU_AUXADC_CON7
#define PMU_AUXADC_TRIM_CH9_SEL_MASK                  0x3
#define PMU_AUXADC_TRIM_CH9_SEL_SHIFT                 2
#define PMU_AUXADC_TRIM_CH10_SEL_ADDR                 PMU_AUXADC_CON7
#define PMU_AUXADC_TRIM_CH10_SEL_MASK                 0x3
#define PMU_AUXADC_TRIM_CH10_SEL_SHIFT                4
#define PMU_AUXADC_TRIM_CH11_SEL_ADDR                 PMU_AUXADC_CON7
#define PMU_AUXADC_TRIM_CH11_SEL_MASK                 0x3
#define PMU_AUXADC_TRIM_CH11_SEL_SHIFT                6
#define PMU_AUXADC_ADC_2S_COMP_ENB_ADDR               PMU_AUXADC_CON7_H
#define PMU_AUXADC_ADC_2S_COMP_ENB_MASK               0x1
#define PMU_AUXADC_ADC_2S_COMP_ENB_SHIFT              6
#define PMU_AUXADC_ADC_TRIM_COMP_ADDR                 PMU_AUXADC_CON7_H
#define PMU_AUXADC_ADC_TRIM_COMP_MASK                 0x1
#define PMU_AUXADC_ADC_TRIM_COMP_SHIFT                7
#define PMU_AUXADC_SW_GAIN_TRIM_LSB_ADDR              PMU_AUXADC_CON8
#define PMU_AUXADC_SW_GAIN_TRIM_LSB_MASK              0xFF
#define PMU_AUXADC_SW_GAIN_TRIM_LSB_SHIFT             0
#define PMU_AUXADC_SW_GAIN_TRIM_MSB_ADDR              PMU_AUXADC_CON8_H
#define PMU_AUXADC_SW_GAIN_TRIM_MSB_MASK              0x7F
#define PMU_AUXADC_SW_GAIN_TRIM_MSB_SHIFT             0
#define PMU_AUXADC_SW_OFFSET_TRIM_LSB_ADDR            PMU_AUXADC_CON9
#define PMU_AUXADC_SW_OFFSET_TRIM_LSB_MASK            0xFF
#define PMU_AUXADC_SW_OFFSET_TRIM_LSB_SHIFT           0
#define PMU_AUXADC_SW_OFFSET_TRIM_MSB_ADDR            PMU_AUXADC_CON9_H
#define PMU_AUXADC_SW_OFFSET_TRIM_MSB_MASK            0x7F
#define PMU_AUXADC_SW_OFFSET_TRIM_MSB_SHIFT           0
#define PMU_AUXADC_RNG_EN_ADDR                        PMU_AUXADC_CON10
#define PMU_AUXADC_RNG_EN_MASK                        0x1
#define PMU_AUXADC_RNG_EN_SHIFT                       0
#define PMU_AUXADC_DATA_REUSE_SEL_ADDR                PMU_AUXADC_CON10
#define PMU_AUXADC_DATA_REUSE_SEL_MASK                0x3
#define PMU_AUXADC_DATA_REUSE_SEL_SHIFT               1
#define PMU_AUXADC_TEST_MODE_ADDR                     PMU_AUXADC_CON10
#define PMU_AUXADC_TEST_MODE_MASK                     0x1
#define PMU_AUXADC_TEST_MODE_SHIFT                    3
#define PMU_AUXADC_BIT_SEL_ADDR                       PMU_AUXADC_CON10
#define PMU_AUXADC_BIT_SEL_MASK                       0x1
#define PMU_AUXADC_BIT_SEL_SHIFT                      4
#define PMU_AUXADC_START_SW_ADDR                      PMU_AUXADC_CON10
#define PMU_AUXADC_START_SW_MASK                      0x1
#define PMU_AUXADC_START_SW_SHIFT                     5
#define PMU_AUXADC_START_SWCTRL_ADDR                  PMU_AUXADC_CON10
#define PMU_AUXADC_START_SWCTRL_MASK                  0x1
#define PMU_AUXADC_START_SWCTRL_SHIFT                 6
#define PMU_AUXADC_TS_VBE_SEL_ADDR                    PMU_AUXADC_CON10_H
#define PMU_AUXADC_TS_VBE_SEL_MASK                    0x1
#define PMU_AUXADC_TS_VBE_SEL_SHIFT                   0
#define PMU_AUXADC_TS_VBE_SEL_SWCTRL_ADDR             PMU_AUXADC_CON10_H
#define PMU_AUXADC_TS_VBE_SEL_SWCTRL_MASK             0x1
#define PMU_AUXADC_TS_VBE_SEL_SWCTRL_SHIFT            1
#define PMU_AUXADC_VBUF_EN_ADDR                       PMU_AUXADC_CON10_H
#define PMU_AUXADC_VBUF_EN_MASK                       0x1
#define PMU_AUXADC_VBUF_EN_SHIFT                      2
#define PMU_AUXADC_VBUF_EN_SWCTRL_ADDR                PMU_AUXADC_CON10_H
#define PMU_AUXADC_VBUF_EN_SWCTRL_MASK                0x1
#define PMU_AUXADC_VBUF_EN_SWCTRL_SHIFT               3
#define PMU_AUXADC_OUT_SEL_ADDR                       PMU_AUXADC_CON10_H
#define PMU_AUXADC_OUT_SEL_MASK                       0x1
#define PMU_AUXADC_OUT_SEL_SHIFT                      4
#define PMU_AUXADC_DA_DAC_LSB_ADDR                    PMU_AUXADC_CON11
#define PMU_AUXADC_DA_DAC_LSB_MASK                    0xFF
#define PMU_AUXADC_DA_DAC_LSB_SHIFT                   0
#define PMU_AUXADC_DA_DAC_MSB_ADDR                    PMU_AUXADC_CON11_H
#define PMU_AUXADC_DA_DAC_MSB_MASK                    0xF
#define PMU_AUXADC_DA_DAC_MSB_SHIFT                   0
#define PMU_AUXADC_DA_DAC_SWCTRL_ADDR                 PMU_AUXADC_CON11_H
#define PMU_AUXADC_DA_DAC_SWCTRL_MASK                 0x1
#define PMU_AUXADC_DA_DAC_SWCTRL_SHIFT                4
#define PMU_AD_AUXADC_COMP_ADDR                       PMU_AUXADC_CON11_H
#define PMU_AD_AUXADC_COMP_MASK                       0x1
#define PMU_AD_AUXADC_COMP_SHIFT                      7
#define PMU_RG_VBUF_EXTEN_ADDR                        PMU_AUXADC_CON12
#define PMU_RG_VBUF_EXTEN_MASK                        0x1
#define PMU_RG_VBUF_EXTEN_SHIFT                       4
#define PMU_RG_VBUF_CALEN_ADDR                        PMU_AUXADC_CON12
#define PMU_RG_VBUF_CALEN_MASK                        0x1
#define PMU_RG_VBUF_CALEN_SHIFT                       5
#define PMU_RG_VBUF_BYP_ADDR                          PMU_AUXADC_CON12
#define PMU_RG_VBUF_BYP_MASK                          0x1
#define PMU_RG_VBUF_BYP_SHIFT                         6
#define PMU_RG_VBUF_EN_ADDR                           PMU_AUXADC_CON12
#define PMU_RG_VBUF_EN_MASK                           0x1
#define PMU_RG_VBUF_EN_SHIFT                          7
#define PMU_RG_AUX_RSV_ADDR                           PMU_AUXADC_CON12_H
#define PMU_RG_AUX_RSV_MASK                           0xF
#define PMU_RG_AUX_RSV_SHIFT                          0
#define PMU_RG_AUXADC_CALI_ADDR                       PMU_AUXADC_CON12_H
#define PMU_RG_AUXADC_CALI_MASK                       0xF
#define PMU_RG_AUXADC_CALI_SHIFT                      4
#define PMU_AUXADC_ADCIN_VSEN_EN_ADDR                 PMU_AUXADC_CON13
#define PMU_AUXADC_ADCIN_VSEN_EN_MASK                 0x1
#define PMU_AUXADC_ADCIN_VSEN_EN_SHIFT                0
#define PMU_AUXADC_ADCIN_VBAT_EN_ADDR                 PMU_AUXADC_CON13
#define PMU_AUXADC_ADCIN_VBAT_EN_MASK                 0x1
#define PMU_AUXADC_ADCIN_VBAT_EN_SHIFT                1
#define PMU_AUXADC_ADCIN_VSEN_MUX_EN_ADDR             PMU_AUXADC_CON13
#define PMU_AUXADC_ADCIN_VSEN_MUX_EN_MASK             0x1
#define PMU_AUXADC_ADCIN_VSEN_MUX_EN_SHIFT            2
#define PMU_AUXADC_ADCIN_VSEN_EXT_BATON_EN_ADDR       PMU_AUXADC_CON13
#define PMU_AUXADC_ADCIN_VSEN_EXT_BATON_EN_MASK       0x1
#define PMU_AUXADC_ADCIN_VSEN_EXT_BATON_EN_SHIFT      3
#define PMU_AUXADC_ADCIN_CHR_EN_ADDR                  PMU_AUXADC_CON13
#define PMU_AUXADC_ADCIN_CHR_EN_MASK                  0x1
#define PMU_AUXADC_ADCIN_CHR_EN_SHIFT                 4
#define PMU_AUXADC_ADCIN_BATON_TDET_EN_ADDR           PMU_AUXADC_CON13
#define PMU_AUXADC_ADCIN_BATON_TDET_EN_MASK           0x1
#define PMU_AUXADC_ADCIN_BATON_TDET_EN_SHIFT          5
#define PMU_AUXADC_ACCDET_ANASWCTRL_EN_ADDR           PMU_AUXADC_CON13
#define PMU_AUXADC_ACCDET_ANASWCTRL_EN_MASK           0x1
#define PMU_AUXADC_ACCDET_ANASWCTRL_EN_SHIFT          6
#define PMU_AUXADC_DIG0_RSV0_LSB_ADDR                 PMU_AUXADC_CON13
#define PMU_AUXADC_DIG0_RSV0_LSB_MASK                 0x1
#define PMU_AUXADC_DIG0_RSV0_LSB_SHIFT                7
#define PMU_AUXADC_DIG0_RSV0_MSB_ADDR                 PMU_AUXADC_CON13_H
#define PMU_AUXADC_DIG0_RSV0_MSB_MASK                 0x7
#define PMU_AUXADC_DIG0_RSV0_MSB_SHIFT                0
#define PMU_AUXADC_CHSEL_ADDR                         PMU_AUXADC_CON13_H
#define PMU_AUXADC_CHSEL_MASK                         0xF
#define PMU_AUXADC_CHSEL_SHIFT                        3
#define PMU_AUXADC_SWCTRL_EN_ADDR                     PMU_AUXADC_CON13_H
#define PMU_AUXADC_SWCTRL_EN_MASK                     0x1
#define PMU_AUXADC_SWCTRL_EN_SHIFT                    7
#define PMU_AUXADC_SOURCE_LBAT_SEL_ADDR               PMU_AUXADC_CON14
#define PMU_AUXADC_SOURCE_LBAT_SEL_MASK               0x1
#define PMU_AUXADC_SOURCE_LBAT_SEL_SHIFT              0
#define PMU_AUXADC_SOURCE_LBAT2_SEL_ADDR              PMU_AUXADC_CON14
#define PMU_AUXADC_SOURCE_LBAT2_SEL_MASK              0x1
#define PMU_AUXADC_SOURCE_LBAT2_SEL_SHIFT             1
#define PMU_AUXADC_DIG0_RSV2_ADDR                     PMU_AUXADC_CON14
#define PMU_AUXADC_DIG0_RSV2_MASK                     0x7
#define PMU_AUXADC_DIG0_RSV2_SHIFT                    2
#define PMU_AUXADC_DIG1_RSV2_LSB_ADDR                 PMU_AUXADC_CON14
#define PMU_AUXADC_DIG1_RSV2_LSB_MASK                 0x7
#define PMU_AUXADC_DIG1_RSV2_LSB_SHIFT                5
#define PMU_AUXADC_DIG1_RSV2_MSB_ADDR                 PMU_AUXADC_CON14_H
#define PMU_AUXADC_DIG1_RSV2_MSB_MASK                 0x1
#define PMU_AUXADC_DIG1_RSV2_MSB_SHIFT                0
#define PMU_AUXADC_DAC_EXTD_ADDR                      PMU_AUXADC_CON14_H
#define PMU_AUXADC_DAC_EXTD_MASK                      0xF
#define PMU_AUXADC_DAC_EXTD_SHIFT                     3
#define PMU_AUXADC_DAC_EXTD_EN_ADDR                   PMU_AUXADC_CON14_H
#define PMU_AUXADC_DAC_EXTD_EN_MASK                   0x1
#define PMU_AUXADC_DAC_EXTD_EN_SHIFT                  7
#define PMU_AUXADC_PMU_THR_PDN_SW_ADDR                PMU_AUXADC_CON15_H
#define PMU_AUXADC_PMU_THR_PDN_SW_MASK                0x1
#define PMU_AUXADC_PMU_THR_PDN_SW_SHIFT               2
#define PMU_AUXADC_PMU_THR_PDN_SEL_ADDR               PMU_AUXADC_CON15_H
#define PMU_AUXADC_PMU_THR_PDN_SEL_MASK               0x1
#define PMU_AUXADC_PMU_THR_PDN_SEL_SHIFT              3
#define PMU_AUXADC_PMU_THR_PDN_STATUS_ADDR            PMU_AUXADC_CON15_H
#define PMU_AUXADC_PMU_THR_PDN_STATUS_MASK            0x1
#define PMU_AUXADC_PMU_THR_PDN_STATUS_SHIFT           4
#define PMU_AUXADC_DIG0_RSV1_ADDR                     PMU_AUXADC_CON15_H
#define PMU_AUXADC_DIG0_RSV1_MASK                     0x7
#define PMU_AUXADC_DIG0_RSV1_SHIFT                    5
#define PMU_AUXADC_START_SHADE_NUM_LSB_ADDR           PMU_AUXADC_CON16
#define PMU_AUXADC_START_SHADE_NUM_LSB_MASK           0xFF
#define PMU_AUXADC_START_SHADE_NUM_LSB_SHIFT          0
#define PMU_AUXADC_START_SHADE_NUM_MSB_ADDR           PMU_AUXADC_CON16_H
#define PMU_AUXADC_START_SHADE_NUM_MSB_MASK           0x3
#define PMU_AUXADC_START_SHADE_NUM_MSB_SHIFT          0
#define PMU_AUXADC_START_SHADE_EN_ADDR                PMU_AUXADC_CON16_H
#define PMU_AUXADC_START_SHADE_EN_MASK                0x1
#define PMU_AUXADC_START_SHADE_EN_SHIFT               6
#define PMU_AUXADC_START_SHADE_SEL_ADDR               PMU_AUXADC_CON16_H
#define PMU_AUXADC_START_SHADE_SEL_MASK               0x1
#define PMU_AUXADC_START_SHADE_SEL_SHIFT              7
#define PMU_AUXADC_AUTORPT_PRD_LSB_ADDR               PMU_AUXADC_AUTORPT0
#define PMU_AUXADC_AUTORPT_PRD_LSB_MASK               0xFF
#define PMU_AUXADC_AUTORPT_PRD_LSB_SHIFT              0
#define PMU_AUXADC_AUTORPT_PRD_MSB_ADDR               PMU_AUXADC_AUTORPT0_H
#define PMU_AUXADC_AUTORPT_PRD_MSB_MASK               0x3
#define PMU_AUXADC_AUTORPT_PRD_MSB_SHIFT              0
#define PMU_AUXADC_AUTORPT_EN_ADDR                    PMU_AUXADC_AUTORPT0_H
#define PMU_AUXADC_AUTORPT_EN_MASK                    0x1
#define PMU_AUXADC_AUTORPT_EN_SHIFT                   7
#define PMU_AUXADC_LBAT_DEBT_MAX_ADDR                 PMU_AUXADC_LBAT0
#define PMU_AUXADC_LBAT_DEBT_MAX_MASK                 0xFF
#define PMU_AUXADC_LBAT_DEBT_MAX_SHIFT                0
#define PMU_AUXADC_LBAT_DEBT_MIN_ADDR                 PMU_AUXADC_LBAT0_H
#define PMU_AUXADC_LBAT_DEBT_MIN_MASK                 0xFF
#define PMU_AUXADC_LBAT_DEBT_MIN_SHIFT                0
#define PMU_AUXADC_LBAT_DET_PRD_15_0_LSB_ADDR         PMU_AUXADC_LBAT1
#define PMU_AUXADC_LBAT_DET_PRD_15_0_LSB_MASK         0xFF
#define PMU_AUXADC_LBAT_DET_PRD_15_0_LSB_SHIFT        0
#define PMU_AUXADC_LBAT_DET_PRD_15_0_MSB_ADDR         PMU_AUXADC_LBAT1_H
#define PMU_AUXADC_LBAT_DET_PRD_15_0_MSB_MASK         0xFF
#define PMU_AUXADC_LBAT_DET_PRD_15_0_MSB_SHIFT        0
#define PMU_AUXADC_LBAT_DET_PRD_19_16_ADDR            PMU_AUXADC_LBAT2
#define PMU_AUXADC_LBAT_DET_PRD_19_16_MASK            0xF
#define PMU_AUXADC_LBAT_DET_PRD_19_16_SHIFT           0
#define PMU_AUXADC_LBAT_VOLT_MAX_LSB_ADDR             PMU_AUXADC_LBAT3
#define PMU_AUXADC_LBAT_VOLT_MAX_LSB_MASK             0xFF
#define PMU_AUXADC_LBAT_VOLT_MAX_LSB_SHIFT            0
#define PMU_AUXADC_LBAT_VOLT_MAX_MSB_ADDR             PMU_AUXADC_LBAT3_H
#define PMU_AUXADC_LBAT_VOLT_MAX_MSB_MASK             0xF
#define PMU_AUXADC_LBAT_VOLT_MAX_MSB_SHIFT            0
#define PMU_AUXADC_LBAT_IRQ_EN_MAX_ADDR               PMU_AUXADC_LBAT3_H
#define PMU_AUXADC_LBAT_IRQ_EN_MAX_MASK               0x1
#define PMU_AUXADC_LBAT_IRQ_EN_MAX_SHIFT              4
#define PMU_AUXADC_LBAT_EN_MAX_ADDR                   PMU_AUXADC_LBAT3_H
#define PMU_AUXADC_LBAT_EN_MAX_MASK                   0x1
#define PMU_AUXADC_LBAT_EN_MAX_SHIFT                  5
#define PMU_AUXADC_LBAT_MAX_IRQ_B_ADDR                PMU_AUXADC_LBAT3_H
#define PMU_AUXADC_LBAT_MAX_IRQ_B_MASK                0x1
#define PMU_AUXADC_LBAT_MAX_IRQ_B_SHIFT               7
#define PMU_AUXADC_LBAT_VOLT_MIN_LSB_ADDR             PMU_AUXADC_LBAT4
#define PMU_AUXADC_LBAT_VOLT_MIN_LSB_MASK             0xFF
#define PMU_AUXADC_LBAT_VOLT_MIN_LSB_SHIFT            0
#define PMU_AUXADC_LBAT_VOLT_MIN_MSB_ADDR             PMU_AUXADC_LBAT4_H
#define PMU_AUXADC_LBAT_VOLT_MIN_MSB_MASK             0xF
#define PMU_AUXADC_LBAT_VOLT_MIN_MSB_SHIFT            0
#define PMU_AUXADC_LBAT_IRQ_EN_MIN_ADDR               PMU_AUXADC_LBAT4_H
#define PMU_AUXADC_LBAT_IRQ_EN_MIN_MASK               0x1
#define PMU_AUXADC_LBAT_IRQ_EN_MIN_SHIFT              4
#define PMU_AUXADC_LBAT_EN_MIN_ADDR                   PMU_AUXADC_LBAT4_H
#define PMU_AUXADC_LBAT_EN_MIN_MASK                   0x1
#define PMU_AUXADC_LBAT_EN_MIN_SHIFT                  5
#define PMU_AUXADC_LBAT_MIN_IRQ_B_ADDR                PMU_AUXADC_LBAT4_H
#define PMU_AUXADC_LBAT_MIN_IRQ_B_MASK                0x1
#define PMU_AUXADC_LBAT_MIN_IRQ_B_SHIFT               7
#define PMU_AUXADC_LBAT_DEBOUNCE_COUNT_MAX_L_ADDR     PMU_AUXADC_LBAT5
#define PMU_AUXADC_LBAT_DEBOUNCE_COUNT_MAX_L_MASK     0xFF
#define PMU_AUXADC_LBAT_DEBOUNCE_COUNT_MAX_L_SHIFT    0
#define PMU_AUXADC_LBAT_DEBOUNCE_COUNT_MAX_H_ADDR     PMU_AUXADC_LBAT5_H
#define PMU_AUXADC_LBAT_DEBOUNCE_COUNT_MAX_H_MASK     0x1
#define PMU_AUXADC_LBAT_DEBOUNCE_COUNT_MAX_H_SHIFT    0
#define PMU_AUXADC_LBAT_DEBOUNCE_COUNT_MIN_L_ADDR     PMU_AUXADC_LBAT6
#define PMU_AUXADC_LBAT_DEBOUNCE_COUNT_MIN_L_MASK     0xFF
#define PMU_AUXADC_LBAT_DEBOUNCE_COUNT_MIN_L_SHIFT    0
#define PMU_AUXADC_LBAT_DEBOUNCE_COUNT_MIN_H_ADDR     PMU_AUXADC_LBAT6_H
#define PMU_AUXADC_LBAT_DEBOUNCE_COUNT_MIN_H_MASK     0x1
#define PMU_AUXADC_LBAT_DEBOUNCE_COUNT_MIN_H_SHIFT    0
#define PMU_AUXADC_ACCDET_AUTO_SPL_ADDR               PMU_AUXADC_ACCDET
#define PMU_AUXADC_ACCDET_AUTO_SPL_MASK               0x1
#define PMU_AUXADC_ACCDET_AUTO_SPL_SHIFT              0
#define PMU_AUXADC_ACCDET_AUTO_RQST_CLR_ADDR          PMU_AUXADC_ACCDET
#define PMU_AUXADC_ACCDET_AUTO_RQST_CLR_MASK          0x1
#define PMU_AUXADC_ACCDET_AUTO_RQST_CLR_SHIFT         1
#define PMU_AUXADC_ACCDET_DIG1_RSV0_ADDR              PMU_AUXADC_ACCDET
#define PMU_AUXADC_ACCDET_DIG1_RSV0_MASK              0x3F
#define PMU_AUXADC_ACCDET_DIG1_RSV0_SHIFT             2
#define PMU_AUXADC_ACCDET_DIG0_RSV0_ADDR              PMU_AUXADC_ACCDET_H
#define PMU_AUXADC_ACCDET_DIG0_RSV0_MASK              0xFF
#define PMU_AUXADC_ACCDET_DIG0_RSV0_SHIFT             0
#define PMU_AUXADC_THR_DEBT_MAX_ADDR                  PMU_AUXADC_THR0
#define PMU_AUXADC_THR_DEBT_MAX_MASK                  0xFF
#define PMU_AUXADC_THR_DEBT_MAX_SHIFT                 0
#define PMU_AUXADC_THR_DEBT_MIN_ADDR                  PMU_AUXADC_THR0_H
#define PMU_AUXADC_THR_DEBT_MIN_MASK                  0xFF
#define PMU_AUXADC_THR_DEBT_MIN_SHIFT                 0
#define PMU_AUXADC_THR_DET_PRD_15_0_LSB_ADDR          PMU_AUXADC_THR1
#define PMU_AUXADC_THR_DET_PRD_15_0_LSB_MASK          0xFF
#define PMU_AUXADC_THR_DET_PRD_15_0_LSB_SHIFT         0
#define PMU_AUXADC_THR_DET_PRD_15_0_MSB_ADDR          PMU_AUXADC_THR1_H
#define PMU_AUXADC_THR_DET_PRD_15_0_MSB_MASK          0xFF
#define PMU_AUXADC_THR_DET_PRD_15_0_MSB_SHIFT         0
#define PMU_AUXADC_THR_DET_PRD_19_16_ADDR             PMU_AUXADC_THR2
#define PMU_AUXADC_THR_DET_PRD_19_16_MASK             0xF
#define PMU_AUXADC_THR_DET_PRD_19_16_SHIFT            0
#define PMU_AUXADC_THR_VOLT_MAX_LSB_ADDR              PMU_AUXADC_THR3
#define PMU_AUXADC_THR_VOLT_MAX_LSB_MASK              0xFF
#define PMU_AUXADC_THR_VOLT_MAX_LSB_SHIFT             0
#define PMU_AUXADC_THR_VOLT_MAX_MSB_ADDR              PMU_AUXADC_THR3_H
#define PMU_AUXADC_THR_VOLT_MAX_MSB_MASK              0xF
#define PMU_AUXADC_THR_VOLT_MAX_MSB_SHIFT             0
#define PMU_AUXADC_THR_IRQ_EN_MAX_ADDR                PMU_AUXADC_THR3_H
#define PMU_AUXADC_THR_IRQ_EN_MAX_MASK                0x1
#define PMU_AUXADC_THR_IRQ_EN_MAX_SHIFT               4
#define PMU_AUXADC_THR_EN_MAX_ADDR                    PMU_AUXADC_THR3_H
#define PMU_AUXADC_THR_EN_MAX_MASK                    0x1
#define PMU_AUXADC_THR_EN_MAX_SHIFT                   5
#define PMU_AUXADC_THR_MAX_IRQ_B_ADDR                 PMU_AUXADC_THR3_H
#define PMU_AUXADC_THR_MAX_IRQ_B_MASK                 0x1
#define PMU_AUXADC_THR_MAX_IRQ_B_SHIFT                7
#define PMU_AUXADC_THR_VOLT_MIN_LSB_ADDR              PMU_AUXADC_THR4
#define PMU_AUXADC_THR_VOLT_MIN_LSB_MASK              0xFF
#define PMU_AUXADC_THR_VOLT_MIN_LSB_SHIFT             0
#define PMU_AUXADC_THR_VOLT_MIN_MSB_ADDR              PMU_AUXADC_THR4_H
#define PMU_AUXADC_THR_VOLT_MIN_MSB_MASK              0xF
#define PMU_AUXADC_THR_VOLT_MIN_MSB_SHIFT             0
#define PMU_AUXADC_THR_IRQ_EN_MIN_ADDR                PMU_AUXADC_THR4_H
#define PMU_AUXADC_THR_IRQ_EN_MIN_MASK                0x1
#define PMU_AUXADC_THR_IRQ_EN_MIN_SHIFT               4
#define PMU_AUXADC_THR_EN_MIN_ADDR                    PMU_AUXADC_THR4_H
#define PMU_AUXADC_THR_EN_MIN_MASK                    0x1
#define PMU_AUXADC_THR_EN_MIN_SHIFT                   5
#define PMU_AUXADC_THR_MIN_IRQ_B_ADDR                 PMU_AUXADC_THR4_H
#define PMU_AUXADC_THR_MIN_IRQ_B_MASK                 0x1
#define PMU_AUXADC_THR_MIN_IRQ_B_SHIFT                7
#define PMU_AUXADC_THR_DEBOUNCE_COUNT_MAX_L_ADDR      PMU_AUXADC_THR5
#define PMU_AUXADC_THR_DEBOUNCE_COUNT_MAX_L_MASK      0xFF
#define PMU_AUXADC_THR_DEBOUNCE_COUNT_MAX_L_SHIFT     0
#define PMU_AUXADC_THR_DEBOUNCE_COUNT_MAX_H_ADDR      PMU_AUXADC_THR5_H
#define PMU_AUXADC_THR_DEBOUNCE_COUNT_MAX_H_MASK      0x1
#define PMU_AUXADC_THR_DEBOUNCE_COUNT_MAX_H_SHIFT     0
#define PMU_AUXADC_THR_DEBOUNCE_COUNT_MIN_L_ADDR      PMU_AUXADC_THR6
#define PMU_AUXADC_THR_DEBOUNCE_COUNT_MIN_L_MASK      0xFF
#define PMU_AUXADC_THR_DEBOUNCE_COUNT_MIN_L_SHIFT     0
#define PMU_AUXADC_THR_DEBOUNCE_COUNT_MIN_H_ADDR      PMU_AUXADC_THR6_H
#define PMU_AUXADC_THR_DEBOUNCE_COUNT_MIN_H_MASK      0x1
#define PMU_AUXADC_THR_DEBOUNCE_COUNT_MIN_H_SHIFT     0
#define PMU_EFUSE_GAIN_CH4_TRIM_LSB_ADDR              PMU_AUXADC_EFUSE0
#define PMU_EFUSE_GAIN_CH4_TRIM_LSB_MASK              0xFF
#define PMU_EFUSE_GAIN_CH4_TRIM_LSB_SHIFT             0
#define PMU_EFUSE_GAIN_CH4_TRIM_MSB_ADDR              PMU_AUXADC_EFUSE0_H
#define PMU_EFUSE_GAIN_CH4_TRIM_MSB_MASK              0xF
#define PMU_EFUSE_GAIN_CH4_TRIM_MSB_SHIFT             0
#define PMU_EFUSE_OFFSET_CH4_TRIM_LSB_ADDR            PMU_AUXADC_EFUSE1
#define PMU_EFUSE_OFFSET_CH4_TRIM_LSB_MASK            0xFF
#define PMU_EFUSE_OFFSET_CH4_TRIM_LSB_SHIFT           0
#define PMU_EFUSE_OFFSET_CH4_TRIM_MSB_ADDR            PMU_AUXADC_EFUSE1_H
#define PMU_EFUSE_OFFSET_CH4_TRIM_MSB_MASK            0x7
#define PMU_EFUSE_OFFSET_CH4_TRIM_MSB_SHIFT           0
#define PMU_EFUSE_GAIN_CH0_TRIM_LSB_ADDR              PMU_AUXADC_EFUSE2
#define PMU_EFUSE_GAIN_CH0_TRIM_LSB_MASK              0xFF
#define PMU_EFUSE_GAIN_CH0_TRIM_LSB_SHIFT             0
#define PMU_EFUSE_GAIN_CH0_TRIM_MSB_ADDR              PMU_AUXADC_EFUSE2_H
#define PMU_EFUSE_GAIN_CH0_TRIM_MSB_MASK              0xF
#define PMU_EFUSE_GAIN_CH0_TRIM_MSB_SHIFT             0
#define PMU_EFUSE_OFFSET_CH0_TRIM_LSB_ADDR            PMU_AUXADC_EFUSE3
#define PMU_EFUSE_OFFSET_CH0_TRIM_LSB_MASK            0xFF
#define PMU_EFUSE_OFFSET_CH0_TRIM_LSB_SHIFT           0
#define PMU_EFUSE_OFFSET_CH0_TRIM_MSB_ADDR            PMU_AUXADC_EFUSE3_H
#define PMU_EFUSE_OFFSET_CH0_TRIM_MSB_MASK            0x7
#define PMU_EFUSE_OFFSET_CH0_TRIM_MSB_SHIFT           0
#define PMU_EFUSE_GAIN_CH7_TRIM_LSB_ADDR              PMU_AUXADC_EFUSE4
#define PMU_EFUSE_GAIN_CH7_TRIM_LSB_MASK              0xFF
#define PMU_EFUSE_GAIN_CH7_TRIM_LSB_SHIFT             0
#define PMU_EFUSE_GAIN_CH7_TRIM_MSB_ADDR              PMU_AUXADC_EFUSE4_H
#define PMU_EFUSE_GAIN_CH7_TRIM_MSB_MASK              0xF
#define PMU_EFUSE_GAIN_CH7_TRIM_MSB_SHIFT             0
#define PMU_EFUSE_OFFSET_CH7_TRIM_LSB_ADDR            PMU_AUXADC_EFUSE5
#define PMU_EFUSE_OFFSET_CH7_TRIM_LSB_MASK            0xFF
#define PMU_EFUSE_OFFSET_CH7_TRIM_LSB_SHIFT           0
#define PMU_EFUSE_OFFSET_CH7_TRIM_MSB_ADDR            PMU_AUXADC_EFUSE5_H
#define PMU_EFUSE_OFFSET_CH7_TRIM_MSB_MASK            0x7
#define PMU_EFUSE_OFFSET_CH7_TRIM_MSB_SHIFT           0
#define PMU_AUXADC_FGADC_START_SW_ADDR                PMU_AUXADC_DBG0
#define PMU_AUXADC_FGADC_START_SW_MASK                0x1
#define PMU_AUXADC_FGADC_START_SW_SHIFT               0
#define PMU_AUXADC_FGADC_START_SEL_ADDR               PMU_AUXADC_DBG0
#define PMU_AUXADC_FGADC_START_SEL_MASK               0x1
#define PMU_AUXADC_FGADC_START_SEL_SHIFT              1
#define PMU_AUXADC_FGADC_R_SW_ADDR                    PMU_AUXADC_DBG0
#define PMU_AUXADC_FGADC_R_SW_MASK                    0x1
#define PMU_AUXADC_FGADC_R_SW_SHIFT                   2
#define PMU_AUXADC_FGADC_R_SEL_ADDR                   PMU_AUXADC_DBG0
#define PMU_AUXADC_FGADC_R_SEL_MASK                   0x1
#define PMU_AUXADC_FGADC_R_SEL_SHIFT                  3
#define PMU_AUXADC_DBG_DIG0_RSV2_LSB_ADDR             PMU_AUXADC_DBG0
#define PMU_AUXADC_DBG_DIG0_RSV2_LSB_MASK             0xF
#define PMU_AUXADC_DBG_DIG0_RSV2_LSB_SHIFT            4
#define PMU_AUXADC_DBG_DIG0_RSV2_MSB_ADDR             PMU_AUXADC_DBG0_H
#define PMU_AUXADC_DBG_DIG0_RSV2_MSB_MASK             0x3
#define PMU_AUXADC_DBG_DIG0_RSV2_MSB_SHIFT            0
#define PMU_AUXADC_DBG_DIG1_RSV2_ADDR                 PMU_AUXADC_DBG0_H
#define PMU_AUXADC_DBG_DIG1_RSV2_MASK                 0x3F
#define PMU_AUXADC_DBG_DIG1_RSV2_SHIFT                2
#define PMU_AUXADC_IMPEDANCE_CNT_ADDR                 PMU_AUXADC_IMP0
#define PMU_AUXADC_IMPEDANCE_CNT_MASK                 0x3F
#define PMU_AUXADC_IMPEDANCE_CNT_SHIFT                0
#define PMU_AUXADC_IMPEDANCE_CHSEL_ADDR               PMU_AUXADC_IMP0
#define PMU_AUXADC_IMPEDANCE_CHSEL_MASK               0x1
#define PMU_AUXADC_IMPEDANCE_CHSEL_SHIFT              6
#define PMU_AUXADC_IMPEDANCE_IRQ_CLR_ADDR             PMU_AUXADC_IMP0
#define PMU_AUXADC_IMPEDANCE_IRQ_CLR_MASK             0x1
#define PMU_AUXADC_IMPEDANCE_IRQ_CLR_SHIFT            7
#define PMU_AUXADC_IMPEDANCE_IRQ_STATUS_ADDR          PMU_AUXADC_IMP0_H
#define PMU_AUXADC_IMPEDANCE_IRQ_STATUS_MASK          0x1
#define PMU_AUXADC_IMPEDANCE_IRQ_STATUS_SHIFT         0
#define PMU_AUXADC_CLR_IMP_CNT_STOP_ADDR              PMU_AUXADC_IMP0_H
#define PMU_AUXADC_CLR_IMP_CNT_STOP_MASK              0x1
#define PMU_AUXADC_CLR_IMP_CNT_STOP_SHIFT             6
#define PMU_AUXADC_IMPEDANCE_MODE_ADDR                PMU_AUXADC_IMP0_H
#define PMU_AUXADC_IMPEDANCE_MODE_MASK                0x1
#define PMU_AUXADC_IMPEDANCE_MODE_SHIFT               7
#define PMU_AUXADC_IMP_AUTORPT_PRD_LSB_ADDR           PMU_AUXADC_IMP1
#define PMU_AUXADC_IMP_AUTORPT_PRD_LSB_MASK           0xFF
#define PMU_AUXADC_IMP_AUTORPT_PRD_LSB_SHIFT          0
#define PMU_AUXADC_IMP_AUTORPT_PRD_MSB_ADDR           PMU_AUXADC_IMP1_H
#define PMU_AUXADC_IMP_AUTORPT_PRD_MSB_MASK           0x3
#define PMU_AUXADC_IMP_AUTORPT_PRD_MSB_SHIFT          0
#define PMU_AUXADC_IMP_AUTORPT_EN_ADDR                PMU_AUXADC_IMP1_H
#define PMU_AUXADC_IMP_AUTORPT_EN_MASK                0x1
#define PMU_AUXADC_IMP_AUTORPT_EN_SHIFT               7
#define PMU_AUXADC_VISMPS0_DEBT_MAX_ADDR              PMU_AUXADC_VISMPS0_1
#define PMU_AUXADC_VISMPS0_DEBT_MAX_MASK              0xFF
#define PMU_AUXADC_VISMPS0_DEBT_MAX_SHIFT             0
#define PMU_AUXADC_VISMPS0_DEBT_MIN_ADDR              PMU_AUXADC_VISMPS0_1_H
#define PMU_AUXADC_VISMPS0_DEBT_MIN_MASK              0xFF
#define PMU_AUXADC_VISMPS0_DEBT_MIN_SHIFT             0
#define PMU_AUXADC_VISMPS0_DET_PRD_15_0_LSB_ADDR      PMU_AUXADC_VISMPS0_2
#define PMU_AUXADC_VISMPS0_DET_PRD_15_0_LSB_MASK      0xFF
#define PMU_AUXADC_VISMPS0_DET_PRD_15_0_LSB_SHIFT     0
#define PMU_AUXADC_VISMPS0_DET_PRD_15_0_MSB_ADDR      PMU_AUXADC_VISMPS0_2_H
#define PMU_AUXADC_VISMPS0_DET_PRD_15_0_MSB_MASK      0xFF
#define PMU_AUXADC_VISMPS0_DET_PRD_15_0_MSB_SHIFT     0
#define PMU_AUXADC_VISMPS0_DET_PRD_19_16_ADDR         PMU_AUXADC_VISMPS0_3
#define PMU_AUXADC_VISMPS0_DET_PRD_19_16_MASK         0xF
#define PMU_AUXADC_VISMPS0_DET_PRD_19_16_SHIFT        0
#define PMU_AUXADC_VISMPS0_VOLT_MAX_LSB_ADDR          PMU_AUXADC_VISMPS0_4
#define PMU_AUXADC_VISMPS0_VOLT_MAX_LSB_MASK          0xFF
#define PMU_AUXADC_VISMPS0_VOLT_MAX_LSB_SHIFT         0
#define PMU_AUXADC_VISMPS0_VOLT_MAX_MSB_ADDR          PMU_AUXADC_VISMPS0_4_H
#define PMU_AUXADC_VISMPS0_VOLT_MAX_MSB_MASK          0xF
#define PMU_AUXADC_VISMPS0_VOLT_MAX_MSB_SHIFT         0
#define PMU_AUXADC_VISMPS0_IRQ_EN_MAX_ADDR            PMU_AUXADC_VISMPS0_4_H
#define PMU_AUXADC_VISMPS0_IRQ_EN_MAX_MASK            0x1
#define PMU_AUXADC_VISMPS0_IRQ_EN_MAX_SHIFT           4
#define PMU_AUXADC_VISMPS0_EN_MAX_ADDR                PMU_AUXADC_VISMPS0_4_H
#define PMU_AUXADC_VISMPS0_EN_MAX_MASK                0x1
#define PMU_AUXADC_VISMPS0_EN_MAX_SHIFT               5
#define PMU_AUXADC_VISMPS0_MAX_IRQ_B_ADDR             PMU_AUXADC_VISMPS0_4_H
#define PMU_AUXADC_VISMPS0_MAX_IRQ_B_MASK             0x1
#define PMU_AUXADC_VISMPS0_MAX_IRQ_B_SHIFT            7
#define PMU_AUXADC_VISMPS0_VOLT_MIN_LSB_ADDR          PMU_AUXADC_VISMPS0_5
#define PMU_AUXADC_VISMPS0_VOLT_MIN_LSB_MASK          0xFF
#define PMU_AUXADC_VISMPS0_VOLT_MIN_LSB_SHIFT         0
#define PMU_AUXADC_VISMPS0_VOLT_MIN_MSB_ADDR          PMU_AUXADC_VISMPS0_5_H
#define PMU_AUXADC_VISMPS0_VOLT_MIN_MSB_MASK          0xF
#define PMU_AUXADC_VISMPS0_VOLT_MIN_MSB_SHIFT         0
#define PMU_AUXADC_VISMPS0_IRQ_EN_MIN_ADDR            PMU_AUXADC_VISMPS0_5_H
#define PMU_AUXADC_VISMPS0_IRQ_EN_MIN_MASK            0x1
#define PMU_AUXADC_VISMPS0_IRQ_EN_MIN_SHIFT           4
#define PMU_AUXADC_VISMPS0_EN_MIN_ADDR                PMU_AUXADC_VISMPS0_5_H
#define PMU_AUXADC_VISMPS0_EN_MIN_MASK                0x1
#define PMU_AUXADC_VISMPS0_EN_MIN_SHIFT               5
#define PMU_AUXADC_VISMPS0_MIN_IRQ_B_ADDR             PMU_AUXADC_VISMPS0_5_H
#define PMU_AUXADC_VISMPS0_MIN_IRQ_B_MASK             0x1
#define PMU_AUXADC_VISMPS0_MIN_IRQ_B_SHIFT            7
#define PMU_AUXADC_VISMPS0_DEBOUNCE_COUNT_MAX_L_ADDR  PMU_AUXADC_VISMPS0_6
#define PMU_AUXADC_VISMPS0_DEBOUNCE_COUNT_MAX_L_MASK  0xFF
#define PMU_AUXADC_VISMPS0_DEBOUNCE_COUNT_MAX_L_SHIFT 0
#define PMU_AUXADC_VISMPS0_DEBOUNCE_COUNT_MAX_H_ADDR  PMU_AUXADC_VISMPS0_6_H
#define PMU_AUXADC_VISMPS0_DEBOUNCE_COUNT_MAX_H_MASK  0x1
#define PMU_AUXADC_VISMPS0_DEBOUNCE_COUNT_MAX_H_SHIFT 0
#define PMU_AUXADC_VISMPS0_DEBOUNCE_COUNT_MIN_L_ADDR  PMU_AUXADC_VISMPS0_7
#define PMU_AUXADC_VISMPS0_DEBOUNCE_COUNT_MIN_L_MASK  0xFF
#define PMU_AUXADC_VISMPS0_DEBOUNCE_COUNT_MIN_L_SHIFT 0
#define PMU_AUXADC_VISMPS0_DEBOUNCE_COUNT_MIN_H_ADDR  PMU_AUXADC_VISMPS0_7_H
#define PMU_AUXADC_VISMPS0_DEBOUNCE_COUNT_MIN_H_MASK  0x1
#define PMU_AUXADC_VISMPS0_DEBOUNCE_COUNT_MIN_H_SHIFT 0
#define PMU_AUXADC_LBAT2_DEBT_MAX_ADDR                PMU_AUXADC_LBAT2_1
#define PMU_AUXADC_LBAT2_DEBT_MAX_MASK                0xFF
#define PMU_AUXADC_LBAT2_DEBT_MAX_SHIFT               0
#define PMU_AUXADC_LBAT2_DEBT_MIN_ADDR                PMU_AUXADC_LBAT2_1_H
#define PMU_AUXADC_LBAT2_DEBT_MIN_MASK                0xFF
#define PMU_AUXADC_LBAT2_DEBT_MIN_SHIFT               0
#define PMU_AUXADC_LBAT2_DET_PRD_15_0_LSB_ADDR        PMU_AUXADC_LBAT2_2
#define PMU_AUXADC_LBAT2_DET_PRD_15_0_LSB_MASK        0xFF
#define PMU_AUXADC_LBAT2_DET_PRD_15_0_LSB_SHIFT       0
#define PMU_AUXADC_LBAT2_DET_PRD_15_0_MSB_ADDR        PMU_AUXADC_LBAT2_2_H
#define PMU_AUXADC_LBAT2_DET_PRD_15_0_MSB_MASK        0xFF
#define PMU_AUXADC_LBAT2_DET_PRD_15_0_MSB_SHIFT       0
#define PMU_AUXADC_LBAT2_DET_PRD_19_16_ADDR           PMU_AUXADC_LBAT2_3
#define PMU_AUXADC_LBAT2_DET_PRD_19_16_MASK           0xF
#define PMU_AUXADC_LBAT2_DET_PRD_19_16_SHIFT          0
#define PMU_AUXADC_LBAT2_VOLT_MAX_LSB_ADDR            PMU_AUXADC_LBAT2_4
#define PMU_AUXADC_LBAT2_VOLT_MAX_LSB_MASK            0xFF
#define PMU_AUXADC_LBAT2_VOLT_MAX_LSB_SHIFT           0
#define PMU_AUXADC_LBAT2_VOLT_MAX_MSB_ADDR            PMU_AUXADC_LBAT2_4_H
#define PMU_AUXADC_LBAT2_VOLT_MAX_MSB_MASK            0xF
#define PMU_AUXADC_LBAT2_VOLT_MAX_MSB_SHIFT           0
#define PMU_AUXADC_LBAT2_IRQ_EN_MAX_ADDR              PMU_AUXADC_LBAT2_4_H
#define PMU_AUXADC_LBAT2_IRQ_EN_MAX_MASK              0x1
#define PMU_AUXADC_LBAT2_IRQ_EN_MAX_SHIFT             4
#define PMU_AUXADC_LBAT2_EN_MAX_ADDR                  PMU_AUXADC_LBAT2_4_H
#define PMU_AUXADC_LBAT2_EN_MAX_MASK                  0x1
#define PMU_AUXADC_LBAT2_EN_MAX_SHIFT                 5
#define PMU_AUXADC_LBAT2_MAX_IRQ_B_ADDR               PMU_AUXADC_LBAT2_4_H
#define PMU_AUXADC_LBAT2_MAX_IRQ_B_MASK               0x1
#define PMU_AUXADC_LBAT2_MAX_IRQ_B_SHIFT              7
#define PMU_AUXADC_LBAT2_VOLT_MIN_LSB_ADDR            PMU_AUXADC_LBAT2_5
#define PMU_AUXADC_LBAT2_VOLT_MIN_LSB_MASK            0xFF
#define PMU_AUXADC_LBAT2_VOLT_MIN_LSB_SHIFT           0
#define PMU_AUXADC_LBAT2_VOLT_MIN_MSB_ADDR            PMU_AUXADC_LBAT2_5_H
#define PMU_AUXADC_LBAT2_VOLT_MIN_MSB_MASK            0xF
#define PMU_AUXADC_LBAT2_VOLT_MIN_MSB_SHIFT           0
#define PMU_AUXADC_LBAT2_IRQ_EN_MIN_ADDR              PMU_AUXADC_LBAT2_5_H
#define PMU_AUXADC_LBAT2_IRQ_EN_MIN_MASK              0x1
#define PMU_AUXADC_LBAT2_IRQ_EN_MIN_SHIFT             4
#define PMU_AUXADC_LBAT2_EN_MIN_ADDR                  PMU_AUXADC_LBAT2_5_H
#define PMU_AUXADC_LBAT2_EN_MIN_MASK                  0x1
#define PMU_AUXADC_LBAT2_EN_MIN_SHIFT                 5
#define PMU_AUXADC_LBAT2_MIN_IRQ_B_ADDR               PMU_AUXADC_LBAT2_5_H
#define PMU_AUXADC_LBAT2_MIN_IRQ_B_MASK               0x1
#define PMU_AUXADC_LBAT2_MIN_IRQ_B_SHIFT              7
#define PMU_AUXADC_LBAT2_DEBOUNCE_COUNT_MAX_L_ADDR    PMU_AUXADC_LBAT2_6
#define PMU_AUXADC_LBAT2_DEBOUNCE_COUNT_MAX_L_MASK    0xFF
#define PMU_AUXADC_LBAT2_DEBOUNCE_COUNT_MAX_L_SHIFT   0
#define PMU_AUXADC_LBAT2_DEBOUNCE_COUNT_MAX_H_ADDR    PMU_AUXADC_LBAT2_6_H
#define PMU_AUXADC_LBAT2_DEBOUNCE_COUNT_MAX_H_MASK    0x1
#define PMU_AUXADC_LBAT2_DEBOUNCE_COUNT_MAX_H_SHIFT   0
#define PMU_AUXADC_LBAT2_DEBOUNCE_COUNT_MIN_L_ADDR    PMU_AUXADC_LBAT2_7
#define PMU_AUXADC_LBAT2_DEBOUNCE_COUNT_MIN_L_MASK    0xFF
#define PMU_AUXADC_LBAT2_DEBOUNCE_COUNT_MIN_L_SHIFT   0
#define PMU_AUXADC_LBAT2_DEBOUNCE_COUNT_MIN_H_ADDR    PMU_AUXADC_LBAT2_7_H
#define PMU_AUXADC_LBAT2_DEBOUNCE_COUNT_MIN_H_MASK    0x1
#define PMU_AUXADC_LBAT2_DEBOUNCE_COUNT_MIN_H_SHIFT   0
#define PMU_AUXADC_MDRT_DET_PRD_LSB_ADDR              PMU_AUXADC_MDRT_0
#define PMU_AUXADC_MDRT_DET_PRD_LSB_MASK              0xFF
#define PMU_AUXADC_MDRT_DET_PRD_LSB_SHIFT             0
#define PMU_AUXADC_MDRT_DET_PRD_MSB_ADDR              PMU_AUXADC_MDRT_0_H
#define PMU_AUXADC_MDRT_DET_PRD_MSB_MASK              0x3
#define PMU_AUXADC_MDRT_DET_PRD_MSB_SHIFT             0
#define PMU_AUXADC_MDRT_DET_EN_ADDR                   PMU_AUXADC_MDRT_0_H
#define PMU_AUXADC_MDRT_DET_EN_MASK                   0x1
#define PMU_AUXADC_MDRT_DET_EN_SHIFT                  7
#define PMU_AUXADC_MDRT_DET_WKUP_START_CNT_LSB_ADDR   PMU_AUXADC_MDRT_1
#define PMU_AUXADC_MDRT_DET_WKUP_START_CNT_LSB_MASK   0xFF
#define PMU_AUXADC_MDRT_DET_WKUP_START_CNT_LSB_SHIFT  0
#define PMU_AUXADC_MDRT_DET_WKUP_START_CNT_MSB_ADDR   PMU_AUXADC_MDRT_1_H
#define PMU_AUXADC_MDRT_DET_WKUP_START_CNT_MSB_MASK   0xF
#define PMU_AUXADC_MDRT_DET_WKUP_START_CNT_MSB_SHIFT  0
#define PMU_AUXADC_MDRT_DET_WKUP_START_CLR_ADDR       PMU_AUXADC_MDRT_1_H
#define PMU_AUXADC_MDRT_DET_WKUP_START_CLR_MASK       0x1
#define PMU_AUXADC_MDRT_DET_WKUP_START_CLR_SHIFT      7
#define PMU_AUXADC_MDRT_DET_WKUP_START_ADDR           PMU_AUXADC_MDRT_2
#define PMU_AUXADC_MDRT_DET_WKUP_START_MASK           0x1
#define PMU_AUXADC_MDRT_DET_WKUP_START_SHIFT          0
#define PMU_AUXADC_MDRT_DET_WKUP_START_SEL_ADDR       PMU_AUXADC_MDRT_2
#define PMU_AUXADC_MDRT_DET_WKUP_START_SEL_MASK       0x1
#define PMU_AUXADC_MDRT_DET_WKUP_START_SEL_SHIFT      1
#define PMU_AUXADC_MDRT_DET_WKUP_EN_ADDR              PMU_AUXADC_MDRT_2
#define PMU_AUXADC_MDRT_DET_WKUP_EN_MASK              0x1
#define PMU_AUXADC_MDRT_DET_WKUP_EN_SHIFT             2
#define PMU_AUXADC_MDRT_DET_SRCLKEN_IND_ADDR          PMU_AUXADC_MDRT_2
#define PMU_AUXADC_MDRT_DET_SRCLKEN_IND_MASK          0x1
#define PMU_AUXADC_MDRT_DET_SRCLKEN_IND_SHIFT         3
#define PMU_AUXADC_JEITA_DEBT_ADDR                    PMU_AUXADC_JEITA_0
#define PMU_AUXADC_JEITA_DEBT_MASK                    0xF
#define PMU_AUXADC_JEITA_DEBT_SHIFT                   0
#define PMU_AUXADC_JEITA_MIPI_DIS_ADDR                PMU_AUXADC_JEITA_0
#define PMU_AUXADC_JEITA_MIPI_DIS_MASK                0x1
#define PMU_AUXADC_JEITA_MIPI_DIS_SHIFT               4
#define PMU_AUXADC_JEITA_IRQ_EN_ADDR                  PMU_AUXADC_JEITA_0_H
#define PMU_AUXADC_JEITA_IRQ_EN_MASK                  0x1
#define PMU_AUXADC_JEITA_IRQ_EN_SHIFT                 0
#define PMU_AUXADC_JEITA_EN_ADDR                      PMU_AUXADC_JEITA_0_H
#define PMU_AUXADC_JEITA_EN_MASK                      0x1
#define PMU_AUXADC_JEITA_EN_SHIFT                     1
#define PMU_AUXADC_JEITA_DET_PRD_ADDR                 PMU_AUXADC_JEITA_0_H
#define PMU_AUXADC_JEITA_DET_PRD_MASK                 0xF
#define PMU_AUXADC_JEITA_DET_PRD_SHIFT                2
#define PMU_AUXADC_JEITA_VOLT_HOT_LSB_ADDR            PMU_AUXADC_JEITA_1
#define PMU_AUXADC_JEITA_VOLT_HOT_LSB_MASK            0xFF
#define PMU_AUXADC_JEITA_VOLT_HOT_LSB_SHIFT           0
#define PMU_AUXADC_JEITA_VOLT_HOT_MSB_ADDR            PMU_AUXADC_JEITA_1_H
#define PMU_AUXADC_JEITA_VOLT_HOT_MSB_MASK            0xF
#define PMU_AUXADC_JEITA_VOLT_HOT_MSB_SHIFT           0
#define PMU_AUXADC_JEITA_HOT_IRQ_ADDR                 PMU_AUXADC_JEITA_1_H
#define PMU_AUXADC_JEITA_HOT_IRQ_MASK                 0x1
#define PMU_AUXADC_JEITA_HOT_IRQ_SHIFT                7
#define PMU_AUXADC_JEITA_VOLT_WARM_LSB_ADDR           PMU_AUXADC_JEITA_2
#define PMU_AUXADC_JEITA_VOLT_WARM_LSB_MASK           0xFF
#define PMU_AUXADC_JEITA_VOLT_WARM_LSB_SHIFT          0
#define PMU_AUXADC_JEITA_VOLT_WARM_MSB_ADDR           PMU_AUXADC_JEITA_2_H
#define PMU_AUXADC_JEITA_VOLT_WARM_MSB_MASK           0xF
#define PMU_AUXADC_JEITA_VOLT_WARM_MSB_SHIFT          0
#define PMU_AUXADC_JEITA_WARM_IRQ_ADDR                PMU_AUXADC_JEITA_2_H
#define PMU_AUXADC_JEITA_WARM_IRQ_MASK                0x1
#define PMU_AUXADC_JEITA_WARM_IRQ_SHIFT               7
#define PMU_AUXADC_JEITA_VOLT_COOL_LSB_ADDR           PMU_AUXADC_JEITA_3
#define PMU_AUXADC_JEITA_VOLT_COOL_LSB_MASK           0xFF
#define PMU_AUXADC_JEITA_VOLT_COOL_LSB_SHIFT          0
#define PMU_AUXADC_JEITA_VOLT_COOL_MSB_ADDR           PMU_AUXADC_JEITA_3_H
#define PMU_AUXADC_JEITA_VOLT_COOL_MSB_MASK           0xF
#define PMU_AUXADC_JEITA_VOLT_COOL_MSB_SHIFT          0
#define PMU_AUXADC_JEITA_COOL_IRQ_ADDR                PMU_AUXADC_JEITA_3_H
#define PMU_AUXADC_JEITA_COOL_IRQ_MASK                0x1
#define PMU_AUXADC_JEITA_COOL_IRQ_SHIFT               7
#define PMU_AUXADC_JEITA_VOLT_COLD_LSB_ADDR           PMU_AUXADC_JEITA_4
#define PMU_AUXADC_JEITA_VOLT_COLD_LSB_MASK           0xFF
#define PMU_AUXADC_JEITA_VOLT_COLD_LSB_SHIFT          0
#define PMU_AUXADC_JEITA_VOLT_COLD_MSB_ADDR           PMU_AUXADC_JEITA_4_H
#define PMU_AUXADC_JEITA_VOLT_COLD_MSB_MASK           0xF
#define PMU_AUXADC_JEITA_VOLT_COLD_MSB_SHIFT          0
#define PMU_AUXADC_JEITA_COLD_IRQ_ADDR                PMU_AUXADC_JEITA_4_H
#define PMU_AUXADC_JEITA_COLD_IRQ_MASK                0x1
#define PMU_AUXADC_JEITA_COLD_IRQ_SHIFT               7
#define PMU_AUXADC_JEITA_DEBOUNCE_COUNT_WARM_ADDR     PMU_AUXADC_JEITA_5
#define PMU_AUXADC_JEITA_DEBOUNCE_COUNT_WARM_MASK     0xF
#define PMU_AUXADC_JEITA_DEBOUNCE_COUNT_WARM_SHIFT    0
#define PMU_AUXADC_JEITA_DEBOUNCE_COUNT_HOT_ADDR      PMU_AUXADC_JEITA_5
#define PMU_AUXADC_JEITA_DEBOUNCE_COUNT_HOT_MASK      0xF
#define PMU_AUXADC_JEITA_DEBOUNCE_COUNT_HOT_SHIFT     4
#define PMU_AUXADC_JEITA_DEBOUNCE_COUNT_COLD_ADDR     PMU_AUXADC_JEITA_5_H
#define PMU_AUXADC_JEITA_DEBOUNCE_COUNT_COLD_MASK     0xF
#define PMU_AUXADC_JEITA_DEBOUNCE_COUNT_COLD_SHIFT    0
#define PMU_AUXADC_JEITA_DEBOUNCE_COUNT_COOL_ADDR     PMU_AUXADC_JEITA_5_H
#define PMU_AUXADC_JEITA_DEBOUNCE_COUNT_COOL_MASK     0xF
#define PMU_AUXADC_JEITA_DEBOUNCE_COUNT_COOL_SHIFT    4
#define PMU_AUXADC_DCXO_MDRT_DET_PRD_LSB_ADDR         PMU_AUXADC_DCXO_MDRT_0
#define PMU_AUXADC_DCXO_MDRT_DET_PRD_LSB_MASK         0xF
#define PMU_AUXADC_DCXO_MDRT_DET_PRD_LSB_SHIFT        0
#define PMU_AUXADC_DCXO_MDRT_DET_EN_ADDR              PMU_AUXADC_DCXO_MDRT_0
#define PMU_AUXADC_DCXO_MDRT_DET_EN_MASK              0x1
#define PMU_AUXADC_DCXO_MDRT_DET_EN_SHIFT             7
#define PMU_AUXADC_DCXO_MDRT_DET_PRD_MSB_ADDR         PMU_AUXADC_DCXO_MDRT_0_H
#define PMU_AUXADC_DCXO_MDRT_DET_PRD_MSB_MASK         0x3F
#define PMU_AUXADC_DCXO_MDRT_DET_PRD_MSB_SHIFT        0
#define PMU_AUXADC_DCXO_MDRT_DET_WKUP_START_CNT_LSB_ADDR PMU_AUXADC_DCXO_MDRT_1
#define PMU_AUXADC_DCXO_MDRT_DET_WKUP_START_CNT_LSB_MASK 0xF
#define PMU_AUXADC_DCXO_MDRT_DET_WKUP_START_CNT_LSB_SHIFT 0
#define PMU_AUXADC_DCXO_MDRT_DET_WKUP_START_CLR_ADDR  PMU_AUXADC_DCXO_MDRT_1
#define PMU_AUXADC_DCXO_MDRT_DET_WKUP_START_CLR_MASK  0x1
#define PMU_AUXADC_DCXO_MDRT_DET_WKUP_START_CLR_SHIFT 7
#define PMU_AUXADC_DCXO_MDRT_DET_WKUP_START_CNT_MSB_ADDR PMU_AUXADC_DCXO_MDRT_1_H
#define PMU_AUXADC_DCXO_MDRT_DET_WKUP_START_CNT_MSB_MASK 0xFF
#define PMU_AUXADC_DCXO_MDRT_DET_WKUP_START_CNT_MSB_SHIFT 0
#define PMU_AUXADC_DCXO_MDRT_DET_WKUP_EN_ADDR         PMU_AUXADC_DCXO_MDRT_2
#define PMU_AUXADC_DCXO_MDRT_DET_WKUP_EN_MASK         0x1
#define PMU_AUXADC_DCXO_MDRT_DET_WKUP_EN_SHIFT        0
#define PMU_AUXADC_DCXO_MDRT_DET_WKUP_START_SEL_ADDR  PMU_AUXADC_DCXO_MDRT_2
#define PMU_AUXADC_DCXO_MDRT_DET_WKUP_START_SEL_MASK  0x1
#define PMU_AUXADC_DCXO_MDRT_DET_WKUP_START_SEL_SHIFT 1
#define PMU_AUXADC_DCXO_MDRT_DET_WKUP_START_ADDR      PMU_AUXADC_DCXO_MDRT_2
#define PMU_AUXADC_DCXO_MDRT_DET_WKUP_START_MASK      0x1
#define PMU_AUXADC_DCXO_MDRT_DET_WKUP_START_SHIFT     2
#define PMU_AUXADC_DCXO_MDRT_DET_SRCLKEN_IND_ADDR     PMU_AUXADC_DCXO_MDRT_2
#define PMU_AUXADC_DCXO_MDRT_DET_SRCLKEN_IND_MASK     0x1
#define PMU_AUXADC_DCXO_MDRT_DET_SRCLKEN_IND_SHIFT    3
#define PMU_AUXADC_DCXO_CH4_MUX_AP_SEL_ADDR           PMU_AUXADC_DCXO_MDRT_2
#define PMU_AUXADC_DCXO_CH4_MUX_AP_SEL_MASK           0x1
#define PMU_AUXADC_DCXO_CH4_MUX_AP_SEL_SHIFT          4
#define PMU_AUXADC_NAG_EN_ADDR                        PMU_AUXADC_NAG_0
#define PMU_AUXADC_NAG_EN_MASK                        0x1
#define PMU_AUXADC_NAG_EN_SHIFT                       0
#define PMU_AUXADC_NAG_CLR_ADDR                       PMU_AUXADC_NAG_0
#define PMU_AUXADC_NAG_CLR_MASK                       0x1
#define PMU_AUXADC_NAG_CLR_SHIFT                      1
#define PMU_AUXADC_NAG_VBAT1_SEL_ADDR                 PMU_AUXADC_NAG_0
#define PMU_AUXADC_NAG_VBAT1_SEL_MASK                 0x1
#define PMU_AUXADC_NAG_VBAT1_SEL_SHIFT                2
#define PMU_AUXADC_NAG_IRQ_EN_ADDR                    PMU_AUXADC_NAG_0
#define PMU_AUXADC_NAG_IRQ_EN_MASK                    0x1
#define PMU_AUXADC_NAG_IRQ_EN_SHIFT                   3
#define PMU_AUXADC_NAG_C_DLTV_IRQ_ADDR                PMU_AUXADC_NAG_0
#define PMU_AUXADC_NAG_C_DLTV_IRQ_MASK                0x1
#define PMU_AUXADC_NAG_C_DLTV_IRQ_SHIFT               4
#define PMU_AUXADC_NAG_PRD_ADDR                       PMU_AUXADC_NAG_0_H
#define PMU_AUXADC_NAG_PRD_MASK                       0x7F
#define PMU_AUXADC_NAG_PRD_SHIFT                      0
#define PMU_AUXADC_NAG_ZCV_LSB_ADDR                   PMU_AUXADC_NAG_1
#define PMU_AUXADC_NAG_ZCV_LSB_MASK                   0xFF
#define PMU_AUXADC_NAG_ZCV_LSB_SHIFT                  0
#define PMU_AUXADC_NAG_ZCV_MSB_ADDR                   PMU_AUXADC_NAG_1_H
#define PMU_AUXADC_NAG_ZCV_MSB_MASK                   0x7F
#define PMU_AUXADC_NAG_ZCV_MSB_SHIFT                  0
#define PMU_AUXADC_NAG_C_DLTV_TH_15_0_LSB_ADDR        PMU_AUXADC_NAG_2
#define PMU_AUXADC_NAG_C_DLTV_TH_15_0_LSB_MASK        0xFF
#define PMU_AUXADC_NAG_C_DLTV_TH_15_0_LSB_SHIFT       0
#define PMU_AUXADC_NAG_C_DLTV_TH_15_0_MSB_ADDR        PMU_AUXADC_NAG_2_H
#define PMU_AUXADC_NAG_C_DLTV_TH_15_0_MSB_MASK        0xFF
#define PMU_AUXADC_NAG_C_DLTV_TH_15_0_MSB_SHIFT       0
#define PMU_AUXADC_NAG_C_DLTV_TH_26_16_LSB_ADDR       PMU_AUXADC_NAG_3
#define PMU_AUXADC_NAG_C_DLTV_TH_26_16_LSB_MASK       0xFF
#define PMU_AUXADC_NAG_C_DLTV_TH_26_16_LSB_SHIFT      0
#define PMU_AUXADC_NAG_C_DLTV_TH_26_16_MSB_ADDR       PMU_AUXADC_NAG_3_H
#define PMU_AUXADC_NAG_C_DLTV_TH_26_16_MSB_MASK       0x7
#define PMU_AUXADC_NAG_C_DLTV_TH_26_16_MSB_SHIFT      0
#define PMU_AUXADC_NAG_CNT_15_0_L_ADDR                PMU_AUXADC_NAG_4
#define PMU_AUXADC_NAG_CNT_15_0_L_MASK                0xFF
#define PMU_AUXADC_NAG_CNT_15_0_L_SHIFT               0
#define PMU_AUXADC_NAG_CNT_15_0_H_ADDR                PMU_AUXADC_NAG_4_H
#define PMU_AUXADC_NAG_CNT_15_0_H_MASK                0xFF
#define PMU_AUXADC_NAG_CNT_15_0_H_SHIFT               0
#define PMU_AUXADC_NAG_CNT_25_16_L_ADDR               PMU_AUXADC_NAG_5
#define PMU_AUXADC_NAG_CNT_25_16_L_MASK               0xFF
#define PMU_AUXADC_NAG_CNT_25_16_L_SHIFT              0
#define PMU_AUXADC_NAG_CNT_25_16_H_ADDR               PMU_AUXADC_NAG_5_H
#define PMU_AUXADC_NAG_CNT_25_16_H_MASK               0x3
#define PMU_AUXADC_NAG_CNT_25_16_H_SHIFT              0
#define PMU_AUXADC_NAG_DLTV_L_ADDR                    PMU_AUXADC_NAG_6
#define PMU_AUXADC_NAG_DLTV_L_MASK                    0xFF
#define PMU_AUXADC_NAG_DLTV_L_SHIFT                   0
#define PMU_AUXADC_NAG_DLTV_H_ADDR                    PMU_AUXADC_NAG_6_H
#define PMU_AUXADC_NAG_DLTV_H_MASK                    0xFF
#define PMU_AUXADC_NAG_DLTV_H_SHIFT                   0
#define PMU_AUXADC_NAG_C_DLTV_15_0_L_ADDR             PMU_AUXADC_NAG_7
#define PMU_AUXADC_NAG_C_DLTV_15_0_L_MASK             0xFF
#define PMU_AUXADC_NAG_C_DLTV_15_0_L_SHIFT            0
#define PMU_AUXADC_NAG_C_DLTV_15_0_H_ADDR             PMU_AUXADC_NAG_7_H
#define PMU_AUXADC_NAG_C_DLTV_15_0_H_MASK             0xFF
#define PMU_AUXADC_NAG_C_DLTV_15_0_H_SHIFT            0
#define PMU_AUXADC_NAG_C_DLTV_26_16_L_ADDR            PMU_AUXADC_NAG_8
#define PMU_AUXADC_NAG_C_DLTV_26_16_L_MASK            0xFF
#define PMU_AUXADC_NAG_C_DLTV_26_16_L_SHIFT           0
#define PMU_AUXADC_NAG_C_DLTV_26_16_H_ADDR            PMU_AUXADC_NAG_8_H
#define PMU_AUXADC_NAG_C_DLTV_26_16_H_MASK            0x7
#define PMU_AUXADC_NAG_C_DLTV_26_16_H_SHIFT           0
#define PMU_RG_VBT_OC_DEB_LEN_ADDR                    PMU_VBTCTL1
#define PMU_RG_VBT_OC_DEB_LEN_MASK                    0x3
#define PMU_RG_VBT_OC_DEB_LEN_SHIFT                   0
#define PMU_RG_VBT_CAL_ADDR                           PMU_VBTLDO0
#define PMU_RG_VBT_CAL_MASK                           0xF
#define PMU_RG_VBT_CAL_SHIFT                          0
#define PMU_RG_VBT_VOSEL_ADDR                         PMU_VBTLDO1
#define PMU_RG_VBT_VOSEL_MASK                         0x7
#define PMU_RG_VBT_VOSEL_SHIFT                        0
#define PMU_RG_VBT_NDIS_EN_ADDR                       PMU_VBTLDO2
#define PMU_RG_VBT_NDIS_EN_MASK                       0x1
#define PMU_RG_VBT_NDIS_EN_SHIFT                      1
#define PMU_RG_VBT_RSV_ADDR                           PMU_VBTLDO2
#define PMU_RG_VBT_RSV_MASK                           0xF
#define PMU_RG_VBT_RSV_SHIFT                          2
#define PMU_RG_VBT_DUMMY1_ADDR                        PMU_VBTLDO3
#define PMU_RG_VBT_DUMMY1_MASK                        0x1
#define PMU_RG_VBT_DUMMY1_SHIFT                       0
#define PMU_RG_VBT_BUF_CAL_ADDR                       PMU_VBTLDOBF0
#define PMU_RG_VBT_BUF_CAL_MASK                       0xF
#define PMU_RG_VBT_BUF_CAL_SHIFT                      0
#define PMU_RG_VBT_COIN_SS_TRIM_BIAS_ADDR             PMU_VBTLDOBF0
#define PMU_RG_VBT_COIN_SS_TRIM_BIAS_MASK             0x7
#define PMU_RG_VBT_COIN_SS_TRIM_BIAS_SHIFT            4
#define PMU_RG_VBT_BUF_DUMMY0_ADDR                    PMU_VBTLDOBF1
#define PMU_RG_VBT_BUF_DUMMY0_MASK                    0x1
#define PMU_RG_VBT_BUF_DUMMY0_SHIFT                   0
#define PMU_RG_HP_VBT_PMOD_ADDR                       PMU_VBTPSI0
#define PMU_RG_HP_VBT_PMOD_MASK                       0x3
#define PMU_RG_HP_VBT_PMOD_SHIFT                      1
#define PMU_RG_LP_VBT_PMOD_ADDR                       PMU_VBTPSI0
#define PMU_RG_LP_VBT_PMOD_MASK                       0x3
#define PMU_RG_LP_VBT_PMOD_SHIFT                      5
#define PMU_RGS_S0_VBT_ON_ADDR                        PMU_VBTPSI1
#define PMU_RGS_S0_VBT_ON_MASK                        0x1
#define PMU_RGS_S0_VBT_ON_SHIFT                       0
#define PMU_RG_S0_VBT_PMOD_ADDR                       PMU_VBTPSI1
#define PMU_RG_S0_VBT_PMOD_MASK                       0x3
#define PMU_RG_S0_VBT_PMOD_SHIFT                      1
#define PMU_RGS_S1_VBT_ON_ADDR                        PMU_VBTPSI1
#define PMU_RGS_S1_VBT_ON_MASK                        0x1
#define PMU_RGS_S1_VBT_ON_SHIFT                       4
#define PMU_RG_S1_VBT_PMOD_ADDR                       PMU_VBTPSI1
#define PMU_RG_S1_VBT_PMOD_MASK                       0x3
#define PMU_RG_S1_VBT_PMOD_SHIFT                      5
#define PMU_RG_VA_OC_DEB_LEN_ADDR                     PMU_VACTL1
#define PMU_RG_VA_OC_DEB_LEN_MASK                     0x3
#define PMU_RG_VA_OC_DEB_LEN_SHIFT                    0
#define PMU_RG_VA_CAL_ADDR                            PMU_VALDO0
#define PMU_RG_VA_CAL_MASK                            0xF
#define PMU_RG_VA_CAL_SHIFT                           0
#define PMU_RG_VA_VOSEL_ADDR                          PMU_VALDO1
#define PMU_RG_VA_VOSEL_MASK                          0x7
#define PMU_RG_VA_VOSEL_SHIFT                         0
#define PMU_RG_VA_NDIS_EN_ADDR                        PMU_VALDO2
#define PMU_RG_VA_NDIS_EN_MASK                        0x1
#define PMU_RG_VA_NDIS_EN_SHIFT                       1
#define PMU_RG_VA_RSV_ADDR                            PMU_VALDO2
#define PMU_RG_VA_RSV_MASK                            0xF
#define PMU_RG_VA_RSV_SHIFT                           2
#define PMU_RG_VA_DUMMY0_ADDR                         PMU_VALDO3
#define PMU_RG_VA_DUMMY0_MASK                         0x1
#define PMU_RG_VA_DUMMY0_SHIFT                        0
#define PMU_RG_VA_BUF_CAL_ADDR                        PMU_VALDOBF0
#define PMU_RG_VA_BUF_CAL_MASK                        0xF
#define PMU_RG_VA_BUF_CAL_SHIFT                       0
#define PMU_RG_VA_COIN_SS_TRIM_BIAS_ADDR              PMU_VALDOBF0
#define PMU_RG_VA_COIN_SS_TRIM_BIAS_MASK              0x7
#define PMU_RG_VA_COIN_SS_TRIM_BIAS_SHIFT             4
#define PMU_RG_VA_BUF_DUMMY0_ADDR                     PMU_VALDOBF1
#define PMU_RG_VA_BUF_DUMMY0_MASK                     0x1
#define PMU_RG_VA_BUF_DUMMY0_SHIFT                    0
#define PMU_RG_HP_VA_PMOD_ADDR                        PMU_VAPSI0
#define PMU_RG_HP_VA_PMOD_MASK                        0x3
#define PMU_RG_HP_VA_PMOD_SHIFT                       1
#define PMU_RG_LP_VA_PMOD_ADDR                        PMU_VAPSI0
#define PMU_RG_LP_VA_PMOD_MASK                        0x3
#define PMU_RG_LP_VA_PMOD_SHIFT                       5
#define PMU_RGS_S0_VA_ON_ADDR                         PMU_VAPSI1
#define PMU_RGS_S0_VA_ON_MASK                         0x1
#define PMU_RGS_S0_VA_ON_SHIFT                        0
#define PMU_RG_S0_VA_PMOD_ADDR                        PMU_VAPSI1
#define PMU_RG_S0_VA_PMOD_MASK                        0x3
#define PMU_RG_S0_VA_PMOD_SHIFT                       1
#define PMU_RGS_S1_VA_ON_ADDR                         PMU_VAPSI1
#define PMU_RGS_S1_VA_ON_MASK                         0x1
#define PMU_RGS_S1_VA_ON_SHIFT                        4
#define PMU_RG_S1_VA_PMOD_ADDR                        PMU_VAPSI1
#define PMU_RG_S1_VA_PMOD_MASK                        0x3
#define PMU_RG_S1_VA_PMOD_SHIFT                       5
#define PMU_RG_VCAMA_EN_ADDR                          PMU_VCAMACTL0
#define PMU_RG_VCAMA_EN_MASK                          0x1
#define PMU_RG_VCAMA_EN_SHIFT                         0
#define PMU_RG_VCAMA_OCFB_EN_ADDR                     PMU_VCAMACTL0
#define PMU_RG_VCAMA_OCFB_EN_MASK                     0x1
#define PMU_RG_VCAMA_OCFB_EN_SHIFT                    1
#define PMU_RG_OVR_VCAMA_PMOD_ADDR                    PMU_VCAMACTL0
#define PMU_RG_OVR_VCAMA_PMOD_MASK                    0x3
#define PMU_RG_OVR_VCAMA_PMOD_SHIFT                   2
#define PMU_RG_VCAMA_STBTD_ADDR                       PMU_VCAMACTL0
#define PMU_RG_VCAMA_STBTD_MASK                       0x3
#define PMU_RG_VCAMA_STBTD_SHIFT                      4
#define PMU_RGS_VCAMA_STBSTS_ADDR                     PMU_VCAMACTL0
#define PMU_RGS_VCAMA_STBSTS_MASK                     0x1
#define PMU_RGS_VCAMA_STBSTS_SHIFT                    6
#define PMU_RG_VCAMA_OC_DEB_LEN_ADDR                  PMU_VCAMACTL1
#define PMU_RG_VCAMA_OC_DEB_LEN_MASK                  0x3
#define PMU_RG_VCAMA_OC_DEB_LEN_SHIFT                 0
#define PMU_RG_VCAMA_CAL_ADDR                         PMU_VCAMALDO0
#define PMU_RG_VCAMA_CAL_MASK                         0xF
#define PMU_RG_VCAMA_CAL_SHIFT                        0
#define PMU_RG_VCAMA_VOSEL_ADDR                       PMU_VCAMALDO1
#define PMU_RG_VCAMA_VOSEL_MASK                       0x7
#define PMU_RG_VCAMA_VOSEL_SHIFT                      0
#define PMU_RG_VCAMA_NDIS_EN_ADDR                     PMU_VCAMALDO2
#define PMU_RG_VCAMA_NDIS_EN_MASK                     0x1
#define PMU_RG_VCAMA_NDIS_EN_SHIFT                    1
#define PMU_RG_VCAMA_RSV_ADDR                         PMU_VCAMALDO2
#define PMU_RG_VCAMA_RSV_MASK                         0xF
#define PMU_RG_VCAMA_RSV_SHIFT                        2
#define PMU_RG_VCAMA_DUMMY0_ADDR                      PMU_VCAMALDO3
#define PMU_RG_VCAMA_DUMMY0_MASK                      0x1
#define PMU_RG_VCAMA_DUMMY0_SHIFT                     0
#define PMU_RG_VCAMA_BUF_CAL_ADDR                     PMU_VCAMALDOBF0
#define PMU_RG_VCAMA_BUF_CAL_MASK                     0xF
#define PMU_RG_VCAMA_BUF_CAL_SHIFT                    0
#define PMU_RG_VCAMA_COIN_SS_TRIM_BIAS_ADDR           PMU_VCAMALDOBF0
#define PMU_RG_VCAMA_COIN_SS_TRIM_BIAS_MASK           0x7
#define PMU_RG_VCAMA_COIN_SS_TRIM_BIAS_SHIFT          4
#define PMU_RG_VCAMA_BUF_DUMMY0_ADDR                  PMU_VCAMALDOBF1
#define PMU_RG_VCAMA_BUF_DUMMY0_MASK                  0x1
#define PMU_RG_VCAMA_BUF_DUMMY0_SHIFT                 0
#define PMU_RG_EFUSE_RSVED0_ADDR                      PMU_EFUSERSVED0
#define PMU_RG_EFUSE_RSVED0_MASK                      0xFF
#define PMU_RG_EFUSE_RSVED0_SHIFT                     0
#define PMU_RG_EFUSE_RSVED1_ADDR                      PMU_EFUSERSVED1
#define PMU_RG_EFUSE_RSVED1_MASK                      0x1F
#define PMU_RG_EFUSE_RSVED1_SHIFT                     0
#define PMU_RG_SWXM_EN_ADDR                           PMU_PSWCTL0
#define PMU_RG_SWXM_EN_MASK                           0x1
#define PMU_RG_SWXM_EN_SHIFT                          0
#define PMU_RG_SWDP_EN_ADDR                           PMU_PSWCTL0
#define PMU_RG_SWDP_EN_MASK                           0x1
#define PMU_RG_SWDP_EN_SHIFT                          1
#define PMU_RG_SWMP_EN_ADDR                           PMU_PSWCTL0
#define PMU_RG_SWMP_EN_MASK                           0x1
#define PMU_RG_SWMP_EN_SHIFT                          2
#define PMU_RG_SWXM_TRIM_BIAS_ADDR                    PMU_VIO18PSW0
#define PMU_RG_SWXM_TRIM_BIAS_MASK                    0x7
#define PMU_RG_SWXM_TRIM_BIAS_SHIFT                   5
#define PMU_RG_SWXM_NDIS_EN_ADDR                      PMU_VIO18PSW1
#define PMU_RG_SWXM_NDIS_EN_MASK                      0x1
#define PMU_RG_SWXM_NDIS_EN_SHIFT                     0
#define PMU_RG_SWXM_RSV_ADDR                          PMU_VIO18PSW1
#define PMU_RG_SWXM_RSV_MASK                          0x3
#define PMU_RG_SWXM_RSV_SHIFT                         1
#define PMU_RG_SWDP_TRIM_BIAS_ADDR                    PMU_VIO18PSW2
#define PMU_RG_SWDP_TRIM_BIAS_MASK                    0x7
#define PMU_RG_SWDP_TRIM_BIAS_SHIFT                   5
#define PMU_RG_SWDP_NDIS_EN_ADDR                      PMU_VIO18PSW3
#define PMU_RG_SWDP_NDIS_EN_MASK                      0x1
#define PMU_RG_SWDP_NDIS_EN_SHIFT                     0
#define PMU_RG_SWDP_RSV_ADDR                          PMU_VIO18PSW3
#define PMU_RG_SWDP_RSV_MASK                          0x3
#define PMU_RG_SWDP_RSV_SHIFT                         1
#define PMU_RGS_S0_SWXM_ON_ADDR                       PMU_SWIO18PSI
#define PMU_RGS_S0_SWXM_ON_MASK                       0x1
#define PMU_RGS_S0_SWXM_ON_SHIFT                      0
#define PMU_RGS_S1_SWXM_ON_ADDR                       PMU_SWIO18PSI
#define PMU_RGS_S1_SWXM_ON_MASK                       0x1
#define PMU_RGS_S1_SWXM_ON_SHIFT                      1
#define PMU_RGS_S0_SWDP_ON_ADDR                       PMU_SWIO18PSI
#define PMU_RGS_S0_SWDP_ON_MASK                       0x1
#define PMU_RGS_S0_SWDP_ON_SHIFT                      2
#define PMU_RGS_S1_SWDP_ON_ADDR                       PMU_SWIO18PSI
#define PMU_RGS_S1_SWDP_ON_MASK                       0x1
#define PMU_RGS_S1_SWDP_ON_SHIFT                      3
#define PMU_RG_SWMP_NDIS_EN_ADDR                      PMU_VIO28PSW0
#define PMU_RG_SWMP_NDIS_EN_MASK                      0x1
#define PMU_RG_SWMP_NDIS_EN_SHIFT                     0
#define PMU_RG_SWMP_RSV_ADDR                          PMU_VIO28PSW0
#define PMU_RG_SWMP_RSV_MASK                          0x3
#define PMU_RG_SWMP_RSV_SHIFT                         1
#define PMU_RG_SWMP_TRIM_BIAS_ADDR                    PMU_VIO28PSW0
#define PMU_RG_SWMP_TRIM_BIAS_MASK                    0x7
#define PMU_RG_SWMP_TRIM_BIAS_SHIFT                   5
#define PMU_RG_VIO28_OC_DEB_LEN_ADDR                  PMU_VIO28CTL1
#define PMU_RG_VIO28_OC_DEB_LEN_MASK                  0x3
#define PMU_RG_VIO28_OC_DEB_LEN_SHIFT                 0
#define PMU_RG_VIO28_CAL_E1_ADDR                      PMU_VIO28LDO0
#define PMU_RG_VIO28_CAL_E1_MASK                      0xF
#define PMU_RG_VIO28_CAL_E1_SHIFT                     0
#define PMU_RG_VIO28_VOSEL_E1_ADDR                    PMU_VIO28LDO1
#define PMU_RG_VIO28_VOSEL_E1_MASK                    0x1
#define PMU_RG_VIO28_VOSEL_E1_SHIFT                   0
#define PMU_RG_VIO28_NDIS_EN_ADDR                     PMU_VIO28LDO2
#define PMU_RG_VIO28_NDIS_EN_MASK                     0x1
#define PMU_RG_VIO28_NDIS_EN_SHIFT                    1
#define PMU_RG_VIO28_FT_EN_ADDR                       PMU_VIO28LDO2
#define PMU_RG_VIO28_FT_EN_MASK                       0x1
#define PMU_RG_VIO28_FT_EN_SHIFT                      2
#define PMU_RG_VIO28_RSV_ADDR                         PMU_VIO28LDO2
#define PMU_RG_VIO28_RSV_MASK                         0xF
#define PMU_RG_VIO28_RSV_SHIFT                        3
#define PMU_RG_VIO28_DUMMY0_ADDR                      PMU_VIO28LDO3
#define PMU_RG_VIO28_DUMMY0_MASK                      0x1
#define PMU_RG_VIO28_DUMMY0_SHIFT                     0
#define PMU_RG_VIO28_BUF_CAL_E1_ADDR                  PMU_VIO28LDOBF0
#define PMU_RG_VIO28_BUF_CAL_E1_MASK                  0xF
#define PMU_RG_VIO28_BUF_CAL_E1_SHIFT                 0
#define PMU_RG_VIO28_COIN_SS_TRIM_BIAS_ADDR           PMU_VIO28LDOBF0
#define PMU_RG_VIO28_COIN_SS_TRIM_BIAS_MASK           0x7
#define PMU_RG_VIO28_COIN_SS_TRIM_BIAS_SHIFT          4
#define PMU_RG_VIO28_BUF_DUMMY0_ADDR                  PMU_VIO28LDOBF1
#define PMU_RG_VIO28_BUF_DUMMY0_MASK                  0x1
#define PMU_RG_VIO28_BUF_DUMMY0_SHIFT                 0
#define PMU_RG_HP_VIO28_PMOD_E1_ADDR                  PMU_VIO28PSI0
#define PMU_RG_HP_VIO28_PMOD_E1_MASK                  0x3
#define PMU_RG_HP_VIO28_PMOD_E1_SHIFT                 1
#define PMU_RG_LP_VIO28_PMOD_E1_ADDR                  PMU_VIO28PSI0
#define PMU_RG_LP_VIO28_PMOD_E1_MASK                  0x3
#define PMU_RG_LP_VIO28_PMOD_E1_SHIFT                 5
#define PMU_RGS_S0_VIO28_ON_E1_ADDR                   PMU_VIO28PSI1
#define PMU_RGS_S0_VIO28_ON_E1_MASK                   0x1
#define PMU_RGS_S0_VIO28_ON_E1_SHIFT                  0
#define PMU_RG_S0_VIO28_PMOD_E1_ADDR                  PMU_VIO28PSI1
#define PMU_RG_S0_VIO28_PMOD_E1_MASK                  0x3
#define PMU_RG_S0_VIO28_PMOD_E1_SHIFT                 1
#define PMU_RGS_S1_VIO28_ON_E1_ADDR                   PMU_VIO28PSI1
#define PMU_RGS_S1_VIO28_ON_E1_MASK                   0x1
#define PMU_RGS_S1_VIO28_ON_E1_SHIFT                  4
#define PMU_RG_S1_VIO28_PMOD_E1_ADDR                  PMU_VIO28PSI1
#define PMU_RG_S1_VIO28_PMOD_E1_MASK                  0x3
#define PMU_RG_S1_VIO28_PMOD_E1_SHIFT                 5
#define PMU_RG_VMC_OC_DEB_LEN_ADDR                    PMU_VMCCTL1
#define PMU_RG_VMC_OC_DEB_LEN_MASK                    0x3
#define PMU_RG_VMC_OC_DEB_LEN_SHIFT                   0
#define PMU_RG_VMC_DMYLOAD_VAL_ADDR                   PMU_VMCCTL1
#define PMU_RG_VMC_DMYLOAD_VAL_MASK                   0x1F
#define PMU_RG_VMC_DMYLOAD_VAL_SHIFT                  2
#define PMU_RG_VMC_CAL_ADDR                           PMU_VMCLDO0
#define PMU_RG_VMC_CAL_MASK                           0xF
#define PMU_RG_VMC_CAL_SHIFT                          0
#define PMU_RG_VMC_VOSEL_ADDR                         PMU_VMCLDO1
#define PMU_RG_VMC_VOSEL_MASK                         0x3
#define PMU_RG_VMC_VOSEL_SHIFT                        0
#define PMU_RG_VMC_NDIS_EN_ADDR                       PMU_VMCLDO2
#define PMU_RG_VMC_NDIS_EN_MASK                       0x1
#define PMU_RG_VMC_NDIS_EN_SHIFT                      1
#define PMU_RG_VMC_DUMMYLOAD_EN_ADDR                  PMU_VMCLDO2
#define PMU_RG_VMC_DUMMYLOAD_EN_MASK                  0x1
#define PMU_RG_VMC_DUMMYLOAD_EN_SHIFT                 2
#define PMU_RG_VMC_FT_EN_ADDR                         PMU_VMCLDO2
#define PMU_RG_VMC_FT_EN_MASK                         0x1
#define PMU_RG_VMC_FT_EN_SHIFT                        3
#define PMU_RG_VMC_RSV_ADDR                           PMU_VMCLDO2
#define PMU_RG_VMC_RSV_MASK                           0x3
#define PMU_RG_VMC_RSV_SHIFT                          4
#define PMU_RG_VMC_DUMMY0_ADDR                        PMU_VMCLDO3
#define PMU_RG_VMC_DUMMY0_MASK                        0x1
#define PMU_RG_VMC_DUMMY0_SHIFT                       0
#define PMU_RG_VMC_BUF_CAL_ADDR                       PMU_VMCLDOBF0
#define PMU_RG_VMC_BUF_CAL_MASK                       0xF
#define PMU_RG_VMC_BUF_CAL_SHIFT                      0
#define PMU_RG_VMC_COIN_SS_TRIM_BIAS_ADDR             PMU_VMCLDOBF0
#define PMU_RG_VMC_COIN_SS_TRIM_BIAS_MASK             0x7
#define PMU_RG_VMC_COIN_SS_TRIM_BIAS_SHIFT            4
#define PMU_RG_VMC_OC_TRIM_LSB_ADDR                   PMU_VMCLDOBF0
#define PMU_RG_VMC_OC_TRIM_LSB_MASK                   0x1
#define PMU_RG_VMC_OC_TRIM_LSB_SHIFT                  7
#define PMU_RG_VMC_OC_TRIM_MSB_ADDR                   PMU_VMCLDOBF1
#define PMU_RG_VMC_OC_TRIM_MSB_MASK                   0x1F
#define PMU_RG_VMC_OC_TRIM_MSB_SHIFT                  0
#define PMU_RG_HP_VMC_PMOD_ADDR                       PMU_VMCPSI0
#define PMU_RG_HP_VMC_PMOD_MASK                       0x3
#define PMU_RG_HP_VMC_PMOD_SHIFT                      1
#define PMU_RG_LP_VMC_PMOD_ADDR                       PMU_VMCPSI0
#define PMU_RG_LP_VMC_PMOD_MASK                       0x3
#define PMU_RG_LP_VMC_PMOD_SHIFT                      5
#define PMU_RGS_S0_VMC_ON_ADDR                        PMU_VMCPSI1
#define PMU_RGS_S0_VMC_ON_MASK                        0x1
#define PMU_RGS_S0_VMC_ON_SHIFT                       0
#define PMU_RG_S0_VMC_PMOD_ADDR                       PMU_VMCPSI1
#define PMU_RG_S0_VMC_PMOD_MASK                       0x3
#define PMU_RG_S0_VMC_PMOD_SHIFT                      1
#define PMU_RGS_S1_VMC_ON_ADDR                        PMU_VMCPSI1
#define PMU_RGS_S1_VMC_ON_MASK                        0x1
#define PMU_RGS_S1_VMC_ON_SHIFT                       4
#define PMU_RG_S1_VMC_PMOD_ADDR                       PMU_VMCPSI1
#define PMU_RG_S1_VMC_PMOD_MASK                       0x3
#define PMU_RG_S1_VMC_PMOD_SHIFT                      5
#define PMU_RG_VIBR_EN_ADDR                           PMU_VIBRCTL0
#define PMU_RG_VIBR_EN_MASK                           0x1
#define PMU_RG_VIBR_EN_SHIFT                          0
#define PMU_RG_VIBR_OCFB_EN_ADDR                      PMU_VIBRCTL0
#define PMU_RG_VIBR_OCFB_EN_MASK                      0x1
#define PMU_RG_VIBR_OCFB_EN_SHIFT                     1
#define PMU_RG_OVR_VIBR_PMOD_ADDR                     PMU_VIBRCTL0
#define PMU_RG_OVR_VIBR_PMOD_MASK                     0x3
#define PMU_RG_OVR_VIBR_PMOD_SHIFT                    2
#define PMU_RG_VIBR_STBTD_ADDR                        PMU_VIBRCTL0
#define PMU_RG_VIBR_STBTD_MASK                        0x3
#define PMU_RG_VIBR_STBTD_SHIFT                       4
#define PMU_RGS_VIBR_STBSTS_ADDR                      PMU_VIBRCTL0
#define PMU_RGS_VIBR_STBSTS_MASK                      0x1
#define PMU_RGS_VIBR_STBSTS_SHIFT                     6
#define PMU_RG_VIBR_OC_DEB_LEN_ADDR                   PMU_VIBRCTL1
#define PMU_RG_VIBR_OC_DEB_LEN_MASK                   0x3
#define PMU_RG_VIBR_OC_DEB_LEN_SHIFT                  0
#define PMU_RG_VIBR_CAL_ADDR                          PMU_VIBRLDO0
#define PMU_RG_VIBR_CAL_MASK                          0xF
#define PMU_RG_VIBR_CAL_SHIFT                         0
#define PMU_RG_VIBR_VOSEL_ADDR                        PMU_VIBRLDO1
#define PMU_RG_VIBR_VOSEL_MASK                        0x7
#define PMU_RG_VIBR_VOSEL_SHIFT                       0
#define PMU_RG_VIBR_NDIS_EN_ADDR                      PMU_VIBRLDO2
#define PMU_RG_VIBR_NDIS_EN_MASK                      0x1
#define PMU_RG_VIBR_NDIS_EN_SHIFT                     1
#define PMU_RG_VIBR_FT_EN_ADDR                        PMU_VIBRLDO2
#define PMU_RG_VIBR_FT_EN_MASK                        0x1
#define PMU_RG_VIBR_FT_EN_SHIFT                       2
#define PMU_RG_VIBR_RSV_ADDR                          PMU_VIBRLDO2
#define PMU_RG_VIBR_RSV_MASK                          0xF
#define PMU_RG_VIBR_RSV_SHIFT                         3
#define PMU_RG_VIBR_DUMMY0_ADDR                       PMU_VIBRLDO3
#define PMU_RG_VIBR_DUMMY0_MASK                       0x1
#define PMU_RG_VIBR_DUMMY0_SHIFT                      0
#define PMU_RG_VIBR_BUF_CAL_ADDR                      PMU_VIBRLDOBF0
#define PMU_RG_VIBR_BUF_CAL_MASK                      0xF
#define PMU_RG_VIBR_BUF_CAL_SHIFT                     0
#define PMU_RG_VIBR_COIN_SS_TRIM_BIAS_ADDR            PMU_VIBRLDOBF0
#define PMU_RG_VIBR_COIN_SS_TRIM_BIAS_MASK            0x7
#define PMU_RG_VIBR_COIN_SS_TRIM_BIAS_SHIFT           4
#define PMU_RG_VIBR_BUF_DUMMY0_ADDR                   PMU_VIBRLDOBF1
#define PMU_RG_VIBR_BUF_DUMMY0_MASK                   0x3
#define PMU_RG_VIBR_BUF_DUMMY0_SHIFT                  0
#define PMU_ISINK_DIM0_FSEL_L_ADDR                    PMU_ISINK0_CON0
#define PMU_ISINK_DIM0_FSEL_L_MASK                    0xFF
#define PMU_ISINK_DIM0_FSEL_L_SHIFT                   0
#define PMU_ISINK_DIM0_FSEL_H_ADDR                    PMU_ISINK0_CON1
#define PMU_ISINK_DIM0_FSEL_H_MASK                    0xFF
#define PMU_ISINK_DIM0_FSEL_H_SHIFT                   0
#define PMU_ISINK_DIM0_DUTY_ADDR                      PMU_ISINK0_CON2
#define PMU_ISINK_DIM0_DUTY_MASK                      0x1F
#define PMU_ISINK_DIM0_DUTY_SHIFT                     0
#define PMU_ISINK_CH0_STEP_ADDR                       PMU_ISINK0_CON2
#define PMU_ISINK_CH0_STEP_MASK                       0x7
#define PMU_ISINK_CH0_STEP_SHIFT                      5
#define PMU_ISINK0_RSV1_ADDR                          PMU_ISINK0_CON3
#define PMU_ISINK0_RSV1_MASK                          0xF
#define PMU_ISINK0_RSV1_SHIFT                         0
#define PMU_ISINK0_RSV0_ADDR                          PMU_ISINK0_CON3
#define PMU_ISINK0_RSV0_MASK                          0xF
#define PMU_ISINK0_RSV0_SHIFT                         4
#define PMU_ISINK_BREATH0_TR2_SEL_ADDR                PMU_ISINK0_CON4
#define PMU_ISINK_BREATH0_TR2_SEL_MASK                0xF
#define PMU_ISINK_BREATH0_TR2_SEL_SHIFT               0
#define PMU_ISINK_BREATH0_TR1_SEL_ADDR                PMU_ISINK0_CON4
#define PMU_ISINK_BREATH0_TR1_SEL_MASK                0xF
#define PMU_ISINK_BREATH0_TR1_SEL_SHIFT               4
#define PMU_ISINK_BREATH0_TF2_SEL_ADDR                PMU_ISINK0_CON5
#define PMU_ISINK_BREATH0_TF2_SEL_MASK                0xF
#define PMU_ISINK_BREATH0_TF2_SEL_SHIFT               0
#define PMU_ISINK_BREATH0_TF1_SEL_ADDR                PMU_ISINK0_CON5
#define PMU_ISINK_BREATH0_TF1_SEL_MASK                0xF
#define PMU_ISINK_BREATH0_TF1_SEL_SHIFT               4
#define PMU_ISINK_BREATH0_TOFF_SEL_ADDR               PMU_ISINK0_CON6
#define PMU_ISINK_BREATH0_TOFF_SEL_MASK               0xF
#define PMU_ISINK_BREATH0_TOFF_SEL_SHIFT              0
#define PMU_ISINK_BREATH0_TON_SEL_ADDR                PMU_ISINK0_CON6
#define PMU_ISINK_BREATH0_TON_SEL_MASK                0xF
#define PMU_ISINK_BREATH0_TON_SEL_SHIFT               4
#define PMU_ISINK_DIM1_FSEL_L_ADDR                    PMU_ISINK1_CON0
#define PMU_ISINK_DIM1_FSEL_L_MASK                    0xFF
#define PMU_ISINK_DIM1_FSEL_L_SHIFT                   0
#define PMU_ISINK_DIM1_FSEL_H_ADDR                    PMU_ISINK1_CON1
#define PMU_ISINK_DIM1_FSEL_H_MASK                    0xFF
#define PMU_ISINK_DIM1_FSEL_H_SHIFT                   0
#define PMU_ISINK_DIM1_DUTY_ADDR                      PMU_ISINK1_CON2
#define PMU_ISINK_DIM1_DUTY_MASK                      0x1F
#define PMU_ISINK_DIM1_DUTY_SHIFT                     0
#define PMU_ISINK_CH1_STEP_ADDR                       PMU_ISINK1_CON2
#define PMU_ISINK_CH1_STEP_MASK                       0x7
#define PMU_ISINK_CH1_STEP_SHIFT                      5
#define PMU_ISINK1_RSV1_ADDR                          PMU_ISINK1_CON3
#define PMU_ISINK1_RSV1_MASK                          0xF
#define PMU_ISINK1_RSV1_SHIFT                         0
#define PMU_ISINK1_RSV0_ADDR                          PMU_ISINK1_CON3
#define PMU_ISINK1_RSV0_MASK                          0xF
#define PMU_ISINK1_RSV0_SHIFT                         4
#define PMU_ISINK_BREATH1_TR2_SEL_ADDR                PMU_ISINK1_CON4
#define PMU_ISINK_BREATH1_TR2_SEL_MASK                0xF
#define PMU_ISINK_BREATH1_TR2_SEL_SHIFT               0
#define PMU_ISINK_BREATH1_TR1_SEL_ADDR                PMU_ISINK1_CON4
#define PMU_ISINK_BREATH1_TR1_SEL_MASK                0xF
#define PMU_ISINK_BREATH1_TR1_SEL_SHIFT               4
#define PMU_ISINK_BREATH1_TF2_SEL_ADDR                PMU_ISINK1_CON5
#define PMU_ISINK_BREATH1_TF2_SEL_MASK                0xF
#define PMU_ISINK_BREATH1_TF2_SEL_SHIFT               0
#define PMU_ISINK_BREATH1_TF1_SEL_ADDR                PMU_ISINK1_CON5
#define PMU_ISINK_BREATH1_TF1_SEL_MASK                0xF
#define PMU_ISINK_BREATH1_TF1_SEL_SHIFT               4
#define PMU_ISINK_BREATH1_TOFF_SEL_ADDR               PMU_ISINK1_CON6
#define PMU_ISINK_BREATH1_TOFF_SEL_MASK               0xF
#define PMU_ISINK_BREATH1_TOFF_SEL_SHIFT              0
#define PMU_ISINK_BREATH1_TON_SEL_ADDR                PMU_ISINK1_CON6
#define PMU_ISINK_BREATH1_TON_SEL_MASK                0xF
#define PMU_ISINK_BREATH1_TON_SEL_SHIFT               4
#define PMU_ISINK_CH2_STEP_ADDR                       PMU_ISINK2_CON1
#define PMU_ISINK_CH2_STEP_MASK                       0x7
#define PMU_ISINK_CH2_STEP_SHIFT                      5
#define PMU_ISINK2_RSV1_ADDR                          PMU_ISINK2_CON2
#define PMU_ISINK2_RSV1_MASK                          0xF
#define PMU_ISINK2_RSV1_SHIFT                         0
#define PMU_ISINK2_RSV0_ADDR                          PMU_ISINK2_CON2
#define PMU_ISINK2_RSV0_MASK                          0xF
#define PMU_ISINK2_RSV0_SHIFT                         4
#define PMU_ISINK_CH3_STEP_ADDR                       PMU_ISINK3_CON1
#define PMU_ISINK_CH3_STEP_MASK                       0x7
#define PMU_ISINK_CH3_STEP_SHIFT                      5
#define PMU_ISINK3_RSV1_ADDR                          PMU_ISINK3_CON2
#define PMU_ISINK3_RSV1_MASK                          0xF
#define PMU_ISINK3_RSV1_SHIFT                         0
#define PMU_ISINK3_RSV0_ADDR                          PMU_ISINK3_CON2
#define PMU_ISINK3_RSV0_MASK                          0xF
#define PMU_ISINK3_RSV0_SHIFT                         4
#define PMU_RG_ISINKS_RSV_ADDR                        PMU_ISINK_ANA0_l
#define PMU_RG_ISINKS_RSV_MASK                        0xF
#define PMU_RG_ISINKS_RSV_SHIFT                       0
#define PMU_RG_ISINK0_DOUBLE_ADDR                     PMU_ISINK_ANA0_H
#define PMU_RG_ISINK0_DOUBLE_MASK                     0x1
#define PMU_RG_ISINK0_DOUBLE_SHIFT                    0
#define PMU_RG_ISINK1_DOUBLE_ADDR                     PMU_ISINK_ANA0_H
#define PMU_RG_ISINK1_DOUBLE_MASK                     0x1
#define PMU_RG_ISINK1_DOUBLE_SHIFT                    1
#define PMU_RG_TRIM_SEL_ADDR                          PMU_ISINK_ANA0_H
#define PMU_RG_TRIM_SEL_MASK                          0x7
#define PMU_RG_TRIM_SEL_SHIFT                         4
#define PMU_RG_TRIM_EN_ADDR                           PMU_ISINK_ANA0_H
#define PMU_RG_TRIM_EN_MASK                           0x1
#define PMU_RG_TRIM_EN_SHIFT                          7
#define PMU_NI_ISINK3_STATUS_ADDR                     PMU_ISINK_ANA1
#define PMU_NI_ISINK3_STATUS_MASK                     0x1
#define PMU_NI_ISINK3_STATUS_SHIFT                    0
#define PMU_NI_ISINK2_STATUS_ADDR                     PMU_ISINK_ANA1
#define PMU_NI_ISINK2_STATUS_MASK                     0x1
#define PMU_NI_ISINK2_STATUS_SHIFT                    1
#define PMU_NI_ISINK1_STATUS_ADDR                     PMU_ISINK_ANA1
#define PMU_NI_ISINK1_STATUS_MASK                     0x1
#define PMU_NI_ISINK1_STATUS_SHIFT                    2
#define PMU_NI_ISINK0_STATUS_ADDR                     PMU_ISINK_ANA1
#define PMU_NI_ISINK0_STATUS_MASK                     0x1
#define PMU_NI_ISINK0_STATUS_SHIFT                    3
#define PMU_ISINK_PHASE_DLY0_EN_ADDR                  PMU_ISINK_PHASE_DLY_L
#define PMU_ISINK_PHASE_DLY0_EN_MASK                  0x1
#define PMU_ISINK_PHASE_DLY0_EN_SHIFT                 0
#define PMU_ISINK_PHASE_DLY1_EN_ADDR                  PMU_ISINK_PHASE_DLY_L
#define PMU_ISINK_PHASE_DLY1_EN_MASK                  0x1
#define PMU_ISINK_PHASE_DLY1_EN_SHIFT                 1
#define PMU_ISINK_PHASE_DLY_TC_ADDR                   PMU_ISINK_PHASE_DLY_L
#define PMU_ISINK_PHASE_DLY_TC_MASK                   0x3
#define PMU_ISINK_PHASE_DLY_TC_SHIFT                  4
#define PMU_ISINK_CHOP0_SW_ADDR                       PMU_ISINK_PHASE_DLY_H
#define PMU_ISINK_CHOP0_SW_MASK                       0x1
#define PMU_ISINK_CHOP0_SW_SHIFT                      4
#define PMU_ISINK_CHOP1_SW_ADDR                       PMU_ISINK_PHASE_DLY_H
#define PMU_ISINK_CHOP1_SW_MASK                       0x1
#define PMU_ISINK_CHOP1_SW_SHIFT                      5
#define PMU_ISINK_CHOP2_SW_ADDR                       PMU_ISINK_PHASE_DLY_H
#define PMU_ISINK_CHOP2_SW_MASK                       0x1
#define PMU_ISINK_CHOP2_SW_SHIFT                      6
#define PMU_ISINK_CHOP3_SW_ADDR                       PMU_ISINK_PHASE_DLY_H
#define PMU_ISINK_CHOP3_SW_MASK                       0x1
#define PMU_ISINK_CHOP3_SW_SHIFT                      7
#define PMU_ISINK_SFSTR1_EN_ADDR                      PMU_ISINK_SFSTR
#define PMU_ISINK_SFSTR1_EN_MASK                      0x1
#define PMU_ISINK_SFSTR1_EN_SHIFT                     0
#define PMU_ISINK_SFSTR1_TC_ADDR                      PMU_ISINK_SFSTR
#define PMU_ISINK_SFSTR1_TC_MASK                      0x3
#define PMU_ISINK_SFSTR1_TC_SHIFT                     1
#define PMU_ISINK_SFSTR0_EN_ADDR                      PMU_ISINK_SFSTR
#define PMU_ISINK_SFSTR0_EN_MASK                      0x1
#define PMU_ISINK_SFSTR0_EN_SHIFT                     4
#define PMU_ISINK_SFSTR0_TC_ADDR                      PMU_ISINK_SFSTR
#define PMU_ISINK_SFSTR0_TC_MASK                      0x3
#define PMU_ISINK_SFSTR0_TC_SHIFT                     5
#define PMU_ISINK_CH0_EN_ADDR                         PMU_ISINK_EN_CTRL_Low
#define PMU_ISINK_CH0_EN_MASK                         0x1
#define PMU_ISINK_CH0_EN_SHIFT                        0
#define PMU_ISINK_CH1_EN_ADDR                         PMU_ISINK_EN_CTRL_Low
#define PMU_ISINK_CH1_EN_MASK                         0x1
#define PMU_ISINK_CH1_EN_SHIFT                        1
#define PMU_ISINK_CH2_EN_ADDR                         PMU_ISINK_EN_CTRL_Low
#define PMU_ISINK_CH2_EN_MASK                         0x1
#define PMU_ISINK_CH2_EN_SHIFT                        2
#define PMU_ISINK_CH3_EN_ADDR                         PMU_ISINK_EN_CTRL_Low
#define PMU_ISINK_CH3_EN_MASK                         0x1
#define PMU_ISINK_CH3_EN_SHIFT                        3
#define PMU_RG_ISINK0_CHOP_EN_ADDR                    PMU_ISINK_EN_CTRL_Low
#define PMU_RG_ISINK0_CHOP_EN_MASK                    0x1
#define PMU_RG_ISINK0_CHOP_EN_SHIFT                   4
#define PMU_RG_ISINK1_CHOP_EN_ADDR                    PMU_ISINK_EN_CTRL_Low
#define PMU_RG_ISINK1_CHOP_EN_MASK                    0x1
#define PMU_RG_ISINK1_CHOP_EN_SHIFT                   5
#define PMU_RG_ISINK2_CHOP_EN_ADDR                    PMU_ISINK_EN_CTRL_Low
#define PMU_RG_ISINK2_CHOP_EN_MASK                    0x1
#define PMU_RG_ISINK2_CHOP_EN_SHIFT                   6
#define PMU_RG_ISINK3_CHOP_EN_ADDR                    PMU_ISINK_EN_CTRL_Low
#define PMU_RG_ISINK3_CHOP_EN_MASK                    0x1
#define PMU_RG_ISINK3_CHOP_EN_SHIFT                   7
#define PMU_ISINK_CH0_BIAS_EN_ADDR                    PMU_ISINK_EN_CTRL_High
#define PMU_ISINK_CH0_BIAS_EN_MASK                    0x1
#define PMU_ISINK_CH0_BIAS_EN_SHIFT                   0
#define PMU_ISINK_CH1_BIAS_EN_ADDR                    PMU_ISINK_EN_CTRL_High
#define PMU_ISINK_CH1_BIAS_EN_MASK                    0x1
#define PMU_ISINK_CH1_BIAS_EN_SHIFT                   1
#define PMU_ISINK_CH2_BIAS_EN_ADDR                    PMU_ISINK_EN_CTRL_High
#define PMU_ISINK_CH2_BIAS_EN_MASK                    0x1
#define PMU_ISINK_CH2_BIAS_EN_SHIFT                   2
#define PMU_ISINK_CH3_BIAS_EN_ADDR                    PMU_ISINK_EN_CTRL_High
#define PMU_ISINK_CH3_BIAS_EN_MASK                    0x1
#define PMU_ISINK_CH3_BIAS_EN_SHIFT                   3
#define PMU_ISINK_RSV_ADDR                            PMU_ISINK_MODE_CTRL
#define PMU_ISINK_RSV_MASK                            0xF
#define PMU_ISINK_RSV_SHIFT                           0
#define PMU_ISINK_CH1_MODE_ADDR                       PMU_ISINK_MODE_CTRL
#define PMU_ISINK_CH1_MODE_MASK                       0x3
#define PMU_ISINK_CH1_MODE_SHIFT                      4
#define PMU_ISINK_CH0_MODE_ADDR                       PMU_ISINK_MODE_CTRL
#define PMU_ISINK_CH0_MODE_MASK                       0x3
#define PMU_ISINK_CH0_MODE_SHIFT                      6
#define PMU_TST_W_KEY0_ADDR                           PMU_TSTWKEY0
#define PMU_TST_W_KEY0_MASK                           0xFF
#define PMU_TST_W_KEY0_SHIFT                          0
#define PMU_TST_W_KEY1_ADDR                           PMU_TSTWKEY1
#define PMU_TST_W_KEY1_MASK                           0xFF
#define PMU_TST_W_KEY1_SHIFT                          0
#define PMU_RG_RTC_TEST_MODE_ADDR                     PMU_TOPTST0
#define PMU_RG_RTC_TEST_MODE_MASK                     0x1
#define PMU_RG_RTC_TEST_MODE_SHIFT                    0
#define PMU_RG_AUXADC_TEST_MODE_ADDR                  PMU_TOPTST0
#define PMU_RG_AUXADC_TEST_MODE_MASK                  0x1
#define PMU_RG_AUXADC_TEST_MODE_SHIFT                 1
#define PMU_RG_PCHR_TEST_MODE_ADDR                    PMU_TOPTST0
#define PMU_RG_PCHR_TEST_MODE_MASK                    0x1
#define PMU_RG_PCHR_TEST_MODE_SHIFT                   2
#define PMU_RG_DEBUG_MODE_ADDR                        PMU_TOPTST0
#define PMU_RG_DEBUG_MODE_MASK                        0x1
#define PMU_RG_DEBUG_MODE_SHIFT                       3
#define PMU_RG_EFUSE_W_MODE_ADDR                      PMU_TOPTST0
#define PMU_RG_EFUSE_W_MODE_MASK                      0x1
#define PMU_RG_EFUSE_W_MODE_SHIFT                     4
#define PMU_RG_NANDTREE_MODE_ADDR                     PMU_TOPTST0
#define PMU_RG_NANDTREE_MODE_MASK                     0x1
#define PMU_RG_NANDTREE_MODE_SHIFT                    5
#define PMU_RG_ATST_SMPS_CLK_EN_ADDR                  PMU_TOPTST0
#define PMU_RG_ATST_SMPS_CLK_EN_MASK                  0x1
#define PMU_RG_ATST_SMPS_CLK_EN_SHIFT                 6
#define PMU_RG_ATST_PMU_CLK32K_EN_ADDR                PMU_TOPTST0
#define PMU_RG_ATST_PMU_CLK32K_EN_MASK                0x1
#define PMU_RG_ATST_PMU_CLK32K_EN_SHIFT               7
#define PMU_RG_SW_PSI0B_ADDR                          PMU_TOPTST1
#define PMU_RG_SW_PSI0B_MASK                          0x3
#define PMU_RG_SW_PSI0B_SHIFT                         0
#define PMU_RG_SW_PSI1B_ADDR                          PMU_TOPTST1
#define PMU_RG_SW_PSI1B_MASK                          0x3
#define PMU_RG_SW_PSI1B_SHIFT                         2
#define PMU_RG_ATST_RTCMISC_CLK_EN_ADDR               PMU_TOPTST1
#define PMU_RG_ATST_RTCMISC_CLK_EN_MASK               0x1
#define PMU_RG_ATST_RTCMISC_CLK_EN_SHIFT              4
#define PMU_RG_ATST_MON_OUT_EN_ADDR                   PMU_TOPTST1
#define PMU_RG_ATST_MON_OUT_EN_MASK                   0x1
#define PMU_RG_ATST_MON_OUT_EN_SHIFT                  5
#define PMU_RG_ATPG_INC_OB_ADDR                       PMU_TOPTST1
#define PMU_RG_ATPG_INC_OB_MASK                       0x1
#define PMU_RG_ATPG_INC_OB_SHIFT                      6
#define PMU_RG_ATPG_INC_CT_ADDR                       PMU_TOPTST1
#define PMU_RG_ATPG_INC_CT_MASK                       0x1
#define PMU_RG_ATPG_INC_CT_SHIFT                      7
#define PMU_RG_VIOPG_SWCTL_ADDR                       PMU_PPCTST1
#define PMU_RG_VIOPG_SWCTL_MASK                       0x1
#define PMU_RG_VIOPG_SWCTL_SHIFT                      0
#define PMU_RG_SWBAT_SWCTL_ADDR                       PMU_PPCTST1
#define PMU_RG_SWBAT_SWCTL_MASK                       0x1
#define PMU_RG_SWBAT_SWCTL_SHIFT                      1
#define PMU_RG_IVGEN_SWCTL_ADDR                       PMU_PPCTST1
#define PMU_RG_IVGEN_SWCTL_MASK                       0x1
#define PMU_RG_IVGEN_SWCTL_SHIFT                      2
#define PMU_RG_OSCEN_SWCTL_ADDR                       PMU_PPCTST1
#define PMU_RG_OSCEN_SWCTL_MASK                       0x1
#define PMU_RG_OSCEN_SWCTL_SHIFT                      3
#define PMU_RG_BGP_ULP_SWCTL_ADDR                     PMU_PPCTST1
#define PMU_RG_BGP_ULP_SWCTL_MASK                     0x1
#define PMU_RG_BGP_ULP_SWCTL_SHIFT                    4
#define PMU_RG_SYSRSTB_SWCTL_ADDR                     PMU_PPCTST1
#define PMU_RG_SYSRSTB_SWCTL_MASK                     0x1
#define PMU_RG_SYSRSTB_SWCTL_SHIFT                    5
#define PMU_RG_PMURSTB_SWCTL_ADDR                     PMU_PPCTST1
#define PMU_RG_PMURSTB_SWCTL_MASK                     0x1
#define PMU_RG_PMURSTB_SWCTL_SHIFT                    6
#define PMU_RG_UVLO_U1U2_SWCTL_ADDR                   PMU_PPCTST1
#define PMU_RG_UVLO_U1U2_SWCTL_MASK                   0x1
#define PMU_RG_UVLO_U1U2_SWCTL_SHIFT                  7
#define PMU_RG_VIOPG_SWMD_ADDR                        PMU_PPCTST2
#define PMU_RG_VIOPG_SWMD_MASK                        0x1
#define PMU_RG_VIOPG_SWMD_SHIFT                       0
#define PMU_RG_SWBAT_SWMD_ADDR                        PMU_PPCTST2
#define PMU_RG_SWBAT_SWMD_MASK                        0x1
#define PMU_RG_SWBAT_SWMD_SHIFT                       1
#define PMU_RG_IVGEN_SWMD_ADDR                        PMU_PPCTST2
#define PMU_RG_IVGEN_SWMD_MASK                        0x1
#define PMU_RG_IVGEN_SWMD_SHIFT                       2
#define PMU_RG_OSCEN_SWMD_ADDR                        PMU_PPCTST2
#define PMU_RG_OSCEN_SWMD_MASK                        0x1
#define PMU_RG_OSCEN_SWMD_SHIFT                       3
#define PMU_RG_BGP_ULP_SWMD_ADDR                      PMU_PPCTST2
#define PMU_RG_BGP_ULP_SWMD_MASK                      0x1
#define PMU_RG_BGP_ULP_SWMD_SHIFT                     4
#define PMU_RG_SYSRSTB_SWMD_ADDR                      PMU_PPCTST2
#define PMU_RG_SYSRSTB_SWMD_MASK                      0x1
#define PMU_RG_SYSRSTB_SWMD_SHIFT                     5
#define PMU_RG_PMURSTB_SWMD_ADDR                      PMU_PPCTST2
#define PMU_RG_PMURSTB_SWMD_MASK                      0x1
#define PMU_RG_PMURSTB_SWMD_SHIFT                     6
#define PMU_RG_UVLO_U1U2_SWMD_ADDR                    PMU_PPCTST2
#define PMU_RG_UVLO_U1U2_SWMD_MASK                    0x1
#define PMU_RG_UVLO_U1U2_SWMD_SHIFT                   7
#define PMU_RG_MON_FLAG_SEL_ADDR                      PMU_MONTST0
#define PMU_RG_MON_FLAG_SEL_MASK                      0xFF
#define PMU_RG_MON_FLAG_SEL_SHIFT                     0
#define PMU_RG_MON_GRP_SEL_ADDR                       PMU_MONTST1
#define PMU_RG_MON_GRP_SEL_MASK                       0xF
#define PMU_RG_MON_GRP_SEL_SHIFT                      0
#define PMU_RG_MON_FLAG_EN_ADDR                       PMU_MONTST1
#define PMU_RG_MON_FLAG_EN_MASK                       0x1
#define PMU_RG_MON_FLAG_EN_SHIFT                      7
#define PMU_RGS_MON_OUT_ADDR                          PMU_MONTST2
#define PMU_RGS_MON_OUT_MASK                          0xF
#define PMU_RGS_MON_OUT_SHIFT                         0
#define PMU_RG_INTR_TEST_SEL_ADDR                     PMU_INTRTST0
#define PMU_RG_INTR_TEST_SEL_MASK                     0x1F
#define PMU_RG_INTR_TEST_SEL_SHIFT                    0
#define PMU_RG_INTR_TEST_EN_ADDR                      PMU_INTRTST0
#define PMU_RG_INTR_TEST_EN_MASK                      0x1
#define PMU_RG_INTR_TEST_EN_SHIFT                     7
#define PMU_RG_INTR_TEST_EVENT_ADDR                   PMU_INTRTST1
#define PMU_RG_INTR_TEST_EVENT_MASK                   0x1
#define PMU_RG_INTR_TEST_EVENT_SHIFT                  0

#endif /* __HAL_MT2523_PMU_PLATFORM_H__ */
